<?php 
/**
 * Plugin Name: imgMCE
 * Plugin URI: http://imgmce.com
 * Description: Easy to use, Professional, Animated, HTML5, Drag&Drop Element Builder
 * Version: 1.3.2
 * Author: Tunafish
 * Author URI: http://tunasite.com
 * Requires at least: 4.6.1
 * Tested up to: 5.0.6
 *
 * Text Domain: imc
 * Domain Path: /localization/
 *
 */
// Exit if accessed directly
if ( ! defined( "ABSPATH" ) ) exit;
// Current plugin version
if ( ! defined( "IMCE_VERSION" ) ) define( "IMCE_VERSION", "1.3.2" );


if ( ! class_exists( "IMC_Home" ) ) : 
    
class IMC_Home { 
    
    /**
     * @var The single instance of the class
     */
    protected static $_instance = null;
    
    /**
     * IMC_Home Instance
     *
     * Ensures only one instance of FRM_Home is loaded or can be loaded.
     * @return IMC_Home - Main instance
     */
    public static function instance() { 
        if ( is_null( self::$_instance ) ) {
            self::$_instance = new self();
        }
        return self::$_instance;
    }
    
    public function __construct() 
    {
        
        // Define constants
        self::define_constants();
        
        // Load Classes ---------------------------------------------------
        spl_autoload_register( array( __CLASS__, 'autoload' ) );
        
        new IMC_Init();
        
		// actions --------------------------------------------------------
		add_action( 'plugins_loaded', array(__CLASS__, 'load_textdomain') );
    }
    
    private static function define_constants() 
    {
        define( 'IMCE_ENVATO_ID', 22443664 );
        define( 'IMCE_FILE', __FILE__ );
        define( 'IMCE_BASENAME', plugin_basename( dirname( __FILE__ ) ));
		define( "IMCE_URL", plugin_dir_url( __FILE__ ) );
		define( "IMCE_DIR", plugin_dir_path( __FILE__ ) );
		define( "IMCE_ASSETS_URL", IMCE_URL. 'assets' );
		define( "IMCE_ASSETS_DIR", IMCE_DIR. 'assets' );
		define( 'IMCE_INC_URL', IMCE_URL. 'include' );
		define( 'IMCE_INC_DIR', IMCE_DIR. 'include' );
		define( "IMCE_CLASSES_URL", IMCE_INC_URL. '/classes' );
		define( "IMCE_CLASSES_DIR", IMCE_INC_DIR. '/classes' );
		define( 'IMCE_TPL_URL', IMCE_INC_URL. '/templates' );
        define( 'IMCE_TPL_DIR', IMCE_INC_DIR. '/templates' );
        define( 'IMCE_EXT_URL', IMCE_INC_URL. '/extensions' );
        define( 'IMCE_EXT_DIR', IMCE_INC_DIR. '/extensions' );
        define( 'IMCE_AJAXURL', admin_url( 'admin-ajax.php' ) );
		define( 'IMCE_ACCESS_ROLE', 'remove_users' );
        define( 'IMCE_ADMIN_ROLE', 'remove_users' );
    }
	
    public static function load_textdomain() 
    {
		load_plugin_textdomain( 'imc', false, IMCE_BASENAME . '/include/extensions/imgmce/localization' );
    }
    

    /**
	 * Autoload classes
	 *
	 * @param string $class
	 */
	public static function autoload( $class ) 
	{
		// Not a Home class
		if ( 0 !== strncmp( 'IMC_', $class, 3 ) ) 
		{
			return;
        }

		$dirs = array(
			IMCE_CLASSES_DIR
		);

		foreach ( $dirs as $dir ) 
		{
			if ( file_exists( $file = "$dir/$class.php" ) ) 
			{
				require_once $file;
				return;
			}
		}
	}
	
}
    
endif;

/**
 * Returns the main instance of IMC_Home to prevent the need to use globals.
 * @return IMC_Home
 */
IMC_Home::instance();