<?php
// Exit if accessed directly
if ( ! defined( "ABSPATH" ) ) exit;
if ( ! class_exists( 'IMC_AMP' ) ) :

class IMC_AMP {


    public function __construct() 
	{
        // Actions --------------------------------------------------------
        if ( ! is_admin() ) 
        {
			add_action( 'wp', array( __CLASS__, 'wp_load' ), 9 );
		}

        // Filters --------------------------------------------------------
    }



    public static function wp_load() 
	{
        if( !ADN_AMP::is_amp() )
            return;

        if( function_exists( 'is_amp_endpoint' ) ) 
        {
            add_action( 'amp_post_template_data', array( __CLASS__, 'add_amp_scripts' ) );
            add_action( 'amp_post_template_css', array( __CLASS__, 'add_amp_css' ) );
        }
    }
    


    public static function add_amp_scripts( $data )
    {
        //$data['font_urls']['blackopsone'] = 'https://fonts.googleapis.com/css?family=Black%20Ops%20One';
        //$data['amp_component_scripts']['amp-iframe'] = 'https://cdn.ampproject.org/v0/amp-iframe-0.1.js';

        return $data;
    }

    // Return CSS string
    public static function add_amp_css()
    {
        $c = '._dn_cont{line-height:1;}
        ._dn_inner {
            position: relative;
        }
        ._dn_elmt {
            position: absolute;
        }body ._dn_obj *{
            -webkit-box-sizing: border-box;
            -moz-box-sizing: border-box;
            box-sizing: border-box;
        }
        ._dn_cont {
            margin:0px auto;
            background-color:#EFEFEF;
            width:300px;
            height:250px;
            overflow:hidden;
            position:relative;
            line-height:1;
        }
        
        ._dn_inner {
            position:relative;
            width:100%;
            height:100%;
        }
        
        ._dn_inner ._dn_slide {
            width:100%;
            height:100%;
            position: relative;
        }
        
        ._dn_elmt {
            position: absolute;
        }
        ._dn_elmt.visible, ._dn_BannerEditor ._dn_elmt, ._dn_BannerEditor.is_playing ._dn_elmt.visible, .my_images_container ._dn_elmt{
            visibility:visible;
        }
        ._dn_BannerEditor ._dn_elmt.hide_layer{
            visibility:hidden;
        }
        ._dn_BannerEditor.is_playing ._dn_elmt {
            visibility: hidden;
        }
            ._dn_elmt img {
                max-width: none;
            }
            ._dn_cont:not(.scale) ._dn_elmt img, ._dn_elmt.noresize img {
                max-width:100%;
                display: block;
            }
        
        ._dn_layer.text_elmt { /*._dn_layer.image_elmt*/
          height: auto !important;
        }
        ._dn_layer .layer_overlay, ._dn_layer .layer_filter {
            position: absolute;
            display: block;
            width: 100%;
            height: 100%;
            z-index: 999;
            top: 0px;
            left: 0px;
            pointer-events: none;
        }
        
        ._dn_obj_container, ._dn_obj {
            width: 100%;
            height: 100%;
            position: relative;
        }
            ._dn_obj .html_shape{
                position: absolute;
                top: 50%;
                -webkit-transform: translateY(-50%);
                -moz-transform: translateY(-50%);
                -ms-transform: translateY(-50%);
                -o-transform: translateY(-50%);
                transform: translateY(-50%);
            }
            ._dn_obj svg{
                width: 100%;
                height: 100%;
            }
            ._dn_obj ._dn_elem{
                display: block;
                height: 100%;
            }
            ._dn_obj ._dn_text {
                padding: 10px;
                margin: 0;
                font-family: inherit;
                color: inherit;
                
                display: table;
                text-align: center;
                height: 100%;
                width: 100%;
            }
                ._dn_obj ._dn_text .text{
                    display: table-cell;
                    vertical-align: middle;
                    font-size:inherit;
                    font-weight: inherit;
                    line-height: inherit;
                    letter-spacing: 1;
                    padding: 0;
                    margin: 0;
                }
            ._dn_text.heading, ._dn_cont ._dn_elem h1 {
                font-size: 32px; 
                font-weight: 800;
                line-height: 1;
                padding: 10px !important;
                margin: 0 !important;
            }
            ._dn_text.sub-heading {
                font-size: 24px; 
                font-weight: 600;
            }
            ._dn_text.normal {
                font-size: 16px; 
                font-weight: normal;
            }
            ._dn_text.small {
                font-size: 12px; 
                font-weight: normal;
            }
        
        ._dn_flip{
            -moz-transform: scaleX(-1);
            -o-transform: scaleX(-1);
            -webkit-transform: scaleX(-1);
            transform: scaleX(-1);
            filter: FlipH;
            -ms-filter: "FlipH";
        }
        
        
        ._dn_spin {
            -webkit-animation: dn_spin 2s infinite linear;
            animation: dn_spin 2s infinite linear;
            -webkit-transform-origin: center center;
            transform-origin: center center; 
        };';
        
        echo $c;
    }

}
endif;
?>