<?php
// Exit if accessed directly
if ( ! defined( "ABSPATH" ) ) exit;
if ( ! class_exists( 'IMC_BBPress' ) ) :

class IMC_BBPress {
	
	public function __construct() 
	{
        // Filters -------------------------------------------------------
        // https://codex.bbpress.org/enable-visual-editor/
		add_filter('bbp_after_get_the_content_parse_args', array(__CLASS__, 'bbp_load_custom_config'));
		//add_filter('mce_buttons', array(__CLASS__, 'bbp_load_custom_config'));
		add_filter('mce_external_plugins', array(__CLASS__, 'my_custom_plugins'));

		add_filter( 'bbp_kses_allowed_tags', array(__CLASS__, 'add_bbp_allowed_html_tags'));
		//add_filter('bbp_get_the_content', array(__CLASS__, 'bbp_before_content') );
    }



    /**
     * Add more allowed HTML tags to bbpress
     */
    public static function add_bbp_allowed_html_tags($tags = array())
	{
		return ADN_Main::parse_args(array(
			'div' => array(
				'class' => array(),
				'id' => array(),
				'contenteditable' => array()
			),
			'pre' => array(
				'class' => array()
			)
		), $tags);
	}


    /**
     * Add imgMCE button to bbpress tinymce editor
     */
	public static function bbp_load_custom_config( $config = array() ) {
        //echo '<pre>'.print_r($config).'</pre>';
        //array_push( $config, "ImgMCE" );
		$config['tinymce'] = array( 
			'toolbar1' => 'undo redo | bold italic underline | bullist numlist | link ImgMCE',
			'toolbar2' => '',
			'plugins'  => 'ImgMCE'
        );
        
		$config['quicktags'] = false;
		$config['teeny'] = false;
		return $config;
	}
	

	/* TinyMCE loading external plugins */
	public static function my_custom_plugins($plugin_array) {
		//$plugin_array['ImgMCE'] = IMC_ASSETS_URL. '/js/'.ADN_main::file_loc(array('name' => 'imgmce_tmce_plugin')).'.js' ;
		$plugin_array['ImgMCE'] = IMC_ASSETS_URL. 'dist/_imc_admin.bundle.js';
		return $plugin_array;
    }
    

    /** 
     * NOT USED for now 
     * add_filter('bbp_get_the_content', array(__CLASS__, 'bbp_before_content') );
    */
    public static function bbp_before_content($content)
	{
		preg_match('/<textarea (.*?) id="(.*?)">(.*?)<\/textarea>/s', $content, $matches, PREG_OFFSET_CAPTURE); 
		$textarea_id = $matches[2][0];

		$h = '';
		$h.= ADN_Templates::imc_button(array('id' => '_open_IMGmceTemplate_Editor'));

		// Template Editor
		$h.= '<script>';
		$h.= 'jQuery(document).ready(function($) {';
			$h.= 'var h = "";';
			$h.= 'h+= \'<div id="TMCimgModal">\';';
				$h.= 'h+= \'<div class="TMCimgModalInner">\';';
				$h.= 'h+= \'<div class="TMCimgEditor">\';';
					$h.= 'h+= \'<div class="_imc_loader">\';';
						$h.= 'h+= \'<div class="loading_logo">\';';
							$h.= 'h+= \'<svg width="20px" height="20px" viewBox="0 0 310 426"><g><g id="bottom_xA0_Image_3_"><g><g><path fill="#FFFF00" d="M237,225c-0.33,0-0.67,0-1,0c-53.73,59.93-108.85,118.49-163,178c-0.85,0.18-0.94-0.39-1-1c26.08-58.92,51.7-118.3,77-178C178,224.67,209.67,222.67,237,225z"></path></g><g></g></g></g><g id="top_xA0_Image_3_"><g id="XMLID_3_"><g><path fill="#FFFF00" d="M289,165c0,1.33,0,2.67,0,4c-17.86,18.48-34.64,38.03-52,57c-56,0-112,0-168,0c0-1,0-2,0-3c21.5-64.83,42.62-130.05,63-196c46.33,0,92.67,0,139,0c-27.25,45.75-54.78,91.22-81,138C223,165,256,165,289,165z"></path></g><g></g></g></g></g><g id="BACK_1_"><g id="bottom_xA0_Image_1_"><g id="XMLID_5_"><g><path fill="#D7CB05" d="M149,225c0,1.33,0,2.67,0,4c-26.73,57.27-50.59,117.41-77,175c-16.02-1.31-37.3,2.63-50-2c25.93-59.4,52.98-117.69,79-177C117,225,133,225,149,225z"></path></g><g></g></g></g><g id="top_xA0_Image_1_"><g id="XMLID_4_"><g><path fill="#D7CB05" d="M133,27c0,1,0,2,0,3c-21.17,64.5-41.92,129.41-62,195c-16.33,0-32.67,0-49,0c0-1,0-2,0-3C43.17,157.5,63.92,92.59,84,27C100.33,27,116.67,27,133,27z"></path></g><g></g></g></g></g></svg>\';';
						$h.= 'h+= \'</div>\';';
					$h.= 'h+= \'</div>\';';          
				$h.= 'h+= \'</div>\';';
			$h.= 'h+= \'</div>\';'; 
			
			
			$h.= 'function _packagee_open_tpl_editor(banner_obj){';
				$h.= '$("html").addClass("Open_imgMCEModal");';
				$h.= '$("body").append(h);';
		
				$h.= 'var callback_str = "";';
				$h.= 'callback_str+= "function(json){";'; 
					$h.= 'callback_str+= "var str = $.ImgMCE_func.tmc_grid_tpl({json:JSON.stringify(json)});";';
					$h.= 'callback_str+= "$(\'#'.$textarea_id.'\').val(str);";';
					$h.= 'callback_str+= "$(\'body\').find(\'.TMCimgModal\').remove();";';
					$h.= 'callback_str+= "$(\'html\').removeClass(\'Open_imgMCEModal\');";';
				$h.= 'callback_str+= "}";';
				
				
				$h.= 'var obj_id = typeof(banner_obj) !== "undefined" ? banner_obj.banner_obj.id : "{ID}";';
				$h.= '$.ajax({';
					$h.= 'type: "POST",';
					$h.= 'url: _dn_.ajaxurl,';
					$h.= 'data: {';
						$h.= '"action": "load_editor_template",';
						$h.= '"tinymce": 0,';
						$h.= '"settings": JSON.stringify(banner_obj),';
						$h.= '"upload_folder": "resources/templates/",';
						$h.= '"callback": callback_str';
					$h.= '}';
				$h.= '}).done(function( msg ){';
					$h.= 'var arr = JSON.parse(msg);';
					$h.= '$(".TMCimgEditor").html(arr.template);';
				$h.= '});';
			$h.= '}';
		
		
			$h.= '$("#_open_IMGmceTemplate_Editor").on("click", function(){';
				$h.= '_packagee_open_tpl_editor();';
			$h.= '});';
		$h.= '});';
		$h.= '</script>';

		return $h.$content;
	}
}
endif;
?>