<?php
// Exit if accessed directly
if ( ! defined( "ABSPATH" ) ) exit;
if ( ! class_exists( 'IMC_Main' ) ) :

class IMC_Main {
	
	public function __construct() 
	{

    }


    /**
     * Default Settings
     */
    public static function default_settings()
    {
        $default_settings = array(
			'debug' => 0,
			'platform' => 'wordpress',
            'image' => array(
                'image_uploads' => 1,
                'upload_size' => 15,
                'upload_file_types' => array('jpg','png','gif'),
                'stock_images' => 1,
                'stock_providers' => array(
                    'unsplash' => array(
                        'name' => 'Unsplash',
                        'url' => 'https://api.unsplash.com/',
                        'application_id' => '',
					),
					'giphy' => array(
                        'name' => 'GIPHY',
                        'url' => 'http://api.giphy.com/v1/',
                        'application_id' => '',
					),
				),
				'giphy' => 1

            ),
            'role' => array(
                'administrator' => array(
					'post_types' => array('post','page'),
					'image' => array(
						'image_uploads' => 1,
						'upload_size' => 100,
						'upload_file_types' => array('jpg','png','gif','svg'),
					),
					'general' => array(
						'save_templates' => 1
					)
                )
            )
        );

        return $default_settings;
    }
    

    /**
	 * Load Settings
	*/
	public static function load_settings($args = array())
	{
        $defaults = array(
			
		);
        $args = wp_parse_args($args, $defaults);

        $settings = get_option('_imgmce_settings', array());
        $settings = class_exists('ADN_Main') ? ADN_Main::parse_args($settings, self::default_settings()) : wp_parse_args($settings, self::default_settings());
        
        return $settings;
    }





    /*
	 * Return the main upload directory
	 *
	 * @access public
	 * @return array
	*/
	public static function upload_dir($type = '')
	{
		$upload = wp_upload_dir();
		//$upload_dir = $upload['basedir'];
		//$upload_url = $upload['baseurl'];

		if(empty($type)){
			return $upload;
		}else{
			return $upload[$type];
		}
	}





    /**
	 * Load Library
	*/
	public static function load_library($args = array())
	{
        $defaults = array(
			'stickers' => array(),
			'templates' => array()
		);
        $args = wp_parse_args($args, $defaults);

        $library = get_option('_imgmce_library', array());
        $library = wp_parse_args($library, $args);

        return $library;
    }





    /*
	 * List All Capabilities for specific User or Role in WordPress
	 *
	 * @access public
	 * @return array
	*/
	public static function capabilities($args = array())
	{
		global $current_user_id;

		$defaults = array(
		 'id' => $current_user_id,
		 'role' => '', 
		);
		$args = wp_parse_args($args, $defaults);
		
		// Capabilities for specific role
		if( !empty($args['role']) )
		{
			return get_role( $args['role'] )->capabilities;
		}
		// Capabilities for specific user id
		else
		{
			$data = get_userdata( $args['id'] );
			if( is_object( $data)) 
			{
				return $data->allcaps;
				//echo '<pre>' . print_r( $data->allcaps, true ) . '</pre>';
			}	
		}
	}
	
	
	
	
	/*
	 * ADNING Capabilities for specific Role
	 *
	 * @access public
	 * @return string
	*/
	public static function adn_capability( $role = 'administrator' )
	{
		$caps = self::capabilities(array('role' => $role));
		//echo '<pre>'.print_r($caps,true).'</pre>';
		$check_for = array('activate_plugins','edit_others_posts','publish_posts','edit_posts','read');
		
		if(!empty($caps))
		{
			foreach($check_for as $cap)
			{
				if(array_key_exists($cap, $caps))
				{
					return $cap;
				}
			}
		}
		
		return 'activate_plugins';
	}






	/*
	 * Plugin registration
	 *
	 * @access public
	 * @return array
	*/
	/*public function PLU_registration( $key )
	{
		global $wp_version;
		
		$license_key = get_option('imgmce_license_key', '');
			
		$request_string = array(
			'body' => array(
				'action'      => 'register', 
				'envato_id'   => IMCE_ENVATO_ID,
				'item_slug'   => IMCE_BASENAME,
				'license-key' => $key,
				'api-key'     => md5(get_bloginfo('url')),
				'url'         => get_bloginfo('url'),
				'email'       => get_bloginfo('admin_email'),
			),
			'user-agent' => 'WordPress/' . $wp_version . '; ' . get_bloginfo('url')
		);
		
        $request = wp_remote_post('http://tunasite.com/updates/?plu-plugin=ajax-handler', $request_string);
		
		if (!is_wp_error($request) || wp_remote_retrieve_response_code($request) === 200) {
            return $request['body'];
        }
        return false;
	}*/

}
endif;
?>