<?php
// Exit if accessed directly
if ( ! defined( "ABSPATH" ) ) exit;
if ( ! class_exists( 'IMC_Templates' ) ) :

class IMC_Templates {
	
	public function __construct() 
	{

	}
	

	public static function admin_header($args = array())
	{
		$defaults = array(
			'page' => 'dashboard',
			'title' => 'ImgMCE Premium Image Editor',
			'desc' => '⚡ ' . __('Welcome! You are using the most powerful image editor plugin for Wordpress. Let\'s get started and make your content shine!','imc'),
			'tabs' => 1
		);
		$args = wp_parse_args($args, $defaults);

		$activation = get_option('imgmce_activation', array());

		$html = '';
		$html.= '<div class="imc-heading-section imgmce-header">';
			$html.= '<h1>'.$args['title'].'</h1>';
			$html.= '<h3>'.$args['desc'].'</h3>';
			$html.= '<div class="imc-head-logo">';
				$html.= '<div class="logo" style="height: 80px;">'.ADN_Templates::logo_svg().'</div>';
				$html.= '<div class="imc-product-ver">';
					$html.= '<div>'.__('Version','imc').' '.IMCE_VERSION.'</div>';
				$html.= '</div>';
			$html.= '</div>';
		$html.= '</div>';

		// Menu options
		if( $args['tabs'])
		{
			$m_about = $args['page'] == 'dashboard' ? ' nav-tab-active' : '';
			$m_settings = $args['page'] == 'settings' ? ' nav-tab-active' : '';
			$m_roles = $args['page'] == 'role-manager' ? ' nav-tab-active' : '';
			$m_packages = $args['page'] == 'packages' ? ' nav-tab-active' : '';
			$m_updates = $args['page'] == 'updates' ? ' nav-tab-active' : '';

			$activated = !empty($activation) ? '' : ' style="background-color:#e4ff00;"';
			$activation_title = !empty($activation) ? '' : ' title="'.__('Your license has not yet been activated.','imc').'"';

			$html.= '<div class="imgmce-settings-wrapper">';
				$html.= '<h2 class="nav-tab-wrapper">';
					$html.= '<a href="?page=imgmce" data-tab="about-imgmce" class="nav-tab'.$m_about.'"> '.__('About','imc').' </a>';
					$html.= '<a href="?page=imgmce-settings" data-tab="imgmce-settings" class="nav-tab'.$m_settings.'"> '.__('General Settings','imc').' </a>';
					$html.= '<a href="?page=imgmce-role-manager" data-tab="imgmce-role-manager" class="nav-tab'.$m_roles.'"> '.__('Role Manager','imc').' </a>';
					$html.= '<a href="?page=imgmce-packages" data-tab="imgmce-packages" class="nav-tab'.$m_packages.'"> '.__('Packages','imc').' </a>';
					$html.= '<a href="?page=imgmce-updates" data-tab="imgmce-updates" class="nav-tab ttip'.$m_updates.'"'.$activated.$activation_title.'> '.__('Product License','imc').' </a>';
					//$html.= '<a href="" data-tab="product-license" class="nav-tab"> '.__('Product License','imc').' </a>';
				$html.= '</h2>';
			$html.= '</div>';
		}
		
		return $html;	
	}



	// ABOUT TABS
	public static function about_tabs($args = array())
	{
		$defaults = array(
			'tab' => 'faq'
		);
		$args = wp_parse_args($args, $defaults);

		$h = '';
		$tab = $args['tab'];
		$activation = get_option('imgmce_activation', array());

		// Menu options
		$m_new = $tab == 'new' ? ' nav-tab-active' : '';
		$m_faq = $tab == 'faq' ? ' nav-tab-active' : '';
		$m_resources = $tab == 'resources' ? ' nav-tab-active' : '';

		$h.= '<div class="imgmce-about-tabs">';
			$h.= '<h2 class="nav-tab-wrapper">';
				//$h.= '<a href="?page=imgmce&tab=new" data-tab="whats-new" class="nav-tab'.$m_new.'"> '.__('What\'s New','imc').' </a>';
				$h.= '<a href="?page=imgmce&tab=faq" data-tab="faq" class="nav-tab'.$m_faq.'"> '.__('FAQ','imc').' </a>';
				$h.= '<a href="?page=imgmce&tab=resources" data-tab="resources" class="nav-tab'.$m_resources.'"> '.__('Resources','imc').' </a>';
				$h.= empty($activation) ? '<a href="?page=imgmce-updates" data-tab="updates" class="nav-tab" style="background-color:#e4ff00;"> '.__('Product License','imc').' </a>' : '';
			$h.= '</h2>';
		$h.= '</div>';
		
		return $h;	
	}




	public static function itm_defaults()
	{
		$defaults = array(
			'title'       => '',
			'name'        => '', 
			'slug'        => '',
			'type'        => 'text',
			'id'          => '',
			'placeholder' => '',
			'value'       => '',
			'class'       => '',
			'style'       => '',
			'script'      => '',
			'text-align'  => 'left',
			'height'      => '100px', // for textareas
			'width'       => 'auto',
			'size'        => '', // one_third
			'desc_pos'    => 'bottom', // bottom, top
			'desc'        => '',
			'content'     => '',
			'show_icon'   => 0,
			'icon'        => '',
			'icon_type'   => 'fa',
			'select_opts' => array(),
			'chk-on'      => __('ON','wpproads'),
			'chk-off'     => __('OFF','wpproads'),
			'chk_width'   => 50,
			'chk_height'  => 30,
			'chk_btn_width' => 30,
			'chk_labels_placement' => 'right',
			'chk_data-values' => '',
			'color_change' => '',
			'trigger_switch_button' => 0
		);
		
		return $defaults;
	}


	/** 
	 * INPUT CONTAINER
	 *
	 */
	public static function inpt_cont($args = array())
	{
		$defaults = self::itm_defaults();
		$args = wp_parse_args( $args, $defaults );
		
		$class = !empty($args['class']) ? ' class="'.$args['class'].'"' : '';
		$id = !empty($args['id']) ? ' id="'.$args['id'].'"' : '';
		$name = !empty($args['name']) ? ' name="'.$args['name'].'"' : '';
		$placeholder = !empty($args['placeholder']) ? ' placeholder="'.$args['placeholder'].'"' : '';
		$input_style = !empty($args['width']) ? ' style="width:'.$args['width'].';"' : '';
		
		$html = '';
		$html.= '<span class="input_container_box '.$args['size'].'">';
			$html.= !empty($args['title']) ? '<h3 class="title">'.$args['title'].'</h3>' : '';
			$html.= $args['desc_pos'] == 'top' && !empty($args['desc']) ? '<span class="description top">'.$args['desc'].'</span>' : '';
			$html.= '<div style="position: relative;">';
				$html.= '<input type="'.$args['type'].'"'.$class.$id.$input_style.$name.$placeholder.' value="'.$args['value'].'" />';
				$html.= $args['show_icon'] ? '<i class="input_icon fa fa-'.$args['icon'].'" aria-hidden="true"></i>' : '';
			$html.= '</div>';
			$html.= $args['desc_pos'] == 'bottom' && !empty($args['desc']) ? '<span class="description bottom">'.$args['desc'].'</span>' : '';
		$html.= '</span>';
		
		return $html;
	} 
	
	
	
	
	/** 
	 * TEXTAREA
	 *
	 */
	public static function textarea_cont($args = array())
	{
		$defaults = self::itm_defaults();
		$args = wp_parse_args( $args, $defaults );
		
		$html = '';
		$html.= '<span class="input_container_box '.$args['size'].'">';
			$html.= !empty($args['title']) ? '<h3 class="title">'.$args['title'].'</h3>' : '';
			$html.= $args['desc_pos'] == 'top' && !empty($args['desc']) ? '<span class="description top">'.$args['desc'].'</span>' : '';
			$html.= '<div style="position: relative;">';
				$html.= '<textarea type="text" class="'.$args['class'].'" id="'.$args['id'].'" name="'.$args['name'].'" placeholder="'.$args['placeholder'].'" style="width:100%; height:'.$args['height'].';">'.$args['value'].'</textarea>';
			$html.= '</div>';
			$html.= $args['desc_pos'] == 'bottom' && !empty($args['desc']) ? '<span class="description bottom">'.$args['desc'].'</span>' : '';
		$html.= '</span>';
		
		return $html;
	} 





	/*public static function imc_button($args = array())
	{
		$defaults = array(
			'id' => '',
			'class' => '',
			'text' => __('Open Template Editor','imc'),
			'width' => '100%',
			'height' => '100%'
		);
		$args = wp_parse_args($args, $defaults);

		$id = !empty($args['id']) ? ' id="'.$args['id'].'"' : '';
		$class = !empty($args['class']) ? ' '.$args['class'] : '';

		$html = '';
		$html.= '<a'.$id.' class="_imgMCE_btn'.$class.'">';
			$html.= '<div class="logo_holder">';
				$html.= ADN_Templates::logo_svg(array('width' => '20px', 'height' => '20px'));
			$html.= '</div>';
			$html.= '<div class="text_holder">';
				$html.= $args['text'];
			$html.= '</div>';
		$html.= '</a>';
		
		return $html;
	}*/


}
endif;
?>