/**
 * https://javascript.info/class
 * 
 * var tool = new _dn_EditorTools({'_obj': _obj});
 * tool.slider(_obj);
*/
export class _dn_EditorTools {

    constructor(options){
        this.settings = Object.assign({
            '_obj': '',
            '_dn_debug': 0
        }, options);
    }


    /**
     * 
     * INPUT
     */
    input(_obj, args) {
        args = Object.assign({
            'add_to': '',
            'container': '',
            'input_class': '',
            'param': '',
            'value': '',
            'callback': {}
        }, args);

        var h = '',
            _dn_debug = this.settings._dn_debug;

        h+= '<div class="spr_column">'; //spr_col-6
            h+= '<div class="spr_column-inner ">';
                h+= '<div class="spr_wrapper">';
                    h+= '<div class="content_element">';

                        h+= '<div class="set_box '+args.container+'">';
                            h+= '<span class="title">'+args.param+'</span>';
                            h+= '<input class="input_val '+args.input_class+'" data-set="'+args.param+'" value="'+args.value+'" />';
                        h+= '</div>';

                    h+= '</div>';
                h+= '</div>';
            h+= '</div>';
        h+= '</div>';
       
        _obj.find('.'+args.add_to).append(h);

        _obj.find('.'+args.input_class).on('change', function(){
            var set = jQuery(this).data('set'),
                value = jQuery(this).val();
            
            if( _dn_debug ){ console.log('CHANGE FROM INPUT FIELD '+set+' '+value); }

            // Call callback if available
            if (typeof(args.callback.change) === 'function') {
                args.callback.change.call(_obj, set, value);
            }
        });
    }



    /**
     * 
     * SELECT
     */
    select(_obj, args) {
        args = Object.assign({
            'add_to': '',
            'container': '',
            'input_class': '',
            'param': '',
            'options': {},
            'value': '',
            'callback': {}
        }, args);

        var h = '',
            //selected = '',
            _dn_debug = this.settings._dn_debug;

        h+= '<div class="spr_column spr_col-6">'; //spr_col-6
            h+= '<div class="spr_column-inner ">';
                h+= '<div class="spr_wrapper">';
                    h+= '<div class="content_element">';

                        h+= '<div class="set_box '+args.container+'">';
                            h+= '<span class="title">'+args.param+'</span>';
                            /*h+= '<select class="input_val '+args.input_class+'" data-set="'+args.param+'">';
                                jQuery.each( args.options, function( opt, option ){
                                    selected = option === args.value ? ' selected="selected"' : '';
                                    h+= '<option value="'+option+'"'+selected+'>'+option+'</option>';
                                });
                            h+= '</select>';*/
                            var options = [];
                            options.push({'value': '', 'option': ''});
                            jQuery.each( args.options, function( opt, option ){
                                options.push({'value': option, 'option': option});
                            });

                            h+= '<input type="text" class="selectBox input_val '+args.input_class+'" data-set="'+args.param+'" style="display: none;">';
                        h+= '</div>';

                    h+= '</div>';
                h+= '</div>';
            h+= '</div>';
        h+= '</div>';
       
        _obj.find('.'+args.add_to).append(h);

        _obj.find('.edit_panel').find('.animation').find('.'+args.input_class).spr_selectBox({
            'value': args.value,
            'options': options,
            'callback': function(val){
                var set = jQuery(this).data('set'),
                value = jQuery(this).val();
            
                if( _dn_debug ){ console.log('CHANGE FROM SELECT FIELD '+set+' '+value); }

                // Call callback if available
                if (typeof(args.callback.change) === 'function') {
                    args.callback.change.call(_obj, set, value);
                }
            }
        });

        /*_obj.find('.'+args.input_class).on('change', function(){
            var set = jQuery(this).data('set'),
                value = jQuery(this).val();
            
            if( _dn_debug ){ console.log('CHANGE FROM SELECT FIELD '+set+' '+value); }

            // Call callback if available
            if (typeof(args.callback.change) === 'function') {
                args.callback.change.call(_obj, set, value);
            }
        });*/
    }


    /**
     * 
     * SLIDER
     */
    slider(_obj, args) {
        args = Object.assign({
            'add_to': '',
            'container': '',
            'input_class': '',
            'param': '',
            'value': '',
            'max': 100,
            'min': 0,
            'step': 1,
            'callback': {}
        }, args);

        var h = '',
            _dn_debug = this.settings._dn_debug;

        h+= '<div class="spr_column spr_col-6">';
            h+= '<div class="spr_column-inner ">';
                h+= '<div class="spr_wrapper">';
                    h+= '<div class="content_element">';

                        h+= '<div class="set_box">';
                            h+= '<span class="title">'+args.param+'</span>';
                            h+= '<div class="'+args.container+'"></div>';
                            h+= '<input class="slider_input_val '+args.input_class+'" data-set="'+args.param+'" value="'+args.value+'" />'; //effect_set
                        h+= '</div>';

                    h+= '</div>';
                h+= '</div>';
            h+= '</div>';
        h+= '</div>';
        
        _obj.find('.'+args.add_to).append(h);

        _obj.find('.'+args.container).slider({
            value: args.value,
            max: args.max,
            min: args.min,
            step: args.step,
            slide: function( event, ui ) {
                _obj.find('.'+args.input_class).val(ui.value);

                // Call callback if available
                if (typeof(args.callback.slide) === 'function') {
                    args.callback.slide.call(_obj, args.param, ui.value);
                }
            },
            change: function( event, ui ) {
                _obj.find('.'+args.input_class).val(ui.value);

                // Call callback if available
                if (typeof(args.callback.change) === 'function') {
                    args.callback.change.call(_obj, args.param, ui.value);
                }
            }
        });

        _obj.find('.'+args.input_class).on('change', function(){
            var set = jQuery(this).data('set'),
                value = jQuery(this).val();
            
            if( _dn_debug ){console.log('CHANGE FROM SLIDER '+set+' '+value); }
            _obj.find('.'+args.container).slider({value:value});

            // Call callback if available
            if (typeof(args.callback.change) === 'function') {
                args.callback.change.call(_obj, set, value);
            }
        });
        
    }


    /**
     * Checkbox
     */
    checkbox(_obj, args){
        args = Object.assign({
            'add_to': '',
            'container': '',
            'input_class': '',
            'param': '',
            'value': '',
            'on': true,
            'off': false,
            //'checked': false,
            'callback': {}
        }, args);

        var checked = args['value'] === args['on'] ? ' checked="checked"' : '';

        var h = '',
            _dn_debug = this.settings._dn_debug;

        h+= '<div class="spr_column spr_col-6">';
            h+= '<div class="spr_column-inner ">';
                h+= '<div class="spr_wrapper">';
                    h+= '<div class="content_element">';

                        h+= '<div class="set_box '+args.container+'">';
                            h+= '<span class="title">'+args.param+'</span>';
                            h+= '<div>';
                                h+= '<label class="spr_check_container">';
                                    h+= '<input class="input_val '+args.input_class+'" type="checkbox" data-set="'+args.param+'" value="'+args.value+'"'+checked+' />';
                                    h+= '<span class="checkmark"></span>';
                                h+= '</label>';
                            h+= '</div>';
                        h+= '</div>';

                    h+= '</div>';
                h+= '</div>';
            h+= '</div>';
        h+= '</div>';

        _obj.find('.'+args.add_to).append(h);

        _obj.find('.'+args.input_class).on('change', function(){
            var set = jQuery(this).data('set'),
                checked = jQuery(this).prop('checked'),
                value = checked ? args['on'] : args['off']; //jQuery(this).val();
            
            if( _dn_debug ){console.log('CHANGE FROM INPUT FIELD param:'+set+' value:'+value+' checked:'+checked);}

            // Call callback if available
            if (typeof(args.callback.change) === 'function') {
                args.callback.change.call(_obj, set, value);
            }
        });
    }

}







export class _dn_Plugins {

	// el: main object, cat: panel classname, options; object, debug: bool
    constructor(el, options, args){
		this.$obj = jQuery(el);
        this.$settings = Object.assign({}, options);
        this.$args = Object.assign({
            'cat': '',
            'group': '',
            'debug': 0
        }, args);
    }

    plugin_setup(){
        var $ = jQuery;
		var _obj = this.$obj;
        var settings = this.$settings;
        var cat = this.$args.cat;
        var group = this.$args.group;
		var _dn_debug = this.$args.debug;
        
        _obj.find('.'+cat).find('.plugin_settings_holder').html('');
        _obj.find('.'+cat).find('.plugin_box').removeClass('added');
        _obj.find('.'+cat).find('.plugin_box').removeClass('selected');
        _obj.find('.'+cat).find('.plugin_box').find('.plugin_box_remove').hide();

        var _dn_obj = _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer),
            layer_plugins = {};

        if( typeof settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].plugins == 'undefined' ){
            settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].plugins = {};
        }
        layer_plugins = settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].plugins;
        
        $.each( layer_plugins, function( pl, plugin ){
            if( typeof(plugin.group) !== 'undefined'){
        
                $.each( plugin.group, function( plg, ani_group ){
                    if( plg === group && Object.keys(ani_group).length ){
                        _obj.find('.'+cat).find('.plugin_box_'+pl).addClass('added');
                        _obj.find('.'+cat).find('.plugin_box_'+pl).find('.plugin_box_remove').show();
                    }
                });
            }else{
                _obj.find('.'+cat).find('.plugin_box_'+pl).addClass('added');
                _obj.find('.'+cat).find('.plugin_box_'+pl).find('.plugin_box_remove').show();
            }
        });


        // ADD PLUGIN BUTTON click action
        _obj.find('.'+cat).find('.plugin_selector').off('click').on('click', function(){
            var plugin_id = $(this).data('id'),
                code_set = JSON.parse( $(this).find('.plugin_code').val() );
            
            if( _dn_debug ){console.log($(this).find('.plugin_code').val());}
            if( _dn_debug ){console.log(code_set);}
            if( _dn_debug ){console.log( settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].plugins[plugin_id] );}

            _obj.find('.'+cat).find('.plugin_box').removeClass('selected');
            $(this).closest('.plugin_box').addClass('selected');
            $(this).closest('.plugin_box').addClass('added');
            _obj.find('.'+cat).find('.plugin_box_'+plugin_id).find('.plugin_box_remove').show();
            _obj.find('.'+cat).find('.plugin_settings_holder').html('');

            
            if( typeof settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].plugins[plugin_id] == 'undefined' ){
                settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].plugins[plugin_id] = {
                    'type': code_set.type,
                    'external': code_set.external,
                    'params': code_set.params,
                    'code': code_set.code,
                    'group': code_set.group
                };
            }
            
            var code = $.extend(code_set, settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].plugins[plugin_id]);
            if( _dn_debug ){console.log(code);}
            
            // Add Effects setting tools
            var editorTools = new _dn_EditorTools({'_obj': _obj, '_dn_debug': _dn_debug});
            var pluginUpdate = new _dn_Plugins(_obj, settings, {'cat': cat, 'group': group, '_dn_debug': _dn_debug});

            // Set default params
            if( typeof(code.group) !== 'undefined' ){
                if( $.isArray(code.group[group]) ){code.group[group] = {};}
                var default_params = jQuery.isEmptyObject(code.group[group]) ? code.params : code.group[group];
            }else{
                var default_params = code.params;
            }
            
            $.each( default_params, function( param, val ){
                pluginUpdate.plugin_update_params(plugin_id, code, param, val);
            });

            if( _dn_debug ){console.log(settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].plugins);}
            //return;
            
            $.each( code_set.editing, function( pm, type ){
                if( Object.keys( type )[0] === 'input' ){
                    var value = typeof(code.group) !== 'undefined' ? code.group[group][pm] : code.params[pm];

                    editorTools.input(_obj,{
                        'add_to': 'plugin_settings_holder',
                        'container': 'plugin_set_box_'+pm,
                        'input_class': 'plugin_set_'+pm,
                        'param': pm,
                        'value': value,
                        'callback': {
                            'change': function(param, val){
                                pluginUpdate.plugin_update_params(plugin_id, code, param, val);
                            }
                        }
                    });
                }
                if( Object.keys( type )[0] === 'select' ){
                    var value = typeof(code.group) !== 'undefined' ? code.group[group][pm] : code.params[pm];
                    
                    editorTools.select(_obj,{
                        'add_to': 'plugin_settings_holder',
                        'container': 'plugin_set_box_'+pm,
                        'input_class': 'plugin_set_'+pm,
                        'param': pm,
                        'options': type.select,
                        'value': value,
                        'callback': {
                            'change': function(param, val){
                                pluginUpdate.plugin_update_params(plugin_id, code, param, val);
                            }
                        }
                    });
                }
                if( Object.keys( type )[0] === 'slider' ){
                    var value = typeof(code.group) !== 'undefined' ? code.group[group][pm] : code.params[pm];

                    editorTools.slider(_obj,{
                        'add_to': 'plugin_settings_holder',
                        'container': 'plugin_set_box_'+pm,
                        'input_class': 'plugin_set_'+pm,
                        'param': pm,
                        'value': value,
                        'max': typeof(type.slider.max) !== 'undefined' ? type.slider.max : 100,
                        'min': typeof(type.slider.min) !== 'undefined' ? type.slider.min : 0,
                        'step': typeof(type.slider.step) !== 'undefined' ? type.slider.step : 1,
                        'callback': {
                            'slide': function(val){},
                            'change': function(param, val){
                                pluginUpdate.plugin_update_params(plugin_id, code, param, val);
                            }
                        }
                    });
                }
                if( Object.keys( type )[0] === 'checkbox' ){
                    var value = typeof(code.group) !== 'undefined' ? code.group[group][pm] : code.params[pm];

                    editorTools.checkbox(_obj,{
                        'add_to': 'plugin_settings_holder',
                        'container': 'plugin_set_box_'+pm,
                        'input_class': 'plugin_set_'+pm,
                        'param': pm,
                        'value': value,
                        'on': typeof(type.checkbox.on) !== 'undefined' ? type.checkbox.on : true,
                        'off': typeof(type.checkbox.off) !== 'undefined' ? type.checkbox.off : false,
                        'callback': {
                            'slide': function(val){},
                            'change': function(param, val){
                                pluginUpdate.plugin_update_params(plugin_id, code, param, val);
                            }
                        }
                    });
                }
            });
        
        });
        // end .plugin_selector on click


        // REMOVE PLUGIN BUTTON click action
        _obj.find('.'+cat).find('.remove_plugin_options').off('click').on('click', function(){
            var plugin_id = $(this).data('plugin'),
                code = JSON.parse( $(this).closest('.plugin_box').find('.plugin_code').val() ),
                group = $(this).closest('.plugin_box').data('group'),
                run_code = '';
            
            if( _dn_debug ){console.log(group);}
            
            if( typeof(group) !== 'undefined'){
                settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].plugins[plugin_id].group[group] = {};
            }else{
                delete settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].plugins[plugin_id];
                var layer_plugins = settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].plugins;
                //
                // @since v1.1.8 changed '_dn_obj' to 'jQuery("._dn_editor_stage").find("._dn_cont").find(".slide_'+settings.current_slide+'").find(".layer_'+settings.current_layer+'")' to fix a compiler issue with Google compiler (https://closure-compiler.appspot.com/home)
                // If compiled with Google compiler an error: "_dn_obj is undefined" was triggered when trying to remove the attached plugin. 
                // This does not happen in the uncompiled version of the code. However it needs to work in the compiled code too so we changed it.
                //
                // EDIT: This happens because when compiled the variable _dn_obj gets renamed. So if we call '_dn_obj' in the string it's undefined... 
                //
                //var run_code = code.code.remove.replace(/{LAYER}/g, '_dn_obj');
                var run_code = code.code.remove.replace(/{LAYER}/g, 'jQuery("._dn_editor_stage").find("._dn_cont").find(".slide_'+settings.current_slide+'").find(".layer_'+settings.current_layer+'")');
                run_code = run_code.replace(/{LAYER-CLASS}/g, settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].class);
                if( typeof(layer_plugins[plugin_id]) !== 'undefined' ){
                    if( typeof(layer_plugins[plugin_id]['params']) !== 'undefined' ){
                        if( typeof(layer_plugins[plugin_id]['params']['class']) !== 'undefined' ){
                            run_code = run_code.replace(/{CLASS}/g, layer_plugins[plugin_id]['params']['class']);
                        }
                    }	
                }
            }
            
            if(run_code !== ''){
                eval(run_code);
            }
            
            $(this).closest('.plugin_box').removeClass('selected');
            $(this).closest('.plugin_box').removeClass('added');
            $(this).closest('.plugin_box').find('.plugin_box_remove').hide();
            _obj.find('.'+cat).find('.plugin_settings_holder').html('');
            if( _dn_debug ){ console.log(settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].plugins); }
        });
        //end remove .plugin click action 
    }
    // end function plugin_setup



    plugin_update_params(plugin_id, code, param, val){
        var $ = jQuery;
        var _obj = this.$obj;
        var settings = this.$settings;
        var cat = this.$args.cat;
        var group = this.$args.group;
        var _dn_debug = this.$args.debug;

        if(typeof(code.group) !== 'undefined'){
            // Fix to make sure object is no array.
            console.log(param);console.log(val);
            if( $.isArray(code.group[group]) ){code.group[group] = {};}
            code.group[group][param] = val;
            settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].plugins[plugin_id].group = code.group;
        }else{
            code.params[param] = val;
            settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].plugins[plugin_id].params = code.params;
        }

        //console.log(settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].plugins[plugin_id].group);
        return settings;
    }
    // end function plugin_update_params
}










export class _dn_Element_Params {

    // el: main object, cat: panel classname, options; object, debug: bool
    constructor(el, options, args){
		this.$obj = jQuery(el);
        this.$settings = Object.assign({}, options);
        this.$args = Object.assign({
            'cat': '',
            'debug': 0
        }, args);
    }

    elm_params_setup(){
        var $ = jQuery;
		var _obj = this.$obj;
        var settings = this.$settings;
        var cat = this.$args.cat;
        var _dn_debug = this.$args.debug;
        var _param_holder = _obj.find('.'+cat).find('._css_obj_params_holder');

        _param_holder.html('');

        var layer_arr = settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer];
        if( typeof layer_arr.obj_params == 'undefined'){ return; }
        
        // Add Effects setting tools
        var editorTools = new _dn_EditorTools({'_obj': _obj, '_dn_debug': _dn_debug});
        var elmUpdate = new _dn_Element_Params(_obj, settings, {'cat': cat, '_dn_debug': _dn_debug});

        // Set default params
        $.each( layer_arr.obj_params, function( key, value ){
            if( typeof value.val !== 'undefined'){
                elmUpdate.elm_update_content(key, value.val);
                /*settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].obj_params[key].val = value.val;
                var obj_params = settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].obj_params;
                if( settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].obj_id == 'youtube' ){
                    _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).find('._dn_elem').attr("src","https://www.youtube.com/embed/"+obj_params['video_id'].val+"?modestbranding=1&amp;rel=0&amp;showinfo=0&amp;"+obj_params['show_controls'].val+"&amp;autoplay="+obj_params['autoplay'].val);
                }*/
            }
        });

        $.each( layer_arr.obj_params, function( key, value ) {
            
            if( typeof value.editing !== 'undefined'){
                $.each( value.editing, function( pm, type ){
                    //console.log(pm);console.log(type);
                    if( pm === 'input'){
                        editorTools.input(_obj,{
                            'add_to': '_css_obj_params_holder',
                            'container': 'param_set_box_'+pm,
                            'input_class': 'param_set_'+pm,
                            'param': key,
                            'value': value.val,
                            'callback': {
                                'change': function(param, val){
                                    elmUpdate.elm_update_content(param, val);
                                    /*value.val = val;
                                    settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].obj_params[param].val = val;
                                    var obj_params = settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].obj_params;

                                    if( settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].obj_id == 'youtube' ){
                                        _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).find('._dn_elem').attr("src","https://www.youtube.com/embed/"+obj_params['video_id'].val+"?modestbranding=1&amp;rel=0&amp;showinfo=0&amp;controls="+obj_params['show_controls'].val+"&amp;autoplay="+obj_params['autoplay'].val);
                                    }else{
                                        _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).find('._dn_elem').attr(param,val);
                                    }
                                    */
                                }
                            }
                        });
                    }
                    if( pm === 'checkbox' ){
                        editorTools.checkbox(_obj,{
                            'add_to': '_css_obj_params_holder',
                            'container': 'param_set_box_'+pm,
                            'input_class': 'param_set_'+pm,
                            'param': key,
                            'value': value.val,
                            'on': typeof(type.on) !== 'undefined' ? type.on : true,
                            'off': typeof(type.off) !== 'undefined' ? type.off : false,
                            'callback': {
                                'slide': function(val){},
                                'change': function(param, val){
                                    elmUpdate.elm_update_content(param, val);
                                    /*value.val = val;
                                    settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].obj_params[param].val = val;
                                    var obj_params = settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].obj_params;

                                    if( settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].obj_id == 'youtube' ){
                                        _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).find('._dn_elem').attr("src","https://www.youtube.com/embed/"+obj_params['video_id'].val+"?modestbranding=1&amp;rel=0&amp;showinfo=0&amp;controls="+obj_params['show_controls'].val+"&amp;autoplay="+obj_params['autoplay'].val);
                                    }else{
                                        _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).find('._dn_elem').attr(param,val);
                                    }*/
                                }
                            }
                        });
                    }
                });
            }
        });
 
    }
    // end function elm_params_setup




    elm_update_content(param, val){
        var $ = jQuery;
		var _obj = this.$obj;
        var settings = this.$settings;
        var cat = this.$args.cat;
        var _dn_debug = this.$args.debug;

        settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].obj_params[param].val = val;
        var obj_params = settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].obj_params;

        if( settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].obj_id == 'youtube' ){
            var loop = obj_params['loop'].val ? "&amp;loop="+obj_params['loop'].val+"&amp;playlist="+obj_params['video_id'].val : '';
            _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).find('._dn_elem').attr("src","https://www.youtube.com/embed/"+obj_params['video_id'].val+"?modestbranding=1&amp;rel=0&amp;showinfo=0&amp;controls="+obj_params['show_controls'].val+"&amp;autoplay="+obj_params['autoplay'].val+loop);
        }else{
            _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).find('._dn_elem').attr(param,val);
        }
    }
    // end function elm_update_content

}
// end class _dn_Element_Params