(function($, win) {

	var dn_emb = {

		// Default options
		_dn_embed_defaults(options){

			var _dn_settings = $.extend({
				//"hash": "", created automatically @since v1.1.0
			  	"id": 0,
			  	"width": null,
			  	"height": null,
			  	"animation": "",
			  	"force_cookie": 1,
			  	"force_viewport": 0,
			  	"display": {},
			  	"showing": function(id){console.log(id);} // event fired when ad becomes visible
			}, options );

			// DISPLAY
			_dn_settings.display = $.extend({
				"type": "",
      			"attr": {}
			}, _dn_settings.display );

			// DISPLAT . ATTR
			_dn_settings.display.attr = $.extend({
				"on_exit": 0,
				"delay":0,
				"cookie": new Date(new Date().getTime() + 3 * 60 * 1000), // expire after 3 minutes
	          	"bg_color": "rgba(56, 56, 56, 0.9)",
	          	"pos_lr": "center", // left | center | right
	          	"pos_tb": "bottom", // top | bottom
	          	"pos_offset": 0,
	            "close_btn": {}
			}, _dn_settings.display.attr );

			// DISPLAY . ATTR . CLOSE_BTN
			_dn_settings.display.attr.close_btn = $.extend({
				"delay": 0,
				"class": "default",
				"count_down_txt": "Close AD in %s seconds",
				"pos_lr": "right" // left | right
			}, _dn_settings.display.attr.close_btn );

			return _dn_settings;
		},




		dn_hash_gen(length){
			// Math.random should be unique because of its seeding algorithm.
			// Convert it to base 36 (numbers + letters), and grab the first (length) characters
			// after the decimal.
			return '_' + Math.random().toString(36).substr(2, length);
		},



		isFileLoaded(url, tagName) {
			if(!url) url = site_url+assets_path+"/js/embed/jquery.js";
			if(!tagName) tagName = "script";
			var files = tagName == "script" ? document.getElementsByTagName("script") : document.styleSheets;
			var arg = tagName == "script" ? "src" : "href";
			for (var i = files.length; i--;) {
				if (files[i][arg] == url) return true;
			}
			return false;
		},



		close_btn(_obj, settings){
			if( _obj.find("._dn_"+settings.display.type+"_close_btn").length == 0){

				var bframe = _obj.find('iframe'),
					type = settings.display.type;
					
				// Close btn timer
				if(settings.display.attr.close_btn.delay > 0){
					if( _obj.find(".timer").length == 0){
						_obj.append("<span class='timer' style='display:inline-block;position:absolute;line-height:1;'></span>");
						var timer_obj = _obj.find('.timer');

						// Setup Countdown
						var delay_seconds = settings.display.attr.close_btn.delay/1000;
						timer_obj.adnCountdown({
							'count':delay_seconds, 
							'str': settings.display.attr.close_btn.count_down_txt, 
							change:function(){
								
								if( type === 'popup'){
									timer_obj.centerMiddle({
										marginLeft:  -bframe.width()+timer_obj.width(),
										marginTop:  -(bframe.height()/2)-timer_obj.height()
									});
								}else{
									timer_obj.css({'top': -timer_obj.height()+'px', 'left':0});
								}
							}, 
							finish: function(){
								
								dn_emb.add_dn_bn_close_btn(_obj, settings);
								timer_obj.remove();
							}
						});
					}
				}else{
					dn_emb.add_dn_bn_close_btn(_obj, settings);
				}
			}
		},



		add_dn_bn_close_btn(_obj, settings){
			var bframe = _obj.find('iframe'),
				type = settings.display.type;

			_obj.append("<span class='_dn_"+type+"_close_btn _dn_bn_close_btn _dn_"+type+"_close_btn_"+settings.hash+"' style='opacity:0;'>X</span>");

			var close_btn = $("._dn_"+type+"_close_btn_"+settings.hash);
			close_btn.addClass(settings.display.attr.close_btn.class);

			// Position close btn
			if( settings.display.type === 'popup'){
				var pos_l = settings.display.attr.close_btn.pos_lr === 'right' ? bframe.width()+(close_btn.width()/2) : -bframe.width()+(close_btn.width()/2);
				close_btn.centerMiddle({
					marginLeft:  pos_l,
					marginTop:  -(bframe.height()/2)+(close_btn.height()/2)
				});
			}else if(settings.display.type === 'flyin'){ 
				// top | bottom
				var pos_t = settings.display.attr.pos_tb === 'top' ? 'bottom' : 'top';
				close_btn.css(pos_t, -close_btn.outerHeight()/2);
				// left | right
				var pos_l = settings.width !== 'full' ? -close_btn.outerWidth()/2 : 0;
				close_btn.css(settings.display.attr.close_btn.pos_lr, pos_l);
			}

			close_btn.css({"opacity":1});

			// Close BTN actions
			$("body").on("click","._dn_"+type+"_close_btn_"+settings.hash, function(){
				$("#_dn_holder_"+settings.hash).remove();
				$("body").removeClass("_dn_popup");
				settings.force_viewport = 0;
			});
		},


		frame_communicator( id, message ) {
			if( $(id).length ){
				// Send message to iframe when in view.
				console.log(message);
				//document.getElementById(id).contentWindow.postMessage(message, '*'); 
				$(id)[0].contentWindow.postMessage(message, '*'); 
			}
		},

		// Wait till frame has been loaded
		wait_till_loaded(id, ld_class, callback) {
			if( $(id).hasClass(ld_class) ){

				if( typeof callback !== 'undefined' ){
					callback();
				}
			}else {
			    setTimeout(function() {
			      	dn_emb.wait_till_loaded(id, ld_class, callback);
			    }, 100);
			}
		}


	};





	/**
	 * DN FRAME CONTAINER
	*/
	$.fn._dn_frame = function(options) {
	  
	  	// Defaults
		var s = dn_emb._dn_embed_defaults(options);
	  
	 	return this.each(function(i,el){

	 		var animation_css = dn_emb.isFileLoaded(site_url+inc_path+"/extensions/spr_columns/assets/css/animate.min.css","link");
			//var hash = s.hash;
			//var hash = $(el).attr('id');
			var hash = dn_emb.dn_hash_gen(6);
			s.hash = hash;

			//console.log('start:' + s.id+' '+hash);

			// Main Variables
			var opacity = "undefined"!==typeof s.animation ? " opacity:0;" : "";
			var bWidth = s.width != "full" ? s.width+"px" : "100%";
			var maxWidth = "max-width:"+bWidth+";";
			var delay = "undefined"!==typeof s.display.attr.delay ? s.display.attr.delay : 0;

			// Display variables
			var display = "";
			if("undefined"!==typeof s.display){
				display = "&display="+s.display.type+";"
			}
			var start_animation = "";
			if("undefined"!==typeof s.sa){
				start_animation = s.sa;
			}

			var g=null,
				ratio=s.height/s.width;

			/*$(el).replaceWith("<div id='_dn_holder_"+hash+"' class='_dn_holder _dn_holder_"+hash+"' style='width:100%;max-width:"+s.width+"px;max-height:"+s.height+"px;'><iframe id='_dn"+hash+"' class='_dn_frame' data-bid='"+s.id+"' src='"+site_url+"?_dnid="+s.id+"&sa="+start_animation+display+"' width='100%' height='"+s.height+"px' frameborder='0' allowtransparency='true' scrolling='no' style='"+maxWidth+opacity+"' allowfullscreen></iframe></div>");*/
			$(el).replaceWith("<div id='_dn_holder_"+hash+"' class='_dn_holder _dn_holder_"+hash+"' style='width:100%;max-width:"+s.width+"px;max-height:"+s.height+"px;'><iframe id='_dn"+hash+"' class='_dn_frame' data-bid='"+s.id+"' src='"+site_url+"?_dnid="+s.id+"&sa="+start_animation+display+"' frameborder='0' allowtransparency='true' scrolling='no' style='width:1px;min-width:100%;*width:100%;height:"+s.height+"px"+maxWidth+opacity+"' allowfullscreen></iframe></div>");

			// Receive message from iframe as soon as it's loaded.
			window.addEventListener("message", function(event) {
				var edi = event.data.id;
				if( $("#_dn"+hash+"[data-bid = "+edi+"]").length && !$("#_dn"+hash+"[data-bid = "+edi+"]").hasClass('loaded')){
					console.log(hash+' '+edi+' has been completely loaded.');
					$("#_dn"+hash+"[data-bid = "+edi+"]").addClass('loaded');
					$("#_dn"+hash+"[data-bid = "+edi+"]").attr('data-bnr_hash', event.data.hash);
					$("#_dn"+hash+"[data-bid = "+edi+"]").data('bnr_hash', event.data.hash);
				}
			});

			// Adjust iframe height on Resize.
			setInterval(function(){
				var a = $("#_dn"+hash);
				a && a.outerWidth() !== g && (a.css({'height':Math.round(a.outerWidth()*ratio)+"px"}), g = a.outerWidth());
			},50);


			// Wait untill iframe src has been loaded.
			dn_emb.wait_till_loaded($("#_dn"+hash),'loaded',function(){
				if(s.display.type === "popup"){
					$("#_dn_holder_"+hash).adnPopup(s);
				}else if(s.display.type === "flyin"){
					$("#_dn_holder_"+hash).adnFlyin(s);
				}else{
					$("#_dn"+hash).adnInViewport(function(px){ if(px){ 
						if( !$(this).hasClass('inview') ){
							$(this).css({"opacity":1}).addClass(s.display.type+" "+s.animation+" animated inview");
							
							// Send message to iframe when in view. (iframe_id, {id: banner_id})
							dn_emb.frame_communicator( $("#_dn"+hash), {'id':s.id, 'hash': $(this).data('bnr_hash')} );
						}
					}}, 
					{"delay":delay, "force":s.force_viewport} );
					
				}
			});

			if("undefined"!==typeof s.animation){
				if(!animation_css){
					$("#_dn_holder_"+hash).append("<link rel='stylesheet' href='"+site_url+inc_path+"/extensions/spr_columns/assets/css/animate.min.css' type='text/css' media='all' />");
				}
			}

	 	});
	}




	/*if (typeof _dn_embed !== "undefined") {
		var animation_css = dn_emb.isFileLoaded(site_url+inc_path+"/extensions/spr_columns/assets/css/animate.min.css","link");
		var hash = _dn_embed.hash;
		var _dn_arr = "undefined"!==typeof _dn_arr ? _dn_arr : [];
		var _dn_obj = {}; 

		_dn_obj[hash] = dn_emb._dn_embed_defaults(_dn_embed);
		_dn_arr.push( _dn_obj );
		
		var i, s, len = _dn_arr.length;
		for(i=0; i<len; ++i){
			if(i in _dn_arr){
				if(hash in _dn_arr[i]){
					s = _dn_arr[i][hash];

					console.log('start:' + s.id+' '+s.hash);

					// Main Variables
					var opacity = "undefined"!==typeof s.animation ? " opacity:0;" : "";
					var bWidth = s.width != "full" ? s.width+"px" : "100%";
					var maxWidth = "max-width:"+bWidth+";";
					var delay = "undefined"!==typeof s.display.attr.delay ? s.display.attr.delay : 0;

					// Display variables
					var display = "";
					var display_class = "";
					var display_attr = {};
					if("undefined"!==typeof s.display){
						display = "&display="+s.display.type+";"
						display_class = " "+s.display.type;
						display_attr = "undefined"!==typeof s.display.attr ? s.display.attr : {};
					}
					var start_animation = "";
					if("undefined"!==typeof s.sa){
						start_animation = s.sa;
					}

					var g=null,
						ratio=s.height/s.width;

					document.write("<div id='_dn_holder_"+s.hash+"' class='_dn_holder _dn_holder_"+s.hash+"' style='width:100%;max-width:"+s.width+"px;max-height:"+s.height+"px;'><iframe id='_dn"+s.hash+"' class='_dn_frame' data-bid='"+s.id+"' src='"+site_url+"?_dnid="+s.id+"&sa="+start_animation+display+"' width='100%' height='"+s.height+"px' frameborder='0' allowtransparency='true' scrolling='no' style='"+maxWidth+opacity+"' allowfullscreen></iframe></div>");

					// Receive message from iframe as soon as it's loaded.
					window.addEventListener("message", function(event) {
						var edi = event.data.id;
						if( $("#_dn"+s.hash+"[data-bid = "+edi+"]").length && !$("#_dn"+s.hash+"[data-bid = "+edi+"]").hasClass('loaded')){
							console.log(s.hash+' '+edi+' has been completely loaded.');
							$("#_dn"+s.hash+"[data-bid = "+edi+"]").addClass('loaded');
						}
					});

					// Adjust iframe height on Resize.
					setInterval(function(){
						var a = $("#_dn"+s.hash);
						a && a.outerWidth() !== g && (a.css({'height':Math.round(a.outerWidth()*ratio)+"px"}), g = a.outerWidth());
					},50);

					//console.log(s.display.type);
					if(s.display.type === "popup"){
						$("#_dn_holder_"+s.hash).adnPopup(s);
					}else if(s.display.type === "flyin"){
						$("#_dn_holder_"+s.hash).adnFlyin(s);
					}else{
						$("#_dn"+s.hash).adnInViewport(function(px){ if(px){ 
							if( !$(this).hasClass('inview') ){
								$(this).css({"opacity":1}).addClass(display_class+" "+s.animation+" animated inview"); 
								
								// Send message to iframe when in view. (iframe_id, {id: banner_id})
								dn_emb.wait_till_loaded("_dn"+s.hash, {'id':s.id});
							}
						}}, 
						{"delay":delay, "force":s.force_viewport} );
						
					}

					if("undefined"!==typeof s.animation){
						if(!animation_css){
							document.write("<link rel='stylesheet' href='"+site_url+inc_path+"/extensions/spr_columns/assets/css/animate.min.css' type='text/css' media='all' />");
						}
					}
				}
			}
		}
		
	}*/







	/**
	 * FLYIN
	*/
	$.fn.adnFlyin = function(settings) {
		return this.each(function(i,el){
			// Check if cookie exists.
 			if( typeof Cookies.get('_dn_flyin_'+settings.id) === 'undefined' || settings.display.attr.cookie === null || settings.force_cookie ){
	 			// Load popup CSS
	 			var popup_css = dn_emb.isFileLoaded(site_url+assets_path+"/css/embed/display.css","link");
				if(!popup_css){
					//document.write("<link rel='stylesheet' href='"+site_url+assets_path+"/css/embed/display.css' type='text/css' media='all' />");
					$(el).append("<link rel='stylesheet' href='"+site_url+assets_path+"/css/embed/display.css' type='text/css' media='all' />");
				}

		 		var bframe = $(el).find('iframe');
		 		$(el).css({"opacity":0});

		 		$(el).adnInViewport(function(px){if(px){ 
		 			create_flyin($(this)); 

		 			if( !$(this).hasClass('inview') ){
						$(this).addClass("inview");
						
						// Send message to iframe when in view. (iframe_id, {id: banner_id})
						dn_emb.frame_communicator( $("#_dn"+settings.hash), {'id':settings.id} );
					}
		 		}},
		 		{"delay":settings.display.attr.delay, "force":settings.force_viewport});

		 		function create_flyin(_obj){
					if(!_obj.hasClass('visible')){
						
						_obj.addClass('visible');
						_obj.css({"opacity":1,"position": "fixed","z-index":9998});

						// Set Cookie
						Cookies.set('_dn_flyin_'+settings.id, settings.id, { expires: settings.display.attr.cookie });

						// Positioning
						if(settings.display.attr.pos_lr === 'center'){
							_obj.css({'left':0});
							if(settings.width !== 'full'){
								_obj.css({'left':'50%', 'transform':'translateX(-50%)'});
							}
						}else{
							_obj.css(settings.display.attr.pos_lr, settings.display.attr.pos_offset);
						}

						// Top | Bottom
						var admin_bar_offset = $('#wpadminbar').length !== 0 ? $('#wpadminbar').height() : 0,
							offset = settings.display.attr.pos_tb === 'top' ? settings.display.attr.pos_offset + admin_bar_offset : settings.display.attr.pos_offset;

						_obj.css(settings.display.attr.pos_tb, offset);
						bframe.css({"opacity":1}).addClass(settings.display.type+" "+settings.animation+" animated");
						// Add close btn
						dn_emb.close_btn(_obj, settings);

						// Fire showing event 
						if(settings.showing) {
							settings.showing.call(_obj.get(0), settings.id);
						}
					}
				}
		 	}else{
				// Flyin has already been seen. Remove the banner
				$("#_dn_holder_"+settings.hash).remove();
			}
		});
	};






	/**
	 * POPUP
	*/
	$.fn.adnPopup = function(settings) {
	 	return this.each(function(i,el){
	 		
 			// Check if cookie exists.
 			if( typeof Cookies.get('_dn_popup_'+settings.id) === 'undefined' || settings.display.attr.cookie === null || settings.force_cookie ){
	 			// Load popup CSS
	 			var popup_css = dn_emb.isFileLoaded(site_url+assets_path+"/css/embed/display.css","link");
				if(!popup_css){
					$(el).append("<link rel='stylesheet' href='"+site_url+assets_path+"/css/embed/display.css' type='text/css' media='all' />");
				}

		 		var bframe = $(el).find('iframe');
		 		$(el).css({"opacity":0});


		 		// Exit Popup options
		 		if( settings.display.attr.on_exit && $(this).length ){
		 			bframe.hide();
			 		// Track mouse movements
					document.addEventListener("mousemove", function(e) {
						// Get current scroll position
						var scroll = window.pageYOffset || document.documentElement.scrollTop;
						
						if((e.pageY - scroll) < 7){
							//console.log('Exiting page');
							create_popup($(el));
							bframe.css({"opacity":1}).addClass(settings.display.type+" "+settings.animation+" animated");
							bframe.centerMiddle();

							if( !$(this).hasClass('inview') ){
								$(this).addClass("inview");
								
								// Send message to iframe when in view. (iframe_id, {id: banner_id})
								dn_emb.frame_communicator( $("#_dn"+settings.hash), {'id':settings.id} );
							}
						}
					});
				}else{ // 
					$(el).adnInViewport(function(px){if(px){ 
						create_popup($(this)); 
						$("#_dn"+settings.hash).css({'opacity': 1}).addClass(settings.display.type+" "+settings.animation+" animated");
						
						if( !$(this).hasClass('inview') ){
							$(this).addClass("inview");
							
							// Send message to iframe when in view. (iframe_id, {id: banner_id})
							dn_emb.frame_communicator( $("#_dn"+settings.hash), {'id':settings.id} );
						}
					}},
					{"delay":settings.display.attr.delay, "force":settings.force_viewport});
				}

				
				function create_popup(_obj){
					//if($("#_dn_holder_"+settings.hash).length !== 0){
					if(!_obj.hasClass('visible')){
						_obj.addClass('visible');
						
						bframe.centerMiddle();
						_obj.css({"opacity":1,"position": "fixed","max-height":"100%","max-width":"100%","background": settings.display.attr.bg_color,"text-align":"center","left": 0,"top": 0,"right": 0,"bottom": 0,"z-index":9999});
						
						$("body").addClass("_dn_popup");

						// Set Cookie
						Cookies.set('_dn_popup_'+settings.id, settings.id, { expires: settings.display.attr.cookie });

						// Close Btn
						dn_emb.close_btn(_obj, settings);
						
						// Fire showing event 
						if(settings.showing) {
							settings.showing.call(_obj.get(0), settings.id);
						}
					}
				}
			}else{
				// Popup has already been seen. Remove the banner
				$("#_dn_holder_"+settings.hash).remove();
			}

	 	});
	 }









	$.fn.centerMiddle = function(options) {
	  
	  	// Defaults
		var settings = $.extend({
			'parentRelative': window,
			'marginLeft': null, 
			'marginRight':null,
			'marginTop' : null,
			'position' : 'absolute'
		}, options );
	  
	 	return this.each(function(i,el){
		
	   		function crml(){
	   			$(document).ready(function(){
			   		var parent = $(settings.parentRelative);
			   		var parentHeight = $(parent).innerHeight();
			   		var parentWidth = $(parent).innerWidth();
			   
			   		parent.css({
						position : 'relative'
					});
			   
			   		// Clear element margin and padding to calculate actual dimensions
					$(el).css({
						margin : '',
						padding : '',
						display : 'inline-block'
					});
			   
			   		var contentWidth = $(el).outerWidth(); 
			   		var contentHeight = $(el).outerHeight();  
			   
			   		var set_left = (parentWidth - contentWidth - settings.marginLeft - settings.marginRight) / 2;
			   		var set_top = (parentHeight - contentHeight) / 2; 
			   
					return $(el).css({
						'position' : settings.position,
						'left' : set_left,
						'top' : set_top,
						'margin-left' : settings.marginLeft,
						'margin-right' : settings.marginRight,
						'margin-top' : settings.marginTop
					}); 
				});
	   		} crml();
	   		$(win).on('resize scroll', crml);
	 	});
  	};





  	$.fn.adnCountdown = function(options) {
	  
	  	// Defaults
		var settings = $.extend({
			'count': 5,
			'str': 'Close in %s seconds.',
			'change' : null,
			'finish': null
		}, options );


		return this.each(function(i,el){

			setInterval(function() {
				settings.count--;
				if (settings.count >= 0) {
					var str = settings.str.replace('%s',settings.count);
				  	$(el).html(str);
				  	if(settings.change) {
						settings.change.call($(el).get(0));
					}
				}
				// Display 'counter' wherever you want to display it.
				if (settings.count === 0) {
				    //console.log('Timer ended');
				    // Fire finish event 
					if(settings.finish) {
						settings.finish.call($(el).get(0));
					}
				    clearInterval(settings.count);
				}
			}, 1000);
		});

	};


}(jQuery, window));



