(function($, win) {

    window.requestAnimFrame = function(){
		return (
			window.requestAnimationFrame       || 
			window.webkitRequestAnimationFrame || 
			window.mozRequestAnimationFrame    || 
			window.oRequestAnimationFrame      || 
			window.msRequestAnimationFrame     || 
			function( callback){
				window.setTimeout(callback, 1000 / 60);
			}
		);
	}();

	window.cancelAnimFrame = function(){
		return (
			window.cancelAnimationFrame       || 
			window.webkitCancelAnimationFrame || 
			window.mozCancelAnimationFrame    || 
			window.oCancelAnimationFrame      || 
			window.msCancelAnimationFrame     || 
			function(id){
				window.clearTimeout(id);
			}
		);
    }();
    

	var _adng = {

		/**
		 * GET PROPORTION
		*/
		get_proportion(_obj){
				
			var width = _obj.attr('data-size').split('x')[0];
			var height = _obj.attr('data-size').split('x')[1];
			
			var proportion_width = _obj.outerWidth() / width;
			var proportion_height = _obj.outerHeight() / height
			
			//console.log(proportion_width +' '+proportion_height);
			var prop = Math.min(proportion_width, proportion_height);
			
			// Dont allow item to be bigger then original width.
			prop = prop > 1 ? 1 : prop;
			prop = prop > 0 ? prop : 1;
			
			return {
				proportion: prop
			};
        },
        
		/*sizeFix(){
			setTimeout(function() { 
				//console.log('nu');
				$(window).trigger('resize'); 
			}, 500);
		}*/
	};








	/**
	 * Responsive Banners
	 * Used for the banner instaces itself (mostly inside iframe)
	 *
	 * $(".example").adnResponsive({width:null});
	 *
	*/
	$.fn.adnResponsive = function(options) {
	  
	  	// Defaults
		var settings = $.extend({
		  	width: null,
		  	height:null,
		  	animation: null,
			delay: 200,
			callback: function(id){},
			showing: function(id){}, // deprecated
		}, options );
	  
     	return this.each(function(i,el){
			
		 	var _obj = $(el),
				 animation_class = settings.animation !== null ? ' '+settings.animation+' animated' : '';
			
			// Dont resize banners in editor
			if( _obj.parent().hasClass('_dn_editor_stage')){ 
				if(parseInt(_dn_.debug)){ console.log('Banner in editor mode, dont resize it.'); }
				return; 
			}
		 	
		 	//console.log(_obj.outerWidth());
			// Fire when banner enters viewport
			_obj.adnInViewport(function(px){ 
				if(px){
					if(!$(this).hasClass('_dn_visible')){
						$(this).removeClass("_dn_hidden").addClass("_dn_visible"+animation_class);

						if(_obj.hasClass('responsive') && !_obj.hasClass('_fw')){
							_obj._dn_fitParent();
							//setTimeout(function(){ _obj._dn_fitParent() }, 1);
						}

						// Fire when image gets shown
						if(settings.callback) {
							if(parseInt(_dn_.debug)){ console.log('inViewport Callback'); }
							settings.callback.call(_obj.get(0), $(this).data('id'));
						}
						//Deprecated
						if(settings.showing) {
							settings.showing.call(_obj.get(0), $(this).data('id'));
						}
					}
				}
			}, {delay:settings.delay});
			

			if(_obj.hasClass('responsive') && !_obj.hasClass('_fw')){
				if(parseInt(_dn_.debug)){ console.log('responsive'); }
				//_obj._dn_fitParent();
				//setTimeout(function(){ _obj._dn_fitParent() }, 1);
				$(window).on('resize', function(){ _obj._dn_fitParent(); });
			}
    	});
  	};








  	/**
	 * Resize banners to fit parent and keep aspect ratio 
	 * Inspired by: https://github.com/funkhaus/fitToParent
	 *
	 * $(".banner")._dn_fitParent();
	 *
	*/
  	$.fn._dn_fitParent = function(options) {
	  
		// Defaults
		var settings = $.extend({
			'elWidth': null,
			'elHeight': null,
			'heightOffset': 0,
			'widthOffset': 0,
			'upres': false,
			'callback': null
		}, options );

		return this.each(function(i,el){
			
			var _obj = $(el),
				elWidth = _obj.outerWidth(),
				elHeight = _obj.outerHeight(),
				elMaxWidth = _obj.data('size').split('x')[0],
				elMaxHeight = _obj.data('size').split('x')[1],
				ratio = elWidth / elHeight,
				parentWidth = _obj.parent().outerWidth(),
				parentHeight = _obj.parent().outerHeight(),
				stage = {
			        height: parentHeight - settings.heightOffset,
			        width: parentWidth - settings.widthOffset
			    };
			
			//console.log('Look: '+elHeight+' '+parentHeight+' '+stage.height+' '+elMaxHeight+' '+$(window).height());
			// Get lowest value
			if ( !settings.upres ){
		        stage.height = Math.min(stage.height, elMaxHeight, $(window).height());
		        stage.width = Math.min(stage.width, elMaxWidth, $(window).width());
			}
			
			/*console.log('resp fit parent');
			//console.log('window:' +$(window).width());
			console.log('stage:' +stage.width+' '+stage.height);
			console.log('ratio:' +ratio);*/
			

		    var stageAspect = stage.width / stage.height,
		    	newWidth, 
		    	newHeight;
			
		   	if (ratio > stageAspect) {
				newWidth = stage.width;
				newHeight = (newWidth / ratio);
			} else {

				newHeight = stage.height;
				newWidth = newHeight * ratio;
			}
		
			if(!parentHeight || !parentWidth){
				newWidth = elWidth;
				newHeight = elHeight;
			}

		    // Set new size of element (if we have one)
		    if ( _obj ){
		        _obj.css({'width': newWidth});
				_obj.css({'height': newHeight});

				// Scale banner content
				var prop = _adng.get_proportion(_obj);
				_obj.find('._dn_inner').css({'transform': 'translate(0, 0) scale('+prop.proportion+')', 'transform-origin':'0px 0px 0px'});
		    }

		    // Fire callback if provided
		    if (typeof(settings.callback) == 'function') {
		        settings.callback.call(_obj, [newWidth, newHeight])
		    }
		});
	}










  	// Return the visible amount of px
	// of any element currently in viewport.
	// https://stackoverflow.com/a/27462500/3481803
	// http://jsfiddle.net/RokoCB/tw6g2oeu/7/
	/**
	 * $(".example").adnInViewport(function(px){ if(px) $(this).addClass("class"); }, {padding:0, delay:500});
	 *
	*/
  	$.fn.adnInViewport = function(cb, options) {
	  
		// Defaults
		var settings = $.extend({
			padding: 0, // Add delay
			delay: 200,
			force: 0
		}, options );

		return this.each(function(i,el){

			// If not in iframe
			function visPx(){
				
				if(settings.force){
					settings.force = 0; // Only allow force to run once.
					setTimeout(function() { 
						return cb.call(el, 1); 
					}, settings.delay);
					//return cb.call(el, 1);
				}
				
				var H = $(this).height(), // NOT $(el).height() !!
			    	r = el.getBoundingClientRect(), t=r.top+settings.padding, b=r.bottom+settings.padding,
					res = Math.max(0, t>0? H-t : (b<H?b:H));
				
			    if(res !== 0){
			    	setTimeout(function() { 
						return cb.call(el, res); 
					}, settings.delay);
			 		//return cb.call(el, res); 
			 	}
			}
			// @since v1.2.1 - If in iframe
			// https://gist.github.com/tiarno/ec445e2e6c5141cbb893
            function iframePx() {
				
				//if(typeof($(el).data('id')) !== 'undefined' && typeof($(el).data('iframe_id')) !== 'undefined'){
				var ifrId = $(el).data('iframe_id');
				var anchor = '_dn_cnt_'+$(el).data('id');
				
				var ifrOffset = window.parent.document.getElementById(ifrId).offsetTop;
				
				var myloc = document.getElementById(anchor).offsetTop + ifrOffset;
				var viewtop = window.parent.scrollY;
				var viewbot = viewtop + window.parent.innerHeight;
				if (viewbot > myloc && myloc > viewtop){
					setTimeout(function() { 
						return cb.call(el, true);
					}, settings.delay);
				}
				//}
			};
			// @since v1.2.1
			function inIframe() {
				try {
					return window.self !== window.top;
				} catch (e) {
					return true;
				}
			}

			// Two way iframe communication - https://gist.github.com/pbojinov/8965299
			function bindEvent(element, eventName, eventHandler) {
				if (element.addEventListener) {
					element.addEventListener(eventName, eventHandler, false);
				} else if (element.attachEvent) {
					element.attachEvent("on" + eventName, eventHandler);
				}
			}
			
			// If banner gets loaded inside iframe and banner data-id and iframe data-iframe_id is available.
			// ex.: [imgmce_element id="DYJg6q6" user_id="1" iframe_id="_dn725"]
			if( inIframe() && typeof($(el).data('id')) !== 'undefined' ){ // && typeof($(el).data('iframe_id')) !== 'undefined'

				// In case iframe_id data would be available. ( this will most likely never happen but who knows. You can always add it manually :) )
				if( typeof($(el).data('iframe_id')) !== 'undefined' ){
					iframePx();
					$(win.parent).on("resize scroll", iframePx);
				}else{
					// Listen to messages from parent window
					bindEvent(window, "message", function (e) {
						if( typeof e.data.id !== "undefined" ){
							if(parseInt(_dn_.debug)){ console.log("Banner received message from parent: ", e.data); }
							$("._dn_"+$(el).data('id')).data("iframe_id",e.data.id);
							$("._dn_"+$(el).data('id')).attr("data-iframe_id",e.data.id);

							iframePx();
							$(win.parent).on("resize scroll", iframePx);
						}
					});
				}
			}else{
				//visPx();
				setTimeout(function(){ visPx() }, 1);
				$(win).on("resize scroll", visPx);
			}
		});
    };
    





    /**
	 * Animate svg strokes
	 * https://24ways.org/2013/animating-vectors-with-svg/
	*/
	$.fn._dn_animate_stroke = function(options) {

		var settings = $.extend({
			'current_frame': 0,
			'total_frames': 100,
			'sync': 1, 
			'start': null,
			'callback' : null
		}, options );

		settings.speed_arr = [];
		settings.speed_arr[0] = 100;
		settings.speed_key = 0;

		return this.each(function(ix,el){
  
			var path = new Array(),
				length = new Array(),
				handle = 0,
				draws = 0;
			
			if (typeof(settings.start) == 'function') {
				if(parseInt(_dn_.debug)){ console.log('calling start callback...'); }
				settings.start.call($(el), settings);
			}


			if( typeof($(el).data('sync')) !== 'undefined'){
				settings.sync = $(el).data('sync');
			}

			// Animate paths and lines
			$(el).find('path[stroke]').each(function(i, item){
				path[i] = item;
				var l = path[i].getTotalLength();
				length[i] = l;
				path[i].style.strokeDasharray = l + ' ' + l; 
				path[i].style.strokeDashoffset = l;	

				if( typeof($(path[i]).data('speed')) !== 'undefined'){
					settings.speed_arr[i] = $(path[i]).data('speed');
				}
				// example to get a path data-* field
				/*if( typeof(path[i].attributes['data-play']) !== 'undefined'){
					console.log(path[i].attributes['data-play'].value);
			  	}*/
			});
			
			draw();
		  
			function draw(){
				//var progress = settings.current_frame/settings.total_frames;
				var speed = typeof(settings.speed_arr[settings.speed_key]) !== 'undefined' ? settings.speed_arr[settings.speed_key] : settings.total_frames;
				var progress = settings.current_frame/speed;
				
				if (progress > 1) {
					draws++;
					
					if( !settings.sync && draws < path.length ){
						if(parseInt(_dn_.debug)){ console.log('line by line'); }
						settings.current_frame = 0;
						var speed = typeof(settings.speed_arr[settings.speed_key]) !== 'undefined' ? settings.speed_arr[settings.speed_key] : settings.total_frames;
						//progress = settings.current_frame/settings.total_frames;
						progress = settings.current_frame/speed;
						draw();
				  	}else{
						window.cancelAnimFrame(handle);

						if (typeof(settings.callback) == 'function') {
							if(parseInt(_dn_.debug)){ console.log('calling ending callback...'); }
							settings.callback.call($(el), settings);
						}
					}
					
				} else {
					settings.current_frame++;
					if( settings.sync ){
						$.each( path, function( j, val ) {
							path[j].style.strokeDashoffset = Math.floor(length[j] * (1 - progress));
						});
					}else{
						settings.speed_key = draws;
						path[draws].style.strokeDashoffset = Math.floor(length[draws] * (1 - progress));
					}
					handle = window.requestAnimFrame(function(){ draw(); });
				}
			}
		});
	};

}(jQuery, window));





class addToHead {

    constructor(options) {
        this.settings = Object.assign({
            'url': ''
        }, options);
    }
  
    addStyleToHead() {
       //console.log('oi'+this.settings.url);
       if (!jQuery("link[href='"+this.settings.url+"']").length){
		    jQuery('<link />').attr('rel','stylesheet').attr('href',this.settings.url).appendTo("head");
	    }
    }
  
}


/*function _dn_add_style_to_head( url ){
	if (!jQuery("link[href='"+url+"']").length){
		jQuery('<link />').attr('rel','stylesheet').attr('href',url).appendTo("head");
	}
}*/
function _dn_add_script_to_head( url){
	if (!jQuery('head > script[src="'+url+'"]').length) {
		jQuery('<script />').attr('src',url).appendTo('head');
	}
}
// https://stackoverflow.com/questions/11803215/how-to-include-multiple-js-files-using-jquery-getscript-method
function _dn_get_scripts(scripts, callback) {
    var progress = 0;

	if( scripts ){
      	var am_js = typeof(scripts.js) !== 'undefined' ? scripts.js.length : 0,
          	am_css = typeof(scripts.css) !== 'undefined' ? scripts.css.length : 0,
			am_scripts = am_js+am_css;
     
      	jQuery.each( scripts, function( key, type ){
			//console.log(type);
        	if(key === 'css'){
				jQuery.each( type, function( k, file ){

                    file = file.replace('{INC_DIR}', _dn_.inc_dir_base);

					if (!jQuery("link[href='"+file+"']").length){
						jQuery.getStylesheet(file, function () {
							//console.log(file);
							if (++progress == am_scripts){ if(typeof(callback) === 'function'){ callback()}; }
						});
					}else{
						if (++progress == am_scripts){ if(typeof(callback) === 'function'){ callback()}; }
					}
				});
			}else{
				jQuery.each( type, function( s, script ){

                    script = script.replace('{INC_DIR}', _dn_.inc_dir_base);
                    
					if (!jQuery('head > script[src="'+script+'"]').length) {
                        jQuery.getScript(script)
                            .done(function() {
                                if(parseInt(_dn_.debug)){console.log(script);}
                                _dn_add_script_to_head( script );
                                if (++progress == am_scripts){ if(typeof(callback) === 'function'){ callback()}; }
                            })
                            .fail(function() {
                                if(parseInt(_dn_.debug)){console.log('Fail '+script);}

                                if(arguments[0].readyState==0){
                                    //script failed to load
                                    if(parseInt(_dn_.debug)){console.log('script Failed to load: '+script);}
                                }else{
                                    //script loaded but failed to parse
                                    if(parseInt(_dn_.debug)){console.log(arguments[2].toString());}
                                }
						}); 
					}else{
						if (++progress == am_scripts){ if(typeof(callback) === 'function'){ callback()}; }
					}
				});
			}
		});
	}
}


module.exports = { 
	//_dn_add_style_to_head,
	addToHead,
	_dn_add_script_to_head, 
	_dn_get_scripts 
};





jQuery.getStylesheet = function (href, callback) {
    var $d = jQuery.Deferred();
    var $link = jQuery('<link/>', {
       rel: 'stylesheet',
       type: 'text/css',
       href: href
    }).appendTo('head');
	$d.resolve($link);
	
	callback();
    //return $d.promise();
};








// @sincs v1.1.8 no longer used.
/*class _dn_Animations {

    constructor(el, options){
        this.$obj = jQuery(el);
        this.settings = Object.assign({
            
        }, options);
    }
  
  	bounce_animation(ele, options, callback){
    
        var i = 0;
        var damping = 0.8;

        bounce(i);

        function bounce_complete(time){
            if( time < (options.times-1) ){
                bounce(time+1);
            }else{
                if( typeof(callback) === 'function'){
                    //console.log('bouncing finished');
                    callback.call(jQuery(this));
                }
            }
        }
        
        function bounce(i){
            var amt = Math.pow(-1, i) * options.distance / (i * damping);
           
            if( options.direction == "top"){
                ele.animate({
                top: "-=" + amt
                }, options.speed).animate({
                top: "+=" + amt,
                }, options.speed, function(){bounce_complete(i);});
            }else if(options.direction == "bottom"){
                ele.animate({
                top: "+=" + amt
                }, options.speed).animate({
                top: "-=" + amt,
                }, options.speed, function(){bounce_complete(i);});
            }else if(options.direction == "right"){
                ele.animate({
                left: "+=" + amt
                }, options.speed).animate({
                left: "-=" + amt
                }, options.speed, function(){bounce_complete(i);});
            }else{
                ele.animate({
                left: "-=" + amt
                }, options.speed).animate({
                left: "+=" + amt
                }, options.speed, function(){bounce_complete(i);});
            }
        }
    }
};
*/





/*
jQuery-Rotate-Plugin v0.2 by anatol.at
http://jsfiddle.net/Anatol/T6kDR/
*/
jQuery.fn.rotate=function(options) {
    var $ = jQuery;
    var $this=$(this), prefixes, opts, wait4css=0;
    prefixes=['-Webkit-', '-Moz-', '-O-', '-ms-', ''];
    opts=$.extend({
      startDeg: false,
      endDeg: 360,
      duration: 1000,
      count: 1,
      easing: 'linear',
      animate: {},
      forceJS: false
    }, options);

    opts.duration = opts.duration/1000;
  
    function supports(prop) {
      var can=false, style=document.createElement('div').style;
      $.each(prefixes, function(i, prefix) {
        if (style[prefix.replace(/\-/g, '')+prop]==='') {
          can=true;
        }
      });
      return can;
    }
  
    function prefixed(prop, value) {
      var css={};
      if (!supports.transform) {
        return css;
      }
      $.each(prefixes, function(i, prefix) {
        css[prefix.toLowerCase()+prop]=value || '';
      });
      return css;
    }
  
    function generateFilter(deg) {
      var rot, cos, sin, matrix;
      if (supports.transform) {
        return '';
      }
      rot=deg>=0 ? Math.PI*deg/180 : Math.PI*(360+deg)/180;
      cos=Math.cos(rot);
      sin=Math.sin(rot);
      matrix='M11='+cos+',M12='+(-sin)+',M21='+sin+',M22='+cos+',SizingMethod="auto expand"';
      return 'progid:DXImageTransform.Microsoft.Matrix('+matrix+')';
    }
  
    supports.transform=supports('Transform');
    supports.transition=supports('Transition');
  
    opts.endDeg*=opts.count;
    opts.duration*=opts.count;
  
    if (supports.transition && !opts.forceJS) { // CSS-Transition
      if ((/Firefox/).test(navigator.userAgent)) {
        wait4css=(!options||!options.animate)&&(opts.startDeg===false||opts.startDeg>=0)?0:25;
      }
      $this.queue(function(next) {
        if (opts.startDeg!==false) {
          $this.css(prefixed('transform', 'rotate('+opts.startDeg+'deg)'));
        }
        setTimeout(function() {
          $this
            .css(prefixed('transition', 'all '+opts.duration+'s '+opts.easing))
            .css(prefixed('transform', 'rotate('+opts.endDeg+'deg)'))
            .css(opts.animate);
        }, wait4css);
  
        setTimeout(function() {
          $this.css(prefixed('transition'));
          if (!opts.persist) {
            $this.css(prefixed('transform'));
          }
          next();
        }, (opts.duration*1000)-wait4css);
      });
  
    } else { // JavaScript-Animation + filter
      if (opts.startDeg===false) {
        opts.startDeg=$this.data('rotated') || 0;
      }
      opts.animate.perc=100;
  
      $this.animate(opts.animate, {
        duration: opts.duration*1000,
        easing: $.easing[opts.easing] ? opts.easing : '',
        step: function(perc, fx) {
          var deg;
          if (fx.prop==='perc') {
            deg=opts.startDeg+(opts.endDeg-opts.startDeg)*perc/100;
            $this
              .css(prefixed('transform', 'rotate('+deg+'deg)'))
              .css('filter', generateFilter(deg));
          }
        },
        complete: function() {
          if (opts.persist) {
            while (opts.endDeg>=360) {
              opts.endDeg-=360;
            }
          } else {
            opts.endDeg=0;
            $this.css(prefixed('transform'));
          }
          $this.css('perc', 0).data('rotated', opts.endDeg);
        }
      });
    }
  
    return $this;
};