<?php
if ( !defined('IMGMCE_ABSPATH') )
    define('IMGMCE_ABSPATH', dirname(__FILE__) . '/');

require_once(IMGMCE_ABSPATH.'config.php');



// base directory path
$base_dir = __DIR__;
// /Applications/XAMPP/xamppfiles/htdocs/wordpress/wp-content/plugins/imgmce/include/extensions/imgmce

// server protocol
$protocol = empty($_SERVER['HTTPS']) ? 'http' : 'https';

// domain name
$domain = $_SERVER['SERVER_NAME'];
// localhost

// document root path
$doc_root = preg_replace("!${_SERVER['SCRIPT_NAME']}$!", '', $_SERVER['SCRIPT_FILENAME']);
// /Applications/XAMPP/xamppfiles/htdocs

// base url
$base_url = preg_replace("!^${doc_root}!", '', $base_dir);
// /wordpress/wp-content/plugins/imgmce/include/extensions/imgmce

// server port
$port = $_SERVER['SERVER_PORT'];
$disp_port = ($protocol == 'http' && $port == 80 || $protocol == 'https' && $port == 443) ? '' : ":$port";

// put em all together to get the complete base URL
$url = "${protocol}://${domain}${disp_port}${base_url}";
// http://localhost/wordpress/wp-content/plugins/imgmce/include/extensions/imgmce


$root_url = (!empty($_SERVER['HTTPS']) ? 'https' : 'http') . '://' . $_SERVER['HTTP_HOST'];
$root_path = realpath( $_SERVER['DOCUMENT_ROOT'] );


require_once(IMGMCE_ABSPATH.'/include/dir/TF_Hook_Functions.php');
require_once(IMGMCE_ABSPATH.'/include/dir/TF_Shortcode_Functions.php');
require_once(IMGMCE_ABSPATH.'/include/dir/TF_Formatting_Functions.php');

require_once(IMGMCE_ABSPATH.'imgMCE_Init.php');
ImgMCE::Init(array(
    'version' => '1',
    'imgmce_dir' => IMGMCE_ABSPATH,
    'imgmce_url' => $url.'/',
    'upload_dir' => $root_path.'/'.$upload_dir,
    'upload_url' => $root_url.'/'.$upload_dir,
    'siteurl' => $root_url.'/'.$main_path,
    'current_user_id' => 0,
    'ajaxurl' => $url.'/imgmce-ajax.php'
));


// Check for custom functions file in website root folder.
if( file_exists($root_path.'/'.$main_path.'imgmce_functions.php'))
{
    require_once($root_path.'/'.$main_path.'imgmce_functions.php');
}
?>