<?php
/*
 * AJAX REQUEST FUNCTIONS
 *
 * http://codex.wordpress.org/AJAX_in_Plugins
 * For not logged-in users use: add_action('wp_ajax_nopriv_my_action', 'my_action_callback');
*/
// Exit if accessed directly
if( !defined("IMC_VERSION")) exit;
if ( ! class_exists( 'ADN_Ajax' ) ) :

class ADN_Ajax {

	public function __construct() {
		
		$_dn_ajax_actions = array(
			//'save_draft_banners', 
			'load_banner', 
			'load_banner_js', 
			'check_banner_draft', 
			'_dn_save_banner', 
			'remove_folder', 
			'add_layer_to_banner',
			'duplicate_layer',
			'remove_layer',
			'save_as_template',
			'load_template',
			'editor_load_templates',
			'use_banner_template',
			'update_embed_code',
			'search_stock_images',
			'load_start_screen_template',
			'load_my_images_template',
			'export_folder',
			'export_as_html5',
			'debug'
		);


		foreach($_dn_ajax_actions as $ajax_action)
		{
			add_action( 'wp_ajax_' . $ajax_action, array(__CLASS__, str_replace( '-', '_', $ajax_action )));
			add_action( 'wp_ajax_nopriv_' . $ajax_action, array(__CLASS__, str_replace( '-', '_', $ajax_action )));
		}
	}



	public static function debug()
	{
		echo json_encode( array('debug' => 1));
		exit;
	}
	


	


	/**
	 * Remove draft banner
	*/
	public static function check_banner_draft()
	{
		/*$id = $_POST['id'];
		$status = ADN_DB::get_results(array('sql' => 'SELECT status FROM '.ADN_DB::$wpdb->prefix.'adning_banners WHERE id = '.$id));
		$status = $status[0]['status'];

		if( $status == 'draft')
		{
			ADN_DB::$wpdb->query("DELETE FROM ".ADN_DB::$wpdb->prefix."adning_banners WHERE id = ".$id.";");
		}*/
		exit;
	}




	/**
	 * LOAD BANNER TEMPLATE into editor
	*/
	public static function load_banner()
	{
		// *Important, Set decoding right
		ADN_Settings::magic_quotes();

		$id = isset($_POST['id']) ? $_POST['id'] : 0;
		$user_id = isset($_POST['user_id']) ? $_POST['user_id'] : 0;
		$banner_obj = isset($_POST['banner_obj']) ? json_decode(stripslashes($_POST['banner_obj']), true) : array();
		$slide_nr = isset($_POST['slide']) ? $_POST['slide'] : 0;
		$args = !empty($_POST['args']) ? json_decode(stripslashes($_POST['args']), true) : array();
		$debug = !empty($_POST['debug']) ? $_POST['debug'] : 0;
		$defaults = array(
			'add_url' => 0,
			'load_banner_script' => 0,
			'adjust_id' => '',
			'load_external' => 0,
			'debug' => $debug
		);
		$args = ADN_Main::parse_args($args, $defaults);
		
		// Load banner_obj json directly from user_uploads folder 
		// if ID and USER_ID are available and BANNER_OBJ is EMPTY.
		if( empty($banner_obj) && !empty($id) && !empty($user_id))
		{
			$file = IMC_UPLOAD_DIR.'user_uploads/{UID}/{ID}/imgmce.json';
			$file = ADN_Main::str_replace(array(
                'replace' => array(
                    array('{UID}' => $user_id), 
                    array('{ID}' => $id), 
                ), 
                'string' => $file
            ));
			$json = ADN_Main::get_content(array('path' => $file));
			$banner_obj = json_decode(stripslashes($json), true);
			$banner_obj = empty($banner_obj) ? json_decode($json, true) : $banner_obj;
		}

		$banner_template = ADN_Templates::banner_tpl($banner_obj, $args);
		$timeline_template = ADN_Templates::timeline_tpl($banner_obj['slides']);
		$timeline = ADN_Editor_TPL::timeline($banner_obj['slides'][$slide_nr]);
		
		echo json_encode(array('banner_obj' => $banner_obj, 'id' => $id, 'template' => $banner_template, 'timeline' => $timeline_template, 'timeline_' => $timeline));
		
		exit;
	}







	public static function _dn_save_banner()
	{
		// *Important, Set decoding right
		ADN_Settings::magic_quotes();

		$title = isset($_POST['title']) ? $_POST['title'] : '';
		$editor = isset($_POST['editor']) ? json_decode(stripslashes($_POST['editor']), true) : array();
		$banner_obj = isset($_POST['banner_obj']) ? json_decode(stripslashes($_POST['banner_obj']), true) : array();
		$new_id = isset($_POST['new_id']) ? $_POST['new_id'] : $banner_obj['id'];
		$saved_json = '';
		$path = '';
		
		if( !empty($banner_obj['upload']) && $editor['save_to_folder'])
		{
			$path = ADN_Main::create_url_from_structure(
				$editor['upload']['structure'],
				array(
					'dir' => $editor['upload']['dir'], 
					'folder' => $editor['upload']['folder'], 
					'uid' => $banner_obj['user_id'], 
					'id' => $new_id
				)
			);

			// Check if image needs to get saved to an other diretory, if so copy entire folder (used for saving as template)
			if($banner_obj['upload']['folder'] !== $editor['upload']['folder'] ) 
			{
				$parent_url = ADN_Main::create_url_from_structure($banner_obj['upload']['structure'], array('uid' => $banner_obj['user_id'], 'dir' => $banner_obj['upload']['dir'], 'folder' => $banner_obj['upload']['folder'], 'id' => banner_obj['id']));
				$new_url = ADN_Main::create_url_from_structure($editor['upload']['structure'], array('uid' => ImgMCE::$current_user_id, 'dir' => $editor['upload']['dir'], 'folder' => $editor['upload']['folder'], 'id' => $new_id));
				$copy_result = ADN_Main::recurse_copy($parent_url, $new_url);

				// Set new banner_obj settings 
				$banner_obj['id'] = $new_id;
				$banner_obj['user_id'] = ImgMCE::$current_user_id;
				$banner_obj['upload'] = $editor['upload'];
			}

			$saved_json = ADN_Main::save_file_to_folder(array('path' => $path, 'content' => json_encode($banner_obj, JSON_FORCE_OBJECT)));
		}

		$banner_template = ADN_Templates::banner_tpl($banner_obj);

		echo json_encode(array('banner_obj' => $banner_obj, 'editor' => $editor, 'banner_template' => $banner_template, 'path' => $path, 'save_to_folder' => $editor['save_to_folder'], 'saved_json' => $saved_json)); // 'banner_settings' => $banner_settings, 'slides' => $banner_obj['slides']
		exit;
	}




	public static function remove_folder()
	{
		$id = isset($_POST['id']) ? $_POST['id'] : 0;
		$upload = isset($_POST['upload']) ? json_decode(stripslashes($_POST['upload']), true) : array();

		$res = ADN_Main::delete_dir($upload['upload_dir'].$upload['upload_folder']);

		echo json_encode($res);
		exit;
	}




	public static function export_folder()
	{
		$id = $_POST['id'];
		$upload = json_decode(stripslashes($_POST['upload']), true);

		// upload (array) (needs dir, src, folder) / id
		//$res = ADN_Main::Zip(array('upload' => $upload, 'id' => $id, 'delete_zips_in_folder' => 1));
		$res = ADN_Main::zipDir(array('upload' => $upload, 'id' => $id, 'delete_zips_in_folder' => 1));
		echo json_encode($res);
		exit;
	}




	public static function export_as_html5()
	{
		$id = $_POST['id'];
		$banner_obj = isset($_POST['banner_obj']) ? json_decode(stripslashes($_POST['banner_obj']), true) : array();
		//$banner_tpl = isset($_POST['banner_tpl']) ? $_POST['banner_tpl'] : '';
		$upload = json_decode(stripslashes($_POST['upload']), true);
		$path = $upload['dir'].$upload['folder'].$id.'/';
		$error = '';

		$zipped = ADN_Main::zipDir(array('upload' => $upload, 'id' => $id, 'delete_zips_in_folder' => 1));

		// Add files to zipped folder
		if( $zipped['zipped'])
		{
			$banner_tpl = ADN_Templates::banner_tpl($banner_obj, array('html5_export' => 1));
			$plugin_scripts = ADN_MAin::return_plugin_scripts(array('banner_obj' => $banner_obj));
			
			$zip = new ZipArchive;
			if ($zip->open($zipped['path']) === TRUE) {
				/*$zip->addFile(IMC_ASSETS_DIR.'/css/dist/imgmce_image.min.css', $id.'/assets/css/imgmce_image.min.css');
				$zip->addFile(IMC_ASSETS_DIR.'/js/dist/imgmce_image.min.js', $id.'/assets/js/imgmce_image.min.js');
				$zip->addFile(IMC_INC_DIR.'/files/imgmce_animations.css', $id.'/assets/css/imgmce_animations.css');
				*/
				$zip->addFile(IMC_ASSETS_DIR.'dist/_imc.bundle.js.css', $id.'/assets/dist/_imc.bundle.js.css');
				$zip->addFile(IMC_ASSETS_DIR.'dist/_imc.bundle.js', $id.'/assets/dist/_imc.bundle.js');

				// Add plugin scripts
				$add_to_head = '';
				if( !empty($plugin_scripts))
				{
					foreach($plugin_scripts as $ps => $plugin)
					{
						foreach($plugin as $plugin_script)
						{	
							$script = str_replace('{INC_DIR}', IMC_INC_DIR, $plugin_script);
							$new = str_replace('{INC_DIR}', 'assets/', $plugin_script);
							$zip->addFile($script, $id.'/'.$new);

							// Get code to add to head
							// We add this code to head here because otherwise if loaded localy (file://) jQuery cannot add the files to the head itself.
							$ext = pathinfo($new, PATHINFO_EXTENSION);	
							$add_to_head.= $ext == 'css' ? '<link href="'.$new.'" rel="stylesheet" type="text/css" media="screen" />' : '<script type="text/javascript" src="'.$new.'"></script>';
						}
					}
				}

				// Create and Add index.html || NOTE: this may not work on localhost installs. It seems to work online but index.html is not added when requested from an offline server...
				$saved_html = ADN_Main::save_file_to_folder(array(
					'path' => $path, 
					'filename' => 'index.html', 
					'content' => ADN_Templates::html_template(array('head' => $add_to_head, 'banner_tpl' => $banner_tpl))
				));
				$zip->addFile($path.'index.html', $id.'/index.html');

				$zip->close();
			} else {
				$error = 'failed adding to zip.';
			}
		}

		// Create folders
		/*if(!is_dir($path.'assets')) {
		    mkdir($path.'assets', 0777, true);
		}
		if(!is_dir($path.'assets/js')) {
		    mkdir($path.'assets/js', 0777, true);
		}
		if(!is_dir($path.'assets/css')) {
		    mkdir($path.'assets/css', 0777, true);
		}
		// Copy files
		copy(IMC_ASSETS_URL.'/css/dist/imgmce_image.min.css', $path.'assets/css/imgmce_image.min.css');
		copy(IMC_ASSETS_URL.'/js/dist/imgmce_image.min.js', $path.'assets/js/imgmce_image.min.js');
		*/
		
		unlink($path.'index.html');

		echo json_encode(array('error' => $error, 'zipped' => $zipped, 'plugin_scripts' => $plugin_scripts, 'banner_obj' => $banner_obj, 'banner_tpl' => $banner_tpl, 'upload' => $upload));
		exit;
	}



	public static function add_layer_to_banner()
	{
		// *Important, Set decoding right
		ADN_Settings::magic_quotes();

		$banner_obj = isset($_POST['banner_obj']) ? json_decode(stripslashes($_POST['banner_obj']), true) : array();
		$editor = isset($_POST['editor']) ? json_decode(stripslashes($_POST['editor']), true) : array();
		$layer_json = isset($_POST['layer_json']) ? json_decode(stripslashes($_POST['layer_json']), true) : '';
		$content = isset($_POST['content']) ? $_POST['content'] : '';
		$aspect_ratio = isset($_POST['aspect_ratio']) ? $_POST['aspect_ratio'] : 0;
		$resize_handles = isset($_POST['resize_handles']) ? $_POST['resize_handles'] : '';
		$size = isset($_POST['size']) ? $_POST['size'] : '100x100';
		$size = explode('x', $size);
		$type = isset($_POST['type']) ? $_POST['type'] : '';
		$slide_nr = isset($_POST['slide_nr']) ? $_POST['slide_nr'] : 0;
		$obj_id = isset($_POST['obj_id']) ? $_POST['obj_id'] : '';
		$layer_class = ADN_Main::getToken();

		// Make sure "slide_id" and "slide_order" are defined (for size screen uploads.) 
		$banner_obj['slides'][$slide_nr] = ADN_Main::parse_args($banner_obj['slides'][$slide_nr], array('slide_id' => $slide_nr, 'slide_order' => $slide_nr));

		
		if( empty($layer_json))
		{
			$new_layer = array(
				'type' => $type, 
				'obj_id' => $obj_id,
				'class' => $layer_class,
				'aspect_ratio' => $aspect_ratio,
				'resize_handles' => $resize_handles
			);

			// Add new layer to banner_obj
			$banner_obj['slides'][$slide_nr]['layers'][] = $new_layer;

			// Get latest layer nr
			end($banner_obj['slides'][$slide_nr]['layers']);
			$layer_nr = key($banner_obj['slides'][$slide_nr]['layers']);
			if($type == 'image')
			{
				$new_layer['aspect_ratio'] = 1;
				$new_layer['css'] = array('layer' => array('z-index' => $layer_nr, 'width' => $banner_obj['size']['w']/2));
			}
			else
			{
				$new_layer['css'] = array('layer' => array('z-index' => $layer_nr));
			}

			if($type == 'image')
			{
				$use = isset($_POST['use']) ? $_POST['use'] : '';
				//$upload = isset($_POST['upload']) ? json_decode(stripslashes($_POST['upload']), true) : array();
				if( $use == 'path')
				{
					$folder_structure = str_replace('{DIR}/', '', $editor['upload']['structure']);
					$path = ADN_Main::create_url_from_structure(
						$folder_structure,
						array(
							'dir' => $editor['upload']['dir'], 
							'folder' => $editor['upload']['folder'], 
							'uid' => $banner_obj['user_id'], 
							'id' => $banner_obj['id']
						)
					);
					

					if(!is_dir($path.'images')) {
						mkdir($path.'images', 0777, true);
					}

					// Add more settings to the $new_layer array.
					$new_layer['content'] = basename($content);
					$new_layer['folder'] = $path;
					$new_layer['upload'] = $editor['upload'];
				}
				else
				{
					$new_layer['content'] = $content;
					$new_layer['folder'] = '';
					$new_layer['upload'] = '';
				}
			}
			else
			{
				if($type == 'shape')
				{
					$shape_type = isset($_POST['shape_type']) ? $_POST['shape_type'] : '';
					if($shape_type == 'html') // || $shape_type == 'sticker'
					{
						//$obj_id = isset($_POST['obj_id']) ? $_POST['obj_id'] : 0;
						$group_id = isset($_POST['group_id']) ? $_POST['group_id'] : 0;
					
						$shape = ADN_Main::html_shapes(array('key' => $obj_id));
						$new_layer['content'] = urlencode($shape['html']);
					}
					else
					{
						//$new_layer['aspect_ratio'] = 1;
						$new_layer['content'] = urlencode(stripslashes($content));
					}
				}
				elseif($type == 'element')
				{
					$element_type = isset($_POST['element_type']) ? $_POST['element_type'] : '';
					$new_layer['element_type'] = $element_type;
					if($element_type == 'html')
					{
						$group_id = isset($_POST['group_id']) ? $_POST['group_id'] : 0;
					
						$element = ADN_Main::html_elements(array('type' => 'html', 'key' => $obj_id));
						$new_layer['obj_params'] = $element['params'];
						$new_layer['content'] = urlencode($element['html']);
					}
					elseif($element_type == 'video')
					{
						$group_id = isset($_POST['group_id']) ? $_POST['group_id'] : 0;
					
						$element = ADN_Main::html_elements(array('type' => 'video', 'key' => $obj_id));
						$new_layer['obj_params'] = $element['params'];
						$new_layer['content'] = urlencode($element['html']);
					}
					else
					{
						$new_layer['content'] = urlencode(stripslashes($content));
					}
				}
				elseif($type == 'text')
				{
					$new_layer['content'] = urlencode(stripslashes($content));

					preg_match('/_dn_text\">(.*?)</s', stripslashes($content), $text_matches, PREG_OFFSET_CAPTURE);
					$new_layer['text'] = urlencode($text_matches[1][0]);
				}
				else
				{
					$new_layer['content'] = $content;
				}
				
				$new_layer['css']['layer'] = ADN_Main::parse_args(array('width' => $size[0], 'height' => $size[1], 'top' => 0, 'left' => 0), $new_layer['css']['layer']);
			}
		}
		else
		{
			// add new unique class to the layer
			$new_layer = $layer_json['layer'];
			$new_layer['class'] = $layer_class;
			$layer_nr = 0;
			
			// get layer number
			if( array_key_exists('layers', $banner_obj['slides'][$slide_nr]))
			{
				end($banner_obj['slides'][$slide_nr]['layers']);
				$layer_nr = key($banner_obj['slides'][$slide_nr]['layers'])+1;
			}
			$new_layer['css']['layer']['z-index'] = $layer_nr; // set new z-index

			$external = array_key_exists('external', $layer_json) ? $layer_json['external'] : array();
			if( !empty($external))
			{
				$banner_obj = ADN_Main::parse_args($banner_obj, array('external' => $external));
			}
			
			// Add new layer to banner_obj
			$banner_obj['slides'][$slide_nr]['layers'][] = $new_layer;
		}

		
		// Create layer
		$layer_html = ADN_Banner::create_layer($new_layer, $layer_nr, $banner_obj);
		$html = $layer_html['html'];

		// Create timeline item
		$timeline_item = ADN_Templates::timeline_layer(ADN_Main::parse_args(array('layer_nr' => $layer_nr), $new_layer));
		$timeline = ADN_Templates::timeline_layers(ADN_Main::parse_args(array('layer_nr' => $layer_nr), $new_layer));

		// Update banner_obj with latest CSS value.
		$banner_obj['slides'][$slide_nr]['layers'][$layer_nr] = $new_layer;
		
		echo json_encode(array('layer_nr' => $layer_nr, 'content' => stripslashes($content), 'banner_obj' => $banner_obj, 'html' => $html, 'timeline_item' => $timeline_item, 'timeline' => $timeline));
		exit;
	}




	public static function load_banner_js()
	{
		// *Important, Set decoding right
		ADN_Settings::magic_quotes();

		$id = $_POST['id'];
		$func = isset($_POST['function_name']) ? $_POST['function_name'] : '';
		$selector = isset($_POST['selector']) ? $_POST['selector'] : '';
		$banner_obj = json_decode(stripslashes($_POST['banner_obj']), true);

		$banner_js = ADN_Templates::banner_content($banner_obj, $id, array('only_js' => 1, 'function_name' => $func, 'selector' => $selector));
		$banner_js = $banner_js['js'].$banner_js['external'];
		
		echo json_encode(array('banner_js' => $banner_js));
		exit;
	}





	public static function duplicate_layer()
	{
		// *Important, Set decoding right
		ADN_Settings::magic_quotes();

		$layer_obj = json_decode(stripslashes($_POST['layer_obj']), true);
		$banner_obj = json_decode(stripslashes($_POST['banner_obj']), true);
		$slide_nr = $_POST['slide_nr'];

		// Give layer unique class
		$layer_obj['class'] = ADN_Main::getToken();

		// Add new layer to banner_obj
		$banner_obj['slides'][$slide_nr]['layers'][] = $layer_obj;

		// Get latest layer nr
		end($banner_obj['slides'][$slide_nr]['layers']);
		$layer_nr = key($banner_obj['slides'][$slide_nr]['layers']);

		// Create layer
		$layer_html = ADN_Banner::create_layer($layer_obj, $layer_nr, $banner_obj);
		$html = $layer_html['html'];

		// Create timeline item
		$timeline_item = ADN_Templates::timeline_layer(ADN_Main::parse_args(array('layer_nr' => $layer_nr), $layer_obj));
		$timeline = ADN_Templates::timeline_layers(ADN_Main::parse_args(array('layer_nr' => $layer_nr), $layer_obj));

		// Update banner_obj with latest CSS value.
		$banner_obj['slides'][$slide_nr]['layers'][$layer_nr] = $layer_obj;

		echo json_encode(array('layer_nr' => $layer_nr, 'banner_obj' => $banner_obj, 'layer_obj' => $layer_obj, 'html' => $html, 'timeline_item' => $timeline_item, 'timeline' => $timeline));
		exit;
	}


	




	/**
	 * REMOVE LAYER
	*/
	public static function remove_layer()
	{
		// *Important, Set decoding right
		ADN_Settings::magic_quotes();

		$banner_obj = json_decode(stripslashes($_POST['banner_obj']), true);
		$id = $_POST['id'];
		$layer_nr = $_POST['layer_nr'];
		$slide_nr = $_POST['slide_nr'];

		$layer = $banner_obj['slides'][$slide_nr]['layers'][$layer_nr];
		unset($banner_obj['slides'][$slide_nr]['layers'][$layer_nr]);


		// IF LAYER IS IMAGE
		if($layer['type'] == 'image' && !empty($layer['folder']))
		{
			$upload_dir = IMC_UPLOAD_DIR;
			$banner_folder = $layer['folder'];
			$image = $layer['content'];

			$path = $upload_dir.'/'.$banner_folder.$image;
			if (file_exists($path))
			{
				unlink($path);
			}

			// Check for any other unused images in this folder and delete them if found.
			// 1. Create array with all filenames.
			$used_files = array();
			if(!empty($banner_obj['slides'][$slide_nr]['layers']))
			{
				foreach ($banner_obj['slides'][$slide_nr]['layers'] as $key => $layer) 
				{
					if($layer['type'] == 'image')
					{
						$used_files[] = $layer['name'];
					}
				}
			}
			// 2. Loop true all files in banner folder and check if it exists in the used_files array. If not remove it. 
			if(is_dir($upload_dir.'/'.$banner_folder)) 
			{
				// Find all files in folder
				$files = glob($upload_dir.'/'.$banner_folder."*.*");
				for ($i=0; $i<count($files); $i++)
				{
					// File is not used, Remove it.
					if( !in_array(basename($files[$i]), $used_files))
					{
						unlink($files[$i]);
					}
				}
			}
		}
		// end if layer is image


		// Save banner
		ADN_Banner::save_banner(array('id' => $id, 'banner_obj' => $banner_obj));
		

		echo json_encode(array('banner_obj' => $banner_obj));
		exit;
	}



	/**
	 * SAVE as a Template
	*/
	public static function save_as_template()
	{
		// *Important, Set decoding right
		ADN_Settings::magic_quotes();

		$upload = json_decode(stripslashes($_POST['upload']), true);
		$banner_obj = json_decode(stripslashes($_POST['banner_obj']), true);
		$tpl_path = $upload['upload_path'].$upload['upload_folder'].$banner_obj['id'].'/';

		ADN_Main::save_file_to_folder(array('path' => $tpl_path, 'content' => json_encode($banner_obj)));

		echo json_encode(array('tst' => $upload));
		exit;
	}


	/**
	 * LOAD predefined banner Template
	*/
	public static function load_template()
	{
		$args = array();
		$defaults = array(
			'add_url' => 0,
			'load_banner_script' => 0,
			'load_external' => 0
		);
		$args = ADN_Main::parse_args($args, $defaults);

		$id = isset($_POST['id']) ? $_POST['id'] : 0;
		$new_id = isset($_POST['new_id']) ? $_POST['new_id'] : 0;
		$editor = isset($_POST['editor']) ? json_decode(stripslashes($_POST['editor']), true) : array();
		$banner_obj = '';
		$saved_json = '';

		/*$template = ADN_Templates::predefined_templates($id);
		if( !empty($template) )
		{
			$json = ADN_Main::spacefix($template['json']);
			$banner_obj = json_decode( stripslashes($json),true);
			$banner_obj = empty($banner_obj) ? json_decode($json,true) : $banner_obj; // fix, in some cases stripslashes does not work.
			$banner_obj['id'] = $new_id;
			$banner_template = ADN_Templates::banner_tpl($banner_obj, $args);
			$timeline_template = ADN_Templates::timeline_tpl($banner_obj['slides']);
			echo json_encode(array('json' => $json, 'banner_obj' => $banner_obj, 'template' => $banner_template, 'timeline' => $timeline_template));
		}
		else
		{
			echo json_encode(array('error' => __('No template data found.','imc')));
		}*/

		if(file_exists(IMC_UPLOAD_DIR.'resources/templates/'.$id))
		{
			$json = ADN_Main::get_content(array('path' => IMC_UPLOAD_DIR.'resources/templates/'.$id.'/imgmce.json', 'spacefix' => 1));

			$banner_obj = json_decode(stripslashes($json),true);
			$banner_obj = empty($banner_obj) ? json_decode($json,true) : $banner_obj; // fix, in some cases stripslashes does not work.
			
			// Copy folder to user_uploads
			if( $editor['save_to_folder'])
			{
				$parent_url = ADN_Main::create_url_from_structure($banner_obj['upload']['structure'], array('uid' => $banner_obj['user_id'], 'dir' => $banner_obj['upload']['dir'], 'folder' => $banner_obj['upload']['folder'], 'id' => $id));
				$new_url = ADN_Main::create_url_from_structure('{DIR}/{FOLDER}/{UID}/{ID}', array('uid' => ImgMCE::$current_user_id, 'dir' => IMC_UPLOAD_DIR, 'folder' => 'user_uploads/', 'id' => $new_id));
				$copy_result = ADN_Main::recurse_copy($parent_url, $new_url);

				// Set new banner_obj settings 
				$banner_obj['id'] = $new_id;
				$banner_obj['user_id'] = ImgMCE::$current_user_id;
				$banner_obj['upload']['structure'] = '{DIR}/{FOLDER}/{UID}/{ID}';
				$banner_obj['upload']['folder'] = 'user_uploads/';

				// Save new json data to folder
				$saved_json = ADN_Main::save_file_to_folder(array('path' => $new_url, 'content' => json_encode($banner_obj)));
			}

			$banner_template = ADN_Templates::banner_tpl($banner_obj, $args);
			$timeline_template = ADN_Templates::timeline_tpl($banner_obj['slides']);
			echo json_encode(array('json' => $json, 'banner_obj' => $banner_obj, 'template' => $banner_template, 'timeline' => $timeline_template, 'saved_json' => $saved_json));
		}
		else
		{
			echo json_encode(array('error' => __('No template data found.','imc')));
		}
		exit;
	}


	/**
	 * Load banner templates for editor menu
	*/
	public static function editor_load_templates()
	{
		// *Important, Set decoding right
		ADN_Settings::magic_quotes();

		$editor = json_decode(stripslashes($_POST['editor']), true);
		$banner_obj = json_decode(stripslashes($_POST['banner_obj']), true);
	
		$h = '';
		$n = '';
		$cnt = 0;

		$ratio = $banner_obj['size']['w'] / $banner_obj['size']['h'];
		$new_height = $ratio >= 1 ? 120/$ratio : 120;
		$new_width = $ratio >= 1 ? 120 : (120/$ratio)/10;

		// Fix for low rectangles (leaderboards).
		$new_width = $new_height < 50 ? 250 : $new_width;
		$new_height = $new_height < 50 ? 250/$ratio : $new_height;

		$template_arr = ADN_Templates::predefined_templates();
		$not_fitting_size = array();

		if(!empty($template_arr))
		{
			foreach($template_arr as $key => $template)
			{
				$tpl = json_decode( ADN_Main::spacefix($template['json']) ,true);
				
				if( $banner_obj['size']['full'] == $tpl['size']['full']){
					$h.= '<div class="_dn_tpl_item" style="width:'.$new_width.'px;height:'.$new_height.'px;" data-tpl_id="'.$key.'">';
						$h.= ADN_Templates::banner_tpl($tpl, array('load_banner_script' => 0, 'load_always' => 1));
					$h.= '</div>';
					$cnt++;
				}
				else
				{
					$not_fitting_size[$key] = $tpl;
				}
				//echo '<pre>'.print_r($template[0]['json']).'</pre>';
			}
		}

		if( !empty($not_fitting_size))
		{
			$h.= '<div class="_other_sizes" style="padding: 20px 5px 0;">'.__('Other Sizes', 'imc').'</div>';
			foreach($not_fitting_size as $key => $tpl)
			{
				$h.= '<div class="_dn_tpl_item" style="width:'.$new_width.'px;height:'.$new_height.'px;" data-tpl_id="'.$key.'">';
					$h.= ADN_Templates::banner_tpl($tpl, array('load_always' => 1));
				$h.= '</div>';
			}
		}

		// Save new template
		if( $editor['save_templates'])
		{
			$n.= '<div class="_dn_tpl_save _dn_tpl_item ttip" data-tpl_id="_dn_tpl_save" title="'.__('Save current project as template','imc').'" style="width:'.$new_width.'px;height:'.$new_height.'px;">';
				$n.= '<div class="_dn_cont responsive" style="width:'.$new_width.'px;height:'.$new_height.'px;">';
					$n.= '<svg viewBox="0 0 448 512"><path fill="#FFF" d="M436 238H242V44c0-6.6-5.4-12-12-12h-12c-6.6 0-12 5.4-12 12v194H12c-6.6 0-12 5.4-12 12v12c0 6.6 5.4 12 12 12h194v194c0 6.6 5.4 12 12 12h12c6.6 0 12-5.4 12-12V274h194c6.6 0 12-5.4 12-12v-12c0-6.6-5.4-12-12-12z" class=""></path></svg>';
				$n.= '</div>';
			$n.= '</div>';
		}
		$h = !$cnt ? '<div>'.__('No templates found for this size.','imc').'</div>'.$n.$h : $n.$h; 

		echo json_encode(array('html' => $h, 'count' => $cnt));
		exit;
	}




	/**
	 * USE BANNER TEMPLATE (my banners)
	*/
	public static function use_banner_template()
	{
		$html = ADN_Templates::use_banner_template(array('id' => $_POST['id']));

		echo json_encode(array('html' => $html));
		exit;
	}


	/**
	 * UPDATE EMBED CODE
	*/
	public static function update_embed_code()
	{
		$embed_args = json_decode(stripslashes($_POST['embed_args']),true);
		$embed_code = ADN_Main::embed_code($embed_args);

		echo json_encode(array('args' => $embed_args, 'embed_code' => $embed_code));
		exit;
	}



	/**
	 * search Unsplashed stock images
	*/
	public static function search_stock_images()
	{
		$result_box = isset($_POST['result_box']) ? $_POST['result_box'] : 'stock_result';
		$query = isset($_POST['query']) ? $_POST['query'] : '';
		$template = '';

		if( $result_box == 'stock_result')
		{
			$template = ADN_Templates::unsplashed_photos(array('action' => 'search', 'query' => $query));
			//$photos = ADN_Main::load_unsplash_photos(array('action' => 'search', 'query' => $_POST['query']));
		}
		else
		{
			$template = ADN_Templates::giphy_gifs(array('action' => 'search', 'query' => $query));
		}

		echo json_encode(array('template' => $template, 'query' => $query)); //'result' => $photos
		exit;
	}


	/**
	 * Load START SCREEN TEMPLATE
	 */
	public static function load_start_screen_template()
	{
		// *Important, Set decoding right
		ADN_Settings::magic_quotes();

		$console = array();
		$set = isset($_POST['settings']) ? json_decode(stripslashes($_POST['settings']),true) : array('editor' => array(), 'banner_obj' => array());
		$parent_id = array_key_exists('parent_id', $set) ? $set['parent_id'] : 0;

		$upload = array(
			'structure' => '{DIR}/{FOLDER}/{UID}/{ID}',
			'folder' => 'user_uploads/',
			'dir' => IMC_UPLOAD_DIR,
			'src' => IMC_UPLOAD_SRC,
		);

		$set['editor']['upload'] = array_key_exists('upload', $set['editor']) ? ADN_Main::parse_args($set['editor']['upload'], $upload) : $upload;

		// Load banner_obj json directly from user_uploads folder 
		// if ID and USER_ID are available and BANNER_OBJ is EMPTY.
		if( empty($set['banner_obj']) && !empty($set['id']) && $set['user_id'] !== '') //!empty($set['user_id']))
		{
			$file = ADN_Main::create_url_from_structure(
				$set['editor']['upload']['structure'].'/imgmce.json',
				array(
					'dir' => $set['editor']['upload']['dir'], 
					'folder' => $set['editor']['upload']['folder'], 
					'uid' => $set['user_id'], 
					'id' => $set['id']
				)
			);
			
			$json = ADN_Main::get_content(array('path' => $file));
			$console[] = $json;
			if( !empty($json) )
			{
				$set['banner_obj'] = json_decode(stripslashes($json), true);
				$set['banner_obj'] = empty($banner_obj) ? json_decode($json, true) : $set['banner_obj'];
			}
		}

		// If parent_id is provide we need to make a copy of the parent folder
		$copy_result = '';
		if( $parent_id )
		{
			$parent_url = ADN_Main::create_url_from_structure($set['banner_obj']['upload']['structure'].'/', array('uid' => $set['banner_obj']['user_id'], 'dir' => $set['banner_obj']['upload']['dir'], 'folder' => $set['banner_obj']['upload']['folder'], 'id' => $parent_id));
			$new_url = ADN_Main::create_url_from_structure($set['editor']['upload']['structure'].'/', array('uid' => ImgMCE::$current_user_id, 'dir' => $upload['dir'], 'folder' => $upload['folder'], 'id' => $set['banner_obj']['id']));
			$copy_result = ADN_Main::recurse_copy($parent_url, $new_url);
		}


		// Fix for banners before v1.1.1
		if( !array_key_exists('v', $set['banner_obj']) || $set['banner_obj']['v'] < '1.1.1' ){
			$set['banner_obj']['upload']['structure'] = '{DIR}/{FOLDER}/{UID}/{ID}';
			$set['banner_obj']['upload']['folder'] = 'user_uploads/';
			$set['banner_obj']['upload']['dir'] = IMC_UPLOAD_DIR;
			$set['banner_obj']['upload']['src'] = IMC_UPLOAD_SRC;
		}

		$editor_template = ADN_Editor_TPL::start_screen($set);
		
		echo json_encode(array('template' => $editor_template, 'settings' => $set, 'copy_result' => $copy_result, 'console' => $console));
		exit;
	}





	public static function load_my_images_template()
	{
		$set = isset($_POST['settings']) ? json_decode(stripslashes($_POST['settings']),true) : array();
		
		echo ADN_Templates::load_user_banners(array(
			'user_id' => ImgMCE::$current_user_id,
			'settings' => $set
		));
		exit;
	}

}
endif;

new ADN_Ajax();
?>