<?php
if ( ! class_exists( 'ADN_Banner' ) ) :

class ADN_Banner {



	/**
	 * Get Banner Title
	*/
	public static function banner_title( $id = 0)
	{
		if($id)
		{
			$banner_arr = ADN_DB::get_results(array(
				'sql' => 'SELECT title FROM '.ADN_DB::$wpdb->prefix.'adning_banners WHERE id = '.$id.' LIMIT 1'
			));

			return $banner_arr[0]['title'];
		}

		return __('Untitled banner','imc');
	}






	/**
	 * Save Banner
	*/
	public static function save_banner($args = array())
	{
		$defaults = array(
			'id' => 0,
			'banner_obj' => array(),
			'title' => ''
		);
		$args = ADN_Main::parse_args($args, $defaults);
		
		if( $args['id'] )
		{
			$banner_settings = array_diff_key($args['banner_obj'], ['slides' => ""]);

			// Save Banner Settings
			$banner_update_array = array();
			$banner_update_array['id'] = $args['id'];
			$banner_update_array['settings'] = json_encode($banner_settings);
			$banner_update_array['status'] = 'active';

			if( !empty($args['title']))
			{
				$banner_update_array['title'] = $args['title'];
			}

			// Update Banner Settings
			//ADN_DB::update( $banner_update_array, 'adning_banners' );

			// Save Slide Params
			if( !empty($args['banner_obj']['slides']))
			{
				foreach ($args['banner_obj']['slides'] as $key => $slide) {
					$slide_id = $slide['slide_id'];
					$slide_order = $slide['slide_order'];
					$layers = $slide['layers'];

					unset($slide['slide_order']);
					unset($slide['slide_id']);
					unset($slide['layers']);

					/*ADN_DB::update( 
						array(
							'slide_id' => $slide_id,
							'slide_order' => $slide_order,
							'params' => json_encode($slide),
							'layers' => json_encode($layers)
						), 
						'adning_slides',
						'slide_id'
					);
					*/
				}
			}
			
		}
	}





	/**
	 * Get banner status
	*/
	public static function banner_status( $id = 0)
	{
		if($id)
		{
			$status = ADN_DB::get_results(array('sql' => 'SELECT status FROM '.ADN_DB::$wpdb->prefix.'adning_banners WHERE id = '.$id));
			return !empty($status) ? $status[0]['status'] : 0;
		}
		return 0;
	}





	/**
	 * Create style tag string
	*/
	public static function create_style($args = array())
	{
		$defaults = array(
			'css' => array(),
			'style_tag' => 1
		);
		$args = ADN_Main::parse_args($args, $defaults);

		// Default css values
		$css_defaults = array(
			'layer' => array(),
			'obj_cont' => array(),
			'obj' => array(),
			'element' => array()
		);
		$args['css'] = ADN_Main::parse_args($args['css'], $css_defaults);

		// Default css values
		$obj_css_defaults = array(
			'filter' => 'blur(0px)'
		);
		$args['css']['obj'] = ADN_Main::parse_args($args['css']['obj'], $obj_css_defaults);

		$style = array();
		//$style = $css_defaults;

		if(!empty($args['css']))
		{
			foreach ($args['css'] as $key => $css_arr) 
			{
				if(!empty($css_arr) && is_array($css_arr))
				{
					foreach($css_arr as $csskey => $css) 
					{
						if( !is_array($css))
						{
							$px = in_array($csskey, array('left','right','top','bottom','width','height','font-size','border-radius')) ? 'px' : '';
							$px = in_array($css, array('auto','full')) ? '' : $px;
							$px = strpos($css, '%') !== false ? '' : $px;

							$style[$key] = !array_key_exists($key, $style) ? '' : $style[$key];
							$style[$key] = $style[$key].$csskey.':'.$css.$px.';';
						}
					}
					$style[$key] = $args['style_tag'] ? ' style="'.$style[$key].'"' : $style[$key];
				}
			}
		}

		return $style;
	}






	/**
	 * Create Layer
	 * nr = layer index
	*/
	public static function create_layer( $args = array(), $nr = 0, $banner_obj = array(), $html5_export = 0)
	{
		$defaults = array(
			'type' => 'text',
			'css' => '',
			'content' => '',
			'class' => '',
			'filter' => '',
			'folder' => '',
			'aspect_ratio' => 1,
			'resize_handles' => '',
			'render_html' => 0,
			'actions' => array(),
			'shadow' => array('value' => '')
		);
		$args = ADN_Main::parse_args($args, $defaults);

		// Make sure older banners who have name attribute get it transfered to the content attribute.
		$args['content'] = empty($args['content']) && !empty($args['name']) ? $args['name'] : $args['content'];

		$content = '';
		$html = '';

		// Layer settings
		$styles = self::create_style(array('css' => $args['css'], 'style_tag' => 0));


		if($args['type'] == 'text')
		{
			if( $args['render_html'])
			{
				$content.= htmlspecialchars_decode(stripslashes(urldecode($args['content'])));
			}
			else
			{
				$content.= stripslashes(urldecode($args['content']));
			}
		}
		elseif($args['type'] == 'shape')
		{
			$content.= stripslashes(urldecode($args['content']));
		}
		elseif($args['type'] == 'element')
		{
			$content.= stripslashes(urldecode($args['content']));
		}
		elseif($args['type'] == 'image')
		{
			if( !empty($args['folder']))
			{
				$upload = $banner_obj['upload'];
				//$src_structure = str_replace('{DIR}', '{SRC}', $editor['upload']['structure']);
				$src = ADN_Main::create_url_from_structure(
					$banner_obj['upload']['structure'],
					array(
						'dir' => IMC_UPLOAD_SRC, 
						'folder' => $banner_obj['upload']['folder'], 
						'uid' => $banner_obj['user_id'], 
						'id' => $banner_obj['id']
					)
				);
				$src = !$html5_export ? $src.'/' : '';
				$content.= '<img src="'.$src.'images/'.$args['content'].'" />';
			}
			else
			{
				$content.= '<img src="'.$args['content'].'" />';
			}
		}

		$filter = !empty($args['filter']) ? ' _dnfilter'.$args['filter'] : '';
		$obj_cont_style = !empty($styles['obj_cont']) ? ' style="'.$styles['obj_cont'].'"' : '';
		$data_rsh = !empty($args['resize_handles']) ? ' data-rsh="'.$args['resize_handles'].'"' : '';
		$data_type = ' data-type="'.$args['type'].'"';
		$layer_type = ' '.$args['type'].'_elmt';

		$image_shadow_fix = $args['type'] === 'image' ? ' _dn_elem' : '';
		$image_shadow_fix_style = $args['type'] === 'image' ? '-webkit-box-shadow:'.$args['shadow']['value'].';-moz-box-shadow:'.$args['shadow']['value'].';box-shadow:'.$args['shadow']['value'].';' : '';

		$layer_classes = '_dn_layer _dn_elmt layer_'.$nr.$layer_type.' '.$args['class'];

		//$html.= '<pre>'.print_r($args, true).'</pre>';
		// @since v1.1.8 removed class: "visible", this gets added later to make sure the layer does'nt show to early
		//$html.= '<div class="_dn_layer _dn_elmt layer_'.$nr.$layer_type.' '.$args['class'].'" data-aspect_ratio="'.$args['aspect_ratio'].'" data-nr="'.$nr.'"'.$data_rsh.$data_type.$styles['layer'].'>';
		$html.= '<div class="'.$layer_classes.'" data-aspect_ratio="'.$args['aspect_ratio'].'" data-nr="'.$nr.'"'.$data_rsh.$data_type.' style="'.$styles['layer'].'">';
			$html.= '<div class="_dn_obj_container"'.$obj_cont_style.'>';
				$html.= $args['type'] == 'image' ? '<div class="layer_filter'.$filter.'"></div>' : '';
				$html.= '<div class="_dn_obj '.$args['type'].$image_shadow_fix.'" style="'.$styles['obj'].$image_shadow_fix_style.'">';
					$html.= defined("ABSPATH") ? do_shortcode($content) : $content;
				$html.= '</div>';
			$html.= '</div>';
		$html.= '</div>';

		return array('html' => $html, 'classes' => $layer_classes);
	}








	/**
	 * LAYER ANIMATION
	 * args = array()
	 * $layer = array()
	 * $nr = int
	 * hash = string 
	*/
	public static function layer_animation($animations = array(), $layer, $nr, $hash, $args = array())
	{
		$js = '';
		$external = '';

		$default_args = array(
			'function_name' => '', // to customize the function name
			'selector' => '',
			'loop_element' => 0,
			'layer_classses' => '',
			'layer_timing' => array(),
			'debug' => 0
		);
		$args = ADN_Main::parse_args($args, $default_args);
		$sl = !empty($args['selector']) ? '("'.$args['selector'].'").find' : '';

		$defaults = array(
			'in' => array(),
			'view' => array(),
			'out' => array()
		);
		$animations = ADN_Main::parse_args($animations, $defaults);

		$def = array(
			'delay' => 0,
			'duration' => 0,
			'effect' => 'linear', // https://api.jqueryui.com/easings/
			'queue' => 'false',
			'direction' => '', // empty | left | right | top | botom
			'easing' => '',
			'animation' => ''
		);
		$def_view = array(
			'delay' => 0,
			'duration' => 0,
			'effect' => 'bounce', // https://api.jqueryui.com/category/effects/
			'queue' => 'false',
			'direction' => '', // empty | left | right | top | botom
			'repeat' => 0
		);
		$animations['in'] = ADN_Main::parse_args($animations['in'], $def);
		$animations['view'] = ADN_Main::parse_args($animations['view'], $def_view);
		$animations['out'] = ADN_Main::parse_args($animations['out'], $def);

		
		//$js.= self::custom_js_animations();

		$js.= 'var _ViewTimeout_'.$hash.$nr.' = 0;';
		$js.= 'var _RefTimeout_'.$hash.$nr.' = 0;';
		$js.= 'var _RefInterval_'.$hash.$nr.' = 0;';
		$js.= 'var _InTimeout_'.$hash.$nr.' = 0;';
		$js.= 'var _InTimeout_fx_'.$hash.$nr.' = 0;';
		$js.= 'var _OutTimeout_'.$hash.$nr.' = 0;';
		$js.= 'var ele_'.$nr.' = $'.$sl.'("._dn_'.$hash.'").find(".layer_'.$nr.'");';
		$js.= 'var _stop_layer = [];';


		// VIEW ANIMATION
		$view_delay = $animations['view']['delay'] ? $animations['view']['delay']*1000 : 0;
		$view_delay = !$view_delay ? 100 : $view_delay; // add a minimum delay. For some reason when dalay is 0 some animations don't start.
		$view_duration = $animations['view']['duration'] ? $animations['view']['duration']*1000 : 0;

		$js.= 'var layer_'.$hash.$nr.$args['function_name'].'_view_animation = function(){';

			$js.= $args['debug'] ? 'console.log("START VIEW '.$nr.'");' : '';

			$js.= 'clearTimeout(_InTimeout_'.$hash.$nr.');';
			$js.= 'clearTimeout(_InTimeout_fx_'.$hash.$nr.');';

			if( $view_delay || $view_duration )
			{	
				if( $animations['view']['repeat'] )
				{
					// if loop keep looping effect
					$js.= '_RefInterval_'.$hash.$nr.' = setInterval(function() {';
						// Load animation plugins
						$plugin_code = ADN_Main::layer_plugins(array('layer' => $layer, 'hash' => $hash, 'key' => $nr, 'group' => 'view', 'animation' => true));
						$js.= $plugin_code['js'];
						// Load plugins
						$plugin_code = ADN_Main::layer_plugins(array('layer' => $layer, 'hash' => $hash, 'key' => $nr, 'animation' => false));
						$js.= $plugin_code['js'];
						$external.= $plugin_code['external'];

						//$js.= $effect;
					$js.= '}, '.$view_delay.');';
				}
				else
				{
					$js.= '_RefTimeout_'.$hash.$nr.' = setTimeout(function() {';
						// Load animation plugins
						$plugin_code = ADN_Main::layer_plugins(array('layer' => $layer, 'hash' => $hash, 'key' => $nr, 'group' => 'view', 'animation' => true));
						$js.= $plugin_code['js'];
						// Load plugins
						$plugin_code = ADN_Main::layer_plugins(array('layer' => $layer, 'hash' => $hash, 'key' => $nr, 'animation' => false));
						$js.= $plugin_code['js'];
						$external.= $plugin_code['external'];

						$js.= '_ViewTimeout_'.$hash.$nr.' = setTimeout(function() {';
							$js.= 'layer_'.$hash.$nr.$args['function_name'].'_out_animation();';
						$js.= '}, '.$view_duration.');';

					$js.= '}, '.$view_delay.');';
				}
			}
			else
			{
				// Load animation plugins
				$plugin_code = ADN_Main::layer_plugins(array('layer' => $layer, 'hash' => $hash, 'key' => $nr, 'group' => 'view', 'animation' => true));
				$js.= $plugin_code['js'];
				// Load plugins
				$plugin_code = ADN_Main::layer_plugins(array('layer' => $layer, 'hash' => $hash, 'key' => $nr, 'animation' => false));
				$js.= $plugin_code['js'];
				$external.= $plugin_code['external'];

				$js.= 'layer_'.$hash.$nr.$args['function_name'].'_out_animation();';
			}
		$js.= '};';
		
		// Function to finish "view" animation (based on the layer number)
		$js.= '_stop_layer['.$nr.'] = function(){ ele.stop(true,true); clearInterval(_RefInterval_'.$hash.$nr.'); };'; // clearTimeout(_RefTimeout_'.$hash.$nr.');
		

		// OUT ANIMATION
		$out_delay = $animations['out']['delay'] ? $animations['out']['delay']*1000 : 0;
		$out_duration = $animations['out']['duration'] ? $animations['out']['duration']*1000 : 0;

		$js.= 'var layer_'.$hash.$nr.$args['function_name'].'_out_animation = function(){';

			$js.= $args['debug'] ? 'console.log("START OUT '.$nr.'");' : '';

			$js.= 'clearTimeout(_ViewTimeout_'.$hash.$nr.');';
			$js.= 'clearTimeout(_RefTimeout_'.$hash.$nr.');';

			if( $out_delay || $out_duration )
			{
				if($animations['out']['direction'] == 'top')
				{
					$direction = 'top';
					$end_position = 'ele_'.$nr.'.closest("._dn_cont").height()+$("._dn_'.$hash.'").find(".layer_'.$nr.'").height()+ "px"';
				}
				elseif($animations['out']['direction'] == 'bottom')
				{
					$direction = 'top'; // Even though the direction is bottom to top we still use top to position the layer
					$end_position = '-ele_'.$nr.'.closest("._dn_cont").height()+$("._dn_'.$hash.'").find(".layer_'.$nr.'").height()+ "px"';
				}
				elseif($animations['out']['direction'] == 'left')
				{
					$direction = 'left';
					$end_position = 'ele_'.$nr.'.closest("._dn_cont").width()+$("._dn_'.$hash.'").find(".layer_'.$nr.'").width()+ "px"';
				}
				elseif($animations['out']['direction'] == 'right')
				{
					$direction = 'left'; // Even though the direction is right to left we still use left to position the layer
					$end_position = '-ele_'.$nr.'.closest("._dn_cont").width()+$("._dn_'.$hash.'").find(".layer_'.$nr.'").width()+ "px"';
				}
				else
				{
					$direction = 'left';
					$end_position = 'ele_'.$nr.'.css("'.$direction.'")+"px"';
				}

				$js.= '_OutTimeout_'.$hash.$nr.' = setTimeout(function() {';
					
					// Load animation plugins
					$plugin_code = ADN_Main::layer_plugins(array('layer' => $layer, 'hash' => $hash, 'key' => $nr, 'group' => 'out', 'animation' => true));
					$js.= $plugin_code['js'];

					$animation_class = '';
					if( array_key_exists('classes', $animations['out'])):
					if( !empty($animations['out']['classes'])){
						$animation_class = $animations['out']['classes'];
						$js.= 'ele_'.$nr.'.addClass("'.$animation_class.'");';
					}
					endif;

					$add_build_ani = self::add_build_in_animations($animations, 'out', $nr);
					$js.= $add_build_ani['js'];

					if( !empty($animations['out']['direction']))
					{
						//$js.= 'console.log("ANI direction: '.$animations['out']['direction'].'");';
						$js.= 'ele_'.$nr.'.animate({';
							$js.= '"'.$direction.'": '.$end_position.',';
							$js.= '"opacity": 1';
						$js.= '},'; 
						$js.= '{';
							$js.= 'easing:"'.$animations['out']['easing'].'",';
							$js.= 'duration:'.$out_duration.','; 
							$js.= 'queue:'.$animations['out']['queue'].','; 
							$js.= 'complete: function(){'; 
								// @since v1.1.9 remove opacity 0. Object has to stay visible if no animation is selected.
								//$js.= 'ele_'.$nr.'.css({"opacity":0});';
								$js.= 'ele_'.$nr.'.removeClass("'.$animation_class.'");';

								// END OF ELEMENT
								$js.= $args['debug'] ? 'console.log("finishing layer nr '.$nr.' (called from delay or duration)");' : '';
								$js.= 'ele_'.$nr.'.stop(true,true);';
								if( $args['layer_timing'][0]['nr'] === $nr )
								{
									$js.= 'clearTimeout(_OutTimeout_'.$hash.$nr.');';
									$js.= $args['debug'] ? 'console.log("ELEMENT HAS FINISHED. '.$nr.' (called from delay or duration)");' : '';
									// ##### BETA ##### testing to reload element
									if( $args['loop_element'] )
									{
										//$js.= 'ele_'.$nr.'.replaceWith("'.$args['layer_html'].'");';
										$js.= 'ele_'.$nr.'.attr("class","'.$args['layer_classses'].'");';
										$js.= 'bnr_'.$hash.'_in_animation();';
									}
								}
								
							$js.= '}';
						$js.= '},'; 
						$js.= '"linear");';
					}
				$js.= '}, '.$out_delay.');';
			}
			else
			{
				// Load animation plugins
				$plugin_code = ADN_Main::layer_plugins(array('layer' => $layer, 'hash' => $hash, 'key' => $nr, 'group' => 'out', 'animation' => true));
				$js.= $plugin_code['js'];

				$add_build_ani = self::add_build_in_animations($animations, 'out', $nr);
				$js.= $add_build_ani['js'];

				// END OF ELEMENT
				$js.= $args['debug'] ? 'console.log("finishing layer nr '.$nr.'");' : '';
				$js.= 'ele_'.$nr.'.stop(true,true);';
				if( $args['layer_timing'][0]['nr'] === $nr )
				{
					$js.= 'clearTimeout(_OutTimeout_'.$hash.$nr.');';
					$js.= $args['debug'] ? 'console.log("ELEMENT HAS FINISHED. '.$nr.'");' : '';

					// ##### BETA ##### testing to reload element
					if( $args['loop_element'] )
					{
						$js.= 'ele_'.$nr.'.attr("class","'.$args['layer_classses'].'");';
						$js.= 'bnr_'.$hash.'_in_animation();';
					}
				}
			}
		$js.= '};';


		// IN ANIMATION
		$delay = $animations['in']['delay'] ? $animations['in']['delay']*1000 : 0;
		$duration = $animations['in']['duration'] ? $animations['in']['duration']*1000 : 0;

		if( $delay || $duration )
		{
			// Get start position
			if($animations['in']['direction'] == 'top')
			{
				$direction = 'top';
				$start_position = '-ele_'.$nr.'.closest("._dn_cont").height()+$("._dn_'.$hash.'").find(".layer_'.$nr.'").height()+ "px"';
			}
			elseif($animations['in']['direction'] == 'bottom')
			{
				$direction = 'top'; // Even though the direction is bottom to top we still use top to position the layer
				$start_position = 'ele_'.$nr.'.closest("._dn_cont").height()+$("._dn_'.$hash.'").find(".layer_'.$nr.'").height()+ "px"';
			}
			elseif($animations['in']['direction'] == 'left')
			{
				$direction = 'left';
				$start_position = '-ele_'.$nr.'.closest("._dn_cont").width()+$("._dn_'.$hash.'").find(".layer_'.$nr.'").width()+ "px"';
			}
			elseif($animations['in']['direction'] == 'right')
			{
				$direction = 'left'; // Even though the direction is right to left we still use left to position the layer
				$start_position = 'ele_'.$nr.'.closest("._dn_cont").width()+$("._dn_'.$hash.'").find(".layer_'.$nr.'").width()+ "px"';
			}
			else
			{
				$direction = 'left';
				$start_position = 'ele_'.$nr.'.css("'.$direction.'")+"px"';
				//$js.= 'console.log("POS "+ele_'.$nr.'.css("'.$direction.'"));';
				//$start_position = 0;
			}

			// Set layer opacity to 0
			$js.= 'ele_'.$nr.'.css({"opacity": 0});';
			$js.= 'ele_'.$nr.'.addClass("inactive");';
			$js.= 'ele_'.$nr.'.find("._dn_ani").css({"opacity": 0});';

			// Save original layer position
			$js.= 'var layer_'.$nr.'_pos = ele_'.$nr.'.css("'.$direction.'");';
			// Reset layer position to get it out of vision
			$js.= 'ele_'.$nr.'.css({"'.$direction.'": '.$start_position.'});';

			$animation_class = '';
			if( array_key_exists('classes', $animations['in'])):
			if( !empty($animations['in']['classes'])){
				$animation_class = $animations['in']['classes'];
				$js.= 'ele_'.$nr.'.addClass("'.$animation_class.'");';
			}
			endif;
			
			// Start Animation
			$js.= '_InTimeout_'.$hash.$nr.' = setTimeout(function(){';

				$js.= $args['debug'] ? 'console.log("START IN '.$nr.'");' : '';

				// Load animation plugins
				$plugin_code = ADN_Main::layer_plugins(array('layer' => $layer, 'hash' => $hash, 'key' => $nr, 'group' => 'in', 'animation' => true));
				$js.= $plugin_code['js'];
				$js.= 'ele_'.$nr.'.css({"opacity":0}).addClass("visible");';

				$add_build_ani = self::add_build_in_animations($animations, 'in', $nr);
				$js.= $add_build_ani['js'];


				if(!empty($animations['in']['direction']))
				{
					// @since v1.1.8, added timeout to make sure layer doesn't show too early.
					$js.= '_InTimeout_fx_'.$hash.$nr.' = setTimeout(function() {';
						$js.= 'ele_'.$nr.'.animate({';
							$js.= '"'.$direction.'": layer_'.$nr.'_pos,'; 
							$js.= '"opacity": 1';
						$js.= '},'; 
						$js.= '{';
							$js.= 'easing:"'.$animations['in']['easing'].'",';
							$js.= 'duration:'.$duration.','; 
							$js.= 'queue:'.$animations['in']['queue'].','; 
							$js.= 'complete: function(){'; 
								//$js.= 'console.log("layer_'.$nr.' Animation Complete");'; 
								$js.= 'ele_'.$nr.'.removeClass("'.$animation_class.'");';
								//$js.= 'layer_'.$hash.$nr.$args['function_name'].'_view_animation();';

								$js.= 'ele_'.$nr.'.removeClass("inactive");'; 
								$js.= 'ele_'.$nr.'.addClass("in_ani_complete");'; 

								$plugin_code = ADN_Main::layer_plugins(array('layer' => $layer, 'hash' => $hash, 'key' => $nr, 'animation' => false));
								$js.= $plugin_code['js'];
								$external.= $plugin_code['external'];

								$js.= 'if( ele_'.$nr.'.find("._dn_ani").length ){';
									$js.= 'ele_'.$nr.'.find("._dn_ani")._dn_animate_stroke({'; 
										$js.= '"start": function(set){$(this).css({"opacity": 1});},'; 
										$js.= '"callback": function(){layer_'.$hash.$nr.$args['function_name'].'_view_animation();}';
									$js.= '});'; 
								$js.= '}else{';
									$js.= 'layer_'.$hash.$nr.$args['function_name'].'_view_animation();';
								$js.= '}';

							$js.= '}';
						$js.= '},'; 
						$js.= '"linear");';
					$js.= '},10)';
				}
				else
				{
					$plugin_code = ADN_Main::layer_plugins(array('layer' => $layer, 'hash' => $hash, 'key' => $nr, 'animation' => false));
					$js.= $plugin_code['js'];
					$external.= $plugin_code['external'];

					$js.= 'ele_'.$nr.'.css({"opacity":1});';
					$js.= 'if( ele_'.$nr.'.find("._dn_ani").length ){';
						$js.= 'ele_'.$nr.'.find("._dn_ani")._dn_animate_stroke({'; 
							$js.= '"start": function(set){$(this).css({"opacity": 1});},'; 
							$js.= '"callback": function(){layer_'.$hash.$nr.$args['function_name'].'_view_animation();}';
						$js.= '});'; 
					$js.= '}else{';
						$js.= 'layer_'.$hash.$nr.$args['function_name'].'_view_animation();';
					$js.= '}';
				}
				
			$js.= '}, '.$delay.');';
		}
		else
		{
			$js.= 'ele_'.$nr.'.css({"opacity":0}).addClass("visible");';

			$add_build_ani = self::add_build_in_animations($animations, 'in', $nr);
			$js.= $add_build_ani['js'];
			
			// Load animation plugins
			$plugin_code = ADN_Main::layer_plugins(array('layer' => $layer, 'hash' => $hash, 'key' => $nr, 'group' => 'in', 'animation' => true));
			$js.= $plugin_code['js'];
			// Load plugins
			$plugin_code = ADN_Main::layer_plugins(array('layer' => $layer, 'hash' => $hash, 'key' => $nr, 'animation' => false));
			$js.= $plugin_code['js'];
			$external.= $plugin_code['external'];
			$js.= 'ele_'.$nr.'.css({"opacity":1});';
			$js.= 'layer_'.$hash.$nr.$args['function_name'].'_view_animation();';
		}

		return array('js' => $js, 'external' => $external);
	}




	public static function add_build_in_animations($animations = array(), $type = 'in', $layer_nr = 0)
	{
		$js = '';
		$external = '';

		$defaults = array(
			'animation' => '',
			'delay' => 0,
			'duration' => 0
		);
		$animations[$type] = ADN_Main::parse_args($animations[$type], $defaults);
		
		if( !empty($animations[$type]['animation']))
		{
			//$js.= '_dn_get_scripts( {"css":{0:"{INC_DIR}files/imgmce_animations.css"}} );';
			$speed = empty($animations[$type]['duration']) ? 'imgmce_ani_normal' : ''; //'imgmce_ani_normal';
			$js.= 'ele_'.$layer_nr.'.addClass("'.$animations[$type]['animation'].' '.$speed.'");';
			$js.= !empty($animations[$type]['duration']) ? 'ele_'.$layer_nr.'.css({"animation-duration":"'.$animations[$type]['duration'].'s", "-webkit-animation-duration":"'.$animations[$type]['duration'].'s"});' : '';
			$js.= $type === 'out' ? 'ele_'.$layer_nr.'.css({"opacity":0});' : '';
		}

		return array('js' => $js, 'external' => $external);
	}


}
endif;
?>