<?php
// Exit if accessed directly
if( !defined("IMC_VERSION")) exit;
if ( ! class_exists( 'ADN_Editor_TPL' ) ) :

class ADN_Editor_TPL {

    /**
     * Start Screen
     */
    public static function start_screen($set = array())
	{
        $h= '';
        $set = ADN_Main::parse_args($set, array('editor' => array(), 'banner_obj' => array()));
        //$h.= '<pre>'.print_r($set, true).'</pre>';
        $banner_obj = ADN_Main::parse_args($set['banner_obj'], ADN_Main::default_banner_obj());
        $editor_settings = ADN_Main::parse_args($set['editor'], ADN_Main::load_settings());
        $editor_settings = apply_filters('_dn_start_screen_options', $editor_settings);
        //$h.= '<pre>'.print_r($editor_settings, true).'</pre>';
        //$h.= '<pre>'.print_r($set['editor'], true).'</pre>';

        // Look if image uploads should be enabled. 
        // Note: Don't add this to ADN_Main::load_settings()directly. it will break some functions.
        if( !empty(ImgMCE::$current_user_role))
        {
            $role_set = array_key_exists(ImgMCE::$current_user_role, $editor_settings['role']) ? $editor_settings['role'][ImgMCE::$current_user_role] : array();

            if(!empty($editor_settings['upload']))
            {
                // If specific image settings are found for the current user role we need to overwrite the default settings.
                $editor_settings['image']['image_uploads'] = array_key_exists('image', $role_set) ? $role_set['image']['image_uploads'] : 0;
                $editor_settings['image']['upload_size'] = array_key_exists('image', $role_set) ? $role_set['image']['upload_size'] : $editor_settings['image']['upload_size'];
                $editor_settings['image']['upload_file_types'] = array_key_exists('image', $role_set) ? $role_set['image']['upload_file_types'] : $editor_settings['image']['upload_file_types'];
            }
            else
            {
                // Turn uploads off anyway if no upload folder is provided!
                $editor_settings['image']['image_uploads'] = 0;
            }

            // Save Templates
            $editor_settings['save_templates'] = array_key_exists('general', $role_set) ? $role_set['general']['save_templates'] : 0;
        }
        else
        {
            // Turn uploads off anyway if user is not logged in.
            $editor_settings['image']['image_uploads'] = 0;
        }


        $editor_id = 'imcMCE_Editor_'.rand();

        
        $h.= '<div id="'.$editor_id.'" class="_imgMCE_EDITOR imgmce_editor adning_full_container adning_banner_creator">';
            $h.= '<div class="_dnwrap">';
                // Menu
                $h.= self::menu_tpl($editor_settings);

                $h.= '<div class="_dn_Content_Holder">';
                    
                    $h.= self::choose_size();
                    $h.= self::my_images($editor_settings);
                    $h.= self::editor($editor_settings, $banner_obj);

                $h.= '</div>';
                // end ._dn_Content_Holder
            $h.= '</div>';
            // end ._dnwrap
        $h.= '</div>';
        // end .imgmce_editor


        /**
         * SCRIPT
         */
        $h.= '<script>';
            $h.= 'var sizes = '.json_encode(ADN_Main::image_sizes()).';';

            $h.= 'jQuery(document).ready(function($){';

                $h.= '$("#'.$editor_id.'").imgmce_setup({';
                    $h.= '"user_id": '.ImgMCE::$current_user_id.',';
                    $h.= '"sizes": sizes, ';
                    $h.= "'editor': '".json_encode($editor_settings)."',";
                    $h.= !empty($banner_obj) ? '"banner_obj":'.json_encode($banner_obj).',' : '"banner_obj":{},';
                $h.= '});';

            $h.= '});';
        $h.= '</script>';

        return $h;
    }





    /**
     * CHOOSE SIZE
    */
    public static function choose_size()
    {
        $h = '';
        $h.= '<div id="_dn_ChooseSize" class="_dn_ChooseSize bc_page choose_size" data-bg="#ccc364"></div>';

        return $h;
    }



    /**
     * MY IMAGES
    */
    public static function my_images($set = array())
	{
        $h = '';
        $h.= '<div id="_dn_MyImages" class="_dn_MyImages bc_page my_images" style="display:none;" data-bg="#f1f1f1"></div>';
        // end ._dn_MyImages

        return $h;
    }



    public static function set_uploads($args = array())
    {
        $defaults = array(
            'upload' => array()
        );
        $args = ADN_Main::parse_args($args, $defaults);
    }




    public static function menu_tpl($args = array())
    {
        $image_title = !empty($args['banner_obj']) ? $banner_obj['title'] : '';

        $h = '';
        $h.= '<div class="_dn_menu select_size clearFix">';
            $h.= '<div class="_dn_menu_inner">';

                $h.= '<div class="_dn_menu_left">';
                    $h.= '<div class="menu_tab logo">';
                        $h.= '<a href="'.$args['menu']['logo_url'].'" title="'.$args['menu']['logo_title'].'" target="_blank">';
                            $h.= '<div style="width: 26px;height: 40px;padding: 0px 10px 0 10px;">';
                                $h.= '<svg id="imgMCE_logo" x="0px" y="0px" width="100%" height="100%" viewBox="0 0 310 426" enable-background="new 0 0 310 426">
    <g id="FRONT_1_"><g id="bottom_xA0_Image_3_"><g id="XMLID_2_"><g><path fill="#FFFF00" d="M237,225c-0.33,0-0.67,0-1,0c-53.73,59.93-108.85,118.49-163,178c-0.85,0.18-0.94-0.39-1-1
                        c26.08-58.92,51.7-118.3,77-178C178,224.67,209.67,222.67,237,225z"></path></g><g></g></g></g><g id="top_xA0_Image_3_"><g id="XMLID_3_"><g><path fill="#FFFF00" d="M289,165c0,1.33,0,2.67,0,4c-17.86,18.48-34.64,38.03-52,57c-56,0-112,0-168,0c0-1,0-2,0-3
                        c21.5-64.83,42.62-130.05,63-196c46.33,0,92.67,0,139,0c-27.25,45.75-54.78,91.22-81,138C223,165,256,165,289,165z"></path></g><g></g></g></g></g><g id="BACK_1_"><g id="bottom_xA0_Image_1_"><g id="XMLID_5_"><g><path fill="#D7CB05" d="M149,225c0,1.33,0,2.67,0,4c-26.73,57.27-50.59,117.41-77,175c-16.02-1.31-37.3,2.63-50-2
                        c25.93-59.4,52.98-117.69,79-177C117,225,133,225,149,225z"></path></g><g></g></g></g><g id="top_xA0_Image_1_"><g id="XMLID_4_"><g><path fill="#D7CB05" d="M133,27c0,1,0,2,0,3c-21.17,64.5-41.92,129.41-62,195c-16.33,0-32.67,0-49,0c0-1,0-2,0-3
                        C43.17,157.5,63.92,92.59,84,27C100.33,27,116.67,27,133,27z"></path></g><g></g></g></g></g></svg>';
                            $h.= '</div>';
                        $h.= '</a>';
                    $h.= '</div>';
                    // end .logo

                    $h.= $args['menu']['buttons']['new_image'] ? '<div class="menu_tab selected"><a id="_dnNewImage" class="_dnNewImage">'.__('New Image','imc').'</a></div>' : '';
                    $h.= $args['menu']['buttons']['my_images'] ? '<div class="menu_tab"><a id="_dnMyImages" class="_dnMyImages">'.__('My Images','imc').'</a></div>' : '';
                    $h.= '<div class="menu_tab bc_editor" style="display:none;"><a>'.__('Editor','imc').'</a></div>';
                $h.= '</div>';
                // end ._dn_menu_left

                $h.= '<div class="_dn_menu_right">';
                    $h.= '<div id="_dn_export_as_image_btn" class="menu_tab editor">';
                        $h.= '<a class="btn_text export_as_image_btn ttip" data-tooltipster=\'{"side":"left"}\' title="'.__('Export as Image (.PNG)','imc').'" style="padding: 7px 15px;">';
                            $h.= ' <svg viewBox="0 0 419.2 419.2" style="width:26px;padding-top:4px;"> <g> <g> <g> <circle fill="currentColor" cx="158" cy="144.4" r="28.8"/> <path fill="currentColor" d="M394.4,250.4c-13.6-12.8-30.8-21.2-49.6-23.6V80.4c0-15.6-6.4-29.6-16.4-40C318,30,304,24,288.4,24h-232 c-15.6,0-29.6,6.4-40,16.4C6,50.8,0,64.8,0,80.4v184.4V282v37.2c0,15.6,6.4,29.6,16.4,40c10.4,10.4,24.4,16.4,40,16.4h224.4 c14.8,12,33.2,19.6,53.6,19.6c23.6,0,44.8-9.6,60-24.8c15.2-15.2,24.8-36.4,24.8-60C419.2,286.8,409.6,265.6,394.4,250.4z M21.2,80.4c0-9.6,4-18.4,10.4-24.4c6.4-6.4,15.2-10.4,24.8-10.4h232c9.6,0,18.4,4,24.8,10.4c6.4,6.4,10.4,15.2,10.4,24.8v124.8 l-59.2-59.2c-4-4-10.8-4.4-15.2,0L160,236l-60.4-60.8c-4-4-10.8-4.4-15.2,0l-63.2,64V80.4z M56,354.8v-0.4 c-9.6,0-18.4-4-24.8-10.4c-6-6.4-10-15.2-10-24.8V282v-12.8L92,198l60.4,60.4c4,4,10.8,4,15.2,0l89.2-89.6l58.4,58.8 c-1.2,0.4-2.4,0.8-3.6,1.2c-1.6,0.4-3.2,0.8-5.2,1.6c-1.6,0.4-3.2,1.2-4.8,1.6c-1.2,0.4-2,0.8-3.2,1.6c-1.6,0.8-2.8,1.2-4,2 c-2,1.2-4,2.4-6,3.6c-1.2,0.8-2,1.2-3.2,2c-0.8,0.4-1.2,0.8-2,1.2c-3.6,2.4-6.8,5.2-9.6,8.4c-15.2,15.2-24.8,36.4-24.8,60 c0,6,0.8,11.6,2,17.6c0.4,1.6,0.8,2.8,1.2,4.4c1.2,4,2,8,4,12v0.4c1.6,3.2,3.2,6.8,5.2,9.6H56z M378.8,355.2 c-11.6,11.6-27.2,18.4-44.8,18.4c-16.8,0-32.4-6.8-43.6-17.6c-1.6-1.6-3.2-3.6-4.8-5.2c-1.2-1.2-2.4-2.8-3.6-4.4 c-1.6-2-2.8-4.4-4-6.8c-0.8-1.6-1.6-2.8-2.4-4.4c-0.8-2-1.6-4.4-2-6.8c-0.4-1.6-1.2-3.6-1.6-5.2c-0.8-4-1.2-8.4-1.2-12.8 c0-17.6,7.2-33.2,18.4-44.8c11.2-11.6,27.2-18.4,44.8-18.4s33.2,7.2,44.8,18.4c11.6,11.6,18.4,27.2,18.4,44.8 S390,343.6,378.8,355.2z"/> <path fill="currentColor" d="M351.2,313.2l-6.4,6.4v-44c0-6-4.8-10.8-10.8-10.8s-10.8,4.8-10.8,10.8v44l-6.4-6.4c-4-4-10.8-4-15.2,0 c-4,4-4,10.8,0,15.2l24.8,24.8c0.8,0.8,2,1.6,3.6,2.4c1.2,0.4,2.4,0.8,3.6,0.8c0.4,0,0.4,0,0.4,0c0.4,0,0.4,0,0.4,0 c1.2,0,2.4-0.4,3.6-0.8c1.2-0.4,2.4-1.2,3.6-2.4l24.8-24.8c4-4,4-10.8,0-15.2C362,308.8,355.2,308.8,351.2,313.2z"/> </g> </g> </g> <g> </g> <g> </g> <g> </g> <g> </g> <g> </g> <g> </g> <g> </g> <g> </g> <g> </g> <g> </g> <g> </g> <g> </g> <g> </g> <g> </g> <g> </g> </svg>';
                        $h.= '</a>';
                    $h.= '</div>';
                    $h.= '<div id="_dn_play_btn" class="menu_tab play_btn editor">';
                        //$h.= '<span class="play_loader _dn_loader"><i class="fas fa-spinner fa-pulse"></i></span>';
                        $h.= '<a class="btn_text play_text ttip" data-tooltipster=\'{"side":"left"}\' title="'.__('Preview Element (Alt+p).','imc').'">'.__('PREVIEW','imc').'</a>';
                    $h.= '</div>';
                    $h.= '<div id="_dn_save_btn" class="menu_tab save_btn editor">';
                        $h.= '<a class="btn_text">';
                            $h.= '<span class="save_text">'.__('SAVE','imc').'</span>';
                            $h.= ' <span class="save_loader _dn_loader">'.ADN_Templates::loading_spinner(array('w' => 10)).'</span>';
                        $h.= ' </a>';
                    $h.= '</div>';
                    $h.= '<div class="menu_tab config _add_all_code" style="width:50px;display:none;">';
                        $h.= '<a class="ConfigImgMCE _add_all_code_to_tinymce_checkbox ttip" title="'.__('Export all code. Leave unchecked for optimal SEO.','imc').'" style="line-height: 1;padding-bottom: 11px;cursor:pointer;height: 22px;">';
                            $h.= ADN_Templates::checkbox(array(
                                'title' => __('','imc'),
                                'tooltip' => __('','imc'),
                                'checked' => 0,
                                'class' => 'option_checkbox _add_all_code_to_tinymce _return_all_code'
                            ));
                        $h.= ' </a>';
                    $h.= '</div>';
                    //if( $args['in_popup']){
                        $h.= '<div class="menu_tab close_btn">';
                            $h.= '<a class="CloseImgMCEModal" style="line-height: 1;padding-bottom: 11px;cursor:pointer;">';
                                $h.= '<svg style="height:20px;width:20px;" viewBox="0 0 320 512"><path fill="#ababab" d="M193.94 256L296.5 153.44l21.15-21.15c3.12-3.12 3.12-8.19 0-11.31l-22.63-22.63c-3.12-3.12-8.19-3.12-11.31 0L160 222.06 36.29 98.34c-3.12-3.12-8.19-3.12-11.31 0L2.34 120.97c-3.12 3.12-3.12 8.19 0 11.31L126.06 256 2.34 379.71c-3.12 3.12-3.12 8.19 0 11.31l22.63 22.63c3.12 3.12 8.19 3.12 11.31 0L160 289.94 262.56 392.5l21.15 21.15c3.12 3.12 8.19 3.12 11.31 0l22.63-22.63c3.12-3.12 3.12-8.19 0-11.31L193.94 256z"></path></svg>';
                            $h.= ' </a>';
                        $h.= '</div>';
                    //}
                $h.= '</div>';
                // end ._dn_menu_right

                $h.= '<div class="_dn_menu_center">';
                    $h.= '<div>';
                        $h.= '<input type="text" id="_dn_banner_title" class="_dn_banner_title banner_title_input" value="'.$image_title.'" placeholder="'.__('Give an appropriate title','imc').'">';
                    $h.= '</div>';
                $h.= '</div>';
                // end ._dn_menu_center

            $h.= ' </div>';
            // end ._dn_menu_inner

        $h.= '</div>';
        // end ._dn_menu
        
        return $h;
    }




    /**
	 * Editor Template
	*/
	public static function editor($editor_settings, $banner_obj)
	{
        $args = $editor_settings;
        $h= '';

        /**
         * EDITOR
        */
        $h.= '<div id="_dn_BannerEditor" class="_dn_BannerEditor bc_page banner_editor" style="display:none;" data-bg="#f1f1f1">';
            
            $h.= '<div id="_dn_EditorLoader" class="_dn_EditorLoader">
                <div class="_dn_loader">';
                    $h.= '<div class="_imc_loader">';
                        $h.= '<div class="loading_logo">';
                            $h.= '<svg width="20px" height="20px" viewBox="0 0 310 426"><g><g id="bottom_xA0_Image_3_"><g><g><path fill="#FFFF00" d="M237,225c-0.33,0-0.67,0-1,0c-53.73,59.93-108.85,118.49-163,178c-0.85,0.18-0.94-0.39-1-1c26.08-58.92,51.7-118.3,77-178C178,224.67,209.67,222.67,237,225z"></path></g><g></g></g></g><g id="top_xA0_Image_3_"><g id="XMLID_3_"><g><path fill="#FFFF00" d="M289,165c0,1.33,0,2.67,0,4c-17.86,18.48-34.64,38.03-52,57c-56,0-112,0-168,0c0-1,0-2,0-3c21.5-64.83,42.62-130.05,63-196c46.33,0,92.67,0,139,0c-27.25,45.75-54.78,91.22-81,138C223,165,256,165,289,165z"></path></g><g></g></g></g></g><g id="BACK_1_"><g id="bottom_xA0_Image_1_"><g id="XMLID_5_"><g><path fill="#D7CB05" d="M149,225c0,1.33,0,2.67,0,4c-26.73,57.27-50.59,117.41-77,175c-16.02-1.31-37.3,2.63-50-2c25.93-59.4,52.98-117.69,79-177C117,225,133,225,149,225z"></path></g><g></g></g></g><g id="top_xA0_Image_1_"><g id="XMLID_4_"><g><path fill="#D7CB05" d="M133,27c0,1,0,2,0,3c-21.17,64.5-41.92,129.41-62,195c-16.33,0-32.67,0-49,0c0-1,0-2,0-3C43.17,157.5,63.92,92.59,84,27C100.33,27,116.67,27,133,27z"></path></g><g></g></g></g></g></svg>';
                        $h.= '</div>';
                    $h.= '</div>';
                $h.= '</div>
            </div>';

            $h.= '<div id="_dn_EditorContainer" class="_dn_EditorContainer clearFix" >'; // <!-- style="visibility: hidden;" -->
                
                $h.= '<div class="td" style="float:left;">';
                    $h.= '<div class="toolbar_holder dwplay clear">';
                        $h.= '<div class="bc_editor_toolbar">';
                            
                            $h.= '<div class="tool_btn ttip" data-option="templates" data-tooltipster=\'{"side":"right"}\' title="'.__('Add Template','imc').'">';
                                $h.= '<div class="tb_ico">';
                                    $h.= '<svg viewBox="0,0,448,512"><path fill="currentColor" d="M392 32H56C25.1 32 0 57.1 0 88v336c0 30.9 25.1 56 56 56h336c30.9 0 56-25.1 56-56V88c0-30.9-25.1-56-56-56zM194.9 371.4c0 14.8-12 26.9-26.9 26.9H85.1c-14.8 0-26.9-12-26.9-26.9V117.1c0-14.8 12-26.9 26.9-26.9H168c14.8 0 26.9 12 26.9 26.9v254.3zm194.9-112c0 14.8-12 26.9-26.9 26.9H280c-14.8 0-26.9-12-26.9-26.9V117.1c0-14.8 12-26.9 26.9-26.9h82.9c14.8 0 26.9 12 26.9 26.9v142.3z"></path></svg>';
                                $h.= '</div>';
                            $h.= '</div>';
                            $h.= '<div class="tool_btn ttip" data-option="settings" data-tooltipster=\'{"side":"right"}\' title="'.__('Main Settings','imc').'">';
                                $h.= '<div class="tb_ico">';
                                    $h.= '<svg viewBox="0 0 512 512"><path fill="currentColor" d="M444.788 291.1l42.616 24.599c4.867 2.809 7.126 8.618 5.459 13.985-11.07 35.642-29.97 67.842-54.689 94.586a12.016 12.016 0 0 1-14.832 2.254l-42.584-24.595a191.577 191.577 0 0 1-60.759 35.13v49.182a12.01 12.01 0 0 1-9.377 11.718c-34.956 7.85-72.499 8.256-109.219.007-5.49-1.233-9.403-6.096-9.403-11.723v-49.184a191.555 191.555 0 0 1-60.759-35.13l-42.584 24.595a12.016 12.016 0 0 1-14.832-2.254c-24.718-26.744-43.619-58.944-54.689-94.586-1.667-5.366.592-11.175 5.459-13.985L67.212 291.1a193.48 193.48 0 0 1 0-70.199l-42.616-24.599c-4.867-2.809-7.126-8.618-5.459-13.985 11.07-35.642 29.97-67.842 54.689-94.586a12.016 12.016 0 0 1 14.832-2.254l42.584 24.595a191.577 191.577 0 0 1 60.759-35.13V25.759a12.01 12.01 0 0 1 9.377-11.718c34.956-7.85 72.499-8.256 109.219-.007 5.49 1.233 9.403 6.096 9.403 11.723v49.184a191.555 191.555 0 0 1 60.759 35.13l42.584-24.595a12.016 12.016 0 0 1 14.832 2.254c24.718 26.744 43.619 58.944 54.689 94.586 1.667 5.366-.592 11.175-5.459 13.985L444.788 220.9a193.485 193.485 0 0 1 0 70.2zM336 256c0-44.112-35.888-80-80-80s-80 35.888-80 80 35.888 80 80 80 80-35.888 80-80z"></path></svg>';
                                $h.= '</div>';
                            $h.= '</div>';
                            $h.= '<div class="tool_btn ttip" data-option="background" data-tooltipster=\'{"side":"right"}\' title="'.__('Background Color','imc').'">';
                                $h.= '<div class="tb_ico">';
                                    $h.= '<svg viewBox="0 0 512 512"><path fill="currentColor" d="M204.3 5C104.9 24.4 24.8 104.3 5.2 203.4c-37 187 131.7 326.4 258.8 306.7 41.2-6.4 61.4-54.6 42.5-91.7-23.1-45.4 9.9-98.4 60.9-98.4h79.7c35.8 0 64.8-29.6 64.9-65.3C511.5 97.1 368.1-26.9 204.3 5zM96 320c-17.7 0-32-14.3-32-32s14.3-32 32-32 32 14.3 32 32-14.3 32-32 32zm32-128c-17.7 0-32-14.3-32-32s14.3-32 32-32 32 14.3 32 32-14.3 32-32 32zm128-64c-17.7 0-32-14.3-32-32s14.3-32 32-32 32 14.3 32 32-14.3 32-32 32zm128 64c-17.7 0-32-14.3-32-32s14.3-32 32-32 32 14.3 32 32-14.3 32-32 32z"></path></svg>';
                                $h.= '</div>';
                            $h.= '</div>';
                            $h.= '<div class="tool_btn ttip" data-option="text" data-tooltipster=\'{"side":"right"}\' title="'.__('Add Text','imc').'">';
                                $h.= '<div class="tb_ico">';
                                    $h.= '<svg viewBox="0 0 448 512"><path fill="currentColor" d="M152 416h-24.013l26.586-80.782H292.8L319.386 416H296c-8.837 0-16 7.163-16 16v32c0 8.837 7.163 16 16 16h136c8.837 0 16-7.163 16-16v-32c0-8.837-7.163-16-16-16h-26.739L275.495 42.746A16 16 0 0 0 260.382 32h-72.766a16 16 0 0 0-15.113 10.746L42.739 416H16c-8.837 0-16 7.163-16 16v32c0 8.837 7.163 16 16 16h136c8.837 0 16-7.163 16-16v-32c0-8.837-7.163-16-16-16zm64.353-271.778c4.348-15.216 6.61-28.156 7.586-34.644.839 6.521 2.939 19.476 7.727 34.706l41.335 124.006h-98.619l41.971-124.068z"></path></svg>';
                                $h.= '</div>';
                            $h.= '</div>';

                            if( array_key_exists('image', $args)):
                                if( $args['image']['stock_images'] || $args['image']['image_uploads'] ):
                                    $h.= '<div class="tool_btn ttip" data-option="images" data-tooltipster=\'{"side":"right"}\' title="'.__('Add Image','imc').'">';
                                        $h.= '<div class="tb_ico">';
                                            $h.= '<svg viewBox="0 0 576 512"><path fill="currentColor" d="M480 416v16c0 26.51-21.49 48-48 48H48c-26.51 0-48-21.49-48-48V176c0-26.51 21.49-48 48-48h16v208c0 44.112 35.888 80 80 80h336zm96-80V80c0-26.51-21.49-48-48-48H144c-26.51 0-48 21.49-48 48v256c0 26.51 21.49 48 48 48h384c26.51 0 48-21.49 48-48zM256 128c0 26.51-21.49 48-48 48s-48-21.49-48-48 21.49-48 48-48 48 21.49 48 48zm-96 144l55.515-55.515c4.686-4.686 12.284-4.686 16.971 0L272 256l135.515-135.515c4.686-4.686 12.284-4.686 16.971 0L512 208v112H160v-48z"></path></svg>';
                                        $h.= '</div>';
                                    $h.= '</div>';
                                endif;
                            endif;

                            $h.= '<div class="tool_btn ttip" data-option="shapes" data-tooltipster=\'{"side":"right"}\' title="'.__('Add Shape','imc').'">';
                                $h.= '<div class="tb_ico">';
                                    $h.= '<svg viewBox="0,0,512,512"><path fill="currentColor" d="M458.622 255.92l45.985-45.005c13.708-12.977 7.316-36.039-10.664-40.339l-62.65-15.99 17.661-62.015c4.991-17.838-11.829-34.663-29.661-29.671l-61.994 17.667-15.984-62.671C337.085.197 313.765-6.276 300.99 7.228L256 53.57 211.011 7.229c-12.63-13.351-36.047-7.234-40.325 10.668l-15.984 62.671-61.995-17.667C74.87 57.907 58.056 74.738 63.046 92.572l17.661 62.015-62.65 15.99C.069 174.878-6.31 197.944 7.392 210.915l45.985 45.005-45.985 45.004c-13.708 12.977-7.316 36.039 10.664 40.339l62.65 15.99-17.661 62.015c-4.991 17.838 11.829 34.663 29.661 29.671l61.994-17.667 15.984 62.671c4.439 18.575 27.696 24.018 40.325 10.668L256 458.61l44.989 46.001c12.5 13.488 35.987 7.486 40.325-10.668l15.984-62.671 61.994 17.667c17.836 4.994 34.651-11.837 29.661-29.671l-17.661-62.015 62.65-15.99c17.987-4.302 24.366-27.367 10.664-40.339l-45.984-45.004z"></path></svg>';
                                $h.= '</div>';
                            $h.= '</div>';

                            $h.= '<div class="tool_btn ttip" data-option="elements" data-tooltipster=\'{"side":"right"}\' title="'.__('Add Element','imc').'">';
                                $h.= '<div class="tb_ico">';
                                    $h.= '<svg viewBox="0 0 640 512"><path fill="currentColor" d="M278.9 511.5l-61-17.7c-6.4-1.8-10-8.5-8.2-14.9L346.2 8.7c1.8-6.4 8.5-10 14.9-8.2l61 17.7c6.4 1.8 10 8.5 8.2 14.9L293.8 503.3c-1.9 6.4-8.5 10.1-14.9 8.2zm-114-112.2l43.5-46.4c4.6-4.9 4.3-12.7-.8-17.2L117 256l90.6-79.7c5.1-4.5 5.5-12.3.8-17.2l-43.5-46.4c-4.5-4.8-12.1-5.1-17-.5L3.8 247.2c-5.1 4.7-5.1 12.8 0 17.5l144.1 135.1c4.9 4.6 12.5 4.4 17-.5zm327.2.6l144.1-135.1c5.1-4.7 5.1-12.8 0-17.5L492.1 112.1c-4.8-4.5-12.4-4.3-17 .5L431.6 159c-4.6 4.9-4.3 12.7.8 17.2L523 256l-90.6 79.7c-5.1 4.5-5.5 12.3-.8 17.2l43.5 46.4c4.5 4.9 12.1 5.1 17 .6z"></path></svg>';
                                $h.= '</div>';
                            $h.= '</div>';

                            $h.= '<div class="tool_btn" data-option="layer_editor_content" style="display:none;"></div>';
                        $h.= '</div>';
                        // end .bc_editor_toolbar

                        $h.= '<div class="bc_editor_settings">';
                            $h.= '<div class="close_settings">';
                                $h.= '<div class="close_ico">';
                                    //<!-- close icon--> 
                                    $h.= '<svg viewBox="0 0 192 512" style="height:20px;font-size: 48px;"><path fill="currentColor" d="M25.1 247.5l117.8-116c4.7-4.7 12.3-4.7 17 0l7.1 7.1c4.7 4.7 4.7 12.3 0 17L64.7 256l102.2 100.4c4.7 4.7 4.7 12.3 0 17l-7.1 7.1c-4.7 4.7-12.3 4.7-17 0L25 264.5c-4.6-4.7-4.6-12.3.1-17z" class=""></path></svg>';
                                $h.= '</div>';
                            $h.= '</div>';

                            // LAYER EDITOR CONTENT box
                            $h.= '<div class="setting layer_editor_content_settings">';
                                $h.= self::edit_bar_content();
                            $h.= '</div>';

                            //<!-- TEMPLATES -->
                            $h.= '<div id="_dn_TemplateSettings" class="setting templates_settings">';
                                $h.= '<h2>Templates</h2>';
                                
                                $h.= '<div class="_dn_templates_holder">'.__('Loading templates...','imc').'</div>';
                            $h.= '</div>';

                            //<!-- SETTINGS -->
                            $h.= '<div id="_dn_SettingsSettings" class="setting settings_settings">';
                                $h.= '<h2>'.__('Settings','img').'</h2>';

                                $h.= '<div class="main_settings_options tabs border">';
                                    $h.= '<a data-cat="main" class="bg_opt small selected">'.__('Main Settings','imc').'</a>';
                                    //$h.= '<a data-cat="gradient" class="bg_opt small">'.__('Gradient','imc').'</a>';
                                $h.= '</div>';

                                $h.= '<div class="tab_boxes">';
                                    $h.= '<div class="main_settings_option_box tab_option_box main visible">';
                                        $h.= '<div class="set_box bg_size_box">';
                                            $h.= '<div class="spr_row">
                                                <div class="spr_column spr_col-6">
                                                    <div class="spr_column-inner ">
                                                        <div class="spr_wrapper">
                                                            <div class="content_element">
                                                                '.__('width:','imc').' <input type="text" class="_set_inpt _set_bg_width" data-prop="width" placeholder="">
                                                            </div>
                                                        </div>
                                                    </div>
                                                </div>
                                                <div class="spr_column spr_col-6">
                                                    <div class="spr_column-inner ">
                                                        <div class="spr_wrapper">
                                                            <div class="content_element">
                                                                '.__('height:','imc').' <input type="text" class="_set_inpt _set_bg_height" data-prop="height" placeholder="">
                                                            </div>
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>';

                                            $h.= '<div class="spr_row" style="margin-top:10px;">
                                                <div class="spr_column spr_col-6">
                                                    <div class="spr_column-inner ">
                                                        <div class="spr_wrapper">
                                                            <div class="content_element">';
                                                                $h.= '<div>'.__('Align:','imc').'</div>';
                                                                $h.= '<select class="_dn_image_align">';
                                                                    $h.= '<option value="left">Left</option>';
                                                                    $h.= '<option value="center">Center</option>';
                                                                    $h.= '<option value="right">Right</option>';
                                                                $h.= '</select>';
                                                            $h.= '</div>
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>';
                                        $h.= '</div>';
                                        // end .set_box

                                        
                                        $h.= '<div class="set_box">';           
                                            $h.= '<div class="spr_row">
                                                <div class="spr_column spr_col-6">
                                                    <div class="spr_column-inner ">
                                                        <div class="spr_wrapper">
                                                            <div class="content_element">';
                                                                
                                                                // Loop Element checkbox
                                                                $h.= '<div class="" style="margin: 20px 0;">';
                                                                    $h.= ADN_Templates::checkbox(array(
                                                                        'title' => __('Loop Element','imc'),
                                                                        'tooltip' => __('Reload element when it finishes.','imc'),
                                                                        'checked' => 0,
                                                                        'class' => 'option_checkbox loop_element'
                                                                    ));
                                                                $h.= '</div>';

                                                            $h.= '</div>
                                                        </div>
                                                    </div>
                                                </div>
                                                <div class="spr_column spr_col-6">
                                                    <div class="spr_column-inner ">
                                                        <div class="spr_wrapper">
                                                            <div class="content_element">';
                                                                // Responsive checkbox
                                                                $h.= '<div class="" style="margin: 20px 0;">';
                                                                    $h.= ADN_Templates::checkbox(array(
                                                                        'title' => __('Responsive','imc'),
                                                                        'tooltip' => __('Make the image responsive.','imc'),
                                                                        'checked' => 1,
                                                                        'class' => 'option_checkbox img_is_responsive'
                                                                    ));
                                                                $h.= '</div>';
                                                            $h.= '</div>
                                                        </div>
                                                    </div>
                                                </div>
                                                <div class="spr_column spr_col-6">
                                                    <div class="spr_column-inner ">
                                                        <div class="spr_wrapper">
                                                            <div class="content_element">';
                                                                // Full width checkbox
                                                                $h.= '<div class="" style="margin: 20px 0;">';
                                                                    $h.= ADN_Templates::checkbox(array(
                                                                        'title' => __('Full width','imc'),
                                                                        'tooltip' => __('Make image fullwidth.','imc'),
                                                                        'checked' => 0,
                                                                        'class' => 'option_checkbox img_is_fullwidth'
                                                                    ));
                                                                $h.= '</div>';
                                                            $h.= '</div>
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>';
                                        $h.= '</div>';
                                        // end .set_box
                                        

                                    $h.= '</div>';
                                    // end .main option box
                                    

                                $h.= '</div>';
                                // end .tab_boxes
                            $h.= '</div>';

                            //<!-- BACKGROUNDS -->
                            $h.= '<div id="_dn_BackgroundSettings" class="setting background_settings">';
                                $h.= '<h2>'.__('Background Settings','imc').'</h2>';

                                $h.= '<div class="bg_options tabs border">';
                                    $h.= '<a data-cat="solid" class="bg_opt small selected">'.__('Solid','imc').'</a>';
                                    $h.= '<a data-cat="gradient" class="bg_opt small">'.__('Gradient','imc').'</a>';
                                $h.= '</div>';

                                $h.= '<div class="tab_boxes">';
                                    $h.= '<div class="bg_option_box tab_option_box solid visible">';
                                        
                                        $h.= '<div class="bg_color_palets">';
                                            $h.= '<input type="" class="banner_bg_color" data-picker="solid" value="">';
                                            $h.= '<div class="bg_palet trans_p" data-color="transparent"></div>';
                                            $h.= '<div class="bg_palet current" data-color=""></div>';
                                            $h.= '<div>';
                                                $h.= ADN_Templates::predefined_bg_colors(array('type' => 'solid'));
                                            $h.= '</div>';
                                        $h.= '</div>';

                                    $h.= '</div>';
                                    //<!-- end Solid Colors -->
                                    $h.= '<div class="bg_option_box tab_option_box gradient">';
                                        
                                        $h.= '<div class="bg_color_palets">';
                                            $h.= '<input type="" class="banner_bg_color" data-picker="gradient" value="">';
                                            $h.= '<div class="bg_palet trans_p" data-color="transparent"></div>';
                                            $h.= '<div class="bg_palet current" data-color=""></div>';
                                            $h.= '<div>';
                                                $h.= ADN_Templates::predefined_bg_colors(array('type' => 'gradient'));
                                            $h.= '</div>';
                                        $h.= '</div>';

                                    $h.= '</div>';
                                    // <!-- end Gradient Colors -->

                                $h.= '</div>';
                                //<!-- end .tab_boxes -->

                            $h.= '</div>';

                            //<!-- TEXT -->
                            $h.= '<div class="_dn_TextSettings setting text_settings">';
                                $h.= '<h2>'.__('Text','imc').'</h2>';
                                            
                                $h.= '<div class="text_option_box tab_boxes no_tab no_scroll">';
                                    $h.= '<div class="scrollarea">';
                                        $h.= '<div class="text_palets">';
                                            $h.= '<div class="text_palet" data-aspect_ratio="0" data-rsh="e,w" data-size="200xauto">';
                                                $h.= '<div class="_dn_elem"><h1 class="text heading _dn_text">'.sprintf(__('Heading %s','imc'), htmlspecialchars ('<h1>')).'</h1></div>';
                                            $h.= '</div>';
                                            $h.= '<div class="text_palet" data-aspect_ratio="0" data-rsh="e,w" data-size="200xauto">';
                                                $h.= '<div class="_dn_elem"><h2 class="text sub-heading _dn_text">'.sprintf(__('Sub Heading %s','imc'), htmlspecialchars ('<h2>')).'</h2></div>';
                                            $h.= '</div>';
                                            $h.= '<div class="text_palet" data-aspect_ratio="0" data-rsh="e,w" data-size="90xauto">';
                                                $h.= '<div class="_dn_elem"><div class="text normal _dn_text auto_h">'.__('Normal Text','imc').'</div></div>';
                                            $h.= '</div>';
                                            $h.= '<div class="text_palet" data-aspect_ratio="0" data-rsh="e,w" data-size="100xauto">';
                                                $h.= '<div class="_dn_elem"><small class="text small _dn_text">'.sprintf(__('Small %s','imc'), htmlspecialchars ('<small>')).'</small></div>';
                                            $h.= '</div>';
                                            $h.= '<div class="text_palet" data-aspect_ratio="0" data-rsh="e,w" data-size="80x30">';
                                                $h.= '<div class="_dn_elem"><small class="text small _dn_text">☀️</small></div>';
                                            $h.= '</div>';

                                            // Load JSON Template objects
                                            $json_text = ADN_JSON_Templates::text();
                                            if( !empty($json_text))
                                            {
                                                foreach($json_text as $text)
                                                {
                                                    $h.= '<div class="text_palet" data-aspect_ratio="0" data-rsh="e,w" data-size="200xauto">';
                                                        $h.= ADN_Templates::load_json_object(array(
                                                            'json' => urlencode($text['json'])
                                                        ));
                                                    $h.= '</div>';
                                                }
                                            }

                                        $h.= '</div>';
                                    $h.= '</div>';
                                    // end scrollarea
                                $h.= '</div>';
                            $h.= '</div>';

                            //<!-- IMAGES -->
                            if( array_key_exists('image', $args)):
                            
                            $img_uploads = $args['image']['image_uploads'];
                            $stock = $args['image']['stock_images'] ? 1 : 0;
                            $giphy = !empty($args['image']['stock_providers']['giphy']['application_id']) ? 1 : 0;

                            $h.= '<div id="_dn_ImageSettings" class="setting images_settings" style="position: relative;">';
                                $h.= '<h2>'.__('Images','imc').'</h2>';

                                $h.= '<div class="image_options tabs border">';
                                
                                    $h.= $stock ? '<a data-cat="stock" class="image_opt small selected">'.__('Stock Photos','imc').'</a>' : '';
                                    $selected = !$stock ? ' selected' : '';
                                    $h.= '<a data-cat="my" class="image_opt small'.$selected.'">'.__('My Images','imc').'</a>';
                                    $h.= $giphy ? '<a data-cat="giphy" class="image_opt small">'.__('GIFs','imc').'</a>' : ''; 
                                $h.= '</div>';

                                $h.= '<div class="tab_boxes no_scroll">';
                                    //<!-- STOCK images -->
                                    if( $stock )
                                    {
                                        $h.= '<div class="img_option_box tab_option_box stock visible">';
                                            $h.= '<div class="input_container">';
                                                $h.= '<a id="SearchStockImages" class="img_search_btn">';
                                                    $h.= '<svg xmlns="http://www.w3.org/2000/svg" viewBox="0,0,512,512"><path d="M505 442.7L405.3 343c-4.5-4.5-10.6-7-17-7H372c27.6-35.3 44-79.7 44-128C416 93.1 322.9 0 208 0S0 93.1 0 208s93.1 208 208 208c48.3 0 92.7-16.4 128-44v16.3c0 6.4 2.5 12.5 7 17l99.7 99.7c9.4 9.4 24.6 9.4 33.9 0l28.3-28.3c9.4-9.4 9.4-24.6.1-34zM208 336c-70.7 0-128-57.2-128-128 0-70.7 57.2-128 128-128 70.7 0 128 57.2 128 128 0 70.7-57.2 128-128 128z" class="colorful c1"></path></svg>';
                                                $h.= '</a>';
                                                $h.= '<input type="text" class="input search_input _dn_search_images" data-result-box-id="stock_result" placeholder="'.__('Search for images','imc').'">';
                                            $h.= '</div>';
                                            $h.= '<div class="scrollarea has_search">';
                                                $h.= '<div style="position:relative;">';
                                                    $h.= '<div id="stock_result" class="grid">'.ADN_Templates::unsplashed_photos().'</div>'; // to search a specific categroy: array('action' => 'search', 'query' => 'wave')
                                                $h.= '</div>';
                                            $h.= '</div>';
                                        $h.= '</div>';
                                    }
                                    //<!-- end STOCK images content -->

                                    //<!-- MY images -->
                                    //if( $args['image']['image_uploads']){
                                    $visible = !$args['image']['stock_images'] ? ' visible' : '';
                                    $h.= '<div class="img_option_box tab_option_box my'.$visible.'">';
                                        $h.= $img_uploads ? '<form class="box" method="post" action="'.IMC_AJAXURL.'" enctype="multipart/form-data" novalidate></form>' : '';
                                        $h.= '<div class="input_container">';
                                            $h.= '<input type="text" class="input _dn_add_image_from_url" placeholder="'.__('Add image from URL','imc').'" />';
                                        $h.= '</div>';

                                        $h.= '<div class="scrollarea has_upload">';
                                            $h.= '<div id="upload_result" class="grid">';

                                                if( !empty($banner_obj))
                                                {
                                                    if(array_key_exists('user_id', $banner_obj)):
                                                        // fix, need to figure out why we need to load the class file again; if loaded from (my banners/edit) in php version.
                                                        if( !class_exists('IMC_Uploader') ){
                                                            require_once(IMC_INC_DIR. '/extensions/imc_uploader/IMC_Uploader.php');
                                                        }
                                                        //$h.= $editor_settings['upload']['dir'].'user_uploads/'.ImgMCE::$current_user_id.'/'.$banner_obj['id'].'/images/';
                                                        $h.= IMC_Uploader::load_images(array(
                                                            'upload_path' => IMC_UPLOAD_DIR, 
                                                            'upload_src' => IMC_UPLOAD_SRC, 
                                                            'upload_folder' => 'user_uploads/'.$banner_obj['user_id'].'/'.$banner_obj['id'].'/images/',
                                                            'user_id' => ImgMCE::$current_user_id
                                                        ));
                                                    endif;
                                                }
                                            $h.= '</div>';
                                        $h.= '</div>';
                                    $h.= '</div>';
                                    //}
                                    //<!-- end MY images content -->
                                    //<!-- GIPHY animated GIFs -->
                                    if( $giphy )
                                    {
                                        $h.= '<div class="img_option_box tab_option_box giphy">';
                                            $h.= '<div class="input_container">';
                                                $h.= '<a id="SearchGifs" class="img_search_btn">';
                                                    $h.= '<svg xmlns="http://www.w3.org/2000/svg" viewBox="0,0,512,512"><path d="M505 442.7L405.3 343c-4.5-4.5-10.6-7-17-7H372c27.6-35.3 44-79.7 44-128C416 93.1 322.9 0 208 0S0 93.1 0 208s93.1 208 208 208c48.3 0 92.7-16.4 128-44v16.3c0 6.4 2.5 12.5 7 17l99.7 99.7c9.4 9.4 24.6 9.4 33.9 0l28.3-28.3c9.4-9.4 9.4-24.6.1-34zM208 336c-70.7 0-128-57.2-128-128 0-70.7 57.2-128 128-128 70.7 0 128 57.2 128 128 0 70.7-57.2 128-128 128z" class="colorful c1"></path></svg>';
                                                $h.= '</a>';
                                                $h.= '<input type="text" class="input search_input _dn_search_images" data-result-box-id="giphy_result" placeholder="'.__('Search for GIFs','imc').'">';
                                            $h.= '</div>';
                                            $h.= '<div class="scrollarea has_search">';
                                                $h.= '<div style="position:relative;">';
                                                    $h.= '<div id="giphy_result" class="grid">'.ADN_Templates::giphy_gifs().'</div>'; // to search a specific categroy: array('action' => 'search', 'query' => 'wave')
                                                $h.= '</div>';
                                            $h.= '</div>';
                                        $h.= '</div>';
                                    }
                                    //<!-- end GIPHY animated GIFs -->
                                    
                                $h.= '</div>';
                                //<!-- end .tab_boxes -->

                            $h.= '</div>';
                            endif;
                            
                            //<!-- SHAPES -->
                            $h.= '<div id="_dn_ShapeSettings" class="setting shapes_settings" style="position: relative;">';
                                $h.= '<h2>'.__('Shapes','imc').'</h2>';

                                $h.= '<div class="shape_options tabs border">';
                                    $h.= '<a data-cat="html" class="shape_opt small selected">'.__('HTML','imc').'</a>';
                                    $h.= '<a data-cat="emojis" class="shape_opt small">'.__('Emojis','imc').'</a>';
                                    $h.= '<a data-cat="icons" class="shape_opt small">'.__('Icons','imc').'</a>';
                                    $h.= '<a data-cat="stickers" class="shape_opt small">'.__('Stickers','imc').'</a>';
                                    //$h.= '<a data-cat="buttons" class="shape_opt small">'.__('Buttons','imc').'</a>';
                                $h.= '</div>';

                                $h.= '<div class="tab_boxes no_scroll">';
                                    // BASIC Shapes
                                    $h.= '<div class="shape_option_box tab_option_box html visible" data-shape-type="html">';
                                        $h.= '<div class="scrollarea">';
                                            $h.= '<div class="shape_palets">';
                                                $h.= ADN_Templates::html_shapes(array('type' => 'shapes'));

                                                // Load JSON Template objects
                                                $json_html_shapes = ADN_JSON_Templates::html_shapes();
                                                if( !empty($json_html_shapes))
                                                {
                                                    foreach($json_html_shapes as $html_shape)
                                                    {
                                                        $h.= '<div class="shape_palet" data-aspect_ratio="0" data-size="200x200">';
                                                            $h.= ADN_Templates::load_json_object(array(
                                                                'json' => urlencode($html_shape['json'])
                                                            ));
                                                        $h.= '</div>';
                                                    }
                                                }
                                            $h.= '</div>';
                                        $h.= '</div>';
                                    $h.= '</div>';
                                    //<!-- end BASIC shapes -->
                                    // EMOJIS
                                    $h.= '<div class="shape_option_box tab_option_box emojis" data-shape-type="emoji">';
                                        $h.= '<div class="input_container">';
                                            $h.= '<a class="img_search_btn">';
                                                $h.= '<svg xmlns="http://www.w3.org/2000/svg" viewBox="0,0,512,512"><path d="M505 442.7L405.3 343c-4.5-4.5-10.6-7-17-7H372c27.6-35.3 44-79.7 44-128C416 93.1 322.9 0 208 0S0 93.1 0 208s93.1 208 208 208c48.3 0 92.7-16.4 128-44v16.3c0 6.4 2.5 12.5 7 17l99.7 99.7c9.4 9.4 24.6 9.4 33.9 0l28.3-28.3c9.4-9.4 9.4-24.6.1-34zM208 336c-70.7 0-128-57.2-128-128 0-70.7 57.2-128 128-128 70.7 0 128 57.2 128 128 0 70.7-57.2 128-128 128z" class="colorful c1"></path></svg>';
                                            $h.= '</a>';
                                            $h.= '<input type="text" id="SearchEmojis" class="input search_input _dn_search_filter" data-value-class="_dn_filter_emoji_box" placeholder="'.__('Search for emojis','imc').'">';
                                        $h.= '</div>';
                                        $h.= '<div class="scrollarea has_search">';
                                            $h.= '<div class="shape_palets"></div>';
                                        $h.= '</div>';
                                    $h.= '</div>';
                                    //<!-- end EMOJIS shapes -->
                                    // ICONS
                                    $h.= '<div class="shape_option_box tab_option_box icons" data-shape-type="icon">';
                                        $h.= '<div class="input_container">';
                                            $h.= '<a class="img_search_btn">';
                                                $h.= '<svg xmlns="http://www.w3.org/2000/svg" viewBox="0,0,512,512"><path d="M505 442.7L405.3 343c-4.5-4.5-10.6-7-17-7H372c27.6-35.3 44-79.7 44-128C416 93.1 322.9 0 208 0S0 93.1 0 208s93.1 208 208 208c48.3 0 92.7-16.4 128-44v16.3c0 6.4 2.5 12.5 7 17l99.7 99.7c9.4 9.4 24.6 9.4 33.9 0l28.3-28.3c9.4-9.4 9.4-24.6.1-34zM208 336c-70.7 0-128-57.2-128-128 0-70.7 57.2-128 128-128 70.7 0 128 57.2 128 128 0 70.7-57.2 128-128 128z" class="colorful c1"></path></svg>';
                                            $h.= '</a>';
                                            $h.= '<input type="text" id="SearchIcons" class="input search_input _dn_search_filter" data-value-class="_dn_filter_box" placeholder="'.__('Search for icons','imc').'">';
                                        $h.= '</div>';
                                        $h.= '<div class="scrollarea has_search">';
                                            $h.= '<div class="shape_palets"></div>';
                                        $h.= '</div>';
                                    $h.= '</div>';
                                    //<!-- end ICONS shapes -->
                                    // STICKERS
                                    $h.= '<div class="shape_option_box tab_option_box stickers" data-shape-type="sticker">';
                                        $h.= '<div class="input_container">';
                                            $h.= '<input type="text" id="SearchStickers" class="input search_input _dn_search_filter" data-value-class="sticker_palet" placeholder="'.__('Search for stickers','imc').'">';
                                        $h.= '</div>';
                                        $h.= '<div class="scrollarea has_search">';
                                            $h.= '<div class="shape_palets">';
                                                $h.= ADN_Templates::html_shapes(array('type' => 'stickers'));
                                            $h.= '</div>';
                                        $h.= '</div>';
                                    $h.= '</div>';
                                    //<!-- end Stickers -->
                                    // BUTTONS
                                    // @since v1.1.5 moved to Elements
                                    /*$h.= '<div class="_dn_ButtonSettings shape_option_box tab_option_box buttons buttons_settings" data-shape-type="button">';
                                        $h.= '<div class="button_option_box tab_option_box buttons">';
                                            $h.= '<div class="scrollarea">'; // no_x
                                                $h.= '<div class="shape_palets">';
                                                    
                                                    $h.= '<div style="margin:10px 0;">';
                                                        $h.= ADN_Templates::html_shapes(array('type' => 'buttons'));
                                                    $h.= '</div>';
                                                    
                                                    // Load JSON Template objects
                                                    $json_buttons = ADN_JSON_Templates::buttons();
                                                    if( !empty($json_buttons))
                                                    {
                                                        $h.= '<div>';
                                                            foreach($json_buttons as $button)
                                                            {
                                                                if( array_key_exists('json', $button)):
                                                                $h.= '<div class="shape_palet" data-aspect_ratio="0" data-size="172x42">';
                                                                    $h.= ADN_Templates::load_json_object(array(
                                                                        'json' => urlencode($button['json'])
                                                                    ));
                                                                $h.= '</div>';
                                                                endif;
                                                            }
                                                        $h.= '</div>';
                                                    }
                                                $h.= '</div>';
                                            $h.= '</div>';
                                        $h.= '</div>';
                                    $h.= '</div>';*/
                                    //<!-- end Buttons -->
                                    
                                $h.= '</div>';
                                //<!-- end .tab_boxes -->
                            $h.= '</div>';
                            // end .shapes



                            //<!-- ELEMENTS -->
                            $h.= '<div id="_dn_ElementSettings" class="setting elements_settings" style="position: relative;">';
                                $h.= '<h2>'.__('Elements','imc').'</h2>';

                                $h.= '<div class="element_options tabs border">';
                                    $h.= '<a data-cat="html" class="element_opt small selected">'.__('HTML','imc').'</a>';
                                    $h.= '<a data-cat="buttons" class="element_opt small">'.__('Buttons','imc').'</a>';
                                    $h.= '<a data-cat="video" class="element_opt small">'.__('Video','imc').'</a>';
                                $h.= '</div>';

                                $h.= '<div class="tab_boxes no_scroll">';
                                
                                    // HTML ELEMENTS
                                    $h.= '<div class="element_option_box tab_option_box html visible" data-element-type="html">';
                                        $h.= '<div class="scrollarea">';
                                            $h.= '<div class="element_palets">';
                                                
                                                $h.= ADN_Templates::html_elements(array('type' => 'html'));

                                            $h.= '</div>';
                                        $h.= '</div>';
                                    $h.= '</div>';
                                    // end html elements

                                    // BUTTON ELEMENTS
                                    $h.= '<div class="_dn_ButtonSettings element_option_box tab_option_box buttons buttons_settings" data-element-type="button">';
                                        $h.= '<div class="button_option_box tab_option_box buttons">';
                                            $h.= '<div class="scrollarea">'; // no_x
                                                $h.= '<div class="element_palets">';

                                                    $h.= '<div style="margin:10px 0;">';
                                                        $h.= ADN_Templates::html_shapes(array('type' => 'buttons'));
                                                    $h.= '</div>';
                                                    
                                                    // Load JSON Template objects
                                                    $json_buttons = ADN_JSON_Templates::buttons();
                                                    if( !empty($json_buttons))
                                                    {
                                                        $h.= '<div>';
                                                            foreach($json_buttons as $button)
                                                            {
                                                                if( array_key_exists('json', $button)):
                                                                $h.= '<div class="element_palet" data-aspect_ratio="0" data-size="172x42">';
                                                                    $h.= ADN_Templates::load_json_object(array(
                                                                        'json' => urlencode($button['json'])
                                                                    ));
                                                                $h.= '</div>';
                                                                endif;
                                                            }
                                                        $h.= '</div>';
                                                    }

                                                $h.= '</div>';
                                            $h.= '</div>';
                                        $h.= '</div>';
                                    $h.= '</div>';
                                    // end button elements

                                    // VIDEO ELEMENTS
                                    $h.= '<div class="element_option_box tab_option_box video" data-element-type="video">';
                                        $h.= '<div class="scrollarea">';
                                            $h.= '<div class="element_palets">';
                                                
                                                $h.= ADN_Templates::html_elements(array('type' => 'video'));

                                            $h.= '</div>';
                                        $h.= '</div>';
                                    $h.= '</div>';
                                    // end video elements
                                
                                $h.= '</div>';
                                // end .tab_boxes

                            $h.= '</div>';
                            // end .elements

                        $h.= '</div>';
                    $h.= '</div>';
                $h.= '</div>';

                $h.= '<div class="td" style="float:right;">';
                    $h.= '<div class="timeline_holder dwplay closed">';
                        $h.= '<div class="menu">';
                            $h.= '<div class="close_timeline">';
                                $h.= '<div class="close_ico">';
                                    //<!-- close icon--> 
                                    $h.= '<svg viewBox="0 0 192 512" style="font-size:48px;height:20px;"><path d="M166.9 264.5l-117.8 116c-4.7 4.7-12.3 4.7-17 0l-7.1-7.1c-4.7-4.7-4.7-12.3 0-17L127.3 256 25.1 155.6c-4.7-4.7-4.7-12.3 0-17l7.1-7.1c4.7-4.7 12.3-4.7 17 0l117.8 116c4.6 4.7 4.6 12.3-.1 17z" class=""></path></svg>';
                                $h.= '</div>';
                            $h.= '</div>';
                            //$h.= '<h2>'.__('Timeline','imc').'</h2>';
                        $h.= '</div>';

                        $h.= '<div class="slides_and_layers_box"></div>';

                    $h.= '</div>';
                    //<!-- end .timeline_holder -->
                $h.= '</div>';



                $h.= '<div class="td" style="height: calc(100vh - 138px);">';
                    $h.= '<div class="editor_stage_holder">';

                        // Info Message holder
                        $h.= '<div class="_info_message">';
                            if( !empty($editor_settings['messages']['editor_screen']) )
                            {
                                $h.= '<div class="_info_msg_content">'.urldecode($editor_settings['messages']['editor_screen']).'</div>';
                                $h.= '<a class="_close_info_msg"><svg style="height:13px;width:13px;" viewBox="0 0 320 512"><path fill="#ababab" d="M193.94 256L296.5 153.44l21.15-21.15c3.12-3.12 3.12-8.19 0-11.31l-22.63-22.63c-3.12-3.12-8.19-3.12-11.31 0L160 222.06 36.29 98.34c-3.12-3.12-8.19-3.12-11.31 0L2.34 120.97c-3.12 3.12-3.12 8.19 0 11.31L126.06 256 2.34 379.71c-3.12 3.12-3.12 8.19 0 11.31l22.63 22.63c3.12 3.12 8.19 3.12 11.31 0L160 289.94 262.56 392.5l21.15 21.15c3.12 3.12 8.19 3.12 11.31 0l22.63-22.63c3.12-3.12 3.12-8.19 0-11.31L193.94 256z"></path></svg></a>';
                            }
                        $h.= '</div>';
                        // end ._info_message

                        $h.= '<div class="editor_stage_container editor">'; // <!-- style="height: calc((100% - 56px) - 154px);" -->
                            $h.= '<div class="stage_positioning">';

                                $h.= '<div class="scrollarea">';
                                    $h.= '<div class="stage_selection">';
                                        $h.= '<div class="_dn_stage_selection_cont">';
                                            
                                            //<!-- BANNER ELEMENT -->
                                            $h.= '<div class="banner_element"><div class="stage _dn_editor_stage"></div></div>';
                                            //<!-- end .banner_element -->

                                        $h.= '</div>';
                                    $h.= '</div>';
                                $h.= '</div>';
                            $h.= '</div>';
                                //<!-- end .stage_positioning -->

                            $h.= '<div class="stage_zoom">';
                                $h.= '<div>';
                                    $h.= '<a class="ur_btn _dn_undo ttip" title="'.__('Undo (Command+z)','imc').'">';
                                        $h.= '<svg viewBox="0,0,448,512"><path class="undo_path" d="M257.5 445.1l-22.2 22.2c-9.4 9.4-24.6 9.4-33.9 0L7 273c-9.4-9.4-9.4-24.6 0-33.9L201.4 44.7c9.4-9.4 24.6-9.4 33.9 0l22.2 22.2c9.5 9.5 9.3 25-.4 34.3L136.6 216H424c13.3 0 24 10.7 24 24v32c0 13.3-10.7 24-24 24H136.6l120.5 114.8c9.8 9.3 10 24.8.4 34.3z"></path></svg>';
                                    $h.= '</a>';
                                    $h.= '<a class="ur_btn _dn_redo ttip" title="'.__('Redo (Alt+z)','imc').'">';
                                        $h.= '<svg viewBox="0,0,448,512"><path class="undo_path" d="M190.5 66.9l22.2-22.2c9.4-9.4 24.6-9.4 33.9 0L441 239c9.4 9.4 9.4 24.6 0 33.9L246.6 467.3c-9.4 9.4-24.6 9.4-33.9 0l-22.2-22.2c-9.5-9.5-9.3-25 .4-34.3L311.4 296H24c-13.3 0-24-10.7-24-24v-32c0-13.3 10.7-24 24-24h287.4L190.9 101.2c-9.8-9.3-10-24.8-.4-34.3z" class="colorful c1"></path></svg>';
                                    $h.= '</a>';
                                $h.= '</div>';
                                $h.= '<div class="zoom_cont">';
                                    $h.= '<div id="_dn_zoom"></div>';
                                $h.= '</div>';
                            $h.= '</div>';
                            // end .stage_zoom

                            $h.= '<div class="js_preview"></div>';

                        $h.= '</div>';
                        // end .editor_stage_container


                        // Timeline ( change editor height on imgmce_style line 1211 .editor_stage_container { height: calc((100% - 166px)) )
                        $h.= self::timeline();


                    $h.= '</div>';
                $h.= '</div>';
                

    
                    
            $h.= '</div>';
            //<!-- end #_dn_EditorContainer -->
            

        $h.= '</div>';
        //<!-- end #_dn_ImageEditor -->

        //$h.= '<pre>'.print_r($banner_obj, true).'</pre>';

        return $h;
    }










    /**
     * TIMELINE
     */
    public static function timeline($slide = array(), $args = array())
    {
        $defaults = array(
            'start_height' => '151',
            'layer_container' => '107'
		);
        $args = ADN_Main::parse_args($args, $defaults);

        $slide_duration = array_key_exists('duration',$slide) && !empty($slide['duration']) ? $slide['duration']*80 : 400;

        $h = '';
        $h.= '<div class="timeline_container dwplay" style="height:'.$args['start_height'].'px;position:absolute;bottom:0;">';
            $h.= '<div class="timeline_resize"></div>';
            $h.= '<div class="timeline_left_column">';
                $h.= '<div class="timeline_left_header">
                    <div class="timeline_title">
                        <span>Layers</span>
                    </div>   
                </div>';
                $h.= '<div class="timeline_layers_container">';
                    $h.= '<div style="position: relative; overflow: hidden; width: 100%; height: auto; min-height: 144px;">';
                        $h.= '<div class="syncscroll_left syncscroll" style="position: relative; overflow: scroll; margin-right: 0px; margin-bottom: 0px; min-height:'.$args['layer_container'].'px; max-height: 0px;">';
                            
                            $h.= '<div class="timeline_layers_sortable">';
                                
                                if( !empty($slide) && array_key_exists('layers', $slide))
                                {
                                    foreach ($slide['layers'] as $key => $layer) 
                                    {
                                        $layer_html = ADN_Templates::timeline_layers( ADN_Main::parse_args(array('layer_nr' => $key), $layer) );
                                        $h.= $layer_html['layer'];
                                    }
                                }

                            $h.= '</div>';
                            // end .timeline_layers_sortable
                            
                        $h.= '</div>
                    </div>
                </div>
            </div>';
            $h.= '<div class="timeline_right_column">';
                
                $h.= '<div class="timeline_seconds_container">
                    <div class="timeline_seconds_inner" >';
                        $h.= '<div class="timeline_seconds_element_duration" style="left: 0px; width:'.$slide_duration.'px;">';
                            $h.= '<span class="element_duration_handle"></span>';
                        $h.= '</div>';
                        $h.= '<div class="timeline_seconds_ruler_container">';
                           
                            $b = 0;
                            $sec = 0;
                            for($r = 0; $r < 150; $r++) 
                            {
                                $stl = $b === 5 ? ' style="height:10px;"' : '';
                                $unit = !$r ? 'seconds' : ($r/10);
                                $h.= !$b ? '<span class="seconds_ruler ruler_full_second" data-sec="'.$unit.'"></span>' : '<span class="seconds_ruler ruler_micro_second"'.$stl.'></span>';
                                
                                $b = $b === 9 ? 0 : $b+1;
                            }
                           
                        $h.= '</div>
                    </div>
                </div>';
                $h.= '<div style="position: relative; overflow: hidden; width: 100%; height: auto; min-height: 144px;">';
                    $h.= '<div class="syncscroll_right syncscroll" style="position: relative; overflow: scroll; margin-right: 0px; margin-bottom: 0px; min-height:'.$args['layer_container'].'px; max-height: 0px;">';
                        
                        if( !empty($slide) && array_key_exists('layers', $slide))
                        {
                            foreach ($slide['layers'] as $key => $layer) 
                            {
                                $layer_html = ADN_Templates::timeline_layers( ADN_Main::parse_args(array('layer_nr' => $key), $layer) );
                                $h.= $layer_html['animation'];
                            }
                        }

                        // Animation popup
                        $h.= '<div class="timeline_animation_popup">';
                            $h.= '<div class="timeline_animation_popup_inner">';
                                $h.= '<div class="tml_animation_header">';
                                    $h.= '<span class="tml_ani_header_txt">'.__('ANIMATION','imc').'</span>';
                                    $h.= '<span class="tml_ani_close_btn"><svg style="height:20px;width:20px;" viewBox="0 0 320 512"><path fill="#FFFFFF" d="M193.94 256L296.5 153.44l21.15-21.15c3.12-3.12 3.12-8.19 0-11.31l-22.63-22.63c-3.12-3.12-8.19-3.12-11.31 0L160 222.06 36.29 98.34c-3.12-3.12-8.19-3.12-11.31 0L2.34 120.97c-3.12 3.12-3.12 8.19 0 11.31L126.06 256 2.34 379.71c-3.12 3.12-3.12 8.19 0 11.31l22.63 22.63c3.12 3.12 8.19 3.12 11.31 0L160 289.94 262.56 392.5l21.15 21.15c3.12 3.12 8.19 3.12 11.31 0l22.63-22.63c3.12-3.12 3.12-8.19 0-11.31L193.94 256z"></path></svg></span>';
                                $h.= '</div>';
                                // end .tml_animation_header
                                $h.= '<div class="tml_animation_content">';
                                    /*$animations = array(
                                        array('class' => '', 'name' => 'None')
                                    );
                                    foreach($animations as $ani)
                                    {
                                        $icon = '<svg viewBox="0 0 512 512"><path d="M256 8C119 8 8 119 8 256s111 248 248 248 248-111 248-248S393 8 256 8z"></path></svg>';
                                        $icon = empty($ani['class']) ? '<svg viewBox="0 0 512 512"><path d="M256 8C119.034 8 8 119.033 8 256s111.034 248 248 248 248-111.034 248-248S392.967 8 256 8zm130.108 117.892c65.448 65.448 70 165.481 20.677 235.637L150.47 105.216c70.204-49.356 170.226-44.735 235.638 20.676zM125.892 386.108c-65.448-65.448-70-165.481-20.677-235.637L361.53 406.784c-70.203 49.356-170.226 44.736-235.638-20.676z"></path></svg>' : $icon;
                                        $h.= '<div class="animation_box" data-class="'.$ani['class'].'">';
                                            $h.= '<div class="inner">';
                                                $h.= '<div class="example_shape">'.$icon.'</div>';
                                                $h.= $ani['name'];
                                            $h.= '</div>';
                                        $h.= '</div>';
                                    }*/
                                    
                                    $animations = ADN_JSON_Templates::build_animations();
                                    // IN
                                    foreach($animations['in'] as $key => $ani)
                                    {
                                        $icon = '<svg viewBox="0 0 448 512"><path d="M400 32H48C21.5 32 0 53.5 0 80v352c0 26.5 21.5 48 48 48h352c26.5 0 48-21.5 48-48V80c0-26.5-21.5-48-48-48z"></path></svg>';
                                        $icon = $key === 'none' ? '<svg viewBox="0 0 512 512"><path d="M256 8C119.034 8 8 119.033 8 256s111.034 248 248 248 248-111.034 248-248S392.967 8 256 8zm130.108 117.892c65.448 65.448 70 165.481 20.677 235.637L150.47 105.216c70.204-49.356 170.226-44.735 235.638 20.676zM125.892 386.108c-65.448-65.448-70-165.481-20.677-235.637L361.53 406.784c-70.203 49.356-170.226 44.736-235.638-20.676z"></path></svg>' : $icon;
                                        $h.= '<div class="animation_box in_animation" data-class="'.$key.'">';
                                            $h.= '<div class="inner">';
                                                $h.= '<div class="example_shape imgmce_ani_normal">'.$icon.'</div>';
                                                $h.= $ani['name'];
                                                //$h.= '<input class="animation_code" type="hidden" value="'.$ani['code'].'" />';
                                            $h.= '</div>';
                                        $h.= '</div>';
                                    }
                                    

                                    // OUT
                                    foreach($animations['out'] as $key => $ani)
                                    {
                                        $icon = '<svg viewBox="0 0 448 512"><path d="M400 32H48C21.5 32 0 53.5 0 80v352c0 26.5 21.5 48 48 48h352c26.5 0 48-21.5 48-48V80c0-26.5-21.5-48-48-48z"></path></svg>';
                                        $icon = $key === 'none' ? '<svg viewBox="0 0 512 512"><path d="M256 8C119.034 8 8 119.033 8 256s111.034 248 248 248 248-111.034 248-248S392.967 8 256 8zm130.108 117.892c65.448 65.448 70 165.481 20.677 235.637L150.47 105.216c70.204-49.356 170.226-44.735 235.638 20.676zM125.892 386.108c-65.448-65.448-70-165.481-20.677-235.637L361.53 406.784c-70.203 49.356-170.226 44.736-235.638-20.676z"></path></svg>' : $icon;
                                        $h.= '<div class="animation_box out_animation" data-class="'.$key.'">';
                                            $h.= '<div class="inner">';
                                                $h.= '<div class="example_shape imgmce_ani_normal">'.$icon.'</div>';
                                                $h.= $ani['name'];
                                                //$h.= '<input class="animation_code" type="hidden" value="'.$ani['code'].'" />';
                                            $h.= '</div>';
                                        $h.= '</div>';
                                    }
                                    
                                    // ANIMATION PLUGINS
                                    /*$plugins = ADN_JSON_Templates::animation_effect_plugins();
                                    foreach($plugins['imgmce_css_animations']['editing']['class']['select'] as $ani)
                                    {
                                        $icon = '<svg viewBox="0 0 512 512"><path d="M256 8C119 8 8 119 8 256s111 248 248 248 248-111 248-248S393 8 256 8z"></path></svg>';
                                        $h.= '<div class="animation_box" data-plugin="'.$key.'" data-class="'.$ani.'">';
                                            $h.= '<div class="inner">';
                                                $h.= '<div class="example_shape imgmce_ani_normal">'.$icon.'</div>';
                                                $h.= $ani;
                                            $h.= '</div>';
                                        $h.= '</div>';
                                    }*/
                                $h.= '</div>';
                                // end .tml_animation_content


                            $h.= '</div>';
                        $h.= '</div>';
                        // end animation popup

                        //$h.= '</div>';
                    $h.= '</div>';
                    // end .syncscroll_right
                    
                $h.= '</div>';
                
            $h.= '</div>';
        $h.= '</div>';

        return $h;
    }










    public static function edit_bar_content()
    {
        $h = '';
        //<!-- EDIT BAR -->
        $h.= '<div class="edit_bar_container edit_bar_holder">';

            // Menu
            $h.= '<div class="tools_container editor_stage_menu edit_bar_container">';
                $h.= '<div class="edit_tool_btn settings ttip" data-panel="settings" data-tooltipster=\'{"side":"top"}\' title="'.__('Layer Settings','imc').'">';
                    $h.= '<div class="button_overlay"></div>';
                    $h.= '<div class="icon"><svg viewBox="0 0 576 512"><path fill="currentColor" d="M564 100H160V60c0-13.2-10.8-24-24-24H88c-13.2 0-24 10.8-24 24v40H12c-6.6 0-12 5.4-12 12v8c0 6.6 5.4 12 12 12h52v40c0 13.2 10.8 24 24 24h48c13.2 0 24-10.8 24-24v-40h404c6.6 0 12-5.4 12-12v-8c0-6.6-5.4-12-12-12zm-436 64H96V68h32v96zm436 80h-84v-40c0-13.2-10.8-24-24-24h-48c-13.2 0-24 10.8-24 24v40H12c-6.6 0-12 5.4-12 12v8c0 6.6 5.4 12 12 12h372v40c0 13.2 10.8 24 24 24h48c13.2 0 24-10.8 24-24v-40h84c6.6 0 12-5.4 12-12v-8c0-6.6-5.4-12-12-12zm-116 64h-32v-96h32v96zm116 80H288v-40c0-13.2-10.8-24-24-24h-48c-13.2 0-24 10.8-24 24v40H12c-6.6 0-12 5.4-12 12v8c0 6.6 5.4 12 12 12h180v40c0 13.2 10.8 24 24 24h48c13.2 0 24-10.8 24-24v-40h276c6.6 0 12-5.4 12-12v-8c0-6.6-5.4-12-12-12zm-308 64h-32v-96h32v96z" class=""></path></svg></div>';
                $h.= '</div>';
                $h.= '<div class="edit_tool_btn text ttip" data-panel="text" data-tooltipster=\'{"side":"top"}\' title="'.__('Text Settings','imc').'">';
                    $h.= '<div class="button_overlay"></div>';
                    $h.= '<div class="icon">';
                        $h.= '<svg viewBox="0 0 448 512"><path fill="currentColor" d="M402.629 430.504L262.703 39.953A12 12 0 0 0 251.406 32h-54.811a12 12 0 0 0-11.297 7.953L45.371 430.504H20c-6.627 0-12 5.373-12 12V468c0 6.627 5.373 12 12 12h120c6.627 0 12-5.373 12-12v-25.496c0-6.627-5.373-12-12-12h-30.538l34.901-99.625h158.64l34.901 99.625H308c-6.627 0-12 5.373-12 12V468c0 6.627 5.373 12 12 12h120c6.627 0 12-5.373 12-12v-25.496c0-6.627-5.373-12-12-12h-25.371zM160.227 280.113l55.206-155.468C221.145 106.244 224 90.38 224 90.38s2.221 15.864 8.566 34.266l54.573 155.468H160.227z" class=""></path></svg>';
                    $h.= '</div>';
                $h.= '</div>';
                $h.= '<div class="edit_tool_btn filters ttip" data-panel="filters" data-tooltipster=\'{"side":"top"}\' title="'.__('Filters','imc').'">';
                    $h.= '<div class="button_overlay"></div>';
                    $h.= '<div class="icon">';
                        $h.= '<svg viewBox="0 0 205.333 190.668"><circle fill="none" stroke="#000000" stroke-width="10" stroke-miterlimit="10" cx="102.667" cy="66.334" r="55.666"/><circle fill="none" stroke="#000000" stroke-width="10" stroke-miterlimit="10" cx="141.667" cy="127.334" r="55.667"/><circle fill="none" stroke="#000000" stroke-width="10" stroke-miterlimit="10" cx="63.667" cy="125.334" r="55.667"/></svg>';
                        //$h.= '<svg viewBox="0 0 512 512"><path fill="currentColor" d="M464 32H48C21.5 32 0 53.5 0 80v352c0 26.5 21.5 48 48 48h416c26.5 0 48-21.5 48-48V80c0-26.5-21.5-48-48-48zm16 400c0 8.8-7.2 16-16 16H48c-8.8 0-16-7.2-16-16V192h448v240zM32 160V80c0-8.8 7.2-16 16-16h416c8.8 0 16 7.2 16 16v80H32z" class=""></path></svg>';
                    $h.= '</div>';
                $h.= '</div>';

                $h.= '<div class="edit_tool_btn effects ttip" data-panel="effects" data-tooltipster=\'{"side":"top"}\' title="'.__('Effects','imc').'">';
                    $h.= '<div class="button_overlay"></div>';
                    $h.= '<div class="icon">';
                        $h.= '<svg viewBox="0 0 1000 1000"><g><path d="M600.3,258.8L15.5,843.6c-7.3,7.3-7.3,19.2,0,26.5l116,116c7.3,7.3,19.2,7.3,26.5,0l584.8-584.8c7.3-7.3,7.3-19.2,0-26.5l-116-116C619.5,251.5,607.6,251.5,600.3,258.8z M455.7,492.7l157.8-157.8l53.2,53.2L508.9,545.9L455.7,492.7z"/><path d="M782.8,219.3l-0.5-0.5c-13.3-13.3-13.3-34.9,0-48.2l49.2-49.2c13.3-13.3,34.9-13.3,48.2,0l0.5,0.5c13.3,13.3,13.3,34.9,0,48.2L831,219.3C817.7,232.6,796.1,232.6,782.8,219.3z"/><path d="M852.1,391.8v-0.7c0-18.9,15.3-34.2,34.2-34.2h69.6c18.8,0,34.1,15.3,34.1,34.2v0.7c0,18.9-15.3,34.2-34.2,34.2h-69.6C867.4,426,852.1,410.7,852.1,391.8z"/><path d="M779.1,562.8l0.5-0.5c13.3-13.3,34.9-13.3,48.2,0l49.2,49.2c13.3,13.3,13.3,34.9,0,48.2l-0.4,0.6c-13.3,13.3-34.9,13.3-48.2,0l-49.2-49.2C765.8,597.8,765.8,576.2,779.1,562.8z"/><path d="M439.3,215.7l-0.5,0.5c-13.3,13.3-34.9,13.3-48.2,0l-49.2-49.2c-13.3-13.3-13.3-34.9,0-48.2l0.5-0.5c13.3-13.3,34.9-13.3,48.2,0l49.2,49.1C452.6,180.7,452.6,202.3,439.3,215.7z"/><path d="M611.8,146.4h-0.7c-18.8,0-34.2-15.3-34.2-34.2V42.6c0-18.9,15.3-34.2,34.2-34.2h0.7c18.9,0,34.2,15.3,34.2,34.2v69.6C645.9,131.1,630.7,146.4,611.8,146.4z"/></g></svg>';
                    $h.= '</div>';
                $h.= '</div>';

                $h.= '<div class="edit_tool_btn actions ttip" data-panel="actions" data-tooltipster=\'{"side":"top"}\' title="'.__('Layer Actions','imc').'">';
                    $h.= '<div class="button_overlay"></div>';
                    $h.= '<div class="icon">';
                        $h.= '<svg viewBox="0 0 512 512"><path fill="currentColor" d="M301.148 394.702l-79.2 79.19c-50.778 50.799-133.037 50.824-183.84 0-50.799-50.778-50.824-133.037 0-183.84l79.19-79.2a132.833 132.833 0 0 1 3.532-3.403c7.55-7.005 19.795-2.004 20.208 8.286.193 4.807.598 9.607 1.216 14.384.481 3.717-.746 7.447-3.397 10.096-16.48 16.469-75.142 75.128-75.3 75.286-36.738 36.759-36.731 96.188 0 132.94 36.759 36.738 96.188 36.731 132.94 0l79.2-79.2.36-.36c36.301-36.672 36.14-96.07-.37-132.58-8.214-8.214-17.577-14.58-27.585-19.109-4.566-2.066-7.426-6.667-7.134-11.67a62.197 62.197 0 0 1 2.826-15.259c2.103-6.601 9.531-9.961 15.919-7.28 15.073 6.324 29.187 15.62 41.435 27.868 50.688 50.689 50.679 133.17 0 183.851zm-90.296-93.554c12.248 12.248 26.362 21.544 41.435 27.868 6.388 2.68 13.816-.68 15.919-7.28a62.197 62.197 0 0 0 2.826-15.259c.292-5.003-2.569-9.604-7.134-11.67-10.008-4.528-19.371-10.894-27.585-19.109-36.51-36.51-36.671-95.908-.37-132.58l.36-.36 79.2-79.2c36.752-36.731 96.181-36.738 132.94 0 36.731 36.752 36.738 96.181 0 132.94-.157.157-58.819 58.817-75.3 75.286-2.651 2.65-3.878 6.379-3.397 10.096a163.156 163.156 0 0 1 1.216 14.384c.413 10.291 12.659 15.291 20.208 8.286a131.324 131.324 0 0 0 3.532-3.403l79.19-79.2c50.824-50.803 50.799-133.062 0-183.84-50.802-50.824-133.062-50.799-183.84 0l-79.2 79.19c-50.679 50.682-50.688 133.163 0 183.851z" class=""></path></svg>';
                    $h.= '</div>';
                $h.= '</div>';

                $h.= '<div class="edit_tool_btn animation ttip" data-panel="animation" data-tooltipster=\'{"side":"top"}\' title="'.__('Layer Animations','imc').'">';
                    $h.= '<div class="button_overlay"></div>';
                    $h.= '<div class="icon">';
                        $h.= '<svg viewBox="0 0 512 512"><path fill="currentColor" d="M488 64h-8v20c0 6.6-5.4 12-12 12h-40c-6.6 0-12-5.4-12-12V64H96v20c0 6.6-5.4 12-12 12H44c-6.6 0-12-5.4-12-12V64h-8C10.7 64 0 74.7 0 88v336c0 13.3 10.7 24 24 24h8v-20c0-6.6 5.4-12 12-12h40c6.6 0 12 5.4 12 12v20h320v-20c0-6.6 5.4-12 12-12h40c6.6 0 12 5.4 12 12v20h8c13.3 0 24-10.7 24-24V88c0-13.3-10.7-24-24-24zM96 372c0 6.6-5.4 12-12 12H44c-6.6 0-12-5.4-12-12v-40c0-6.6 5.4-12 12-12h40c6.6 0 12 5.4 12 12v40zm0-96c0 6.6-5.4 12-12 12H44c-6.6 0-12-5.4-12-12v-40c0-6.6 5.4-12 12-12h40c6.6 0 12 5.4 12 12v40zm0-96c0 6.6-5.4 12-12 12H44c-6.6 0-12-5.4-12-12v-40c0-6.6 5.4-12 12-12h40c6.6 0 12 5.4 12 12v40zm272 208c0 6.6-5.4 12-12 12H156c-6.6 0-12-5.4-12-12v-96c0-6.6 5.4-12 12-12h200c6.6 0 12 5.4 12 12v96zm0-168c0 6.6-5.4 12-12 12H156c-6.6 0-12-5.4-12-12v-96c0-6.6 5.4-12 12-12h200c6.6 0 12 5.4 12 12v96zm112 152c0 6.6-5.4 12-12 12h-40c-6.6 0-12-5.4-12-12v-40c0-6.6 5.4-12 12-12h40c6.6 0 12 5.4 12 12v40zm0-96c0 6.6-5.4 12-12 12h-40c-6.6 0-12-5.4-12-12v-40c0-6.6 5.4-12 12-12h40c6.6 0 12 5.4 12 12v40zm0-96c0 6.6-5.4 12-12 12h-40c-6.6 0-12-5.4-12-12v-40c0-6.6 5.4-12 12-12h40c6.6 0 12 5.4 12 12v40z" class=""></path></svg>';
                    $h.= '</div>';
                $h.= '</div>';

                $h.= '<div class="edit_tool_btn duplicate ttip" data-tooltipster=\'{"side":"top"}\' title="'.__('Duplicate Layer','imc').'">';
                    $h.= '<div class="button_overlay"></div>';
                    $h.= '<div class="icon">';
                        $h.= '<svg viewBox="0 0 448 512"><path fill="currentColor" d="M433.941 65.941l-51.882-51.882A48 48 0 0 0 348.118 0H176c-26.51 0-48 21.49-48 48v48H48c-26.51 0-48 21.49-48 48v320c0 26.51 21.49 48 48 48h224c26.51 0 48-21.49 48-48v-48h80c26.51 0 48-21.49 48-48V99.882a48 48 0 0 0-14.059-33.941zM266 464H54a6 6 0 0 1-6-6V150a6 6 0 0 1 6-6h74v224c0 26.51 21.49 48 48 48h96v42a6 6 0 0 1-6 6zm128-96H182a6 6 0 0 1-6-6V54a6 6 0 0 1 6-6h106v88c0 13.255 10.745 24 24 24h88v202a6 6 0 0 1-6 6zm6-256h-64V48h9.632c1.591 0 3.117.632 4.243 1.757l48.368 48.368a6 6 0 0 1 1.757 4.243V112z" class=""></path></svg>';
                    $h.= '</div>';
                $h.= '</div>';
                
                $h.= '<div class="edit_tool_btn remove ttip" data-tooltipster=\'{"side":"top"}\' title="'.__('Remove Layer','imc').'">';
                    $h.= '<div class="button_overlay"></div>';
                    $h.= '<div class="icon">';
                        $h.= '<svg viewBox="0 0 448 512"><path fill="currentColor" d="M336 64l-33.6-44.8C293.3 7.1 279.1 0 264 0h-80c-15.1 0-29.3 7.1-38.4 19.2L112 64H24C10.7 64 0 74.7 0 88v2c0 3.3 2.7 6 6 6h26v368c0 26.5 21.5 48 48 48h288c26.5 0 48-21.5 48-48V96h26c3.3 0 6-2.7 6-6v-2c0-13.3-10.7-24-24-24h-88zM184 32h80c5 0 9.8 2.4 12.8 6.4L296 64H152l19.2-25.6c3-4 7.8-6.4 12.8-6.4zm200 432c0 8.8-7.2 16-16 16H80c-8.8 0-16-7.2-16-16V96h320v368zm-176-44V156c0-6.6 5.4-12 12-12h8c6.6 0 12 5.4 12 12v264c0 6.6-5.4 12-12 12h-8c-6.6 0-12-5.4-12-12zm-80 0V156c0-6.6 5.4-12 12-12h8c6.6 0 12 5.4 12 12v264c0 6.6-5.4 12-12 12h-8c-6.6 0-12-5.4-12-12zm160 0V156c0-6.6 5.4-12 12-12h8c6.6 0 12 5.4 12 12v264c0 6.6-5.4 12-12 12h-8c-6.6 0-12-5.4-12-12z" class=""></path></svg>';
                    $h.= '</div>';
                $h.= '</div>';
            $h.= '</div>';
            // end .tools_container



            // Content boxes                         
            $h.= '<div class="edit_panel">';
            
                $h.= '<div class="content" style="margin-top: 20px;">';

                    // SETTINGS
                    $h.= '<div class="settings_panel panel_box" data-header="'.__('Object Settings','imc').'">';
                        
                        $h.= '<div class="mn_options settings_options">';
                            $h.= '<a data-cat="color" class="mn_opt small">'.__('Color','imc').' '.ADN_Templates::tooltip(array('class' => '_dn_quest_tooltip', 'title' => __('Layer coloring options.','imc'))).'</a>';
                            $h.= '<a data-cat="border" class="mn_opt small mn_border_settings">'.__('Border','imc').' '.ADN_Templates::tooltip(array('class' => '_dn_quest_tooltip', 'title' => __('Layer border options.','imc'))).'</a>';
                            $h.= '<a data-cat="size" class="mn_opt small">'.__('Size','imc').' '.ADN_Templates::tooltip(array('class' => '_dn_quest_tooltip', 'title' => __('Layer size and positioning options.','imc'))).'</a>';
                            $h.= '<a data-cat="css" class="mn_opt small mn_css_settings">'.__('Custom','imc').' '.ADN_Templates::tooltip(array('class' => '_dn_quest_tooltip', 'title' => __('Custom element settings.','imc'))).'</a>';
                        $h.= '</div>';

                        $h.= '<div class="settings">';
                            $h.= '<div class="scrollarea">';
                                $h.= '<div class="mn_box set_box settings_color_box">';
                                    $h.= '<div class="set_box color_box">';
                                        $h.= '<span class="title">'.__('Background Color','imc').'</span>';
                                        $h.= '<div class="obj_color_picker_container">';
                                            $h.= '<input type="" class="obj_bg_color" data-picker="solid" value="">';
                                        $h.= '</div>';
                                    $h.= '</div>';

                                    $h.= '<div class="spr_row">
                                        <div class="spr_column spr_col-6">
                                            <div class="spr_column-inner ">
                                                <div class="spr_wrapper">
                                                    <div class="content_element">';
                                                        $h.= '<div class="set_box opacity_box">';
                                                            $h.= '<span class="title">'.__('Opacity','imc').'</span>';
                                                            $h.= '<div class="alpha_slider _dn_ui_slider"></div>';
                                                            $h.= '<input class="slider_input_val" data-set="alpha" value="" />';
                                                        $h.= '</div>';
                                                    $h.= '</div>
                                                </div>
                                            </div>
                                        </div>
                                        <div class="spr_column spr_col-6">
                                            <div class="spr_column-inner ">
                                                <div class="spr_wrapper">
                                                    <div class="content_element">';
                                                        $h.= '<div class="set_box blur_box">';
                                                            $h.= '<span class="title">'.__('Blur','imc').'</span>';
                                                            $h.= '<div class="blur_slider _dn_ui_slider"></div>';
                                                            $h.= '<input class="slider_input_val" data-set="blur" value="" />';
                                                        $h.= '</div>';
                                                    $h.= '</div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>';

                                    // Svg stroke thickness options
                                    $h.= '<div class="set_box svg_stroke_box" style="display:none;margin-top:20px;">';
                                        $h.= '<div style="border-bottom:solid 1px #d4d4d4;">'.__('Stroke width:','imc').'</div>';
                                        $h.= '<div class="set_box svg_stroke_sliders_box"></div>';
                                    $h.= '</div>';


                                    // SHADOW
                                    $h.= '<div class="set_box layer_shadow_box" style="margin-top:20px;">';
                                        $h.= '<div style="border-bottom:solid 1px #d4d4d4;">'.__('Drop Shadow:','imc').'</div>';
                                        $h.= '<div class="set_box layer_shadow_box_containaer">';

                                            $h.= '<div class="spr_row">';

                                                // ADD Drop Shadow - Checkbox
                                                $h.= '<div class="spr_column spr_col-6">
                                                    <div class="spr_column-inner ">
                                                        <div class="spr_wrapper">
                                                            <div class="content_element">';
                                                                $h.= '<div class="set_box add_drop_shadow_box">';
                                                                $h.= '<span class="title">'.__('Add Shadow','imc').'</span>';
                                                                    $h.= ADN_Templates::checkbox(array(
                                                                        'title' => '',
                                                                        'tooltip' => __('Add drop shadow.','imc'),
                                                                        'checked' => 0,
                                                                        'class' => 'option_checkbox drop_shadow'
                                                                    ));
                                                                $h.= '</div>';
                                                            $h.= '</div>
                                                        </div>
                                                    </div>
                                                </div>';


                                                // Shadow Color - shadow_color
                                                $h.= '<div class="spr_column spr_col-6">
                                                    <div class="spr_column-inner ">
                                                        <div class="spr_wrapper">
                                                            <div class="content_element">';
                                                                $h.= '<span class="title">'.__('Color','imc').'</span>';
                                                                $h.= '<div class="shadow_color_picker_container">';
                                                                    $h.= '<input type="" class="shadow_color" data-picker="solid" value="">';
                                                                $h.= '</div>';
                                                            $h.= '</div>
                                                        </div>
                                                    </div>
                                                </div>';                   
                                                
                                            $h.= '</div>';
                                            // end .spr_row

                                            $h.= '<div class="spr_row">';

                                                // Horizontal Length - horizontal_length
                                                $h.= '<div class="spr_column spr_col-6">
                                                    <div class="spr_column-inner ">
                                                        <div class="spr_wrapper">
                                                            <div class="content_element">';
                                                                $h.= '<div class="set_box horizontal_length">';
                                                                    $h.= '<span class="title">'.__('Horizontal','imc').'</span>';
                                                                    $h.= '<div class="horizontal_length_slider _dn_ui_slider"></div>';
                                                                    $h.= '<input class="slider_input_val" data-set="horizontal_length" value="" />';
                                                                $h.= '</div>';
                                                            $h.= '</div>
                                                        </div>
                                                    </div>
                                                </div>';

                                                // Vertical Length - vertical_length
                                                $h.= '<div class="spr_column spr_col-6">
                                                    <div class="spr_column-inner ">
                                                        <div class="spr_wrapper">
                                                            <div class="content_element">';
                                                                $h.= '<div class="set_box vertical_length">';
                                                                    $h.= '<span class="title">'.__('Vertical','imc').'</span>';
                                                                    $h.= '<div class="vertical_length_slider _dn_ui_slider"></div>';
                                                                    $h.= '<input class="slider_input_val" data-set="vertical_length" value="" />';
                                                                $h.= '</div>';
                                                            $h.= '</div>
                                                        </div>
                                                    </div>
                                                </div>';

                                                // Blur Radius - blur_radius
                                                $h.= '<div class="spr_column spr_col-6">
                                                    <div class="spr_column-inner ">
                                                        <div class="spr_wrapper">
                                                            <div class="content_element">';
                                                                $h.= '<div class="set_box blur_radius">';
                                                                    $h.= '<span class="title">'.__('Blur','imc').'</span>';
                                                                    $h.= '<div class="blur_radius_slider _dn_ui_slider"></div>';
                                                                    $h.= '<input class="slider_input_val" data-set="blur_radius" value="" />';
                                                                $h.= '</div>';
                                                            $h.= '</div>
                                                        </div>
                                                    </div>
                                                </div>';

                                                // Spread Radius - spread_radius
                                                $h.= '<div class="spr_column spr_col-6">
                                                    <div class="spr_column-inner ">
                                                        <div class="spr_wrapper">
                                                            <div class="content_element">';
                                                                $h.= '<div class="set_box spread_radius">';
                                                                    $h.= '<span class="title">'.__('Spread','imc').'</span>';
                                                                    $h.= '<div class="spread_radius_slider _dn_ui_slider"></div>';
                                                                    $h.= '<input class="slider_input_val" data-set="spread_radius" value="" />';
                                                                $h.= '</div>';
                                                            $h.= '</div>
                                                        </div>
                                                    </div>
                                                </div>';
                                                
                                                // USING COLOR PICKER FOR OPACITY
                                                // Shadow Opacity - shadow_opacity 
                                                /*$h.= '<div class="spr_column spr_col-6">
                                                    <div class="spr_column-inner ">
                                                        <div class="spr_wrapper">
                                                            <div class="content_element">';
                                                                $h.= '<div class="set_box shadow_opacity">';
                                                                    $h.= '<span class="title">'.__('Opacity','imc').'</span>';
                                                                    $h.= '<div class="blur_radius _dn_ui_slider"></div>';
                                                                    $h.= '<input class="slider_input_val" data-set="shadow_opacity" value="" />';
                                                                $h.= '</div>';
                                                            $h.= '</div>
                                                        </div>
                                                    </div>
                                                </div>';*/

                                                // Shadow outline/inset
                                                $h.= '<div class="spr_column spr_col-6">
                                                    <div class="spr_column-inner ">
                                                        <div class="spr_wrapper">
                                                            <div class="content_element">';
                                                                $h.= '<div class="set_box">';
                                                                    $h.= '<span class="title">'.__('Shadow Style','imc').'</span>';
                                                                    $h.= '<input type="text" class="selectBox shadow_style_options" />';
                                                                $h.= '</div>';
                                                            $h.= '</div>
                                                        </div>
                                                    </div>
                                                </div>';

                                            $h.= '</div>';
                                            // end .spr_row

                                        $h.= '</div>';
                                        // end .layer_shadow_box_containaer
                                    $h.= '</div>';
                                    // end SHADOW .layer_shadow_box

                                
                                $h.= '</div>';
                                // end .settings_color_box


                                // START BORDER SETTINGS 
                                $h.= '<div class="mn_box set_box settings_border_box">';
                                    $h.= '<div class="spr_row">
                                        <div class="spr_column spr_col-6">
                                            <div class="spr_column-inner ">
                                                <div class="spr_wrapper">
                                                    <div class="content_element">';
                                                        $h.= '<div class="set_box border_radius_box">';
                                                            $h.= '<span class="title">'.__('Border Radius','imc').'</span>';
                                                            $h.= '<div class="border_radius_slider _dn_ui_slider"></div>';
                                                            $h.= '<input class="slider_input_val" data-set="border_radius" value="" />';
                                                        $h.= '</div>';
                                                    $h.= '</div>
                                                </div>
                                            </div>
                                        </div>
                                        <div class="spr_column spr_col-6">
                                            <div class="spr_column-inner ">
                                                <div class="spr_wrapper">
                                                    <div class="content_element">';
                                                        $h.= '<div class="set_box border_width_box">';
                                                            $h.= '<span class="title">'.__('Border Width','imc').'</span>';
                                                            $h.= '<div class="border_width_slider _dn_ui_slider"></div>';
                                                            $h.= '<input class="slider_input_val" data-set="border_width" value="" />';
                                                        $h.= '</div>';
                                                    $h.= '</div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>';

                                    $h.= '<div class="spr_row">
                                        <div class="spr_column spr_col-6">
                                            <div class="spr_column-inner ">
                                                <div class="spr_wrapper">
                                                    <div class="content_element">';
                                                        $h.= '<div class="set_box border_color_box">';
                                                            $h.= '<span class="title">'.__('Border Color','imc').'</span>';
                                                            $h.= '<div>';
                                                                $h.= '<input type="" class="obj_border_color" data-picker="solid" value="">';
                                                            $h.= '</div>';
                                                        $h.= '</div>';
                                                    $h.= '</div>
                                                </div>
                                            </div>
                                        </div>
                                        <div class="spr_column spr_col-6">
                                            <div class="spr_column-inner ">
                                                <div class="spr_wrapper">
                                                    <div class="content_element">';
                                                        $h.= '<div class="set_box">';
                                                            $h.= '<span class="title">'.__('Border Style','imc').'</span>';
                                                            $h.= '<input type="text" class="selectBox border_style_options" />';
                                                        $h.= '</div>';
                                                    $h.= '</div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>';
                                    
                                $h.= '</div>';
                                // end .settings_border_box


                                // START SIZE SETTINGS
                                $h.= '<div class="mn_box set_box settings_size_box">';
                                    $h.= '<div class="spr_row">
                                        <div class="spr_column spr_col-6">
                                            <div class="spr_column-inner ">
                                                <div class="spr_wrapper">
                                                    <div class="spr_content_element" style="padding:0 10px 0 0;">
                                                        '.__('width:','imc').' <input type="text" class="_set_inpt _set_width" data-prop="width" placeholder="">
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                        <div class="spr_column spr_col-6">
                                            <div class="spr_column-inner ">
                                                <div class="spr_wrapper">
                                                    <div class="spr_content_element" style="padding: 0 0 0 10px;">
                                                        '.__('height:','imc').' <input type="text" class="_set_inpt _set_height" data-prop="height" placeholder="">
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>';

                                    $h.= '<div style="margin:15px 0 5px;border-bottom:solid 1px #d4d4d4;">'.__('Positioning:','imc').'</div>';
                                    $h.= '<div class="spr_row">
                                        <div class="spr_column spr_col-6">
                                            <div class="spr_column-inner ">
                                                <div class="spr_wrapper">
                                                    <div class="spr_content_element" style="padding:0 10px 0 0;">
                                                        '.__('left:','imc').' <input type="text" class="_set_inpt _set_left" data-prop="left" placeholder="">
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                        <div class="spr_column spr_col-6">
                                            <div class="spr_column-inner ">
                                                <div class="spr_wrapper">
                                                    <div class="spr_content_element" style="padding: 0 0 0 10px;">
                                                        '.__('top:','imc').' <input type="text" class="_set_inpt _set_top" data-prop="top" placeholder="">
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>';
                                    
                                    $h.= '';
                                $h.= '</div>';
                                // end .settings_size_box

                                // START CSS SETTINGS
                                $h.= '<div class="mn_box set_box settings_css_box">';
                                    $h.= '<div class="spr_row">
                                        <div class="spr_column">
                                            <div class="spr_column-inner ">
                                                <div class="spr_wrapper">

                                                    <div class="spr_content_element _css_obj_params_holder clear" style="margin-bottom:20px;padding:0 10px 0 0;border-bottom: solid 1px #eaeaea;"></div>

                                                    <div class="spr_content_element" style="padding:0 10px 0 0;">
                                                        '.__('Custom ID:','imc').' <input type="text" class="_set_inpt _set_id" data-prop="id" placeholder="">
                                                    </div>

                                                    <div class="spr_content_element" style="margin-top:10px;padding:0 10px 0 0;position:relative;">
                                                        '.__('Custom Class:','imc').' '.ADN_Templates::tooltip(array('class' => '_dn_quest_tooltip', 'title' => __('Note: Adding custom classes is permanent and cannot be undone unless removing the whole element.','imc'))).' 
                                                        <input type="text" class="_set_inpt _set_class" data-prop="class" placeholder="">
                                                    </div>
                                                    <div class="spr_content_element" style="margin-top:10px;padding:0 10px 0 0;">
                                                        '.__('Custom Style:','imc').' <textarea class="_set_inpt _set_style" data-prop="style" placeholder="color:#ffffff;"></textarea>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>';
                                    /*$h.= '<div class="spr_row">
                                        <div class="spr_column spr_col-6">
                                            <div class="spr_column-inner ">
                                                <div class="spr_wrapper">
                                                    <div class="spr_content_element" style="padding:0 10px 0 0;">
                                                        '.__('Custom Classes:','imc').' <input type="text" class="_set_inpt _set_class" data-prop="class" placeholder="">
                                                    </div>
                                                    
                                                </div>
                                            </div>
                                        </div>
                                        <div class="spr_column spr_col-6">
                                            <div class="spr_column-inner ">
                                                <div class="spr_wrapper">
                                                    <div class="spr_content_element" style="padding: 0 0 0 10px;">
                                                        '.__('height:','imc').' <input type="text" class="_set_inpt _set_height" data-prop="height" placeholder="">
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>';*/

                                $h.= '</div>';
                                // end .settings_css_box


                            $h.= '</div>';
                            // end .scrollarea
                        $h.= '</div>';
                        // end .settings
                    $h.= '</div>';
                    //<!-- end .settings_panel -->


                    // TEXT
                    $h.= '<div class="text_panel panel_box" data-header="'.__('Text Settings','imc').'">';
                        
                        $h.= '<div class="scrollarea">';
                            $h.= '<div class="spr_row">
                                <div class="spr_column spr_col-6">
                                    <div class="spr_column-inner ">
                                        <div class="spr_wrapper">
                                            <div class="content_element">';
                                                $h.= '<div class="set_box color_box">';
                                                    $h.= '<span class="title">'.__('Font Color','imc').'</span>';
                                                    $h.= '<div class="obj_color_picker_container">';
                                                        $h.= '<input type="" class="obj_font_color" data-picker="solid" value="">';
                                                    $h.= '</div>';
                                                $h.= '</div>';
                                            $h.= '</div>
                                        </div>
                                    </div>
                                </div>
                                <div class="spr_column spr_col-6">
                                    <div class="spr_column-inner ">
                                        <div class="spr_wrapper">
                                            <div class="content_element">';
                                                $h.= '<div class="set_box">';
                                                    $h.= '<span class="title">'.__('Text Align','imc').'</span>';
                                                    $h.= '<div>';
                                                        $h.= '<span class="text_align selected" data-align="left">';
                                                            $h.= '<svg viewBox="0 0 448 512"><path fill="currentColor" d="M288 52v24a6 6 0 0 1-6 6H6a6 6 0 0 1-6-6V52a6 6 0 0 1 6-6h276a6 6 0 0 1 6 6zM6 210h436a6 6 0 0 0 6-6v-24a6 6 0 0 0-6-6H6a6 6 0 0 0-6 6v24a6 6 0 0 0 6 6zm0 256h436a6 6 0 0 0 6-6v-24a6 6 0 0 0-6-6H6a6 6 0 0 0-6 6v24a6 6 0 0 0 6 6zm276-164H6a6 6 0 0 0-6 6v24a6 6 0 0 0 6 6h276a6 6 0 0 0 6-6v-24a6 6 0 0 0-6-6z" class=""></path></svg>';
                                                        $h.= '</span>';
                                                        $h.= '<span class="text_align" data-align="center">';
                                                            $h.= '<svg viewBox="0 0 448 512"><path fill="currentColor" d="M352 52v24a6 6 0 0 1-6 6H102a6 6 0 0 1-6-6V52a6 6 0 0 1 6-6h244a6 6 0 0 1 6 6zM6 210h436a6 6 0 0 0 6-6v-24a6 6 0 0 0-6-6H6a6 6 0 0 0-6 6v24a6 6 0 0 0 6 6zm0 256h436a6 6 0 0 0 6-6v-24a6 6 0 0 0-6-6H6a6 6 0 0 0-6 6v24a6 6 0 0 0 6 6zm340-164H102a6 6 0 0 0-6 6v24a6 6 0 0 0 6 6h244a6 6 0 0 0 6-6v-24a6 6 0 0 0-6-6z" class=""></path></svg>';
                                                        $h.= '</span>';
                                                        $h.= '<span class="text_align" data-align="right">';
                                                            $h.= '<svg viewBox="0 0 448 512"><path fill="currentColor" d="M160 76V52a6 6 0 0 1 6-6h276a6 6 0 0 1 6 6v24a6 6 0 0 1-6 6H166a6 6 0 0 1-6-6zM6 210h436a6 6 0 0 0 6-6v-24a6 6 0 0 0-6-6H6a6 6 0 0 0-6 6v24a6 6 0 0 0 6 6zm0 256h436a6 6 0 0 0 6-6v-24a6 6 0 0 0-6-6H6a6 6 0 0 0-6 6v24a6 6 0 0 0 6 6zm160-128h276a6 6 0 0 0 6-6v-24a6 6 0 0 0-6-6H166a6 6 0 0 0-6 6v24a6 6 0 0 0 6 6z" class=""></path></svg>';
                                                        $h.= '</span>';
                                                    $h.= '</div>';
                                                $h.= '</div>';
                                            $h.= '</div>
                                        </div>
                                    </div>
                                </div>
                            </div>';
                            // end .spr_row

                            $h.= '<div class="set_box text_box font_size_box">';
                                $h.= '<span class="title">'.__('Font Size','imc').'</span>';
                                $h.= '<div class="font_size_slider _dn_ui_slider"></div>';
                                $h.= '<input class="slider_input_val" data-set="font_size" value="" />';
                            $h.= '</div>';

                            $h.= '<div class="spr_row">
                                <div class="spr_column spr_col-6">
                                    <div class="spr_column-inner ">
                                        <div class="spr_wrapper">
                                            <div class="content_element">';
                                                $h.= '<div class="set_box">';
                                                    $h.= '<span class="title">'.__('Font Weight','imc').'</span>';
                                                    $h.= '<input type="text" class="selectBox font_weight_selector" />';
                                                $h.= '</div>';
                                            $h.= '</div>
                                        </div>
                                    </div>
                                </div>
                                <div class="spr_column spr_col-6">
                                    <div class="spr_column-inner ">
                                        <div class="spr_wrapper">
                                            <div class="content_element">';
                                                $h.= '<div class="set_box">';
                                                    $h.= '<span class="title">'.__('Google Fonts','imc').'</span>';
                                                    $h.= '<input class="font_family_selector" />';
                                                    /*$h.= '<div class="font_family_selector"></div>';
                                                    $h.= '<textarea class="googlefontsjson" style="display:none;">'.json_encode(array('items' => ADN_JSON_Templates::google_fonts())).'</textarea>';*/
                                                $h.= '</div>';
                                            $h.= '</div>
                                        </div>
                                    </div>
                                </div>
                            </div>';
                            // end .spr_row
                            

                            $h.= '<div class="set_box">';
                                $h.= '<span class="title">'.__('Text','imc').'</span>';
                                $h.= '<textarea class="text_content"></textarea>';
                            $h.= '</div>';

                            $h.= '<div class="set_box">';
                                $h.= '<span class="title">'.__('Render HTML','imc').'</span>';
                                $h.= '<label class="switch switch-slide small ttip">';
                                    $h.= '<input class="switch-input render_html_switch" type="checkbox" value="0" />';
                                    $h.= '<span class="switch-label" data-on="'.__('Yes','imc').'" data-off="'.__('No','imc').'"></span>'; 
                                    $h.= '<span class="switch-handle"></span>';
                                $h.= '</label>';
                            $h.= '</div>';

                            

                        $h.= '</div>';
                        // end .scrollarea
                    $h.= '</div>';
                    //<!-- end .text_panel -->


                    // EFFECTS
                    $h.= '<div class="effects_panel panel_box" data-header="'.__('Effects','imc').'">';
                        $h.= '<div class="set_box">';
                            $h.= '<div class="_dn_plugins_settings_holder">';
                                $h.= '<div class="spr_row plugin_settings_holder"></div>';  
                            $h.= '</div>';

                            $h.= '<div class="_dn_plugins_holder effect_plugins">';
                               
                                $effects = ADN_JSON_Templates::text_effect_plugins() + ADN_JSON_Templates::image_effect_plugins(); // ADN_JSON_Templates::animation_effect_plugins()
                                //$h.= '<pre>'.print_r($effects, true).'</pre>';
                                if(!empty($effects))
                                {
                                    foreach($effects as $effect)
                                    {
                                        $h.= '<div class="effect_box plugin_box plugin_box_'.$effect['id'].' '.$effect['type'].' clear">';
                                            $h.= '<div class="plugin_box_content plugin_selector" data-id="'.$effect['id'].'">';
                                                $h.= '<div class="plugin_title">'.$effect['title'].'</div>';
                                                $h.= '<div class="plugin_desc">'.$effect['desc'].'</div>';
                                                $h.= '<textarea class="plugin_code" style="display:none;">'.json_encode($effect).'</textarea>';
                                            $h.= '</div>';
                                            $h.= '<div class="plugin_box_remove">';
                                                $h.= '<a class="remove_plugin_options" data-plugin="'.$effect['id'].'"><svg style="height:15px;width:15px;" viewBox="0 0 320 512"><path fill="#ababab" d="M193.94 256L296.5 153.44l21.15-21.15c3.12-3.12 3.12-8.19 0-11.31l-22.63-22.63c-3.12-3.12-8.19-3.12-11.31 0L160 222.06 36.29 98.34c-3.12-3.12-8.19-3.12-11.31 0L2.34 120.97c-3.12 3.12-3.12 8.19 0 11.31L126.06 256 2.34 379.71c-3.12 3.12-3.12 8.19 0 11.31l22.63 22.63c3.12 3.12 8.19 3.12 11.31 0L160 289.94 262.56 392.5l21.15 21.15c3.12 3.12 8.19 3.12 11.31 0l22.63-22.63c3.12-3.12 3.12-8.19 0-11.31L193.94 256z"></path></svg></a>';
                                            $h.= '</div>';
                                        $h.= '</div>';
                                    }
                                }
                                
                            $h.= '</div>';
                            // end ._dn_plugins_holder
                        $h.= '</div>';
                    $h.= '</div>';
                    //<!-- end .effects_panel -->
                    


                    // ACTIONS
                    $h.= '<div class="actions_panel panel_box" data-header="'.__('Action Settings','imc').'">';
                        $h.= '<div class="set_box">';
                            $h.= '<span class="title">'.__('On Click','imc').'</span>';
                            $h.= '<input type="text" class="selectBox click_action_options" />';
                            $h.= '<div class="click_action_result">';
                                $h.= '<div class="gotourl click_action_option">';
                                    $h.= '<input type="text" class="gotourl_input click_action_input" placeholder="http://">';
                                $h.= '</div>';
                                $h.= '<div class="callback click_action_option">';
                                    $h.= '<textarea class="callback_input click_action_input" placeholder=\'alert("click");\'></textarea>';
                                $h.= '</div>';
                                $h.= '<div class="poi_popup click_action_option">';
                                    $h.= '<div>'.__('Popup content','imc').'</div>';
                                    $h.= '<textarea class="poi_popup_input click_action_input" placeholder="add popup content here"></textarea>';
                                    $h.= '<div>'.__('Popup position','imc').'</div>';
                                    $h.= '<select class="poi_popup_position click_action_input">';
                                        $h.= '<option value="top">'.__('Top','imc').'</option>';
                                        $h.= '<option value="bottom">'.__('Bottom','imc').'</option>';
                                        $h.= '<option value="left-top">'.__('Left Top','imc').'</option>';
                                        $h.= '<option value="left">'.__('Left','imc').'</option>';
                                        $h.= '<option value="left-bottom">'.__('Left Bottom','imc').'</option>';
                                        $h.= '<option value="right-top">'.__('Right Top','imc').'</option>';
                                        $h.= '<option value="right">'.__('Right','imc').'</option>';
                                        $h.= '<option value="right-bottom">'.__('Right Bottom','imc').'</option>';
                                    $h.= '</select>';
                                $h.= '</div>';
                            $h.= '</div>';
                        $h.= '</div>';
                    $h.= '</div>';
                    //<!-- end .actions_panel -->


                    // FILTERS
                    $h.= '<div class="panel_box filters_panel" data-header="'.__('Filter Settings','imc').'">';
                        $h.= '<div class="set_box">';
                            //<!--<span class="title">'.__('Layer','imc').'</span>-->
                            
                            $filters = ADN_Main::_dn_filters();
                            foreach($filters as $key => $filter)
                            {
                                $h.= '<div class="filter_container">';
                                    $h.= '<a class="filter" style="filter:'.$filter['layer'].';" data-layer-filter="'.$filter['layer'].'" data-filter="'.$key.'">';
                                        $h.= '<div class="filter_overlay _dnfilter'.$key.'"></div>';
                                        $h.= '<div class="filter_content"></div>';
                                    $h.= '</a>';
                                    $h.= '<div class="filter_title">'.$filter['name'].'</div>';
                                $h.= '</div>';
                            }
                            
                        $h.= '</div>';
                    $h.= '</div>';
                    //<!-- end .layer_panel -->

                    
                    // ANIMATION
                    $h.= '<div class="animation_panel panel_box" data-header="'.__('Animation Settings','imc').'">';
                        
                        $h.= '<div class="scrollarea">';
                        
                            // SVG STROKE ANIMATION PANEL
                            $h.= '<div class="animation_options svg_stroke_animation_panel" style="display:none;margin-bottom:40px;">';
                                $h.= '<div style="border-bottom:solid 1px #d4d4d4;margin-bottom:20px;">'.__('SVG Stroke animation:','imc').'</div>';
                                $h.= '<div class="spr_row">
                                    <div class="spr_column spr_col-6">
                                        <div class="spr_column-inner ">
                                            <div class="spr_wrapper">
                                                <div class="content_element">';
                                                    $h.= '<div class="set_box svg_animation_runner_box">';
                                                        $h.= ADN_Templates::checkbox(array(
                                                            'title' => __('Run animation','imc'),
                                                            'tooltip' => __('Activate animation for this object.','imc'),
                                                            'checked' => 1,
                                                            'class' => 'option_checkbox svg_animation_runner'
                                                        ));
                                                    $h.= '</div>';
                                                $h.= '</div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="spr_column spr_col-6">
                                        <div class="spr_column-inner ">
                                            <div class="spr_wrapper">
                                                <div class="content_element">';
                                                    $h.= '<div class="set_box svg_animation_sync_box">';
                                                        $h.= ADN_Templates::checkbox(array(
                                                            'title' => __('In sync','imc'),
                                                            'tooltip' => __('Load all animations at the same time.','imc'),
                                                            'checked' => 1,
                                                            'class' => 'option_checkbox svg_animation_sync',
                                                            'data' => array('box' => 'svg_animation_sync' )
                                                        ));
                                                    $h.= '</div>';
                                                $h.= '</div>
                                            </div>
                                        </div>
                                    </div>
                                </div>';
                                // end .spr_row
                                
                                $h.= '<div class="set_box svg_animation_speed_sliders_box"></div>';
                                
                            $h.= '</div>';


                            $h.= '<div class="animation_options">';
                                $h.= '<a data-cat="in" class="ani_opt small">'.__('IN','imc').' '.ADN_Templates::tooltip(array('class' => '_dn_quest_tooltip', 'title' => __('Animation when the layer enters the screen.','imc'))).'</a>';
                                $h.= '<a data-cat="view" class="ani_opt small">'.__('VIEW','imc').' '.ADN_Templates::tooltip(array('class' => '_dn_quest_tooltip', 'title' => __('Layer animation when the layer is loaded and visible.','imc'))).'</a>';
                                $h.= '<a data-cat="out" class="ani_opt small">'.__('OUT','imc').' '.ADN_Templates::tooltip(array('class' => '_dn_quest_tooltip', 'title' => __('Animation when the layer exits the screen.','imc'))).'</a>';
                            $h.= '</div>';

                            $h.= '<div class="animation" style="overflow:auto;height: calc(100vh - 250px);">';
                                
                                $h.= '<div class="spr_row delay_duration">
                                    <div class="spr_column spr_col-6">
                                        <div class="spr_column-inner ">
                                            <div class="spr_wrapper">
                                                <div class="content_element">';
                                                    $h.= '<div class="set_box animation_delay_box">';
                                                        $h.= '<span class="title">'.__('Delay','imc').'</span>';
                                                        $h.= '<div class="animation_delay_slider _dn_ui_slider"></div>';
                                                        $h.= '<input class="slider_input_val" data-set="animation_delay" value="" />';
                                                    $h.= '</div>';
                                                $h.= '</div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="spr_column spr_col-6">
                                        <div class="spr_column-inner ">
                                            <div class="spr_wrapper">
                                                <div class="content_element">';
                                                    $h.= '<div class="set_box animation_duration_box">';
                                                        $h.= '<span class="title">'.__('Duration','imc').'</span>';
                                                        $h.= '<div class="animation_duration_slider _dn_ui_slider"></div>';
                                                        $h.= '<input class="slider_input_val" data-set="animation_duration" value="" />';
                                                        //$h.= '<div class="slider_input_val"></div>';
                                                    $h.= '</div>';
                                                $h.= '</div>
                                            </div>
                                        </div>
                                    </div>
                                </div>';
                                // end .spr_row
                                

                                $h.= '<div style="margin: 20px 0 10px 0;border-bottom: solid 1px #d4d4d4;">'.__('Advanced Settings','imc').'</div>';

                                $h.= '<div class="spr_row direction_easing">
                                    <div class="spr_column spr_col-6">
                                        <div class="spr_column-inner ">
                                            <div class="spr_wrapper">
                                                <div class="content_element">';
                                                    $h.= '<div class="set_box animation_direction_box">';
                                                        $h.= '<span class="title">'.__('Direction','imc').'</span>';
                                                        $h.= '<input type="text" class="selectBox animation_direction" />';
                                                    $h.= '</div>';
                                                $h.= '</div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="spr_column spr_col-6">
                                        <div class="spr_column-inner ">
                                            <div class="spr_wrapper">
                                                <div class="content_element">';
                                                    $h.= '<div class="set_box animation_easing_box">';
                                                        $h.= '<span class="title">'.__('Easing','imc').'</span>';
                                                        $h.= '<input type="text" class="selectBox animation_easing" />';
                                                    $h.= '</div>';
                                                $h.= '</div>
                                            </div>
                                        </div>
                                    </div>';
                                    
                                $h.= '</div>';
                                // end .spr_row
                                

                                

                                $h.= '<div class="set_box add_class_box">';
                                    $h.= '<span class="title">'.__('Classes','imc').'</span>';
                                    $h.= '<input type="text" class="animation_classes" />';
                                $h.= '</div>';

                                /*$h.= '<div class="set_box animation_repeat_box">';
                                    $h.= ADN_Templates::checkbox(array(
                                            'title' => __('Repeat','imc'),
                                            'tooltip' => __('Repeat in view layer animation.','imc'),
                                            'checked' => 0,
                                            'class' => 'option_checkbox animation_repeat',
                                            'data' => array('box' => 'animation_repeat' )
                                        ));
                                $h.= '</div>';*/

                                
                                $h.= '<div class="plugins" style="margin-top:20px;border-top:solid 1px #eaeaea;padding-top: 10px;">';
                                    $h.= '<div style="margin: 20px 0 10px 0;border-bottom: solid 1px #d4d4d4;">'.__('Animation plugins','imc').'</div>';
                                    $h.= '<div class="_dn_plugins_settings_holder">';
                                        $h.= '<div class="spr_row plugin_settings_holder"></div>';  
                                    $h.= '</div>';

                                    $h.= '<div class="_dn_plugins_holder animation_effect_plugins">';
                                    
                                        $effects = ADN_JSON_Templates::animation_effect_plugins();
                                        if(!empty($effects))
                                        {
                                            foreach($effects as $effect)
                                            {
                                                $h.= '<div class="animation_effect_plugin_box plugin_box plugin_box_'.$effect['id'].' clear">';
                                                    $h.= '<div class="plugin_box_content plugin_selector" data-id="'.$effect['id'].'">';
                                                        $h.= '<div class="plugin_title">'.$effect['title'].'</div>';
                                                        $h.= '<div class="plugin_desc">'.$effect['desc'].'</div>';
                                                        $h.= '<textarea class="plugin_code" style="display:none;">'.json_encode($effect,JSON_FORCE_OBJECT).'</textarea>';
                                                    $h.= '</div>';
                                                    $h.= '<div class="plugin_box_remove">';
                                                        $h.= '<a class="remove_plugin_options" data-plugin="'.$effect['id'].'"><svg style="height:15px;width:15px;" viewBox="0 0 320 512"><path fill="#ababab" d="M193.94 256L296.5 153.44l21.15-21.15c3.12-3.12 3.12-8.19 0-11.31l-22.63-22.63c-3.12-3.12-8.19-3.12-11.31 0L160 222.06 36.29 98.34c-3.12-3.12-8.19-3.12-11.31 0L2.34 120.97c-3.12 3.12-3.12 8.19 0 11.31L126.06 256 2.34 379.71c-3.12 3.12-3.12 8.19 0 11.31l22.63 22.63c3.12 3.12 8.19 3.12 11.31 0L160 289.94 262.56 392.5l21.15 21.15c3.12 3.12 8.19 3.12 11.31 0l22.63-22.63c3.12-3.12 3.12-8.19 0-11.31L193.94 256z"></path></svg></a>';
                                                    $h.= '</div>';
                                                $h.= '</div>';
                                            }
                                        }
                                        
                                    $h.= '</div>';
                                    // end ._dn_plugins_holder

                                $h.= '</div>';
                                // end .plugins



                            $h.= '</div>';
                        $h.= '</div>';
                        // end .scrollarea 
                    $h.= '</div>';
                // <!-- end .animation_panel -->
                    


                $h.= '</div>';
                //<!--end .content -->
            $h.= '</div>';
            //<!-- end .edit_panel -->
        $h.= '</div>';
        //<!-- end .edit_bar_container -->

        return $h;
    }

}
endif;
?>