<?php
// Exit if accessed directly
if( !defined("IMC_VERSION")) exit;
if ( ! class_exists( 'ADN_Settings' ) ) :

class ADN_Settings {

    public static function magic_quotes() 
    {
        // Don't run this if plugin runs inside Wordpress
        if(defined("ABSPATH")) return;
        // Don't run this if we decide not to.
        if( !IMC_MAGICQUOTES ) return;

        // If already slashed, strip.
        if ( get_magic_quotes_gpc() ) 
        {
            $_GET    = self::stripslashes_deep( $_GET    );
            $_POST   = self::stripslashes_deep( $_POST   );
            $_COOKIE = self::stripslashes_deep( $_COOKIE );
        }

        // Escape
        $_GET    = self::add_magic_quotes( $_GET    );
        $_POST   = self::add_magic_quotes( $_POST   );
        $_COOKIE = self::add_magic_quotes( $_COOKIE );
        $_SERVER = self::add_magic_quotes( $_SERVER );

        // Force REQUEST to be GET + POST.
        $_REQUEST = array_merge( $_GET, $_POST );
    }

    public static function add_magic_quotes( $array ) 
    {
        foreach ( (array) $array as $k => $v ) {
            if ( is_array( $v ) ) {
                $array[$k] = self::add_magic_quotes( $v );
            } else {
                $array[$k] = addslashes( $v );
            }
        }
        return $array;
    }



    public static function stripslashes_deep( $value ) 
    {
        //return self::map_deep( $value, 'stripslashes_from_strings_only' );
        return self::map_deep( $value, array(__CLASS__, 'stripslashes_from_strings_only') );
    }



    public static function stripslashes_from_strings_only( $value ) 
    {
        return is_string( $value ) ? stripslashes( $value ) : $value;
    }



    public static function map_deep( $value, $callback ) 
    {
        if ( is_array( $value ) ) {
            foreach ( $value as $index => $item ) {
                $value[ $index ] = self::map_deep( $item, $callback );
            }
        } elseif ( is_object( $value ) ) {
            $object_vars = get_object_vars( $value );
            foreach ( $object_vars as $property_name => $property_value ) {
                $value->$property_name = self::map_deep( $property_value, $callback );
            }
        } else {
            $value = call_user_func( $callback, $value );
        }

        return $value;
    }

}
endif;
?>