<?php
if ( ! class_exists( 'ADN_Shortcodes' ) ) :

class ADN_Shortcodes {
	
	public function __construct() 
	{
        add_shortcode('imgmce_editor', array(__CLASS__, 'load_editor'));
        add_shortcode('imgmce_element', array(__CLASS__, 'load_element'));
        // @since v1.1.6 imgmce_object Deprecated use imgmce_element instead.
        add_shortcode('imgmce_object', array(__CLASS__, 'load_image'));
    }




    public static function load_element($args = array())
    {
        $defaults = array(
            'id' => 0,
            'user_id' => 0,
            'iframe_id' => 0,
            'display' => 1
        );
        $args = ADN_Main::parse_args($args, $defaults);

        $element = ADN_Main::load_element($args);
        $h = '';
        $h.= $element['template'];

        return $h;
    }


    // @since v1.1.6 Deprecated use imgmce_element instead.
    public static function load_image($args = array())
    {
        $defaults = array(
            'id' => 0,
            'user_id' => 0
        );
        $args = ADN_Main::parse_args($args, $defaults);

        $h = self::load_element($args);

        /*$h = '';
        $h.= '<div class="imgmce_grid" style="width: 300px; height: 250px;" contenteditable="false" data-id="'.$args['id'].'" data-u="'.$args['user_id'].'" data-mce-style="width: 300px; height: 250px;"></div>';
        */

        return $h;
    }
    

    public static function load_editor($args = array())
    {
        $defaults = array(
            // To wrap the code into a javascript function
            'function_name' => '',

            // available args to adjust editor settings
            'image_id' => '',
            'user_id' => '',
            'size_screen_message' => '',
            'editor_screen_message' => '',
            'editor_callback' => '_imgmce_demo_title_save',
            'editor_callback_function' => "function _imgmce_demo_title_save(object, json, settings){ console.log(\"save callback:\"); console.log(json); jQuery(\"#imgmce_home_title\").find('.wpb_content_element').find('.wpb_wrapper').html(json.banner_template); }", 
            'new_image_button' => 1,
            'my_images_button' => 1,
            'image_uploads' => 1,
            'save_to_folder' => 1,
            'logo_url' => 'http://imgmce.com',

            // Advanced options
            'banner_obj' => '{}', // json and url encoded string only!
            'upload' => '{}' // json and url encoded string only!
		);
        $args = ADN_Main::parse_args($args, $defaults);
        
        $banner_obj = '';

        // Check for banner_obj
        if(!empty($args['image_id']) && !empty($args['user_id']))
        {
            $file = IMC_UPLOAD_DIR.'user_uploads/{UID}/{ID}/imgmce.json';
            $file = ADN_Main::str_replace(array(
                'replace' => array(
                    array('{UID}' => $args['user_id']), 
                    array('{ID}' => $args['image_id']), 
                ), 
                'string' => $file
            ));
          
            if(file_exists($file))
            {
                $json = ADN_Main::get_content(array('path' => $file, 'spacefix' => 1));
                $banner_obj = json_decode(stripslashes($json),true);
                $banner_obj = empty($banner_obj) ? json_decode($json,true) : $banner_obj; // fix, in some cases stripslashes does not work.
            } 
        }
        $banner_obj = empty($banner_obj) ? json_decode(urldecode($args['banner_obj']), true) : $banner_obj;

        return ADN_Templates::load_editor_js_function(array(
            'function_name' => $args['function_name'],
            'settings' => array(
                'banner_obj' => $banner_obj,
                'editor' => array(
                    'image' => array(
                        'image_uploads' => $args['image_uploads'],
                    ),
                    'save_to_folder' => $args['save_to_folder'],
                    'upload' => json_decode($args['upload']),
                    'messages' => array(
                        'size_screen' => $args['size_screen_message'],
                        'editor_screen' => $args['editor_screen_message']
                    ),
                    'menu' => array(
                        'buttons' => array(
                            'new_image' => $args['new_image_button'],
                            'my_images' => $args['my_images_button']
                        ),
                        'logo_url' => $args['logo_url']
                    ),
                    'callback' => $args['editor_callback'],
                )
            )
        ), $args['editor_callback_function']);
    }
}
endif;
?>