<?php
if ( ! class_exists( 'ADN_Templates' ) ) :

class ADN_Templates {
	
	
	/**
	 * Main banner container
	*/
	public static function banner_tpl($banner_obj = array(), $args = array())
	{
		$defaults = array(
			'add_url' => 1,
			'load_script' => 1,
			'load_banner_script' => 1,
			'load_external' => 1,
			'start_animation' => '', // "iv" to start when element enters view
			'adjust_id' => '', // string to adjust the ID in nessecery
			'animation' => '',
			'display' => 0, // @since v1.2.8 When true, inline javascript will be collected and added to footer
			'load_always' => 0,
			'html5_export' => 0, // define banner gets loaded as html5 export code
			'delay' => 50,
			'debug' => 0
		);
		$args = ADN_Main::parse_args($args, $defaults);
		//echo '<pre>'.print_r($args,true).'</pre>';
		
		$html = '';
		$banner_obj = ADN_Main::parse_args($banner_obj, ADN_Main::default_banner_obj());

		if( !empty($banner_obj))
		{
			//$hash = ADN_Main::getToken();
			$is_amp = ADN_AMP::is_amp();
			$id = $banner_obj['id'];
			$responsive = array_key_exists('responsive', $banner_obj) ? $banner_obj['responsive'] : 1;
			$full_width = array_key_exists('fw', $banner_obj['size']) ? $banner_obj['size']['fw'] : 0;
			$fw_class = $full_width ? ' _fw' : '';

			// align
			$align = 'margin:0 auto;';
			$align = $banner_obj['align'] == 'left' ? 'float:left;margin:0.5em 1em 0.5em 0;' : $align;
			$align = $banner_obj['align'] == 'right' ? 'float:right; margin: 0.5em 0 0.5em 1em;' : $align;
			

			// Adjust the ID if banner_script doesn't has to get loaded. so that animations will never run on this id 
			// even if another same banner on the page would run.
			//$hash = !$args['load_banner_script'] ? $args['adjust_id'].$id : $id;
			$hash = !empty($args['adjust_id']) ? $args['adjust_id'].$id : $id;
			$url = '';
			$target = '';
			$nofollow = '';
			$content = '';
			$element_html = '';

			$animation = !empty($args['animation']) ? ' data-animation="'.$args['animation'].'"' : '';
			$opacity = !empty($args['animation']) && !$is_amp ? ' opacity:0;' : '';
			$size = !$full_width ? 'width:'.$banner_obj['size']['w'].'px;height:'.$banner_obj['size']['h'].'px;' : 'width:100%;height:'.$banner_obj['size']['h'].'px;';
			$size = $is_amp ? 'max-width:'.$banner_obj['size']['w'].'px;width:100%;max-height:'.$banner_obj['size']['h'].'px;' : $size;
			$inner_size = !$full_width && !$is_amp ? 'width:'.$banner_obj['size']['w'].'px;height:'.$banner_obj['size']['h'].'px;' : 'width:100%;height:'.$banner_obj['size']['h'].'px;';
			$responsive = $responsive ? ' responsive' : '';
			$load_always = !$args['load_always'] && !$is_amp ? ' _dn_hidden' : ' _dn_visible';
			$iframe_id_data = !empty($args['iframe_id']) ? ' data-iframe_id="'.$args['iframe_id'].'"' : '';

			$style = ADN_Banner::create_style(array('css' => array('layer' => $banner_obj['css']), 'style_tag' => 0));
			$html_arr = self::banner_content($banner_obj, $hash, $args);

			// Banner content
			$element_html.= '<div id="_dn_cnt_'.$hash.'" class="_dn_cont _dn_'.$hash.$fw_class.' '.$load_always.$responsive.'" data-id="'.$id.'" data-size="'.$banner_obj['size']['full'].'"'.$iframe_id_data.$animation.' style="'.$align.$size.$opacity.$style['layer'].'">';
				$element_html.= '<div class="_dn_inner" style="'.$inner_size.'">';
					// Banner_url
					$element_html.= !empty($url) && $args['add_url'] ? '<a href="'.$url.'" target="'.$banner_target.'"'.$nofollow.'>' : '';
						$element_html.= $html_arr['html'];
					$element_html.= !empty($url) && $args['add_url'] ? '</a>' : '';
				$element_html.= '</div>';
			$element_html.= '</div>';
			$html.= $element_html;
				
			
			// JS
			if($args['load_script'])
			{
				$js = '';
				$js.= '<script>';
					$js.= 'jQuery(document).ready(function($){';

						if($args['load_external'])
						{
							$js.= $html_arr['external'];

							if( array_key_exists('external', $banner_obj)){
								if( array_key_exists('styles', $banner_obj['external'])){
									if(!empty($banner_obj['external']['styles'])){
										foreach ($banner_obj['external']['styles'] as $key => $font) {
											$js.= '_dn_add_style_to_head( "'.$font['url'].'" );';
										}
									}
								}
							}
						}

						// @since v1.2.1 just to make sure the main element style sheets are loaded.
						$js.= '_dn_add_style_to_head( "'.IMC_ASSETS_URL.'dist/_imc.bundle.js.css" );';


						if( $args['load_banner_script'] ) //&& !empty($html_arr['js'])
						{
							// @since v1.1.8 add code in function always.
							$js.= '/* imgMCE element functions */';
							$js.= 'var bnr_'.$hash.'_in_animation = function(data){';

								$js.= IMC_DEBUG ? 'console.log("START ANIMATION");' : '';
								$js.= '$("._dn_'.$hash.'").css("opacity",1);';
								$js.= $html_arr['js'];

							$js.= '};';
							// If element has to load immediately, call function. 
							$js.= $args['start_animation'] != 'iv' ? 'bnr_'.$hash.'_in_animation();' : '';
						}
					

						$js.= '$("._dn_'.$hash.'").adnResponsive({';
							$js.= '"animation":"'.$args['animation'].'",';
							$js.= '"delay":'.$args['delay'].','; 
							$js.= '"callback":function(id){';
								$js.= IMC_DEBUG ? 'console.log("IN VIEW START ANIMATION _dn_'.$hash.'");' : '';
								$js.= $args['start_animation'] == 'iv' ? 'bnr_'.$hash.'_in_animation({reload:0});' : '';
								$js.= 'if( !$("._dn_'.$hash.'").find("._dn_ani").parents(".inactive").length){';
									$js.= '$("._dn_'.$hash.'").find("._dn_ani")._dn_animate_stroke({';
										$js.= '"start": function(set){$(this).css({"opacity": 1});}';
									$js.= '});'; 
								$js.= '}';
							$js.= '}';
						$js.= '});';


					$js.= '});';
				$js.= '</script>';
				
				// If Wordpress collect scripts and add to Footer
				$doing_ajax = defined( 'DOING_AJAX' ) ? DOING_AJAX : 0;
				
				if( defined( "ABSPATH" ) && $args['display'] && !$doing_ajax )
				{
					ADN_Filters::$collect_js[$hash] = $js;
				}
				else
				{
					$html.= $js;
				}
			}
		}
		
		return $html;
	}





	/**
	 * Create Banner Content
	*/
	public static function banner_content($banner_obj, $hash, $args = array())
	{
		$defaults = array(
			'only_js' => 0,  // Used for editor demo only
			'function_name' => '', // Used for editor demo only
			'selector' => '',  // Used for editor demo only
			'html5_export' => 0,
			'debug' => 0
		);
		$extra_args = ADN_Main::parse_args($args, $defaults);

		$html = '';
		$js = '';
		$external = '';
		$size = '';
		$am_slides = count($banner_obj['slides']);
		$is_last_slide = 0;
		//echo '<pre>'.print_r($extra_args,true).'</pre>';

		if(!empty($banner_obj['slides']))
		{
			foreach ($banner_obj['slides'] as $skey => $slide) 
			{
				$is_last_slide = $am_slides === ($skey+1) ? 1 : 0;
				//$am_animated_layers_in_last_slide = 0;
				$layer_timing = array();
				if( $is_last_slide )
				{
					// Get the duration time of the last slide. ( To know when the element ends )
					$layer_timing = ADN_Main::slide_duration($slide);
					if(!empty($layer_timing))
					{
						$temp_layer_timing = array();
						foreach($layer_timing as $tm => $timing)
						{
							$temp_layer_timing[] = array('nr' => $tm, 'duration'=> $timing);
						}
						$layer_timing = $temp_layer_timing;
					}
				}

				// Slide settings
				$bg_color = array_key_exists('params', $slide) ? ' background-color:'.$slide['params']['css']['background-color'].';' : ' background-color:transparent;';

				// Slide container
				$html.= !$extra_args['only_js'] ? '<div class="_dn_slide slide_'.$slide['slide_order'].'" data-order="'.$slide['slide_order'].'" data-id="'.$slide['slide_id'].'" style="'.$size.$bg_color.'">' : '';
					
					// Slide Layers
					if(!empty($slide['layers']))
					{
						//$am_layers_in_slide = count($slide['layers']);
						$animated_layers_count = 0;

						foreach ($slide['layers'] as $key => $layer) 
						{	
							//echo '<pre>'.print_r($layer,true).'</pre>';
							$layer_defaults = array(
								'animation' => array(),
								'actions' => array()
							);
							$args = ADN_Main::parse_args($layer, $layer_defaults);

							/*
							 * Added to ADN_Main::layer_plugins()
							 * 
							if( ADN_AMP::is_amp() )
							{							
								if( function_exists( 'is_amp_endpoint' ) ) 
								{
									//echo '<pre>'.print_r($layer['plugins']['google_font'],true).'</pre>';
									//$layer['plugins']['google_font']['external']['css'][0]
									if( !empty($layer['plugins']['google_font']['font']))
									{
										$font_key = sanitize_key($layer['plugins']['google_font']['font']);
										$GLOBALS['font_urls'][$font_key] = sanitize_url($layer['plugins']['google_font']['external']['css'][0]);
										
										add_action( 'amp_post_template_data', function($data){ return imc_add_a_font($data); } ); // echo '<pre>'.print_r($array,true).'</pre>';

										if( !function_exists('imc_add_a_font')){
											function imc_add_a_font($data){
												$data['font_urls'] = wp_parse_args($GLOBALS['font_urls'], $data['font_urls']);
												return $data;
											}
										}
									}
								}
							}*/

							// Layer container
							$layer_html = ADN_Banner::create_layer($layer, $key, $banner_obj, $extra_args['html5_export']);
							$layer_classes = $layer_html['classes'];
							$html.= $layer_html['html'];

							// Create layer animation
							if(!empty($layer['animation']))
							{
								$animated_layers_count++;
								$loop_element = array_key_exists('loop_element', $banner_obj) ? $banner_obj['loop_element'] : 0;
								
								$layer_ani = ADN_Banner::layer_animation( $layer['animation'], $layer, $key, $hash, array('loop_element' => $loop_element, 'layer_timing' => $layer_timing, 'layer_html' => $layer_html, 'layer_classses' => $layer_classes, 'debug' => $extra_args['debug']) );
								$js.= $layer_ani['js'];
								$external.= $layer_ani['external'];
							}
							else
							{
								$js.= '$("._dn_'.$hash.'").find(".layer_'.$key.'").addClass("visible");';
								$plugin_code = ADN_Main::layer_plugins(array('layer' => $layer, 'hash' => $hash, 'key' => $key));
								$js.= $plugin_code['js'];
								$external.= $plugin_code['external'];
							}

							// Create layer javascript
							if(!empty($layer['actions']))
							{
								// Layer actions
								if($layer['actions']['click_action'] == 'gotourl' && !empty($layer['actions']['url']))
								{
									$js.= '$("._dn_'.$hash.'").find(".layer_'.$key.'").css("cursor","pointer");';
									$js.= '$("._dn_'.$hash.'").find(".layer_'.$key.'").on("click", function(){';
										$js.= 'window.open("'.$layer['actions']['url'].'","_blank");';
									$js.= '});';
								}
								elseif($layer['actions']['click_action'] == 'callback' && !empty($layer['actions']['callback']))
								{
									$js.= '$("._dn_'.$hash.'").find(".layer_'.$key.'").css("cursor","pointer");';
									$js.= '$("._dn_'.$hash.'").find(".layer_'.$key.'").on("click", function(){'.$layer['actions']['callback'].'});';
								}
								elseif($layer['actions']['click_action'] == 'poi_popup' && !empty($layer['actions']['content']))
								{
									$js.= '$("._dn_'.$hash.'").find(".layer_'.$key.'").css("cursor","pointer");';
									$js.= '$("._dn_'.$hash.'").find(".layer_'.$key.'").on("click", function(){';
										$js.= 'var selectedPoint = $(this).find(".poi-single-point");
										if( selectedPoint.hasClass("is-open") ) {
											selectedPoint.removeClass("is-open"); //.addClass("visited")
										} else {
											selectedPoint.addClass("is-open").siblings(".poi-single-point.is-open").removeClass("is-open"); //.addClass("visited")
											selectedPoint.find(".poi-more-info").html("'.addslashes(urldecode($layer['actions']['content'])).'");
											selectedPoint.find(".poi-more-info").removeClass("poi-top poi-bottom poi-left poi-left-bottom poi-left-top poi-right poi-right-bottom poi-right-top");
											selectedPoint.find(".poi-more-info").addClass("poi-'.$layer['actions']['popup_position'].'");
										}
										$(".poi-close-info").on("click", function(event){
											event.preventDefault();
											$(this).parents(".poi-single-point").eq(0).removeClass("is-open"); //.addClass("visited")
										});';
									$js.= '});';
								}
							}
						}
					}

				$html.= !$extra_args['only_js'] ? '</div>' : '';
				// end ._dn_slide
			}
		}
		

		return array('html' => $html, 'js' => $js, 'external' => $external);
	}



	
	
	



	/**
	 * Timeline Template
	*/
	public static function timeline_tpl($slides = array())
	{
		$html = '';
		//$html.= print_r($slides, true);

		if(!empty($slides))
		{
			foreach ($slides as $key => $slide) 
			{
				$selected = !$key ? ' selected': '';
				$html.= '<div class="slide slide_'.$key.$selected.'" data-nr="'.$key.'">';
					$html.= '<div class="slide_header">';
						$html.= '<div class="icon">';
							$html.= '<svg aria-hidden="true" data-fa-processed="" data-prefix="fal" data-icon="cog" role="img" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512" class="svg-inline--fa fa-cog fa-w-16"><path fill="currentColor" d="M482.696 299.276l-32.61-18.827a195.168 195.168 0 0 0 0-48.899l32.61-18.827c9.576-5.528 14.195-16.902 11.046-27.501-11.214-37.749-31.175-71.728-57.535-99.595-7.634-8.07-19.817-9.836-29.437-4.282l-32.562 18.798a194.125 194.125 0 0 0-42.339-24.48V38.049c0-11.13-7.652-20.804-18.484-23.367-37.644-8.909-77.118-8.91-114.77 0-10.831 2.563-18.484 12.236-18.484 23.367v37.614a194.101 194.101 0 0 0-42.339 24.48L105.23 81.345c-9.621-5.554-21.804-3.788-29.437 4.282-26.36 27.867-46.321 61.847-57.535 99.595-3.149 10.599 1.47 21.972 11.046 27.501l32.61 18.827a195.168 195.168 0 0 0 0 48.899l-32.61 18.827c-9.576 5.528-14.195 16.902-11.046 27.501 11.214 37.748 31.175 71.728 57.535 99.595 7.634 8.07 19.817 9.836 29.437 4.283l32.562-18.798a194.08 194.08 0 0 0 42.339 24.479v37.614c0 11.13 7.652 20.804 18.484 23.367 37.645 8.909 77.118 8.91 114.77 0 10.831-2.563 18.484-12.236 18.484-23.367v-37.614a194.138 194.138 0 0 0 42.339-24.479l32.562 18.798c9.62 5.554 21.803 3.788 29.437-4.283 26.36-27.867 46.321-61.847 57.535-99.595 3.149-10.599-1.47-21.972-11.046-27.501zm-65.479 100.461l-46.309-26.74c-26.988 23.071-36.559 28.876-71.039 41.059v53.479a217.145 217.145 0 0 1-87.738 0v-53.479c-33.621-11.879-43.355-17.395-71.039-41.059l-46.309 26.74c-19.71-22.09-34.689-47.989-43.929-75.958l46.329-26.74c-6.535-35.417-6.538-46.644 0-82.079l-46.329-26.74c9.24-27.969 24.22-53.869 43.929-75.969l46.309 26.76c27.377-23.434 37.063-29.065 71.039-41.069V44.464a216.79 216.79 0 0 1 87.738 0v53.479c33.978 12.005 43.665 17.637 71.039 41.069l46.309-26.76c19.709 22.099 34.689 47.999 43.929 75.969l-46.329 26.74c6.536 35.426 6.538 46.644 0 82.079l46.329 26.74c-9.24 27.968-24.219 53.868-43.929 75.957zM256 160c-52.935 0-96 43.065-96 96s43.065 96 96 96 96-43.065 96-96-43.065-96-96-96zm0 160c-35.29 0-64-28.71-64-64s28.71-64 64-64 64 28.71 64 64-28.71 64-64 64z" class=""></path></svg>';
						$html.= '</div>';
						//$html.= '<div class="title">'.__('Slide','imc').' '.($key+1).'</div>';
						$html.= '<div class="title">'.__('Layers','imc').'</div>';
					$html.= '</div>';
					// end slide_header

					$html.= '<div class="layers_box">';
						if(!empty($slide['layers']))
						{
							foreach ($slide['layers'] as $lr => $layer) 
							{
								$html.= self::timeline_layer(ADN_Main::parse_args(array('layer_nr' => $lr), $layer));
							}
						}
					$html.= '</div>';
					// end layer_boxes

				$html.= '</div>';
			}
		}	

		return $html;
	}




	public static function timeline_layer($args = array())
	{
		$html = '';
		$icon = '';

		if($args['type'] == 'image'){
			$icon = '<svg aria-hidden="true" data-fa-processed="" data-prefix="fal" data-icon="image" role="img" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512" class="svg-inline--fa fa-image fa-w-16" style="height:10px;"><path fill="currentColor" d="M464 64H48C21.49 64 0 85.49 0 112v288c0 26.51 21.49 48 48 48h416c26.51 0 48-21.49 48-48V112c0-26.51-21.49-48-48-48zm16 336c0 8.822-7.178 16-16 16H48c-8.822 0-16-7.178-16-16V112c0-8.822 7.178-16 16-16h416c8.822 0 16 7.178 16 16v288zM112 232c30.928 0 56-25.072 56-56s-25.072-56-56-56-56 25.072-56 56 25.072 56 56 56zm0-80c13.234 0 24 10.766 24 24s-10.766 24-24 24-24-10.766-24-24 10.766-24 24-24zm207.029 23.029L224 270.059l-31.029-31.029c-9.373-9.373-24.569-9.373-33.941 0l-88 88A23.998 23.998 0 0 0 64 344v28c0 6.627 5.373 12 12 12h360c6.627 0 12-5.373 12-12v-92c0-6.365-2.529-12.47-7.029-16.971l-88-88c-9.373-9.372-24.569-9.372-33.942 0zM416 352H96v-4.686l80-80 48 48 112-112 80 80V352z" class=""></path></svg>';
		}
		elseif($args['type'] == 'text'){
			$icon = '<svg aria-hidden="true" data-fa-processed="" data-prefix="far" data-icon="font" role="img" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512" class="svg-inline--fa fa-font fa-w-14" style="height:10px;"><path fill="currentColor" d="M402.629 430.504L262.703 39.953A12 12 0 0 0 251.406 32h-54.811a12 12 0 0 0-11.297 7.953L45.371 430.504H20c-6.627 0-12 5.373-12 12V468c0 6.627 5.373 12 12 12h120c6.627 0 12-5.373 12-12v-25.496c0-6.627-5.373-12-12-12h-30.538l34.901-99.625h158.64l34.901 99.625H308c-6.627 0-12 5.373-12 12V468c0 6.627 5.373 12 12 12h120c6.627 0 12-5.373 12-12v-25.496c0-6.627-5.373-12-12-12h-25.371zM160.227 280.113l55.206-155.468C221.145 106.244 224 90.38 224 90.38s2.221 15.864 8.566 34.266l54.573 155.468H160.227z" class=""></path></svg>';
		}
		elseif( $args['type'] == 'shape'){
			$icon = stripslashes(stripslashes(urldecode($args['content'])));
		}
		elseif( $args['type'] == 'element'){
			if($args['element_type'] == 'video')
			{
				$icon = '<svg viewBox="0,0,576,512" style="height:10px;margin-top:2px;fill:#EB3223;"><path d="M549.655 124.083c-6.281-23.65-24.787-42.276-48.284-48.597C458.781 64 288 64 288 64S117.22 64 74.629 75.486c-23.497 6.322-42.003 24.947-48.284 48.597-11.412 42.867-11.412 132.305-11.412 132.305s0 89.438 11.412 132.305c6.281 23.65 24.787 41.5 48.284 47.821C117.22 448 288 448 288 448s170.78 0 213.371-11.486c23.497-6.321 42.003-24.171 48.284-47.821 11.412-42.867 11.412-132.305 11.412-132.305s0-89.438-11.412-132.305zm-317.51 213.508V175.185l142.739 81.205-142.739 81.201z"></path></svg>';
			}
		}

		$html.= '<div class="layer timeline_layer_'.$args['layer_nr'].'" data-nr="'.$args['layer_nr'].'" data-class="'.$args['class'].'">';
			$html.= '<div class="icon">';
				$html.= '<svg viewBox="0 0 448 512"><path d="M442 114H6a6 6 0 0 1-6-6V84a6 6 0 0 1 6-6h436a6 6 0 0 1 6 6v24a6 6 0 0 1-6 6zm0 160H6a6 6 0 0 1-6-6v-24a6 6 0 0 1 6-6h436a6 6 0 0 1 6 6v24a6 6 0 0 1-6 6zm0 160H6a6 6 0 0 1-6-6v-24a6 6 0 0 1 6-6h436a6 6 0 0 1 6 6v24a6 6 0 0 1-6 6z" class=""></path></svg>';
			$html.= '</div>';
			$html.= '<div class="title">';
				//$html.= '<div class="overlay"></div>';
				$html.= '<div class="layer_icon">'.$icon.'</div>';
				$html.= '<div class="layer_name">'.__('Layer','imc').' '.$args['layer_nr'].'</div>';
			$html.= '</div>';
			// @since v1.1.9 moved to bottom timeline.
			/*$html.= '<div class="layer_visible is_visible">';
				$html.= '<div class="visible_icon"><svg viewBox="0 0 576 512"><path d="M569.354 231.631C512.97 135.949 407.81 72 288 72 168.14 72 63.004 135.994 6.646 231.631a47.999 47.999 0 0 0 0 48.739C63.031 376.051 168.19 440 288 440c119.86 0 224.996-63.994 281.354-159.631a47.997 47.997 0 0 0 0-48.738zM288 392c-102.556 0-192.091-54.701-240-136 44.157-74.933 123.677-127.27 216.162-135.007C273.958 131.078 280 144.83 280 160c0 30.928-25.072 56-56 56s-56-25.072-56-56l.001-.042C157.794 179.043 152 200.844 152 224c0 75.111 60.889 136 136 136s136-60.889 136-136c0-31.031-10.4-59.629-27.895-82.515C451.704 164.638 498.009 205.106 528 256c-47.908 81.299-137.444 136-240 136z" class=""></path></svg></div>';
				$html.= '<div class="invisible_icon" style="display:none;"><svg viewBox="0 0 576 512"><path d="M272.702 359.139c-80.483-9.011-136.212-86.886-116.93-167.042l116.93 167.042zM288 392c-102.556 0-192.092-54.701-240-136 21.755-36.917 52.1-68.342 88.344-91.658l-27.541-39.343C67.001 152.234 31.921 188.741 6.646 231.631a47.999 47.999 0 0 0 0 48.739C63.004 376.006 168.14 440 288 440a332.89 332.89 0 0 0 39.648-2.367l-32.021-45.744A284.16 284.16 0 0 1 288 392zm281.354-111.631c-33.232 56.394-83.421 101.742-143.554 129.492l48.116 68.74c3.801 5.429 2.48 12.912-2.949 16.712L450.23 509.83c-5.429 3.801-12.912 2.48-16.712-2.949L102.084 33.399c-3.801-5.429-2.48-12.912 2.949-16.712L125.77 2.17c5.429-3.801 12.912-2.48 16.712 2.949l55.526 79.325C226.612 76.343 256.808 72 288 72c119.86 0 224.996 63.994 281.354 159.631a48.002 48.002 0 0 1 0 48.738zM528 256c-44.157-74.933-123.677-127.27-216.162-135.007C302.042 131.078 296 144.83 296 160c0 30.928 25.072 56 56 56s56-25.072 56-56l-.001-.042c30.632 57.277 16.739 130.26-36.928 171.719l26.695 38.135C452.626 346.551 498.308 306.386 528 256z" class=""></path></svg></div>';
			$html.= '</div>';*/
		$html.= '</div>';

		return $html;
	}



	public static function timeline_layers($args = array())
	{
		$defaults = array(
			'animation' => array()
		);
		$args = ADN_Main::parse_args($args, $defaults);

		$step = 80;
		$l_h = ''; // Layer html
		$a_h = ''; // Animation html
		$icon = '';

		if($args['type'] == 'image'){
			$icon = '<svg aria-hidden="true" data-fa-processed="" data-prefix="fal" data-icon="image" role="img" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512" class="svg-inline--fa fa-image fa-w-16" style="height:10px;"><path fill="currentColor" d="M464 64H48C21.49 64 0 85.49 0 112v288c0 26.51 21.49 48 48 48h416c26.51 0 48-21.49 48-48V112c0-26.51-21.49-48-48-48zm16 336c0 8.822-7.178 16-16 16H48c-8.822 0-16-7.178-16-16V112c0-8.822 7.178-16 16-16h416c8.822 0 16 7.178 16 16v288zM112 232c30.928 0 56-25.072 56-56s-25.072-56-56-56-56 25.072-56 56 25.072 56 56 56zm0-80c13.234 0 24 10.766 24 24s-10.766 24-24 24-24-10.766-24-24 10.766-24 24-24zm207.029 23.029L224 270.059l-31.029-31.029c-9.373-9.373-24.569-9.373-33.941 0l-88 88A23.998 23.998 0 0 0 64 344v28c0 6.627 5.373 12 12 12h360c6.627 0 12-5.373 12-12v-92c0-6.365-2.529-12.47-7.029-16.971l-88-88c-9.373-9.372-24.569-9.372-33.942 0zM416 352H96v-4.686l80-80 48 48 112-112 80 80V352z" class=""></path></svg>';
		}
		elseif($args['type'] == 'text'){
			$icon = '<svg aria-hidden="true" data-fa-processed="" data-prefix="far" data-icon="font" role="img" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512" class="svg-inline--fa fa-font fa-w-14" style="height:10px;"><path fill="currentColor" d="M402.629 430.504L262.703 39.953A12 12 0 0 0 251.406 32h-54.811a12 12 0 0 0-11.297 7.953L45.371 430.504H20c-6.627 0-12 5.373-12 12V468c0 6.627 5.373 12 12 12h120c6.627 0 12-5.373 12-12v-25.496c0-6.627-5.373-12-12-12h-30.538l34.901-99.625h158.64l34.901 99.625H308c-6.627 0-12 5.373-12 12V468c0 6.627 5.373 12 12 12h120c6.627 0 12-5.373 12-12v-25.496c0-6.627-5.373-12-12-12h-25.371zM160.227 280.113l55.206-155.468C221.145 106.244 224 90.38 224 90.38s2.221 15.864 8.566 34.266l54.573 155.468H160.227z" class=""></path></svg>';
		}
		elseif( $args['type'] == 'shape'){
			$icon = stripslashes(stripslashes(urldecode($args['content'])));
		}
		elseif( $args['type'] == 'element'){
			if($args['element_type'] == 'video')
			{
				$icon = '<svg viewBox="0,0,576,512" style="height:10px;margin-top:2px;fill:#EB3223;"><path d="M549.655 124.083c-6.281-23.65-24.787-42.276-48.284-48.597C458.781 64 288 64 288 64S117.22 64 74.629 75.486c-23.497 6.322-42.003 24.947-48.284 48.597-11.412 42.867-11.412 132.305-11.412 132.305s0 89.438 11.412 132.305c6.281 23.65 24.787 41.5 48.284 47.821C117.22 448 288 448 288 448s170.78 0 213.371-11.486c23.497-6.321 42.003-24.171 48.284-47.821 11.412-42.867 11.412-132.305 11.412-132.305s0-89.438-11.412-132.305zm-317.51 213.508V175.185l142.739 81.205-142.739 81.201z"></path></svg>';
			}
		}

		// LAYER HTML
		$l_h.= '<div class="timeline_layer_element timeline_layer_'.$args['layer_nr'].' layer_is_visible" data-nr="'.$args['layer_nr'].'" data-class="'.$args['class'].'">';
			$l_h.= '<div class="drag_handle">';
				$l_h.= '<svg viewBox="0 0 448 512"><path d="M16 132h416c8.837 0 16-7.163 16-16V76c0-8.837-7.163-16-16-16H16C7.163 60 0 67.163 0 76v40c0 8.837 7.163 16 16 16zm0 160h416c8.837 0 16-7.163 16-16v-40c0-8.837-7.163-16-16-16H16c-8.837 0-16 7.163-16 16v40c0 8.837 7.163 16 16 16zm0 160h416c8.837 0 16-7.163 16-16v-40c0-8.837-7.163-16-16-16H16c-8.837 0-16 7.163-16 16v40c0 8.837 7.163 16 16 16z"></path></svg>';
			$l_h.= '</div>';
			$l_h.= '<div class="timeline_layer_cont">';
				$l_h.= '<div class="timeline_layer_type_icon">';
					$l_h.= $icon;
				$l_h.= '</div>';
				$l_h.= '<div class="timeline_layer_name">';
					$l_h.= '<span class="">'.__('Layer','imc').' '.$args['layer_nr'].'</span>';
				$l_h.= '</div>';
			$l_h.= '</div>';
			$l_h.= '<div class="timeline_layer_visible_icon layer_is_visible_btn">';
				$l_h.= '<svg viewBox="0,0,576,512" class="visible"><path d="M569.354 231.631C512.969 135.949 407.81 72 288 72 168.14 72 63.004 135.994 6.646 231.631a47.999 47.999 0 0 0 0 48.739C63.031 376.051 168.19 440 288 440c119.86 0 224.996-63.994 281.354-159.631a47.997 47.997 0 0 0 0-48.738zM288 392c-75.162 0-136-60.827-136-136 0-75.162 60.826-136 136-136 75.162 0 136 60.826 136 136 0 75.162-60.826 136-136 136zm104-136c0 57.438-46.562 104-104 104s-104-46.562-104-104c0-17.708 4.431-34.379 12.236-48.973l-.001.032c0 23.651 19.173 42.823 42.824 42.823s42.824-19.173 42.824-42.823c0-23.651-19.173-42.824-42.824-42.824l-.032.001C253.621 156.431 270.292 152 288 152c57.438 0 104 46.562 104 104z"></path></svg>';
				$l_h.= '<svg viewBox="0 0 576 512" class="not_visible" style="display:none;"><path d="M286.693 391.984l32.579 46.542A333.958 333.958 0 0 1 288 440C168.19 440 63.031 376.051 6.646 280.369a47.999 47.999 0 0 1 0-48.739c24.023-40.766 56.913-75.775 96.024-102.537l57.077 81.539C154.736 224.82 152 240.087 152 256c0 74.736 60.135 135.282 134.693 135.984zm282.661-111.615c-31.667 53.737-78.747 97.46-135.175 125.475l.011.015 41.47 59.2c7.6 10.86 4.96 25.82-5.9 33.42l-13.11 9.18c-10.86 7.6-25.82 4.96-33.42-5.9L100.34 46.94c-7.6-10.86-4.96-25.82 5.9-33.42l13.11-9.18c10.86-7.6 25.82-4.96 33.42 5.9l51.038 72.617C230.68 75.776 258.905 72 288 72c119.81 0 224.969 63.949 281.354 159.631a48.002 48.002 0 0 1 0 48.738zM424 256c0-75.174-60.838-136-136-136-17.939 0-35.056 3.473-50.729 9.772l19.299 27.058c25.869-8.171 55.044-6.163 80.4 7.41h-.03c-23.65 0-42.82 19.17-42.82 42.82 0 23.626 19.147 42.82 42.82 42.82 23.65 0 42.82-19.17 42.82-42.82v-.03c18.462 34.49 16.312 77.914-8.25 110.95v.01l19.314 27.061C411.496 321.2 424 290.074 424 256zM262.014 356.727l-77.53-110.757c-5.014 52.387 29.314 98.354 77.53 110.757z"></path></svg>';    
			$l_h.= '</div>';
		$l_h.= '</div>';

		// ANIMATION HTML
		$ani_default = array(
			'in' => array(
				'delay' => 0,
				'duration' => 0,
				'animation' => 'none'
			),
			'view' => array(
				'duration' => 5
			),
			'out' => array(
				'duration' => 0,
				'animation' => 'none'
			)
		);
		$animation = ADN_Main::parse_args($args['animation'], $ani_default);
		
		// IN
		$delay = $animation['in']['delay']*$step;
		$has_delay = $delay ? ' has_delay' : '';
		$has_IN_ani = $animation['in']['animation'] !== 'none' ? ' has_animation' : '';
		$in_text = $animation['in']['animation'] !== 'none' ? $animation['in']['animation'] : '';
		$out_text = $animation['out']['animation'] !== 'none' ? $animation['out']['animation'] : '';
		$in_width = empty($animation['in']['duration']) ? 24 : $animation['in']['duration']*80;
		$has_OUT_ani = $animation['out']['animation'] !== 'none' ? ' has_animation' : '';
		$out_width = empty($animation['out']['duration']) ? 24 : $animation['out']['duration']*80;

		// VIEW
		$view_duration = $animation['view']['duration']*$step;

		$a_h.= '<div class="timeline_layer_animation_container" data-nr="'.$args['layer_nr'].'">';                   
			$a_h.= '<div class="layer_animation_container'.$has_delay.'" style="background:#FAD949; width:'.$view_duration.'px; left: '.$delay.'px;">';
				$a_h.= '<div class="layer_animation_duration_container" style="position:relative;height:35px;">';
					
					$a_h.= '<div class="layer_add_animation layer_add_animation_left" title="" data-ani="in" data-animation="'.$animation['in']['animation'].'" style="width:'.$in_width.'px;left: 0px;">';
						$a_h.= '<span class="layer_add_animation_icon'.$has_IN_ani.'">';
							$a_h.= '<svg viewBox="0,0,192,512"><path d="M192 127.338v257.324c0 17.818-21.543 26.741-34.142 14.142L29.196 270.142c-7.81-7.81-7.81-20.474 0-28.284l128.662-128.662c12.599-12.6 34.142-3.676 34.142 14.142z"></path></svg>';
						$a_h.= '</span>';
						$a_h.= '<span class="layer_add_animation_text">'.$in_text.'</span>';
					$a_h.= '</div>';
					
					$a_h.= '<div class="layer_add_animation layer_add_animation_right" data-ani="out" data-animation="'.$animation['out']['animation'].'" title="" style="width:'.$out_width.'px; right: 0px;">';
						$a_h.= '<span class="layer_add_animation_icon'.$has_OUT_ani.'">';
							$a_h.= '<svg viewBox="0,0,192,512"><path d="M0 384.662V127.338c0-17.818 21.543-26.741 34.142-14.142l128.662 128.662c7.81 7.81 7.81 20.474 0 28.284L34.142 398.804C21.543 411.404 0 402.48 0 384.662z"></path></svg>';
						$a_h.= '</span>';
						$a_h.= '<span class="layer_add_animation_text">'.$out_text.'</span>';
					$a_h.= '</div>';
				$a_h.= '</div>';
			$a_h.= '</div>';
		$a_h.= '</div>';

		return array('layer' => $l_h, 'animation' => $a_h);
	}




	/**
	 * Tooltip
	*/
	public static function tooltip($args = array())
	{
		$defaults = array(
			'class' => '',
			'title' => '',
			'icon' => '<svg viewBox="0 0 512 512"><path fill="currentColor" d="M256 40c118.621 0 216 96.075 216 216 0 119.291-96.61 216-216 216-119.244 0-216-96.562-216-216 0-119.203 96.602-216 216-216m0-32C119.043 8 8 119.083 8 256c0 136.997 111.043 248 248 248s248-111.003 248-248C504 119.083 392.957 8 256 8zm-36 344h12V232h-12c-6.627 0-12-5.373-12-12v-8c0-6.627 5.373-12 12-12h48c6.627 0 12 5.373 12 12v140h12c6.627 0 12 5.373 12 12v8c0 6.627-5.373 12-12 12h-72c-6.627 0-12-5.373-12-12v-8c0-6.627 5.373-12 12-12zm36-240c-17.673 0-32 14.327-32 32s14.327 32 32 32 32-14.327 32-32-14.327-32-32-32z" class=""></path></svg>'
		);
		$args = ADN_Main::parse_args($args, $defaults);

		$t = '';
		$class = !empty($args['class']) ? ' '.$args['class'] : '';
		$t.= '<span class="ttip'.$class.'" title="'.$args['title'].'">'.$args['icon'].'</span>';

		return $t;
	}



	/**
	 * Checkbox
	 * 
	*/
	public static function checkbox($args = array())
	{
		$defaults = array(
			'title' => '',
			'tooltip' => '',
			'class' => '',
			'name' => '',
			'data' => array(),
			'value' => '',
			'checked' => '',
			'disabled' => 0,
			'hidden_input' => 0 // to return 0 when check box is unchecked. will only work when a value is provided.
		);
		$args = ADN_Main::parse_args($args, $defaults);

		$check = !empty($args['checked']) ? ' checked="checked"' : '';
		$disabled = !empty($args['disabled']) ? ' disabled="disabled"' : '';
		$disabled_class = !empty($args['disabled']) ? ' disabled' : '';
		$data_string = ADN_Main::create_data_attributes($args['data']);
		$name = !empty($args['name']) ? ' name="'.$args['name'].'"' : '';
		$value = $args['value'] !== '' ? ' value="'.$args['value'].'"' : '';

		$h = '';
		$h.= '<label class="spr_check_container'.$disabled_class.'">';
			$h.= $args['title'];
			$h.= !empty($args['tooltip']) ? self::tooltip(array('class' => '_dn_quest_tooltip', 'title' => $args['tooltip'])) : '';
			$h.= $args['hidden_input'] ? '<input type="hidden" value="0"'.$name.' />' : '';  
			$h.= '<input class="'.$args['class'].'"'.$data_string.$name.$value.' type="checkbox"'.$check.$disabled.'>';
	  		$h.= '<span class="checkmark"></span>';
		$h.= '</label>';

		return $h;
	}


	/**
	 * Switch button
	 *
	*/
	public static function switchbox($args = array())
	{
		$defaults = array(
			'title' => '',
			'tooltip' => '',
			'value' => '',
			'class' => '',
			'checked' => '',
			'on' => __('On','imc'),
			'off' => __('Off','imc')
		);
		$args = ADN_Main::parse_args($args, $defaults);

		$check = !empty($args['checked']) ? ' checked="checked"' : '';

		$h = '';
		$h.= '<label class="switch switch-slide small ttip" title="'.$args['tooltip'].'">';
            $h.= '<input class="switch-input '.$args['class'].'" type="checkbox"'.$check.' value="'.$args['value'].'" />';
            $h.= '<span class="switch-label" data-on="'.$args['on'].'" data-off="'.$args['off'].'"></span>';
            $h.= '<span class="switch-handle"></span>';
        $h.= '</label>';

        return $h;
    }








	/**
	 * "Use" button - banner template (my banners)
	 *
	*/
	public static function use_banner_template($args = array())
	{
		$defaults = array(
			'id' => 0,
			'responsive' => 1
		);
		$args = ADN_Main::parse_args($args, $defaults);

		//$bo = ADN_Banner::load_banner_obj($args['id']);
		$bo = '';
		$banner = do_shortcode('[adning id="'.$args['id'].'"]');

		$args['width'] = $bo['size']['w'];
		$args['height'] = $bo['size']['h'];

		// EXPORT / EMBED TABS
		$exp = '';
		$exp.= '<div class="export_box">';

			// Tabs
   			$exp.= '<div class="export_tabs_container">';
   				$exp.= '<div class="embed_tab exp_tab selected" data-tab="embed">';
   					$exp.= '<div class="tab_title">'.__('EMBED','imc').'</div>';
   				$exp.= '</div>';
   				$exp.= '<div class="export_tab exp_tab" data-tab="export">';
   					$exp.= '<div class="tab_title">'.__('DOWNLOAD','imc').'</div>';
   				$exp.= '</div>';
   			$exp.= '</div>';

   			// Tab Content
   			$exp.= '<div class="export_content_container">';

   				// Embed Content
   				$exp.= '<div class="embed_tab_content exp_cont visible">';

   					// Checkbox
   					$exp.= self::checkbox(array(
   						'title' => __('Responsive','imc'),
   						'tooltip' => __('Make banner responsive.','imc'),
   						'checked' => $args['responsive'],
   						'class' => 'option_checkbox _dn_banner_is_responsive',
   						'data' => array('box' => 'responsive' )
   					));
   					$exp.= self::checkbox(array(
   						'title' => __('Use Iframe','imc'),
   						'tooltip' => __('To take advantage of all available banner settings we recommend to use the default javascript embed code. However, some sites may restrict the ability to add javascript code to their pages. In which case you can use the Iframe embed code.','imc'),
   						'class' => 'option_checkbox _dn_use_iframe',
   						'data' => array('box' => 'use_iframe' )
   					));
   					$exp.= self::checkbox(array(
   						'title' => __('Load jQuery','imc'),
   						'tooltip' => __('Load jQuery in case you add the banner on a site without jQuery.','imc'),
   						'class' => 'option_checkbox _dn_load_jquery not_with_iframe',
   						'data' => array('box' => 'load_jquery' )
   					));
   					
   					
   					$exp.= '<textarea id="_dn_embed_code" class="input">'.ADN_Main::embed_code($args).'</textarea>';
   					$exp.= '<div class="copy_embed_code">'.__('Copy embed code','imc').'</div>';

   					// Display Options
   					$exp.= '<div class="display_options">';
   						$exp.= '<span class="title">'.__('Extra Options:','imc').'</span>';
   						
   						/*
   						 * Javascript to create the animation values.
   						 * refference - http://tutsville.com/docs/css-animations/
   						 *
   						 * var options = 'bounce,flash,pulse,rubberBand,shake,headShake,swing,tada,wobble,jello,bounceIn,bounceInDown,bounceInLeft,bounceInRight,bounceInUp,bounceOut,bounceOutDown,bounceOutLeft,bounceOutRight,bounceOutUp,fadeIn,fadeInDown,fadeInDownBig,fadeInLeft,fadeInLeftBig,fadeInRight,fadeInRightBig,fadeInUp,fadeInUpBig,fadeOut,fadeOutDown,fadeOutDownBig,fadeOutLeft,fadeOutLeftBig,fadeOutRight,fadeOutRightBig,fadeOutUp,fadeOutUpBig,flipInX,flipInY,flipOutX,flipOutY,lightSpeedIn,lightSpeedOut,rotateIn,rotateInDownLeft,rotateInDownRight,rotateInUpLeft,rotateInUpRight,rotateOut,rotateOutDownLeft,rotateOutDownRight,rotateOutUpLeft,rotateOutUpRight,hinge,jackInTheBox,rollIn,rollOut,zoomIn,zoomInDown,zoomInLeft,zoomInRight,zoomInUp,zoomOut,zoomOutDown,zoomOutLeft,zoomOutRight,zoomOutUp,slideInDown,slideInLeft,slideInRight,slideInUp,slideOutDown,slideOutLeft,slideOutRightslideOutUp';

						 options = options.split(',');

						 var ani = [];
						 ani[0] = {"value": 0, "option": "None"};

						 $.each( options, function( key, value ) {
						  	//console.log( key );
						  	//console.log( value );
						  	ani[key+1] = {"value": value, "option": value};
						 });
						 console.log(encodeURIComponent(JSON.stringify(ani)));
						*/

   						$exp.= '<div class="spr_row">';
   							$exp.= SPR_Columns::column(array(
   								'col' => 6,
   								'content' => '<div class="display_option_box"><span class="title">Animation '.self::tooltip(array('class' => '_dn_quest_tooltip', 'title' => __('Animation when the banner becomes visible.', 'imc'))).'</span><div class="animation_options" data-values="%5B%7B%22value%22%3A0%2C%22option%22%3A%22None%22%7D%2C%7B%22value%22%3A%22bounce%22%2C%22option%22%3A%22bounce%22%7D%2C%7B%22value%22%3A%22flash%22%2C%22option%22%3A%22flash%22%7D%2C%7B%22value%22%3A%22pulse%22%2C%22option%22%3A%22pulse%22%7D%2C%7B%22value%22%3A%22rubberBand%22%2C%22option%22%3A%22rubberBand%22%7D%2C%7B%22value%22%3A%22shake%22%2C%22option%22%3A%22shake%22%7D%2C%7B%22value%22%3A%22headShake%22%2C%22option%22%3A%22headShake%22%7D%2C%7B%22value%22%3A%22swing%22%2C%22option%22%3A%22swing%22%7D%2C%7B%22value%22%3A%22tada%22%2C%22option%22%3A%22tada%22%7D%2C%7B%22value%22%3A%22wobble%22%2C%22option%22%3A%22wobble%22%7D%2C%7B%22value%22%3A%22jello%22%2C%22option%22%3A%22jello%22%7D%2C%7B%22value%22%3A%22bounceIn%22%2C%22option%22%3A%22bounceIn%22%7D%2C%7B%22value%22%3A%22bounceInDown%22%2C%22option%22%3A%22bounceInDown%22%7D%2C%7B%22value%22%3A%22bounceInLeft%22%2C%22option%22%3A%22bounceInLeft%22%7D%2C%7B%22value%22%3A%22bounceInRight%22%2C%22option%22%3A%22bounceInRight%22%7D%2C%7B%22value%22%3A%22bounceInUp%22%2C%22option%22%3A%22bounceInUp%22%7D%2C%7B%22value%22%3A%22bounceOut%22%2C%22option%22%3A%22bounceOut%22%7D%2C%7B%22value%22%3A%22bounceOutDown%22%2C%22option%22%3A%22bounceOutDown%22%7D%2C%7B%22value%22%3A%22bounceOutLeft%22%2C%22option%22%3A%22bounceOutLeft%22%7D%2C%7B%22value%22%3A%22bounceOutRight%22%2C%22option%22%3A%22bounceOutRight%22%7D%2C%7B%22value%22%3A%22bounceOutUp%22%2C%22option%22%3A%22bounceOutUp%22%7D%2C%7B%22value%22%3A%22fadeIn%22%2C%22option%22%3A%22fadeIn%22%7D%2C%7B%22value%22%3A%22fadeInDown%22%2C%22option%22%3A%22fadeInDown%22%7D%2C%7B%22value%22%3A%22fadeInDownBig%22%2C%22option%22%3A%22fadeInDownBig%22%7D%2C%7B%22value%22%3A%22fadeInLeft%22%2C%22option%22%3A%22fadeInLeft%22%7D%2C%7B%22value%22%3A%22fadeInLeftBig%22%2C%22option%22%3A%22fadeInLeftBig%22%7D%2C%7B%22value%22%3A%22fadeInRight%22%2C%22option%22%3A%22fadeInRight%22%7D%2C%7B%22value%22%3A%22fadeInRightBig%22%2C%22option%22%3A%22fadeInRightBig%22%7D%2C%7B%22value%22%3A%22fadeInUp%22%2C%22option%22%3A%22fadeInUp%22%7D%2C%7B%22value%22%3A%22fadeInUpBig%22%2C%22option%22%3A%22fadeInUpBig%22%7D%2C%7B%22value%22%3A%22fadeOut%22%2C%22option%22%3A%22fadeOut%22%7D%2C%7B%22value%22%3A%22fadeOutDown%22%2C%22option%22%3A%22fadeOutDown%22%7D%2C%7B%22value%22%3A%22fadeOutDownBig%22%2C%22option%22%3A%22fadeOutDownBig%22%7D%2C%7B%22value%22%3A%22fadeOutLeft%22%2C%22option%22%3A%22fadeOutLeft%22%7D%2C%7B%22value%22%3A%22fadeOutLeftBig%22%2C%22option%22%3A%22fadeOutLeftBig%22%7D%2C%7B%22value%22%3A%22fadeOutRight%22%2C%22option%22%3A%22fadeOutRight%22%7D%2C%7B%22value%22%3A%22fadeOutRightBig%22%2C%22option%22%3A%22fadeOutRightBig%22%7D%2C%7B%22value%22%3A%22fadeOutUp%22%2C%22option%22%3A%22fadeOutUp%22%7D%2C%7B%22value%22%3A%22fadeOutUpBig%22%2C%22option%22%3A%22fadeOutUpBig%22%7D%2C%7B%22value%22%3A%22flipInX%22%2C%22option%22%3A%22flipInX%22%7D%2C%7B%22value%22%3A%22flipInY%22%2C%22option%22%3A%22flipInY%22%7D%2C%7B%22value%22%3A%22flipOutX%22%2C%22option%22%3A%22flipOutX%22%7D%2C%7B%22value%22%3A%22flipOutY%22%2C%22option%22%3A%22flipOutY%22%7D%2C%7B%22value%22%3A%22lightSpeedIn%22%2C%22option%22%3A%22lightSpeedIn%22%7D%2C%7B%22value%22%3A%22lightSpeedOut%22%2C%22option%22%3A%22lightSpeedOut%22%7D%2C%7B%22value%22%3A%22rotateIn%22%2C%22option%22%3A%22rotateIn%22%7D%2C%7B%22value%22%3A%22rotateInDownLeft%22%2C%22option%22%3A%22rotateInDownLeft%22%7D%2C%7B%22value%22%3A%22rotateInDownRight%22%2C%22option%22%3A%22rotateInDownRight%22%7D%2C%7B%22value%22%3A%22rotateInUpLeft%22%2C%22option%22%3A%22rotateInUpLeft%22%7D%2C%7B%22value%22%3A%22rotateInUpRight%22%2C%22option%22%3A%22rotateInUpRight%22%7D%2C%7B%22value%22%3A%22rotateOut%22%2C%22option%22%3A%22rotateOut%22%7D%2C%7B%22value%22%3A%22rotateOutDownLeft%22%2C%22option%22%3A%22rotateOutDownLeft%22%7D%2C%7B%22value%22%3A%22rotateOutDownRight%22%2C%22option%22%3A%22rotateOutDownRight%22%7D%2C%7B%22value%22%3A%22rotateOutUpLeft%22%2C%22option%22%3A%22rotateOutUpLeft%22%7D%2C%7B%22value%22%3A%22rotateOutUpRight%22%2C%22option%22%3A%22rotateOutUpRight%22%7D%2C%7B%22value%22%3A%22hinge%22%2C%22option%22%3A%22hinge%22%7D%2C%7B%22value%22%3A%22jackInTheBox%22%2C%22option%22%3A%22jackInTheBox%22%7D%2C%7B%22value%22%3A%22rollIn%22%2C%22option%22%3A%22rollIn%22%7D%2C%7B%22value%22%3A%22rollOut%22%2C%22option%22%3A%22rollOut%22%7D%2C%7B%22value%22%3A%22zoomIn%22%2C%22option%22%3A%22zoomIn%22%7D%2C%7B%22value%22%3A%22zoomInDown%22%2C%22option%22%3A%22zoomInDown%22%7D%2C%7B%22value%22%3A%22zoomInLeft%22%2C%22option%22%3A%22zoomInLeft%22%7D%2C%7B%22value%22%3A%22zoomInRight%22%2C%22option%22%3A%22zoomInRight%22%7D%2C%7B%22value%22%3A%22zoomInUp%22%2C%22option%22%3A%22zoomInUp%22%7D%2C%7B%22value%22%3A%22zoomOut%22%2C%22option%22%3A%22zoomOut%22%7D%2C%7B%22value%22%3A%22zoomOutDown%22%2C%22option%22%3A%22zoomOutDown%22%7D%2C%7B%22value%22%3A%22zoomOutLeft%22%2C%22option%22%3A%22zoomOutLeft%22%7D%2C%7B%22value%22%3A%22zoomOutRight%22%2C%22option%22%3A%22zoomOutRight%22%7D%2C%7B%22value%22%3A%22zoomOutUp%22%2C%22option%22%3A%22zoomOutUp%22%7D%2C%7B%22value%22%3A%22slideInDown%22%2C%22option%22%3A%22slideInDown%22%7D%2C%7B%22value%22%3A%22slideInLeft%22%2C%22option%22%3A%22slideInLeft%22%7D%2C%7B%22value%22%3A%22slideInRight%22%2C%22option%22%3A%22slideInRight%22%7D%2C%7B%22value%22%3A%22slideInUp%22%2C%22option%22%3A%22slideInUp%22%7D%2C%7B%22value%22%3A%22slideOutDown%22%2C%22option%22%3A%22slideOutDown%22%7D%2C%7B%22value%22%3A%22slideOutLeft%22%2C%22option%22%3A%22slideOutLeft%22%7D%2C%7B%22value%22%3A%22slideOutRightslideOutUp%22%2C%22option%22%3A%22slideOutRightslideOutUp%22%7D%5D"></div></div>'
   							));
   							$exp.= SPR_Columns::column(array(
   								'col' => 6,
   								'content' => '<div class="display_option_box" style="text-align:center;padding-top:16px;">'.self::checkbox(array(
				   						'title' => __('Start in view','imc'),
				   						'tooltip' => __('Only start the banner animations when it becomes visible.','imc'),
				   						'class' => 'option_checkbox _dn_start_animation not_with_iframe',
				   						'data' => array('box' => 'start_animation' ),
				   						'checked' => 1
				   					)).'</div>'
   							));
   						$exp.= '</div>';
   						// end .spr_row


   						$exp.= '<div class="spr_row">';
   							$exp.= SPR_Columns::column(array(
   								'col' => 12,
   								'content' => '<div class="display_option_box not_with_iframe"><span class="title">Display '.self::tooltip(array('class' => '_dn_quest_tooltip', 'title' => __('Display options allow you to show the banner in different ways.', 'imc'))).'</span><div class="banner_display_options"></div></div>'
   							));
   						$exp.= '</div>';
   						// end .spr_row

   						$exp.= '<div id="display_as_popup" class="display_option_content">';

   							$exp.= '<div class="spr_row">';
	   							$exp.= SPR_Columns::column(array(
	   								'col' => 6,
	   								'content' => '<div class="display_option_box" style="padding-top:16px;">'.self::checkbox(array(
					   						'title' => __('Exit Popup','imc'),
					   						'tooltip' => __('Open popup when user is about to leave the page.','imc'),
					   						'class' => 'option_checkbox _dn_on_exit not_with_iframe',
					   						'data' => array('box' => 'display::attr::on_exit' )
					   					)).'</div>'
	   							));
	   							// Close button delay (seconds)
	   							$exp.= SPR_Columns::column(array(
	   								'col' => 6,
	   								'content' => '<div class="display_option_box"><div class="label">'.__('Close button delay.','imc').self::tooltip(array('class' => '_dn_quest_tooltip', 'title' => __('Amount of seconds before the close button becomes visible.', 'imc'))).'</div><input type="text" placeholder="0" id="close_btn_delay_option" class="display_option_input" data-box="display::attr::close_btn::delay" style="width:50px;" /><span class="label">'.__('Sec.','imc').'</span></div>'
	   							));
	   						$exp.= '</div>';
   							// end .spr_row

	   						$exp.= '<div class="spr_row">';
	   							// Countdown Text - close button
	   							$exp.= SPR_Columns::column(array(
	   								'col' => 6,
	   								'content' => '<div class="display_option_box"><div class="label">'.__('Countdown text.','imc').self::tooltip(array('class' => '_dn_quest_tooltip', 'title' => __('Text to show during countdown before showing the close button.', 'imc'))).'</div><input type="text" placeholder="'.__('Close AD in %s seconds','imc').'" id="count_down_txt_option" class="display_option_input" data-box="display::attr::close_btn::count_down_txt" /></div>'
	   							));
	   							// Close button position
	   							$exp.= SPR_Columns::column(array(
	   								'col' => 6,
	   								'content' => '<div class="display_option_box"><div class="label">'.__('Close button position.','imc').self::tooltip(array('class' => '_dn_quest_tooltip', 'title' => __('Select the position for the close button.', 'imc'))).'</div><div class="close_button_position_options"></div></div>'
	   							));
	   							
   							$exp.= '</div>';
   							// end .spr_row

   						$exp.= '</div>';
   						// end #display_as_popup 

   					$exp.= '</div>';

   				$exp.= '</div>';

   				// Export Content
   				$exp.= '<div class="export_tab_content exp_cont">';
   					$exp.= 'Export content';
   				$exp.= '</div>';

   			$exp.= '</div>';
   			// <!-- end .export_content_container -->

   		$exp.= '</div>';
   		// <!-- end .export_box -->

   		$js = '';
   		/*$js.= '<script>';
   			$js.= 'jQuery(document).ready(function($){';

   				$js.= 'var embed_args = {};';
   				$js.= 'var use_iframe = 0;';

				foreach($args as $key => $arg)
				{
					$js.= 'embed_args["'.$key.'"] = "'.$arg.'";';
				}

				// Option box changes
   				$js.= '$(".option_checkbox").on("change", function(){';
   					$js.= 'var option = $(this).data("box");';
   					$js.= 'var is_checked = $(this).prop("checked");';
   					$js.= 'var at = [];';
   					$js.= 'at[option] = is_checked;';
   					$js.= '$.extend(embed_args, at);';
   					//$js.= 'console.log(option+" "+is_checked);';
   					$js.= 'embed_args = ajax_embed_update(embed_args);';

   					// Disable some option when using iframe
   					$js.= 'if(option == "use_iframe"){';
   						$js.= 'use_iframe = is_checked;';
   						$js.= 'if(use_iframe){';
   							$js.= '$(".export_box").find(".not_with_iframe").parent().addClass("disabled");';
   							$js.= '$(".export_box").find(".not_with_iframe").attr( "disabled", "disabled" );';
   						$js.= '}else{';
   							$js.= '$(".export_box").find(".not_with_iframe").parent().removeClass("disabled");';
   							$js.= '$(".export_box").find(".not_with_iframe").removeAttr("disabled");';
   						$js.= '}';
   					$js.= '}';	
   				$js.= '});';


   				// AJAX FUNCTION
   				$js.= 'function ajax_embed_update(embed_args){';
	   				$js.= '$("#_dn_embed_code").css("opacity", .2);';

					$js.= '$.ajax({';
						$js.= 'type: "POST",';
						$js.= 'url: ajaxurl,';
						$js.= 'data: {';
							$js.= '"action": "update_embed_code",';
							$js.= '"embed_args": JSON.stringify(embed_args),';
						$js.= '}';
					$js.= '}).done(function( msg ){';
						$js.= '$("#_dn_embed_code").css("opacity", 1);';
						$js.= 'var obj = JSON.parse(msg);';
						$js.= 'embed_args = obj.args;';
						$js.= '$("#_dn_embed_code").val(obj.embed_code);';
					$js.= '});';

					$js.= 'return embed_args;';
				$js.= '}';
				// END AJAX FUNCTION

   			$js.= '});';
   		$js.= '</script>';
   		*/


		return array('banner' => $banner, 'export' => $exp.$js, 'embed_args' => $args);
	}



	
	
	
	
	/**
	 * Embed code creator. 
	 * @return: js
	 * No longer used @since v1.1.0
	 *
	*/
	/*
	public static function embed_code_creator($args = array())
	{
		$defaults = array(
			'id' => 0,
			'hash' => ADN_Main::getToken(),
			'width' => '',
			'height' => ''
		);
		$args = ADN_Main::parse_args($args, $defaults);
		
		$html = '';
		$html.= 'var embed_args = {};';
	
		// Create embed code arguments
		$embed_args = array(
			'id' => $args['id'],
			'hash' => $args['hash'],
			'width' => $args['width'],
			'height' => $args['height']
		);
		foreach($embed_args as $key => $arg)
		{
			$html.= 'embed_args["'.$key.'"] = "'.$arg.'";';
		}
		//console.log(JSON.stringify(embed_args));
		
		// Default embed code
		$html.= 'var embed_default = "'.ADN_Main::embed_code().'";';
		$html.= 'var embed_split = embed_default.split("{%}");';
		$html.= 'embed_default = embed_split[0]+JSON.stringify(embed_args)+embed_split[1];';
		
		// With jQuery embed code
		$html.= 'var embed_jquery = "'.ADN_Main::embed_code(array('jquery' => 1)).'";';
		$html.= 'var embed_jq_split = embed_jquery.split("{%}");';
		$html.= 'embed_jquery = embed_jq_split[0]+JSON.stringify($.extend(embed_args, {jquery:1}))+embed_jq_split[1];';
		
		$html.= '$("#embed_code").val(embed_default.replace(/<\//g, "</"));';
		$html.= '$("#export_jquery").on("change", function(){';
			$html.= 'if($(this).is(":checked")){';
				$html.= '$("#embed_code").val(embed_jquery.replace(/<\//g, "</"));';
			$html.= '}else{';
				$html.= '$("#embed_code").val(embed_default.replace(/<\//g, "</"));';
			$html.= '}';
		$html.= '});';
		
		return $html;
	}
	*/





	/**
	 * Predefined BG Colors
	 * type: (string) all | solid | gradient
	 *
	*/
	public static function predefined_bg_colors($args = array())
	{
		$defaults = array(
			'type' => 'all'
		);
		$args = ADN_Main::parse_args($args, $defaults);
		$html = '';

		$colors['solid'] = array(
			'#ffffff',
			'#000000',
			'#ff5e5e',
			'#ff8af5',
			'#cb7dff',
			'#6b89ff', // dark blue
			'#5cd1ff',
			'#5cff92',
			'#f8ff70',
			'#ffa459'
		);
		$colors['gradient'] = array(
			'linear-gradient(180deg, rgba(112,245,255,1.00) 0%, rgba(0,191,255,1.00) 100%)', // Light blue
			'linear-gradient(180deg, rgba(250,250,250,1.00) 0%, rgba(217,217,217,1.00) 100%)', // light grey
			'linear-gradient(180deg, rgba(255,156,156,1.00) 0%, rgba(255,61,61,1.00) 100%)', // light red
			'linear-gradient(180deg, rgba(247,214,255,1.00) 0%, rgba(181,20,255,1.00) 100%)', // Light purple
			'radial-gradient(ellipse farthest-side at 50% 50%, rgba(240,255,243,1.00) 43%,rgba(173,255,102,1.00) 100%)', // green white radial
			'linear-gradient(90deg, rgba(241,180,121,1) 0%, rgba(210,73,119,1) 52%, rgba(92,114,209,1) 100%)',
			'radial-gradient(farthest-side at 50% 50%, rgba(112,245,255,1.00) 0%, rgba(186,125,255,1.00) 100%)',
			'linear-gradient(90deg, rgba(102,0,255,1.00) 0%, rgba(255,0,0,1.00) 52%, rgba(255,187,0,1.00) 100%)',
			'linear-gradient(180deg, rgba(213,255,0,1.00) 0%,rgba(255,226,5,0.50) 51%,rgba(255,36,36,0.75) 100%)',
			'radial-gradient(ellipse farthest-side at 0% 50%, rgba(255,255,255,1) 0%,rgba(247,22,247,0.77) 18%,rgba(255,247,0,0.50) 60%,rgba(0,255,21,0.50) 100%)',
			'radial-gradient(ellipse farthest-side at 0% 100%, rgba(241,180,121,1) 29%,rgba(210,73,119,1) 68%,rgba(97,114,194,1.00) 100%)'
		);

		// Create color arr
		if( $args['type'] == 'all')
		{
			$color_arr = ADN_Main::parse_args($colors['solid'], $colors['gradient']);
		}
		else
		{
			$color_arr = $colors[$args['type']];
		}

		

		foreach($color_arr as $color)
		{
			$html.= '<div class="bg_palet" style="background:'.$color.';" data-color="'.$color.'"></div>';
		}

		return $html;
	}




	/**
	 * HTML Shapes
	 * type: (string) all
	 *
	*/
	public static function html_shapes($args = array())
	{
		$defaults = array(
			'type' => 'shapes'
		);
		$args = ADN_Main::parse_args($args, $defaults);
		$html = '';

		// Shapes
		if( $args['type'] == 'shapes')
		{
			$shapes = ADN_Main::html_shapes();

			foreach($shapes as $key => $shape)
			{
				$html.= '<div class="shape_palet" data-key="'.$key.'" data-aspect_ratio="'.$shape['aspect_ratio'].'" data-size="'.$shape['size'].'">'.$shape['html'].'</div>';
			}
		}
		elseif( $args['type'] == 'buttons')
		{
			$buttons = ADN_Main::html_buttons();

			foreach($buttons as $key => $button)
			{
				$html.= '<div class="button_palet shape_palet element_palet" data-key="'.$key.'" data-aspect_ratio="'.$button['aspect_ratio'].'" data-size="'.$button['size'].'">'.$button['html'].'</div>';
			}
		}
		else
		{
			// STICKERS
			$upload_dir = IMC_UPLOAD_DIR;
			// 1. load all stickers available in the upload folder
			$shapes = ADN_Main::library_sticker_files($upload_dir . 'resources/stickers/');
			// 2. load library (WP only) to see if we actually have to show the stickers.
			$library = ADN_Main::load_library();
			// 3. load all json objects so they are ready to add if we find matching groups
			$json_stickers = ADN_JSON_Templates::stickers();
			
			if(!empty($shapes))
			{
				foreach($shapes as $group_key => $group)
				{
					$active = array_key_exists($group_key, $library['stickers']) ? $library['stickers'][$group_key]['active'] : 0;
					if($active)
					{
						$title = !empty($library['stickers'][$group_key]['title']) ? stripslashes($library['stickers'][$group_key]['title']) : $group_key;
						$desc = !empty($library['stickers'][$group_key]['desc']) ? stripslashes($library['stickers'][$group_key]['desc']) : '';
						
						$html.= '<div class="sticker_cat '.$group_key.'" data-group="'.$group_key.'">';
							$html.= '<div class="cat_info">';
								$html.= '<h3>'.$title.'</h3>'; //'.self::tooltip(array('class' => '_dn_quest_tooltip', 'title' => $desc)).'
								$html.= '<p class="description">'.$desc.'</p>';
							$html.= '</div>';

							foreach($group as $key => $shape)
							{
								$html.= '<div class="shape_palet sticker_palet" data-group="'.$group_key.'" data-key="'.$shape['filename'].'" data-aspect_ratio="1" data-size="90x90">';
									$html.= $shape['animation'] ? '<div class="_obj_has_animation badge">A</div>' : '';
									$html.= !$shape['animation'] && $shape['animation_option'] ? '<div class="_obj_has_animation optional badge">A</div>' : '';
									$html.= $shape['svg'];
								$html.= '</div>';
							}

							// Loop true JSON objects
							if( !empty($json_stickers))
							{
								foreach($json_stickers as $key => $sticker)
								{
									if($sticker['group'] == $group_key)
									{
										$html.= '<div class="shape_palet sticker_palet" data-group="'.$group_key.'" data-key="'.$sticker['name'].'" data-aspect_ratio="'.$sticker['aspect_ratio'].'" data-size="'.$sticker['size'].'">';
											$html.= $sticker['animation'] ? '<div class="_obj_has_animation badge">A</div>' : '';
											$html.= array_key_exists('animation_option', $sticker) && !$sticker['animation'] && $sticker['animation_option'] ? '<div class="_obj_has_animation optional badge">A</div>' : '';
											$html.= !empty($sticker['tags']) ? '<span class="_obj_tags" style="display:none;">'.$sticker['tags'].'</span>' : '';
											$html.= ADN_Templates::load_json_object(array(
												'json' => urlencode($sticker['json'])
											));
										$html.= '</div>';
										unset($json_stickers[$key]);
									}
								}
							}
						$html.= '</div>';
					}
				}
			}

			// Find all unused JSON objects and add them to the list
			if( !empty($json_stickers))
			{
				$html.= '<div class="sticker_cat random" data-group="random">';
					$html.= '<div class="cat_info">';
						$html.= '<h3>'.__('Random Objects','imc').'</h3>';
						$html.= '<p class="description"></p>';
					$html.= '</div>';

					foreach($json_stickers as $key => $sticker)
					{
						$html.= '<div class="shape_palet sticker_palet" data-group="random" data-key="'.$sticker['name'].'" data-aspect_ratio="'.$sticker['aspect_ratio'].'" data-size="'.$sticker['size'].'">';
							$html.= $sticker['animation'] ? '<div class="_obj_has_animation badge">A</div>' : '';
							$html.= array_key_exists('animation_option', $sticker) && !$sticker['animation'] && $sticker['animation_option'] ? '<div class="_obj_has_animation optional badge">A</div>' : '';
							$html.= !empty($sticker['tags']) ? '<span class="_obj_tags" style="display:none;">'.$sticker['tags'].'</span>' : '';
							$html.= ADN_Templates::load_json_object(array(
								'json' => urlencode($sticker['json'])
							));
						$html.= '</div>';
					}
				$html.= '</div>';
			}
		}
		
		return $html;
	}



	/**
	 * HTML Elements
	 *
	*/
	public static function html_elements($args = array())
	{
		$defaults = array(
			'type' => 'html'
		);
		$args = ADN_Main::parse_args($args, $defaults);
		$h = '';

		// Elements
		$elements = ADN_Main::html_elements(array('type' => $args['type']));

		foreach($elements as $key => $element)
		{
			$h.= '<div class="element_palet" data-key="'.$key.'" data-aspect_ratio="'.$element['aspect_ratio'].'" data-size="'.$element['size'].'">';
				$h.= $element['icon'];
				//$h.= '<input type="hidden" class="element_code" value="'.urlencode($element['html']).'" style="display:none;">';
			$h.= '</div>';
		}

		return $h;
	}




	/**
	 * Load user banners
	 *
	 *
	*/
	public static function load_user_banners($args = array())
	{
		$defaults = array(
			'user_id' => 0,
			'settings' => array(),
			'remove_unsaved_uploads' => 1
		);
		$args = ADN_Main::parse_args($args, $defaults);

		$h = '';
		$dir = IMC_UPLOAD_DIR.'user_uploads/'.$args['user_id'].'/';
		$banners = ADN_Main::library_template_files($dir);

		if(!empty($banners))
		{
			$h.= '<div class="spr_row">';
				$h.= '<div class="spr_column spr_col-9">';
					$h.= '<div class="spr_column-inner ">';
						$h.= '<div class="spr_wrapper my_images_container">';
							foreach($banners as $key => $banner)
							{
								$size = '';
								if(!empty($banner[0]) && array_key_exists('json', $banner[0]))
								{
									$json = $banner[0]['json'];
									$size = explode('x', $banner[0]['json']['size']['full']);

									$h.= '<div class="banner_box image_'.$key.'">';
										$h.= '<div class="banner_preview">';

											$h.= '<div class="banner_holder">';
												$h.= self::banner_tpl($json, array('load_banner_script' => 0, 'adjust_id' => '__', 'load_always' => 1));	
											$h.= '</div>';

											$h.= '<div class="banner_hover">';
												$h.= '<div class="hover_box_inner">';

													if( !empty($json))
													{
														$h.= '<div class="action_buttons">';
															$h.= '<div class="btn edit" data-id="'.$key.'">';
																$h.= '<a >'.__('Edit', 'imc').'</a>';
															$h.= '</div>';
															$h.= '<div class="btn edit use edit_as_new ttip" data-id="'.$key.'" title="'.__('Edit and save as a new image.','imc').'">';
																$h.= '<a class="use_banner" data-id="'.$key.'">'.__('Edit as new', 'imc').'</a>';
															$h.= '</div>';
															$h.= '<textarea class="_lib_tpl_json_code json_code_'.$key.'">'.json_encode($json).'</textarea>';
														$h.= '</div>';
													}
													$h.= '<span class="file_size">';
														$h.= '<div class="img_id">ID: <strong>#'.$key.'</strong></div>';
														$h.= '<div class="img_size">'.$size[0].' x '.$size[1].' &#126 '.ADN_Main::formatBytes(ADN_Main::getSize( $dir.$key)).'</div>'; // ~
													$h.= '</span>';
													
													if( !empty($args['settings']) && !empty($args['settings']['editor']['upload']))
													{
														$h.= '<span class="file_size remove_btn ttip" data-id="'.$key.'" title="'.__('Remove image','imc').'">';
															$h.= '<svg width="10px" height="10px" viewBox="0,0,448,512"><path fill="#b1a065" d="M0 84V56c0-13.3 10.7-24 24-24h112l9.4-18.7c4-8.2 12.3-13.3 21.4-13.3h114.3c9.1 0 17.4 5.1 21.5 13.3L312 32h112c13.3 0 24 10.7 24 24v28c0 6.6-5.4 12-12 12H12C5.4 96 0 90.6 0 84zm416 56v324c0 26.5-21.5 48-48 48H80c-26.5 0-48-21.5-48-48V140c0-6.6 5.4-12 12-12h360c6.6 0 12 5.4 12 12zm-272 68c0-8.8-7.2-16-16-16s-16 7.2-16 16v224c0 8.8 7.2 16 16 16s16-7.2 16-16V208zm96 0c0-8.8-7.2-16-16-16s-16 7.2-16 16v224c0 8.8 7.2 16 16 16s16-7.2 16-16V208zm96 0c0-8.8-7.2-16-16-16s-16 7.2-16 16v224c0 8.8 7.2 16 16 16s16-7.2 16-16V208z" class="colorful c1"></path></svg>';
														$h.= '</span>';
													}
													
												$h.= '</div>';
											$h.= '</div>';
										$h.= '</div>';

										$title = !empty($banner[0]['json']['title']) ? $banner[0]['json']['title'] : __('No name', 'imc');
										$has_title = empty($banner[0]['json']['title']) ? ' no_title' : '';
										$h.= '<div class="banner_title">';
											$h.= '<span class="select_image ttip" title="'.__('More image settings.','imc').'">';
												$h.= '<svg viewBox="0 0 448 512"><path fill="currentColor" d="M16 132h416c8.837 0 16-7.163 16-16V76c0-8.837-7.163-16-16-16H16C7.163 60 0 67.163 0 76v40c0 8.837 7.163 16 16 16zm0 160h416c8.837 0 16-7.163 16-16v-40c0-8.837-7.163-16-16-16H16c-8.837 0-16 7.163-16 16v40c0 8.837 7.163 16 16 16zm0 160h416c8.837 0 16-7.163 16-16v-40c0-8.837-7.163-16-16-16H16c-8.837 0-16 7.163-16 16v40c0 8.837 7.163 16 16 16z"></path></svg>';
											$h.= '</span>';
											$h.= '<span class="title_inner'.$has_title.'">';
												$h.= $title;
											$h.= '</span>';
											$h.= '<textarea class="image_code" style="display:none;">'.json_encode($json).'</textarea>';
										$h.= '</div>';
									$h.= '</div>';
								}
								else
								{
									// Remove folders containing uploaded images but no .json file (which means the banner never got saved)
									if( $args['remove_unsaved_uploads'])
									{
										ADN_Main::delete_dir($dir.$key);
									}
								}
							}
						$h.= '</div>';
					$h.= '</div>';
				$h.= '</div>';
				// end .spr_column

				$h.= '<div class="spr_column spr_col-3">';
					$h.= '<div class="spr_column-inner ">';
						$h.= '<div class="spr_wrapper my_images_right_container">';
							$h.= '<div class="selected_image_cont">'.__('No image selected.','imc').'</div>';
							$h.= '<div class="selected_image_info">';
								$h.= '<a class="export_as_html5 export_btn options_btn ttip" title="'.__('Export as HTML5 Object','imc').'">';
									$h.= '<svg viewBox="0 0 512 512"><path fill="currentColor" d="M216 0h80c13.3 0 24 10.7 24 24v168h87.7c17.8 0 26.7 21.5 14.1 34.1L269.7 378.3c-7.5 7.5-19.8 7.5-27.3 0L90.1 226.1c-12.6-12.6-3.7-34.1 14.1-34.1H192V24c0-13.3 10.7-24 24-24zm296 376v112c0 13.3-10.7 24-24 24H24c-13.3 0-24-10.7-24-24V376c0-13.3 10.7-24 24-24h146.7l49 49c20.1 20.1 52.5 20.1 72.6 0l49-49H488c13.3 0 24 10.7 24 24zm-124 88c0-11-9-20-20-20s-20 9-20 20 9 20 20 20 20-9 20-20zm64 0c0-11-9-20-20-20s-20 9-20 20 9 20 20 20 20-9 20-20z"></path></svg>';
									$h.= '<span class="btn_title">'.__('HTML5','imc').'</span>';
								$h.= '</a>';
								
								$h.= '<div class="shortcode">';
									$h.= '<p>'.__('Shortcode','imc').'</p>';
									$h.= '<input class="shortcode_input" type="text" value="" />';
								$h.= '</div>';
								/*$h.= '<a class="export_as_template export_btn options_btn ttip" title="'.__('Export as Template','imc').'">';
									$h.= '<svg viewBox="0 0 512 512"><path fill="currentColor" d="M216 0h80c13.3 0 24 10.7 24 24v168h87.7c17.8 0 26.7 21.5 14.1 34.1L269.7 378.3c-7.5 7.5-19.8 7.5-27.3 0L90.1 226.1c-12.6-12.6-3.7-34.1 14.1-34.1H192V24c0-13.3 10.7-24 24-24zm296 376v112c0 13.3-10.7 24-24 24H24c-13.3 0-24-10.7-24-24V376c0-13.3 10.7-24 24-24h146.7l49 49c20.1 20.1 52.5 20.1 72.6 0l49-49H488c13.3 0 24 10.7 24 24zm-124 88c0-11-9-20-20-20s-20 9-20 20 9 20 20 20 20-9 20-20zm64 0c0-11-9-20-20-20s-20 9-20 20 9 20 20 20 20-9 20-20z"></path></svg>';
									$h.= '<span class="btn_title">'.__('Template','imc').'</span>';
								$h.= '</a>';*/
							$h.= '</div>';
						$h.= '</div>';
					$h.= '</div>';
				$h.= '</div>';
				// end .spr_column

			$h.= '</div>';
			// end .spr_row
		}
		else
		{
			$h.= __('You have no saved images yet.','imc');
		}
		
		//$h.= '<pre>'.print_r($banners, true).'</pre>';

		return $h;
	}



	/**
	 * GIPHY Gifs
	 *
	 *
	*/
	public static function giphy_gifs($args = array())
	{
		$defaults = array(
			'action' => 'trending',
			'query' => ''
		);
		$args = ADN_Main::parse_args($args, $defaults);

		$gifs = ADN_Main::load_giphy_gifs($args);
		$h = '';

		if( !empty($gifs) )
		{
			foreach($gifs['data'] as $gif) 
			{
				$info = array(
					'provider' => 'GIPHY',
					'link' => $gif['url'],
					'picby' => $gif['username'],
					'profile' => $gif['user']['profile_url']
				);
				$h.= '<div class="grid-item is-loading" data-use="url" data-src="'.$gif['images']['original']['url'].'">';
					$h.= '<img src="'.$gif['images']['preview_gif']['url'].'" />';
					$h.= '<div class="info_btn">';
						$h.= '<textarea style="display:none;" class="img_info_json">'.json_encode($info).'</textarea>';
						$h.= '<svg viewBox="0 0 448 512" style="height:18px;border-radius:2px;"><path fill="currentColor" d="M400 32H48C21.49 32 0 53.49 0 80v352c0 26.51 21.49 48 48 48h352c26.51 0 48-21.49 48-48V80c0-26.51-21.49-48-48-48zm-176 86c23.196 0 42 18.804 42 42s-18.804 42-42 42-42-18.804-42-42 18.804-42 42-42zm56 254c0 6.627-5.373 12-12 12h-88c-6.627 0-12-5.373-12-12v-24c0-6.627 5.373-12 12-12h12v-64h-12c-6.627 0-12-5.373-12-12v-24c0-6.627 5.373-12 12-12h64c6.627 0 12 5.373 12 12v100h12c6.627 0 12 5.373 12 12v24z" class=""></path></svg>';
					$h.= '</div>';
				$h.= '</div>';
				//echo $item['links']['html'];
			}
		}

		return $h;
	}



	
	/**
	 * Unsplash photos
	 *
	 *
	*/
	public static function unsplashed_photos($args = array())
	{
		$defaults = array(
			'action' => '',
			'query' => ''
		);
		$args = ADN_Main::parse_args($args, $defaults);

		$photos = ADN_Main::load_unsplash_photos($args);
		$html = '';

		if( !empty($photos) )
		{
			//$html.= '<pre>'.print_r($photos['results'], true).'</pre>';
			$pics = $args['action'] == 'search' ? $photos['results'] : $photos;
			foreach($pics as $photo) 
			{
				$info = array(
					'provider' => 'unsplash',
					'link' => $photo['links']['html'],
					'picby' => $photo['user']['name'],
					'profile' => $photo['user']['links']['html']
				);
				$html.= '<div class="grid-item is-loading" data-use="url" data-src="'.$photo['urls']['small'].'">';
					$html.= '<img src="'.$photo['urls']['thumb'].'" />';
					$html.= '<div class="info_btn">';
						$html.= '<textarea style="display:none;" class="img_info_json">'.json_encode($info).'</textarea>';
						$html.= '<svg viewBox="0 0 448 512" style="height:18px;border-radius:2px;"><path fill="currentColor" d="M400 32H48C21.49 32 0 53.49 0 80v352c0 26.51 21.49 48 48 48h352c26.51 0 48-21.49 48-48V80c0-26.51-21.49-48-48-48zm-176 86c23.196 0 42 18.804 42 42s-18.804 42-42 42-42-18.804-42-42 18.804-42 42-42zm56 254c0 6.627-5.373 12-12 12h-88c-6.627 0-12-5.373-12-12v-24c0-6.627 5.373-12 12-12h12v-64h-12c-6.627 0-12-5.373-12-12v-24c0-6.627 5.373-12 12-12h64c6.627 0 12 5.373 12 12v100h12c6.627 0 12 5.373 12 12v24z" class=""></path></svg>';
					$html.= '</div>';
				$html.= '</div>';
				//echo $item['links']['html'];
			}
		}

		return $html;
	}



	/**
	 * Load json object for editor library.
	*/
	public static function load_json_object($args = array())
	{
		$defaults = array(
			'json' => ''
		);
		$args = ADN_Main::parse_args($args, $defaults);
		$json = urldecode($args['json']);
		//$json = $args['json'];
		$json = json_decode(stripslashes($json), true);
		$json = empty($json) ? json_decode($json, true) : $json;
		$h = '';
		//echo '<pre>'.print_r($json, true).'</pre>';

		
		if( !empty($json))
		{
			// check for external styles/scripts
			if( array_key_exists('external', $json))
			{
				if(array_key_exists('styles', $json['external']) && !empty($json['external']['styles']))
				{
					foreach($json['external']['styles'] as $style)
					{
						$h.= '<link href="'.urldecode($style['url']).'" rel="stylesheet" type="text/css">';
					}
				}
			}

			// check for plugins styles
			if( array_key_exists('plugins', $json['layer']))
			{
				foreach($json['layer']['plugins'] as $pl => $plugin){
					foreach ($plugin['external'] as $ext => $types){
						if(!empty($types)){
							foreach($types as $type){
								if(!empty($type)){

									if( is_array($type) && !empty($type['path'])){
										$url = $type['path']['dir'].$type['path']['folder'].$type['path']['file'];
									}else{
										$url = $type;
									}

									if( $ext == 'css'){
										$h.= '<link href="'.urldecode($url).'" rel="stylesheet" type="text/css">';
									}
								}
							}
						}
					}
				}
			}

			$h.= urldecode($json['layer']['content']);
			$h.= '<input type="hidden" class="_layer_objcd" value="'.$args['json'].'" />';
		}
		
		return $h;
	}




	/**
	 * array containing all predefined image templates
	 */
	public static function predefined_templates($key = '')
	{
		// Load JSON templates
		$templates = array();


		// 1. Load templates from template folder
		$templates_in_folder = ADN_Main::library_template_files(IMC_UPLOAD_DIR . 'resources/templates/');
		// 2. load library (WP only) to see if we actually have to show the stickers.
		$library = ADN_Main::load_library();

		if(!empty($templates_in_folder))
        {
			foreach($templates_in_folder as $tpid => $tpl)
        	{
				$active = array_key_exists($tpid, $library['templates']) ? $library['templates'][$tpid]['active'] : 0;
				if($active)
				{
					$templates[$tpid] = array('json' => json_encode($tpl[0]['json']));
				}
			}
		}

		$templates = apply_filters('_imgmce_templates', $templates);
		//echo '<pre>'.print_r($templates, true).'</pre>';

		if( !empty($key) ) 
		{
			return array_key_exists($key, $templates) ? $templates[$key] : array();
		}

		return $templates;
	}




	public static function imc_button($args = array())
	{
		$defaults = array(
			'id' => '',
			'class' => '',
			'text' => __('Open Template Editor','imc'),
			'width' => '100%',
			'height' => '100%'
		);
		$args = ADN_Main::parse_args($args, $defaults);

		$id = !empty($args['id']) ? ' id="'.$args['id'].'"' : '';
		$class = !empty($args['class']) ? ' '.$args['class'] : '';

		$html = '';
		$html.= '<a'.$id.' class="_imgMCE_btn'.$class.'">';
			$html.= '<div class="logo_holder">';
				$html.= self::logo_svg(array('width' => '20px', 'height' => '20px'));
			$html.= '</div>';
			$html.= '<div class="text_holder">';
				$html.= $args['text'];
			$html.= '</div>';
		$html.= '</a>';
		
		return $html;
	}



	public static function logo_svg($args = array()){
		$defaults = array(
			'width' => '100%',
			'height' => '100%'
		);
		$args = ADN_Main::parse_args($args, $defaults);

		return '<svg x="0px" y="0px" width="'.$args['width'].'" height="'.$args['height'].'" viewBox="0 0 310 426">
					<g><g><g><g><path fill="#FFFF00" d="M237,225c-0.33,0-0.67,0-1,0c-53.73,59.93-108.85,118.49-163,178c-0.85,0.18-0.94-0.39-1-1
					c26.08-58.92,51.7-118.3,77-178C178,224.67,209.67,222.67,237,225z"/></g><g></g></g></g><g><g><g><path fill="#FFFF00" d="M289,165c0,1.33,0,2.67,0,4c-17.86,18.48-34.64,38.03-52,57c-56,0-112,0-168,0c0-1,0-2,0-3
					c21.5-64.83,42.62-130.05,63-196c46.33,0,92.67,0,139,0c-27.25,45.75-54.78,91.22-81,138C223,165,256,165,289,165z"/></g><g></g></g></g></g><g><g id="bottom_xA0_Image_1_"><g><g><path fill="#D7CB05" d="M149,225c0,1.33,0,2.67,0,4c-26.73,57.27-50.59,117.41-77,175c-16.02-1.31-37.3,2.63-50-2
					c25.93-59.4,52.98-117.69,79-177C117,225,133,225,149,225z"/></g><g></g></g></g><g><g><g><path fill="#D7CB05" d="M133,27c0,1,0,2,0,3c-21.17,64.5-41.92,129.41-62,195c-16.33,0-32.67,0-49,0c0-1,0-2,0-3
					C43.17,157.5,63.92,92.59,84,27C100.33,27,116.67,27,133,27z"/></g><g></g></g></g></g></svg>';

	}




	public static function premium_badge_svg(){
		
		return '<svg version="1.1" id="Layer_1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px"
	 width="100%" height="100%" viewBox="221.505 369.706 168.424 243.794"
	 enable-background="new 221.505 369.706 168.424 243.794" xml:space="preserve"><g id="XMLID_3_"><g><path fill="#6CBB3C" d="M221.511,607.739c0.085-79.335,0.19-158.684,0.286-238.033c56.14,0.067,112.29,0.135,168.43,0.202
			c-0.105,79.677-0.191,159.354-0.297,239.017c-4.397-2.387-7.272-6.583-11.308-10.353c-20.688-19.32-40.073-38.924-60.4-58.229
			c-2.258-2.156-8.718-9.922-10.238-9.867c-1.66,0.056-7.789,7.764-10.271,9.843C271.255,562.377,246.687,586.149,221.511,607.739z"/></g><g></g></g><path fill="#FFFFFF" d="M363,398c-2.867,0-4.456-1.978-4.773-4.174h-95.255v103.189h100.056v-99.017
	C363.018,397.999,363.01,398,363,398z"/><path fill="#6CBB3C" d="M301.796,453.773c-6.415-5.57-12.563-10.859-18.979-15.855c-7.012-5.838-8.473-5.564-14.89,0.549
	c-3.208,3.055-3.804,5.289-1.171,8.895c3.207,4.721,7.012,9.195,10.797,13.635c7.012,8.346,13.721,16.965,20.733,25.311
	c2.34,2.779,5.547,2.779,7.875,0c0.582-0.844,1.172-1.393,1.748-2.232c16.383-21.707,32.729-43.393,49.092-65.098
	c0.576-0.842,1.461-1.939,2.037-3.056c1.461-2.782,1.172-4.722-1.172-6.681c-1.748-1.391-3.498-2.78-5.553-3.896
	c-2.344-1.667-4.381-1.393-6.129,0.548c-2.631,2.782-5.553,5.837-8.184,8.895C325.477,427.615,313.768,440.406,301.796,453.773z
	 M312.902,375.311c40.326,0.273,72.736,31.148,73.025,69.27c0.287,40.607-32.713,71.775-75.369,70.936
	c-39.712-0.549-71.833-31.992-71.544-70.387C239.014,406.478,272.019,375.311,312.902,375.311z"/></svg>';
	}




	/**
	 * This function loads all templates and javascript to open the editor from a javascript function.
	 */
	public static function load_editor_js_function($args = array(), $callback_function = '')
	{
		$defaults = array(
			'function_name' => '',
			'settings' => array(),
		);
		$args = ADN_Main::parse_args($args, $defaults);

		$editing = 1;

		$h = '';
		$h.= '<script type="text/javascript">';
			$h.= !empty($args['function_name']) ? 'function '.$args['function_name'].'(){' : '';
				$h.= 'ImgMCE_global.load_editor('.json_encode($args['settings']).');';
			$h.= !empty($args['function_name']) ? '};' : '';
			$h.= $callback_function;
		$h.= '</script>';

		return $h;
	}




	public static function loading_spinner($args = array())
	{
		$defaults = array(
			'w' => '',
			'h' => '',
			'class' => '',
			'style' => '',
		);
		$args = ADN_Main::parse_args($args, $defaults);

		$class = !empty($args['class']) ? ' '.$args['class'] : '';
		$style = !empty($args['style']) ? ' style="'.$args['style'].'"' : '';
		$h = !empty($args['h']) ? ' width="'.$args['h'].'"' : '';
		$w = !empty($args['w']) ? ' width="'.$args['w'].'"' : '';
		$h = !empty($args['h']) ? ' width="'.$args['h'].'"' : '';

		$h = '';
		$h.= '<svg viewBox="0 0 512 512"'.$w.$h.' class="_dn_spin'.$class.'"'.$style.'><path fill="currentColor" d="M304 48c0 26.51-21.49 48-48 48s-48-21.49-48-48 21.49-48 48-48 48 21.49 48 48zm-48 368c-26.51 0-48 21.49-48 48s21.49 48 48 48 48-21.49 48-48-21.49-48-48-48zm208-208c-26.51 0-48 21.49-48 48s21.49 48 48 48 48-21.49 48-48-21.49-48-48-48zM96 256c0-26.51-21.49-48-48-48S0 229.49 0 256s21.49 48 48 48 48-21.49 48-48zm12.922 99.078c-26.51 0-48 21.49-48 48s21.49 48 48 48 48-21.49 48-48c0-26.509-21.491-48-48-48zm294.156 0c-26.51 0-48 21.49-48 48s21.49 48 48 48 48-21.49 48-48c0-26.509-21.49-48-48-48zM108.922 60.922c-26.51 0-48 21.49-48 48s21.49 48 48 48 48-21.49 48-48-21.491-48-48-48z"></path></svg>';
		
		return $h;
	}




	public static function html_template($args = array())
	{
		$defaults = array(
			'head' => '',
			'banner_tpl' => ''
		);
		$args = ADN_Main::parse_args($args, $defaults);

		$h = '';
		$h.= '<!DOCTYPE html>';
		$h.= '<html>';
		$h.= '<head>';
			$h.= '<meta charset="UTF-8">';
			$h.= '<meta name="author" content="imgMCE - v'.IMC_VERSION.'">';
			$h.= '<meta name="viewport" content="width=device-width">';

			$h.= '<script type="text/javascript">';
				$h.= 'var _dn_ = {"debug":"0", "inc_dir_base":"assets/"};';
			$h.= '</script>';

			$h.= '<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>';
			//$h.= '<script type="text/javascript" src="assets/js/imgmce_image.min.js"></script>';	
			$h.= '<script type="text/javascript" src="assets/dist/_imc.bundle.js"></script>';	

			$h.= '<style>';
				$h.= 'body{';
					$h.= 'font-family:sans-serif;';
					$h.= 'line-height:1;';
					$h.= 'letter-spacing:.018em;';
					$h.= 'margin: 0;';
					$h.= 'padding: 0;';
				$h.= '}';
			$h.= '</style>';
			$h.= '<link href="assets/dist/_imc.bundle.js.css" rel="stylesheet" type="text/css" media="screen" />';
			//$h.= '<link href="assets/css/imgmce_image.min.css" rel="stylesheet" type="text/css" media="screen" />';
			//$h.= '<link href="assets/css/imgmce_animations.css" rel="stylesheet" type="text/css" media="screen" />';
			$h.= $args['head'];
			
		$h.= '</head>';
		$h.= '<body>';
			$h.= stripslashes($args['banner_tpl']);
		$h.= '</body>';
		$h.= '</html>';

		return $h;
	}





	/**
	 * Youtube Player API
	 */
	/*public static function youtube_player_api($args = array()) 
	{	
		$defaults = array(
			'settings' => array(
				'video_id' => 'j8Ffu2qLOHk',
				'duration' => 0, // movie time in seconds
				'player_w' => 940,
				'player_h' => 529,
				'theme' => 'dark',
				'yt_options' => array(
					'showinfo' => 0,
					'rel' => 0,
					'fs' => 0,
					'autohide' => 1,
					'autoplay' => 0,
					'controls' => 0,
					'modestbranding' => 1,
					'iv_load_policy' => 3,
					'playsinline' => 1,
					'webkit_playsinline' => true
				),
			),
			//'options' => self::test_array()
		);
		$args = wp_parse_args( $args, $defaults );
		$args['settings'] = wp_parse_args( $args['settings'], $defaults['settings'] );
		$args['settings']['yt_options'] = wp_parse_args( $args['settings']['yt_options'], $defaults['settings']['yt_options'] );
		
		$html = '';
		$js = '';
		$html.= '<div class="yt_wrapper" style="width:100%;height:100%;">';
		
			$html.= '<div class="container" style="width:100%;height:100%;">';
				$html.= '<div id="ytplayer" class="_dn_elem"></div>';
			$html.= '</div>';
			//end .container
			
			//$html.= self::add_video_controls($args);	
		$html.= '</div>';
		// end .yt_wrapper
		
		$js.= '<script type="text/javascript">';
			
			$js.= 'var tag = document.createElement("script");';
			$js.= 'tag.src = "https://www.youtube.com/player_api";';
			//$js.= 'tag.src = "'.VIDANA_ASSETS_URL.'/js/yt_iframe_api.js";';
			//$js.= 'tag.src = "https://www.youtube.com/iframe_api";';
			$js.= 'var firstScriptTag = document.getElementsByTagName("script")[0];';
			$js.= 'firstScriptTag.parentNode.insertBefore(tag, firstScriptTag);';
			
			$js.= 'function onYouTubeIframeAPIReady() {';
				$js.= 'var json = \''.addslashes(json_encode($args)).'\';';
				$js.= 'player = new YT.Player("ytplayer", {
					height: "100%",
					width: "100%",
					showinfo: "0",
					videoId: "'.$args['settings']['video_id'].'"
				});';
				//$js.= 'jQuery(document).ready(function($){';
					//$js.= 'var json = \''.addslashes(json_encode($args)).'\';';
					//$js.= '$(this).vidana.load_yt_player(json);';
				//$js.= '});';
			$js.= '}';
			
		$js.= '</script>';
		
		return $html.$js;
	}*/
}

endif;
?>