<?php
// Dont load when Wordpress is running.
if ( defined( "ABSPATH" ) ) exit;

use Gettext\Translator;


/**
 * Translation class. 
 * Not used for imgMCE Wordpress plugin.
 * 
 * https://github.com/oscarotero/Gettext
 */
if ( ! class_exists( 'ADN_Translation' ) ) :

class ADN_Translation {

    public static function translate($args = array())
    {
        $defaults = array(
            'text' => '',
            'domain' => 'imc',
            'lang' => 'en_US'
		);
        $args = array_merge( $defaults, $args );
        
        $translation_path = file_exists('../extensions/gettext/autoloader.php') ? '../extensions/gettext/autoloader.php' : IMC_INC_DIR . '/extensions/gettext/autoloader.php';
        require_once($translation_path);
        
        $t = new Translator();

        if( file_exists('../../localization/'.$args['domain'].'-'.$args['lang'].'.po'))
        {
            $translations = Gettext\Translations::fromPoFile('../../localization/'.$args['domain'].'-'.$args['lang'].'.po');
            $t->loadTranslations($translations);
        }

        return $t->gettext($args['text']);
    }



    public static function lang_codes()
    {
        //echo substr($_SERVER['HTTP_ACCEPT_LANGUAGE'], 0, 2);
        

        return $codes;
    }
}
endif;
?>