<?php
if ( ! class_exists( 'ADN_API' ) ) :

class ADN_API {
	
	public function __construct() 
	{
		// API Iframe url ---------------------------------------------------
		add_action( 'wp', array( __CLASS__, 'iframe_url' ), 4);		
		add_action( 'wp', array( __CLASS__, 'iframe_embed' ), 4);	
		add_action( 'wp', array( __CLASS__, 'load_embed_scripts'), 1);
	}
	
	
	public static function iframe_url()
	{	
		// API Iframe URL
		if( isset( $_GET['_dnid'] ) && !empty( $_GET['_dnid'] ) )
		{
			//header('Access-Control-Allow-Origin: *'); 
			// Safer add allowed urls
			//header('Access-Control-Allow-Origin: http://mysite1.com', false); 

			$id = $_GET['_dnid'];
			$start_animation = isset( $_GET['sa'] ) ? $_GET['sa'] : ''; // iv (in view) | '' (on page load)
			$html = '';
			$custom_css = '';
			//$banner_obj = ADN_Banner:: load_banner_obj($id);
			$banner_obj = '';
			//$post_type = get_post_type( $_GET['_dnid'] );
			//$type = $post_type == ADN_CPT::$banner_cpt ? 'banner' : 'adzone';
			$type = 'banner';
			$display = isset( $_GET['display'] ) && !empty( $_GET['display'] ) ? ' display="'.$_GET['display'].'"' : '';
			
			$html.= '<!doctype html>';
			$html.= '<html>';
				$html.= '<head>';
					$html.= '<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />';
					
					$html.= '<script type="text/javascript" src="'.get_site_url().'/wp-includes/js/jquery/jquery.js"></script>';
					$html.= '<script type="text/javascript" src="'.get_site_url().'/wp-includes/js/jquery/ui/effect.min.js"></script>';
					$html.= '<script type="text/javascript" src="'.get_site_url().'/wp-includes/js/jquery/ui/effect-slide.min.js"></script>';
					$html.= '<script type="text/javascript" src="'.ADN_ASSETS_URL. '/js/jQuery.adnplugins.js"></script>';
					//$html.= '<script src="https://code.jquery.com/ui/1.12.1/jquery-ui.js"></script>';
					//$html.= $type == 'adzone' ? '<script type="text/javascript" src="'.ADN_ASSETS_URL.'/js/jssor.slider-22.2.16.min.js"></script>' : '';
					$html.= '<link rel="stylesheet" href="'.ADN_ASSETS_URL. '/css/_dn.css" type="text/css" media="all" />';
					$html.= '<style>html, body {margin:0;height:100%;</style>';

					// Load external styles
					if( array_key_exists('external', $banner_obj)){
						if( array_key_exists('styles', $banner_obj['external'])){
							if(!empty($banner_obj['external']['styles'])){
								foreach ($banner_obj['external']['styles'] as $key => $font) {
									$html.= '<link href="'.$font['url'].'" rel="stylesheet" type="text/css">';
								}
							}
						}
					}
					
					$html.= '<style type="text/css">body{ margin:0; padding:0; '.$custom_css.' }</style>';
					$html.= '<title>ADNING - Revolutionary Ad Manager for Wordpress</title>';
				$html.= '</head>';
				$html.= '<body>';
					$html.= do_shortcode('[adn_'.$type.' id="'.$_GET['_dnid'].'" load_external="0" start_animation="'.$start_animation.'"'.$display.']');
				$html.= '</body>';
			$html.= '</html>';
			
			echo $html;
			exit;
		}
	}
	
	
	
	public static function load_embed_scripts()
	{
		if( isset( $_GET['_dnembedscripts'] ) && !empty( $_GET['_dnembedscripts'] ) )
		{
			header("Content-Type: application/javascript");
			// Load jQuery
			require_once(ADN_ASSETS_DIR.'/js/embed/jquery.js');
			
			exit;
		}
	}
	
	
	
	/**
	 * EMBED BANNERS
	 *
	 * Usage:
	 *
	 * <script type="text/javascript">
	   		var _dn_embed = {"id":"46","width":728,"height":90};
       </script>
       <script type="text/javascript" src="http://adning.com?_dnembed=true"></script>
	 *
	*/
	public static function iframe_embed()
	{	
		if( isset( $_GET['_dnembed'] ) && !empty( $_GET['_dnembed'] ) )
		{
			header("Content-Type: application/javascript");
			
			/*
			 * $foo = "http://www.example.com/foo/bar?hat=bowler&accessory=cane";
			 * parse_url($foo) returns:
			 *Array
				(
					[scheme] => http
					[host] => www.example.com
					[path] => /foo/bar
					[query] => hat=bowler&accessory=cane
				)
			*/
			$site_url = parse_url(get_site_url());
			$inc_url = parse_url(ADN_INC_URL);
			$assets_url = parse_url(ADN_ASSETS_URL);
			
			$html = '';
			$html.= 'var site_url = "'.get_site_url().'";';
			$html.= 'var inc_path = "'.$inc_url['path'].'";';
			$html.= 'var assets_path = "'.$assets_url['path'].'";';

			echo $html;

			require_once(ADN_ASSETS_DIR.'/js/lib/js.cookie.js');
			//require_once(ADN_ASSETS_DIR.'/js/lib/jQuery.adnplugins.js');
			require_once(ADN_ASSETS_DIR.'/js/lib/embed/dn_embed.js');
			exit;
		}
	}
	
}
endif;
?>