<?php
/**
 * Usage:
 *
 * require_once(DIR. '/spr_columns/SPR_Columns.php');
 * new SPR_Columns();
 * SPR_Columns::enqueue_scripts(array('inc_url' => '', 'version' => 0));
 *
*/
if ( ! class_exists( 'IMC_Columns' ) ) :

class IMC_Columns {
	
	
	/*
	 * enqueue_scripts (but actually we only register most of them here)
	 *
	 * @access public
	 * @return null
	*/
	public static function enqueue_scripts($args = array())
	{
		global $imc_scripts;

		$defaults = array(
			'version' => 1,
			'inc_url' => '',
			'inc_dir' => '',
		);
		$args = array_merge( $defaults, $args );
		
		// Scripts
		$imc_scripts->register_script( 'imc_inViewport_js', $args['inc_url']. '/extensions/imc_columns/assets/js/spr_inViewport.js', array( 'jquery' ), $args['version'], true );
		$imc_scripts->register_script( 'imc_parallax_js', $args['inc_url']. '/extensions/imc_columns/assets/js/parallax.min.js', array( 'jquery' ), $args['version'], true );
		
		$imc_scripts->register_script( 'imc_col_animate_css', $args['inc_url']. '/extensions/imc_columns/assets/css/animate.min.css', false, $args['version'], "all" );
		$imc_scripts->register_script( 'imc_col_css', $args['inc_url']. '/extensions/imc_columns/assets/css/spr_columns.css', false, $args['version'], "all" );
	}



	/**
	 * Column Template
	 * 
	 * col options:
	 *
	 * 12 - 100%
	 * 10 - 83.3%
	 * 9 - 75%
	 * 8 - 66.6%
	 * 7 - 58.3%
	 * 6 - 50%
	 * 5 - 41.6%
	 * 4 - 33.3%
	 * 3 - 25%
	 * 2 - 16.6%
	 * 1 - 8.3%
	*/
	public static function column($args = array())
	{
		$defaults = array(
			'col' => 12,
			'id' => '',
			'class' => '',
			'content' => ''
		);
		$args = array_merge( $defaults, $args );

		$id = !empty($args['id']) ? ' id="'.$args['id'].'"' : '';
		$class = !empty($args['class']) ? ' '.$args['class'] : '';

		$t = '';
		$t.= '<div class="spr_column spr_col-'.$args['col'].'">';
	    	$t.= '<div class="spr_column-inner ">';
	        	$t.= '<div class="spr_wrapper">';
	            	$t.= '<div'.$id.' class="spr_content_element'.$class.'">';
	            	
	            		$t.= $args['content'];

	            	$t.= '</div>';
	            	//<!-- end .spr_content_element -->
	           $t.= '</div>';
	        $t.= '</div>';
	    $t.= '</div>';

		return $t;
	}
}

endif;
?>