(function($, win) {

	/**
	 * Select Box jQuery plugin
	*/
	$.fn.spr_selectBox = function(options) {
	  
	  	// Defaults
		var settings = $.extend({
			'options': [],
			'value': null,
			'destroy': false,
			'max-height': 300
		}, options );

		var html = '';
	  
	 	return this.each(function(i,el){

	 		if( settings.destroy ){
	 			$(el).parent().find('._select_label').remove();
	 			$(el).parent().find('._select_dropdown').remove();
	 			if( $(el).parent().hasClass('_select_cont')){
	 				$(el).unwrap();
	 			}
	 			return;
	 		}

	 		if( !$(el).parent().hasClass('_select_cont')){
				var select_cont = '<div class="_select_cont" />';
				
	     		$(el).wrap(select_cont);
	     		$(el).hide();

	     		$(el).parent().append('<div class="_select_label"><div class="label_text"></div><div class="dropdown_arrow"><svg aria-hidden="true" data-fa-processed="" data-prefix="fas" data-icon="sort-down" role="img" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 320 512" class="svg-inline--fa fa-sort-down fa-w-10" style="font-size: 48px;height:15px;vertical-align:top;"><path fill="currentColor" d="M41 288h238c21.4 0 32.1 25.9 17 41L177 448c-9.4 9.4-24.6 9.4-33.9 0L24 329c-15.1-15.1-4.4-41 17-41z" class=""></path></svg></div></div>');
	     		
	     		$(el).parent().append('<div class="_select_dropdown hidden"></div>');
     		}

     		// LOOP TRUE SELECT OPTIONS
     		if( $(el).data('values') ){
     			//console.log(JSON.parse(decodeURIComponent($(el).data('values'))));
     			// encodeURIComponent(JSON.stringify( {"object": "value" } ))
     			settings.options = JSON.parse(decodeURIComponent($(el).data('values')));
     		}
	 		$.each( settings.options, function( key, val ) {

	 			var selected = '',
					disabled = '';

	 			val = $.extend({
					'option': '',
					'value': '',
					'selected': false,
					'disabled': false,
					'action': null
				}, val);

	 			// First Item
	 			if(!key){
	 				$(el).val(val.value);
	 				$(el).parent().find('._select_label').find('.label_text').html(_select_option_decode(val.option));
	 			}

	 			// If selected item is found
 				if(val.selected || settings.value == val.value){
 					selected = ' selected';
 					$(el).val(val.value);
 					$(el).parent().find('._select_label').find('.label_text').html(_select_option_decode(val.option));
 				}

 				// If disabled item is found
 				if(val.disabled){
 					disabled = ' disabled';
 					$(el).val('');
 					$(el).parent().find('._select_label').find('.label_text').html('');
 				}
	 			
	 			html+= '<div class="option'+selected+disabled+'" data-nr="'+key+'" data-value="'+val.value+'" data-option="'+_select_option_encode(val.option)+'">';
	 				html+= val.option;
	 			html+= '</div>';
	 		});

	 		//console.log(html);
	 		$(el).parent().find('._select_dropdown').css("max-height", settings['max-height']);
	 		if( $(el).parent().find('._select_dropdown').html() == '' ){
	 			$(el).parent().find('._select_dropdown').append(html);
	 		}

	 		// Click actions
	 		$(el).parent().find('._select_label').on('click', function(){
	 			$(el).parent().find('._select_dropdown').toggleClass('hidden');
	 		});

	 		// Select option
	 		$(el).parent().find('._select_dropdown').find('.option').on('click', function(){
	 			if(!$(this).hasClass('disabled')){
		 			$(el).parent().find('._select_dropdown').find('.option').removeClass('selected');
		 			$(this).addClass('selected');
		 			$(el).val($(this).data('value'));
		 			$(el).attr('value', $(this).data('value'));
		 			$(el).parent().find('._select_label').find('.label_text').html(_select_option_decode($(this).data('option')));
		 		}

		 		// Fire option action
		 		if(settings.options[$(this).data('nr')].action){
		 			settings.options[$(this).data('nr')].action.call($(el).get(0), $(this).data('value'), _select_option_decode($(this).data('option')));
		 		}
		 		// Fire option callback
		 		if(settings.callback){
		 			settings.callback.call($(el).get(0), $(this).data('value'), _select_option_decode($(this).data('option')));
		 		}
	 		});

	 		$(document).mouseup(function(e){
			    // if the target of the click isn't the container nor a descendant of the container
			    if(!$(el).parent().find('._select_label').is(e.target) && $(el).parent().find('._select_label').has(e.target).length === 0 && !$(el).parent().find('.option.disabled').is(e.target) && $(el).parent().find('.option.disabled').has(e.target).length === 0) 
			   	// && !$(el).parent().find('.option').is(e.target) && $(el).parent().find('.option').has(e.target).length === 0
			    {
			        $(el).parent().find('._select_dropdown').addClass('hidden');
			    }
			});

	 	});



	 	function _select_option_encode(option){
	 		return encodeURI(option);
	 	}
	 	function _select_option_decode(option){
	 		return decodeURI(option);
	 	}
	}

}(jQuery, window));