<?php
//delete_option( '_imgmce_settings' );
$settings = IMC_Main::load_settings();

/**
 * IF POST DATA
*/
if($_SERVER['REQUEST_METHOD'] == 'POST')
{
    if(isset($_POST['submit_btn']))
    {
        // Role Manager
        $roles_arr = array();
        foreach($_POST['imc_roles'] as $key => $role)
        {
            // Post types
            if( !empty($role['post_types']))
            {
                foreach($role['post_types'] as $pt => $val)
                {
                    $roles_arr[$key]['post_types'][] = $pt;
                }
            }

            // Image settings
            $roles_arr[$key]['image'] = ADN_Main::parse_args($role['image'], $settings['image']);
            
            $file_types_arr = array();
            if(!empty($_POST['imc_roles'][$key]['image']['upload_file_types']))
            {
                foreach($_POST['imc_roles'][$key]['image']['upload_file_types'] as $k => $ftype)
                {
                    $file_types_arr[] = $k;
                }
            }
            $roles_arr[$key]['image']['upload_file_types'] = $file_types_arr;
            //echo '<pre>'.print_r($role['image'], true).'</pre>';

            // General
            if(!empty($_POST['imc_general'][$key]['general']))
            {
                $roles_arr[$key]['general'] = $_POST['imc_general'][$key]['general'];
            }
        }
        $settings['role'] = $roles_arr;
        

        // UPDATE SETTINGS
        update_option('_imgmce_settings', $settings);
    }
}
//echo '<pre>'.print_r($settings, true).'</pre>';
?>

<!-- Wordpress Messages -->
<h2 class="messages-position"></h2>

<div class="imgmce_dashboard">
	<div class="wrap">
       
        <?php echo IMC_Templates::admin_header(array(
            'page' => 'role-manager',
            'title' => 'ImgMCE Role Manager',
            'desc' => '⚡ ' . __('Control which user roles have access to the imgMCE features on the default Wordpress text editors for specific post types.','imc')
        )); ?>

        <div class="container">

            <form action="" method="post" id="imc-role-settings">

                <?php
                foreach (get_editable_roles() as $role_name => $role_info): 
                //if( array_key_exists('edit_posts', $role_info['capabilities']) ){
                    $role_set = array_key_exists($role_name, $settings['role']) ? $settings['role'][$role_name] : array();
                    ?>
                    <div class="spr_row">  
                        <div class="spr_column spr_hidden" data-animation="bounce">
                            <div class="spr_column-inner left_column">
                                <div class="spr_wrapper">
                                    <div class="option_box">
                                        <div class="info_header">
                                            <!--<span class="nr">1</span>-->
                                            <span class="text"><?php echo $role_name; ?></span>
                                        </div>
                                        <div class="input_container">
                                            <div class="input_container_inner">
                                                
                                                <!--<p style="margin: 20px 0 30px 0;">
                                                    ⚡ <?php _e('','imc'); ?>
                                                </p>-->

                                                <?php 
                                                $html = '';
                                                
                                                $exclude = array('attachment','revision','nav_menu_item','custom_css','customize_changeset','oembed_cache');
                                                $post_types = get_post_types();
                                                
                                                // Post types
                                                $html.= '<div class="imc_settings_cont post_types">';
                                                    $html.= '<h4>'.__('Post types', 'imc').'</h4>';
                                                    $html.= '<div class="imc_settings_cont_inner">';
                                                        foreach($post_types as $post_type)
                                                        {
                                                            if( !in_array($post_type, $exclude))
                                                            {
                                                                $checked = 1;
                                                                if( !empty($settings['role'] ))
                                                                {
                                                                    $checked = array_key_exists('post_types', $role_set) ? in_array($post_type, $settings['role'][$role_name]['post_types']) : 0;
                                                                }

                                                                $html.= ADN_Templates::checkbox(array(
                                                                    'title' => $post_type,
                                                                    'tooltip' => __('','imc'),
                                                                    'checked' => $checked,
                                                                    'name' => 'imc_roles['.$role_name.'][post_types]['.$post_type.']',
                                                                    'class' => 'option_checkbox imc_post_type',
                                                                    'data' => array('box' => 'imc_post_type' )
                                                                ));
                                                            }
                                                        }
                                                    $html.= '</div>';
                                                $html.= '</div>';
                                                //$html.= '<span class="description bottom">'.__('Enable/Disable imgMCE on specific text editors.','imc').'</span>';
                                                // end Post types
                                                        
                                                        
                                                // Image uploads
                                                $html.= '<div class="imc_settings_cont post_types">';
                                                    $html.= '<h4>'.__('Image uploads', 'imc').'</h4>';
                                                    $html.= '<div class="imc_settings_cont_inner">';
                                                        // Enable Image Uploads
                                                        $html.= '<span class="input_container_box">';
                                                            //$html.= '<h3 class="title">'.__('Enable ','imc').'</h3>';
                                                            $html.= ADN_Templates::checkbox(array(
                                                                'title' => __('Image Uploads','imc'),
                                                                'tooltip' => '', // __('Enable/Disable image uploads.','imc')
                                                                'checked' => !empty($role_set['image']['image_uploads']) ? $role_set['image']['image_uploads'] : 0,
                                                                'value' => 1,
                                                                'name' => 'imc_roles['.$role_name.'][image][image_uploads]',
                                                                'class' => 'option_checkbox',
                                                                'data' => array('box' => 'imc_enable_uploads' ),
                                                                'hidden_input' => 1
                                                            ));
                                                            //$html.= '<span class="description bottom">'.__('','imc').'</span>';
                                                        $html.= '</span>';
                                                        // Max. file size
                                                        $html.= IMC_Templates::inpt_cont(array(
                                                            'type' => 'text',
                                                            'title' => __('Max. file upload size (MB)','imc'),
                                                            'desc' => __('Define the max. file upload size in mega bites (mb).','imc'),
                                                            'name' => 'imc_roles['.$role_name.'][image][upload_size]',
                                                            'value' => !empty($role_set['image']['upload_size']) ? $role_set['image']['upload_size'] : 100,
                                                            'placeholder' => '15',
                                                            'desc_pos' => 'bottom'
                                                        ));
                                                        // File types
                                                        $html.= '<span class="input_container_box">';
                                                            $html.= '<h3 class="title">'.__('Allowed filetypes','imc').'</h3>';
                                                            $file_types = array('jpg','png','gif','svg');
                                                            foreach($file_types as $type)
                                                            {
                                                                $html.= ADN_Templates::checkbox(array(
                                                                    'title' => $type,
                                                                    'tooltip' => '',//sprintf(__('Enable/Disable %s image uploads.','imc'),'.'.$type)
                                                                    'checked' => !empty($role_set['image']['upload_file_types']) ? in_array($type, $role_set['image']['upload_file_types']) : 0,
                                                                    'value' => 1,
                                                                    'name' => 'imc_roles['.$role_name.'][image][upload_file_types]['.$type.']',
                                                                    'class' => 'option_checkbox',
                                                                    //'hidden_input' => 1
                                                                ));
                                                            }
                                                            //$html.= '<span class="description bottom">'.__('Select filetypes','imc').'</span>';
                                                        $html.= '</span>';
                                                    $html.= '</div>';
                                                $html.= '</div>';
                                                // end Image uploads

                                                // General 
                                                $html.= '<div class="imc_settings_cont post_types">';
                                                    $html.= '<h4>'.__('Templates', 'imc').'</h4>';
                                                    $html.= '<div class="imc_settings_cont_inner">';
                                                        // Enable Image Uploads
                                                        $html.= '<span class="input_container_box">';
                                                            $html.= ADN_Templates::checkbox(array(
                                                                'title' => __('Save Templates','imc'),
                                                                'tooltip' =>  '', //__('Enable/Disable image uploads.','imc'),
                                                                'checked' => !empty($role_set['general']['save_templates']) ? $role_set['general']['save_templates'] : 0,
                                                                'value' => 1,
                                                                'name' => 'imc_general['.$role_name.'][general][save_templates]',
                                                                'class' => 'option_checkbox',
                                                                'data' => array('box' => 'imc_save_templates' ),
                                                                'hidden_input' => 1
                                                            ));
                                                            //$html.= '<span class="description bottom">'.__('','imc').'</span>';
                                                        $html.= '</span>';
                                                    $html.= '</div>';
                                                $html.= '</div>';
                                                // end General
                                               
                                                echo $html;
                                                ?>    
                                            </div>
                                            <span class="description bottom"></span>
                                        </div>
                                        <!-- end .input_container -->
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                    </div>
                    <!-- end .spr_row -->
                    <?php
                //}
                endforeach; 
                ?>

                <input type="submit" name="submit_btn" id="submit_btn" class="button button-primary" value="<?php _e('Save Changes','imc'); ?>" style="display: inline-block;width: auto;">
            </form>
            
            
        </div>
        <!-- end .container -->

    </div>
    <!-- end .wrap -->
</div>

<script type="text/javascript">
jQuery(document).ready(function($) {

    ImgMCE_global.activate_tooltips($('.imgmce_dashboard'));
    
	$(".spr_column").inViewport(function(px){
		var animation = $(this).data('animation');
		if( typeof animation !== 'undefined' && animation != ''){
			if(px) $(this).addClass(animation+" spr_visible animated");
		}
	}, {padding:0});
});
</script>