// https://www.minifier.org/
(function($, win) {

	var _dn_debug = 1,
		got_saved = 0,
		stage_scale = 1,
		active_editor = '',
		selected_tool_btn = '',
		dn_content = '',
		_dn_undo = new Array(),
		_dn_redo = new Array();

	var _dn_bc = { 

		trigger_resize(){
			window.dispatchEvent(new Event('resize'));
			$('.scrollarea').scrollTo({top:'50%', left:'50%'}, 0);
		},

		// _dn_bc.urldecode(url);
		urldecode(url){
			return decodeURIComponent(url.replace(/\+/g, ' '));
		},


		// _dn_bc._imc_menu_actions(_obj);
		_imc_menu_actions(_obj){
			// Close info message
			_obj.find('._close_info_msg').off('click').on('click', function(){
				_obj.find('._info_message').html('');
			});
		},

		//https://hashids.org/
		// https://github.com/ivanakimov/hashids.js
		_imc_id_generator(string, type){
			var hashids = new Hashids(),
				timestamp = Math.floor(Date.now() / 1000);
		  
			string = typeof(string) !== 'undefined' ? string : 0;
			type = typeof(type) !== 'undefined' ? type : 'encode';
			
			if( type === 'encode' ){
				return hashids.encode(timestamp, string);
			}else{
			  	return hashids.decode(string);
			}
		},

		/*_imc_id_generator(string){
			var hashids = new Hashids(),
				timestamp = Math.floor(Date.now() / 1000);

			string = typeof(string) !== 'undefined' ? string : '';
			var id = hashids.encode(timestamp, string);
			//var numbers = hashids.decode(id); if( _dn_debug ){ console.log(numbers); } // decode example
			return id;
		},*/

		create_size_boxes(cat, _obj, settings){
			_obj.html('');
			var h = '',
				sizes = settings.sizes,
				_imc_id = _dn_bc._imc_id_generator( settings.editor.user_id );
			
			settings.id = _imc_id;
			if( _dn_debug ){ console.log(settings.sizes); }
			
			sizes[cat]['sizes'] = $.extend({
				'upload': {'premium':0,'disabled':0,'title': 'Upload Image', 'size': 'upload', 'pv': '68x68'},
				'custom': {'premium':0,'title': 'Custom size', 'size': 'custom', 'pv': '68x68', 'thumb': encodeURIComponent('<span class="custom_size_btn">+</span>')},
			}, sizes[cat]['sizes'] );

			// Check if image uploads are Enabled.
			if( !parseInt(settings.editor.image.image_uploads) ){
				if( _dn_debug ){ console.log('no image uploads'); }
				delete sizes[cat]['sizes'].upload;
			}
	
			$.each( sizes[cat]['sizes'], function( key, value ) {
				h+= _dn_bc.create_size_option(value);
			});
			_obj.append(h);

			function getImage(url){
				return new Promise(function(resolve, reject){
					var img = new Image()
					img.onload = function(){
						resolve(url)
					}
					img.onerror = function(){
						reject(url)
					}
					img.src = url
				})
			}
		

			$('#ChooseSizeUploader')._dn_file_uploader({
				'user_id': settings.user_id, 
				'template': 2,
				'max_upload_size':settings.editor.image.upload_size,
				'allowed_file_types': settings.editor.image.upload_file_types,
				'upload': {
					'folder': settings.editor.upload.folder+settings.user_id+'/'+settings.id+'/images/',
					'dir': settings.editor.upload.dir,
					'src' : settings.editor.upload.src
				},
				'text': {
					'upload_info': 'Max. size '+settings.editor.image.upload_size+' MB. '+_dn_bc.allowed_upload_file_types(settings.editor.image.upload_file_types)+' only.',
				},
				//<img/>	
				'callback': function(file){
					var tmpImg = new Image();
					tmpImg.src = file.src;
					$(tmpImg).on('load', function(){
						
						var img_w = this.width,
							img_h = this.height,
							img_size = img_w+'x'+img_h;

							settings.banner_obj.upload = settings.editor.upload;
							settings.banner_obj.size = {'full': img_size, 'w': img_w, 'h': img_h};
							settings.banner_obj.css = {'background-color': 'transparent'};
							settings.banner_obj.id = settings.id;
							settings.banner_obj.user_id = settings.user_id;
							settings.banner_obj.slides = [];
							settings.banner_obj.slides[0] = {'params':{'css': {'background-color': 'transparent'}}};

							$.ajax({
								type: "POST",
								url: _dn_.ajaxurl,
								data: {
									"action": "add_layer_to_banner",
									"content": file.src,
									"use": "path",
									"upload": JSON.stringify(settings.upload),
									"type": "image",
									"id": settings.id,
									"user_id": settings.user_id,
									"editor": JSON.stringify(settings.editor),
									"banner_obj": JSON.stringify(settings.banner_obj),
									"slide_nr": 0
								}
							}).done(function( msg ){
		
								var obj = JSON.parse(msg);

								var tmp_obj = $.extend(true, {}, settings.banner_obj);
								_dn_editor_func.set_undo_redo(tmp_obj, 'undo');
								
								settings.banner_obj = obj.banner_obj;
								if( _dn_debug ){ console.log(settings.banner_obj); }
								settings.size = img_size;

								$('#_dn_ChooseSize').hide();
								$('#_dn_BannerEditor')._dn_banner_editor(settings);
							});
					});
					
				}
			});

			$.each( sizes[cat]['sizes'], function( key, value ) {
				
				var option_box = $('.size_option[data-size = '+key+']');

				option_box.find('.thumbnail')._dn_fitParent({
					'heightOffset': typeof value.offset !== 'undefined' ? value.offset : 50,
					'widthOffset': typeof value.offset !== 'undefined' ? value.offset : 50,
					'callback': function(){option_box.find('.thumbnail').centerMiddle({'parentRelative': option_box.find('.thumbnail').parent()});}
				});

				option_box.css('opacity',1);
			});
		},


		create_size_option(data){
			var html = '',
				size = data.size.split('x'),
				thumb = typeof data.thumb !== 'undefined' ? _dn_bc.urldecode(data.thumb) : '',
				premium = typeof data.premium !== 'undefined' && $(this)._dn_bgprem() ? data.premium : 0,
				premium_data = premium ? ' data-premium="1"' : '';
				disabled = typeof data.disabled !== 'undefined' ? data.disabled : 0,
				disabled_data = disabled ? ' data-disabled="1"' : '';
				badge = typeof data.badge !== 'undefined' && data.badge !== "" ? data.badge : 0;
			
			html+= '<div class="size_option" data-size="'+data.size+'"'+premium_data+disabled_data+' style="opacity:0;">';
				html+= '<div class="size_item">';
					html+= '<div class="thumbnail_container">';
						html+= premium === 0 && badge !== 0 ? '<div class="badge '+badge+'">'+badge+'</div>' : '';
						html+= premium !== 0 ? '<div style="width:15px;float:right;">'+_dn_bc.premium_badge_svg('#feff00')+'</div>' : '';

						if(data.size == 'upload'){
							html+= '<form id="ChooseSizeUploader" class="box" method="post" action="'+_dn_.ajaxurl+'" enctype="multipart/form-data"></form>';
						}else{
							html+= '<div class="thumbnail" data-size="'+data.size+'" style="width:'+size[0]+'px;height:'+size[1]+'px;">'+thumb+'</div>';
						}
					html+= '</div>';
					html+= '<div class="name">'+data.title+'</div>';
					html+= data.size !== 'custom' && data.size !== 'upload' ? '<div class="size">'+data.size+'</div>' : '';
				html+= '</div>';
			html+= '</div>';

			return html;
		},


		premium_badge_svg(color, icon_color){
			color = typeof color !== 'undefined' ? color : 'rgba(254, 255, 0, 0.9)'; //#feff00'; // '#6CBB3C'; // #ffa500
			icon_color = typeof icon_color !== 'undefined' ? icon_color : '#d8cb04'; 
			return '<svg viewBox="221.505 369.706 168.424 243.794"><g id="XMLID_3_"><g><path fill="'+color+'" d="M221.51,608.195c0-0.143,0-0.3,0-0.456c0.085-79.335,0.19-158.684,0.286-238.033 c56.14,0.067,112.29,0.135,168.43,0.202c-0.105,79.677-0.191,159.354-0.297,239.017c-4.398-1.288-7.276-3.56-11.313-5.604 c-20.697-10.45-40.095-21.041-60.433-31.49c-2.258-1.157-8.724-5.358-10.243-5.331c-1.66,0.026-7.785,4.183-10.267,5.307 C271.229,583.712,246.674,596.546,221.51,608.195z"/></g><g></g></g><g id="XMLID_7_"><g><path fill="'+icon_color+'" d="M295.684,471.655c11.676,0.288,24.427-0.57,35.431,0.43c-0.133,0-0.27,0-0.402,0 c-21.633,25.702-43.826,50.817-65.628,76.34c-0.342,0.077-0.378-0.167-0.402-0.429 C275.182,522.727,285.497,497.26,295.684,471.655z"/></g><g></g></g><g id="XMLID_6_"><g><path fill="'+icon_color+'" d="M288.839,387.167c18.653,0,37.311,0,55.965,0c-10.972,19.621-22.056,39.122-32.612,59.185 c13.286,0,26.572,0,39.859,0c0,0.57,0,1.146,0,1.716c-7.191,7.926-13.947,16.311-20.937,24.446c-22.547,0-45.094,0-67.641,0 c0-0.429,0-0.858,0-1.287C272.13,443.423,280.633,415.451,288.839,387.167z"/></g><g></g></g></svg>';
		},



		/*load_banner_editor(settings){
			if( _dn_debug ){ console.log(settings); }
			$.ajax({
				type: "POST",
				url: _dn_.ajaxurl,
				data: {
					"action": "save_draft_banners",
					"id": settings.id,
					"size": settings.size,
					"title": settings.page.title,
					"user_id": settings.user_id
				}
			}).done(function( msg ) {
				var arr = JSON.parse(msg);
				if( _dn_debug ){ console.log(arr); }

				//if( arr.id ){
				if( arr.banner_obj ){
					$('._dn_ChooseSize').hide();

					settings.banner_obj = arr.banner_obj;
			
					// Load Banner Editor
					$('._dn_BannerEditor')._dn_banner_editor(settings);
				}

			});
		},*/


		allowed_upload_file_types(file_types){
			var types = '';
			$.each( file_types, function( key, value ) {
				types+= key != 0 ? ', '+value.toUpperCase() : value.toUpperCase();
		  	});
			return types;
		},



		save_as_template(settings, upload){
			if( _dn_debug ){ 
				console.log('Save as template');
				console.log(settings['banner_obj']);
				console.log(upload);
			}

			$.ajax({
				type: "POST",
				url: _dn_.ajaxurl,
				async: false,
				data: {
					"action": "save_as_template",
					"upload": JSON.stringify(upload),
					"banner_obj": JSON.stringify(settings['banner_obj'])
				}
			}).done(function( msg ){

				var obj = JSON.parse(msg);
				if( _dn_debug ){ console.log(obj); }
				$('body').find('#TMCimgModal').remove(); 
				$("html").removeClass("Open_imgMCEModal");
				location.reload();
			});
		},



		/**
		 * Remove object with class from html sting/variable.
		 * _dn_bc.remove_class_from_string(string, classname);
		 */
		remove_class_from_string(string, classname){
			var temp_html = '<div class="temp_cont">'+string+'</div>';
			var $c = $(temp_html); //Get the JQ object to a var
			$c.find('.'+classname).remove(); //Remove it from there

			return $c.html(); //Get back the html
		}
		
	};



	/**
	 * LOAD _dn_bc functions
	*/
	$.fn._func_dn_bc = function(options) {
		if( _dn_debug ){ console.log('LOAD _dn_bn functions'); }
		return _dn_bc;
	}



	/**
	 * SIZE BOXES jQuery PLUGIN
	*/
	$.fn._dn_size_boxes = function(options) {
	  
	  	// Defaults
		var settings = $.extend({
			'user_id': 0,
			'sizes': {},
			'banner_obj': [],
			'page': {},
			'callback': null
		}, options );

		settings.page = $.extend({
			'title': '1. Select Image Size',
		}, settings.page );

		if( _dn_debug ){ console.log(settings); }
		
	 	return this.each(function(i,el){
			 var _obj = $(el);
			 
			// Hide editor menu buttons
			$('._dn_menu').find('.menu_tab.editor').hide();


			var html = '';
			// Info message
			html+= '<div class="_info_message">';
				if( settings.editor.messages.size_screen !== '' ){
					html+= '<div class="_info_msg_content">'+_dn_bc.urldecode(settings.editor.messages.size_screen)+'</div>';
					html+= '<a class="_close_info_msg"><svg style="height:13px;width:13px;" viewBox="0 0 320 512"><path fill="#ababab" d="M193.94 256L296.5 153.44l21.15-21.15c3.12-3.12 3.12-8.19 0-11.31l-22.63-22.63c-3.12-3.12-8.19-3.12-11.31 0L160 222.06 36.29 98.34c-3.12-3.12-8.19-3.12-11.31 0L2.34 120.97c-3.12 3.12-3.12 8.19 0 11.31L126.06 256 2.34 379.71c-3.12 3.12-3.12 8.19 0 11.31l22.63 22.63c3.12 3.12 8.19 3.12 11.31 0L160 289.94 262.56 392.5l21.15 21.15c3.12 3.12 8.19 3.12 11.31 0l22.63-22.63c3.12-3.12 3.12-8.19 0-11.31L193.94 256z"></path></svg></a>';
				}
			html+= '</div>';
	 		html+= '<h2 class="page_title">'+settings.page.title+'</h2>';
			html+= '<div class="tabs">';
				var s = 0;
				$.each( settings.sizes, function( key, value ) {
					var selected = !s ? ' selected' : '';
					html+= '<a data-cat="'+key+'" class="size_categorie'+selected+'">'+value.title+'</a>';
					s++;
				});
			html+= '</div>';
			html+= '<div class="centered_container"></div>';
			
			_obj.append(html);
	 		_dn_bc.create_size_boxes( 'most_popular', _obj.find('.centered_container'), settings );
			
	 		// Reset page CSS
			_obj._dn_update_page_color({'color':_obj.data('bg')});

	 		// CATEGORY TABS - action
			$('.size_categorie').on('click', function(){
				$('.size_categorie').removeClass('selected');
				$(this).addClass('selected');
				
				_dn_bc.create_size_boxes( $(this).data('cat'), _obj.find('.centered_container'), settings );
			});


			// Menu actions
			_dn_bc._imc_menu_actions(_obj);
			
			// Size option select
			_obj.off('click').on('click', '.size_option', function(e) {
				var premium_size = $(this).data('premium'),
					disabled_option = $(this).data('disabled');

				if( premium_size && $(this)._dn_bgprem() ){
					alert('Please upgrade to PREMIUM to use this option.');
				}else if( disabled_option ){
					alert('This option has been disabled.');
				}else{

					// Init banner_obj
					settings.size = $(this).data('size');
					settings.banner_obj.id = settings.id;
					settings.banner_obj.upload = settings.editor.upload;


					// Custom Size
					if( settings.size == 'custom'){
						if(!$(this).hasClass('settingsize')){
							$(this).addClass('settingsize');
							var custom_size_tpl = '';
							custom_size_tpl += '<div style="padding:17px 10px 10px;">';
								custom_size_tpl += '<input type="text" class="csz_ipt csw" placeholder="width">';
								custom_size_tpl += ' x ';
								custom_size_tpl += '<input type="text" class="csz_ipt csh" placeholder="height">';
								custom_size_tpl += '<a class="_dn_init_csz_bnr">Create</a>';
							custom_size_tpl += '</div>'

							$(this).find('.thumbnail_container').html(custom_size_tpl);
						}

						// Custom size create button
						_obj.find('._dn_init_csz_bnr').off('click').on('click', function(e) {
							var w = $('.csw').val() !== "" ? $('.csw').val() : 300,
								h= $('.csh').val() !== "" ? $('.csh').val() : 250;

							settings.size = w+'x'+h;
							settings.banner_obj.size = {'full':settings.size, 'w':w, 'h':h};
							$('#_dn_ChooseSize').hide();
							$('#_dn_BannerEditor')._dn_banner_editor(settings);
						});
					}else if(settings.size == 'upload'){
						//console.log('UPLOADING');
					}else{
						//console.log(settings);
						var sz = settings.size.split('x');
						settings.banner_obj.size = {'full':settings.size, 'w':sz[0], 'h':sz[1]};

						$('#_dn_ChooseSize').hide();
						$('#_dn_BannerEditor')._dn_banner_editor(settings);
					}	
				}
			});
			


	 	});
	};















	

	var _dn_editor_func = {

		/**
		 * FIRE WHEN PAGE IS LOADED.
		 *
		 *
		 */
		onReady: function(callback) {
			var intervalID = window.setInterval(checkReady, 1000);
			function checkReady() {
				if (document.getElementsByTagName('body')[0] !== undefined) {
					window.clearInterval(intervalID);
					
					callback.call(this);
				}
			}
		},


		// _dn_editor_func.set_undo_redo(banner_obj, 'undo');
		set_undo_redo: function(banner_obj, type){
			if(type == 'undo'){
				_dn_undo.push(banner_obj);
				$('body').find('.banner_editor').find('._dn_undo').addClass('active');
			}else{
				_dn_redo.push(banner_obj);
				$('body').find('.banner_editor').find('._dn_redo').addClass('active');
			}
		},


		check_banner_saved(options){
			var settings = $.extend({
				'unload': null
			}, options );

			// Banner is Saved check.
	 		$(window).bind('beforeunload', function(){
				if(!got_saved){
					return 'Are you sure you want to leave?';
				}
			});
			// do stuff before exiting.
			/*if( settings.unload){
				// .unload is deprecated, looking for replacement...
				//$(window).unload(settings.unload);
			}*/
		},


		editor_template(options){
			var html = '';

			html+= 'OIOI';

			return html;
		},


		// KEY PRESS SHORTCUTS
		// _dn_editor_func.key_press_shortcuts(_obj, layer, settings, callback);
		//
		// https://css-tricks.com/snippets/javascript/javascript-keycodes/
		// https://therelentlessfrontend.com/2012/11/13/detect-multiple-key-press-in-javascript-for-your-website/
		key_press_shortcuts(_obj, layer, settings, callback) {
			
			var codeset = [];

			//Tracking the Key down & Key up events
			$(document).off('keydown').on('keydown', function(e) {

				// On Stage Elements (only fires when stage element is selected)
				if( layer.hasClass('selected')){

					// KEY COMBINATIONS
					var move_layer_left_arrow = { 91: false, 37: false }; // Command + Left Arrow
					var move_layer_right_arrow = { 91: false, 39: false }; // Command + Right Arrow
					var move_layer_up_arrow = { 91: false, 38: false }; // Command + Up Arrow
					var move_layer_down_arrow = { 91: false, 40: false }; // Command + Down Arrow

					if (e.keyCode in move_layer_left_arrow) {
						codeset[e.keyCode] = true;
						if (codeset[91] && codeset[37]) {
							e.preventDefault();
							//Functionality to be executed on key press - Command + Left Arrow
							if( _dn_debug ){console.log('key_press_shortcuts MOVE LAYER LEFT (Command + Left Arrow)');}
							layer.animate({
								left: "-=1"
							},{
								complete: function(){
									var newLeft = parseInt(layer.css('left'), 10);
									$('.edit_panel').find('.settings').find('._set_left').val(newLeft);
									if (typeof(callback) == 'function') {
										callback.call(layer, {'left': newLeft}, settings)
									}
								}
							});
						}
					}
					if (e.keyCode in move_layer_right_arrow) {
						codeset[e.keyCode] = true;
						if (codeset[91] && codeset[39]) {
							e.preventDefault();
							//Functionality to be executed on key press - Command + Right Arrow
							if( _dn_debug ){console.log('key_press_shortcuts MOVE LAYER Right (Command + Right Arrow)');}
							layer.animate({
								left: "+=1"
							},{
								complete: function(){
									var newLeft = parseInt(layer.css('left'), 10);
									$('.edit_panel').find('.settings').find('._set_left').val(newLeft);
									if (typeof(callback) == 'function') {
										callback.call(layer, {'left': newLeft}, settings)
									}
								}
							});
						}
					}
					if (e.keyCode in move_layer_up_arrow) {
						codeset[e.keyCode] = true;
						if (codeset[91] && codeset[38]) {
							e.preventDefault();
							//Functionality to be executed on key press - Command + Up Arrow
							if( _dn_debug ){console.log('key_press_shortcuts MOVE LAYER UP (Command + Up Arrow)');}
							layer.animate({
								top: "-=1"
							},{
								complete: function(){
									var newTop = parseInt(layer.css('top'), 10);
									$('.edit_panel').find('.settings').find('._set_top').val(newTop);
									if (typeof(callback) == 'function') {
										callback.call(layer, {'top': newTop}, settings)
									}
								}
							});
						}
					}
					if (e.keyCode in move_layer_down_arrow) {
						codeset[e.keyCode] = true;
						if (codeset[91] && codeset[40]) {
							e.preventDefault();
							//Functionality to be executed on key press - Command + Down Arrow
							if( _dn_debug ){console.log('key_press_shortcuts MOVE LAYER DOWN (Command + Down Arrow)');}
							layer.animate({
								top: "+=1"
							},{
								complete: function(){
									var newTop = parseInt(layer.css('top'), 10);
									$('.edit_panel').find('.settings').find('._set_top').val(newTop);
									if (typeof(callback) == 'function') {
										callback.call(layer, {'top': newTop}, settings)
									}
								}
							});
						}
					}

				}





				// KEY COMBINATIONS
				// https://css-tricks.com/snippets/javascript/javascript-keycodes/
				// http://keycode.info/
				var save = { 91: false, 83: false }; // Command + s
				var preview = { 18: false, 80: false} // Alt + p
				var undo = { 91: false, 90: false} // Command + z
				var redo = { 18: false, 90: false} // Alt + z
				var zoomIn = { 91: false, 187: false} // Command + +
				var zoomOut = { 91: false, 189: false} // Command + -
				var duplicate = { 91: false, 68: false} // Command + d
				var remove = { 91: false, 8: false} // Command + Backspace
				var hide_layer = { 91: false, 72: false} // Command + h
				var move_layer_up = { 18: false, 187: false} // Command + h
				var move_layer_down = { 18: false, 189: false} // Command + h

				if (e.keyCode in save) {
					codeset[e.keyCode] = true;
					if (codeset[91] && codeset[83]) {
						e.preventDefault();
						//Functionality to be executed on key press - Command + s
						if( _dn_debug ){console.log('key_press_shortcuts SAVE (Command + s)');}
						_obj.closest('.imgmce_editor').find('.save_btn').click();
					}
				}
				if (e.keyCode in preview) {
					codeset[e.keyCode] = true;
					if (codeset[18] && codeset[80]) {
						e.preventDefault();
						if( _dn_debug ){console.log('key_press_shortcuts PREVIEW (Alt + p)');}
						_obj.closest('.imgmce_editor').find('.play_btn').click();
					}
				}
				if (e.keyCode in undo) {
					codeset[e.keyCode] = true;
					if (codeset[91] && codeset[90]) {
						e.preventDefault();
						if( _dn_debug ){console.log('key_press_shortcuts UNDO (Command + z)');}
						_obj.find('._dn_undo').click();
					}
				}
				if (e.keyCode in redo) {
					codeset[e.keyCode] = true;
					if (codeset[18] && codeset[90]) {
						e.preventDefault();
						if( _dn_debug ){console.log('key_press_shortcuts REDO (Alt + z)');}
						_obj.find('._dn_redo').click();
					}
				}
				if (e.keyCode in zoomIn) {
					codeset[e.keyCode] = true;
					if (codeset[91] && codeset[187]) {
						e.preventDefault();
						if( _dn_debug ){console.log('key_press_shortcuts ZOOM IN (Command + +)');}
						var zoom_val = typeof _obj.find('#_dn_zoom').data('val') !== 'undefined' ? _obj.find('#_dn_zoom').data('val')+10 : 110;
						_obj.find('#_dn_zoom').slider({value:zoom_val});
					}
				}
				if (e.keyCode in zoomOut) {
					codeset[e.keyCode] = true;
					if (codeset[91] && codeset[189]) {
						e.preventDefault();
						if( _dn_debug ){console.log('key_press_shortcuts ZOOM OUT (Command + -)');}
						var zoom_val = typeof _obj.find('#_dn_zoom').data('val') !== 'undefined' ? _obj.find('#_dn_zoom').data('val')-10 : 90;
						_obj.find('#_dn_zoom').slider({value:zoom_val});
					}
				}
				if (e.keyCode in duplicate) {
					codeset[e.keyCode] = true;
					if (codeset[91] && codeset[68]) {
						e.preventDefault();
						if( _dn_debug ){console.log('key_press_shortcuts DUPLICATE LAYER (Command + d)');}
						_obj.find('.editor_stage_menu').find('.edit_tool_btn.duplicate').click();
					}
				}
				if (e.keyCode in remove) {
					codeset[e.keyCode] = true;
					if (codeset[91] && codeset[8]) {
						e.preventDefault();
						if( _dn_debug ){console.log('key_press_shortcuts REMOVE LAYER (Command + Backspace)');}
						_obj.find('.editor_stage_menu').find('.edit_tool_btn.remove').click();
					}
				}
				if (e.keyCode in hide_layer) {
					codeset[e.keyCode] = true;
					if (codeset[91] && codeset[72]) {
						e.preventDefault();
						if( _dn_debug ){console.log('key_press_shortcuts HIDE LAYER (Command + h)');}
						/*var tml_v = _obj.find('.layers_box').find('.timeline_layer_'+layer.data('nr')).find('.layer_visible');
						tml_v.toggleClass('is_visible');
						if(tml_v.hasClass('is_visible')){
							tml_v.find('.invisible_icon').hide();
							tml_v.find('.visible_icon').show();
						}else{
							tml_v.find('.invisible_icon').show();
							tml_v.find('.visible_icon').hide();
						}
						
						_obj.find('.banner_element').find('.stage').find('.layer_'+layer.data('nr')).toggleClass('hide_layer');*/
						var tml_v = _obj.find('.timeline_layers_sortable').find('.timeline_layer_'+layer.data('nr')).find('.timeline_layer_visible_icon');
						tml_v.toggleClass('layer_is_visible');
						if( tml_v.hasClass('layer_is_visible') ){
							tml_v.find('.visible').hide();
							tml_v.find('.not_visible').show();
						}else{
							tml_v.find('.visible').show();
							tml_v.find('.not_visible').hide();
						}
						_obj.find('.banner_element').find('.stage').find('.layer_'+layer.data('nr')).toggleClass('hide_layer');
					}
				}
				if (e.keyCode in move_layer_up) {
					codeset[e.keyCode] = true;
					if (codeset[18] && codeset[187]) {
						e.preventDefault();
						if( _dn_debug ){console.log('key_press_shortcuts MOVE LAYER UP (Alt + +)');}
						_dn_editor_func.update_timeline_item_positions(_obj, settings, 'up');
					}
				}
				if (e.keyCode in move_layer_down) {
					codeset[e.keyCode] = true;
					if (codeset[18] && codeset[189]) {
						e.preventDefault();
						if( _dn_debug ){console.log('key_press_shortcuts MOVE LAYER DOWN (Alt + -)');}
						_dn_editor_func.update_timeline_item_positions(_obj, settings, 'down');
					}
				}

				
			}).off('keyup').on('keyup', function(e) {
				codeset = [];
			});
		},



		// Save layer position on the stage
		// _dn_editor_func.save_layer_position(css, settings);
		save_layer_position( css, settings ){
			if( _dn_debug ){ console.log(css); }
			var tmp_obj = $.extend(true, {}, settings.banner_obj);
			_dn_editor_func.set_undo_redo(tmp_obj, 'undo');

			// Check if imgisfull width, if yes we need to use percentage.
			var cur_layer_class = settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].class;
			var layer = $('.stage').find('.'+cur_layer_class);
			if( $('.img_is_fullwidth').prop("checked") === true ){
				if( _dn_debug ){ console.log('FULL WIDTH USE PERCENTAGE'); }
				var percent = ImgMCE_global.pixToPerc(layer, layer.closest('._dn_cont'));
				css.left = percent.left+'%';
				//console.log(css); console.log(layer); console.log(layer.closest('._dn_cont')); console.log(percent);
			}
			
			
			settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].css.layer = $.extend(settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].css.layer, css );
			got_saved = 0;
			if( _dn_debug ){ console.log(settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer]); }
		},




		/**
		 * MAKE ITEMS DRAGGABLE
		 *
		 *
		 */
		make_draggable: function(_obj, handle, containment, banner_element, settings, callback) { 
			
			if(typeof banner_element !== 'undefined' && banner_element){
				_dn_editor_func.make_resizable(_obj, settings, callback);
				_dn_editor_func.rotating_itm(_obj, function(css){
					if( _dn_debug ){ console.log(css); console.log($(this)); }

					var tmp_obj = $.extend(true, {}, settings.banner_obj);
					_dn_editor_func.set_undo_redo(tmp_obj, 'undo');

					// Making it draggable again doesn't work yet. looking for solution. for now we just deselect the layer after rotation. at the end of this function.
					//_dn_editor_func.make_draggable( $(this), false, false, 1, settings, callback);

					settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].css.obj_cont = $.extend(settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].css.obj_cont, css );
					got_saved = 0;
					_dn_editor_func.deselect_items($('.banner_editor'), settings);
					if( _dn_debug ){ console.log(settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer]); }
				});
				
				// Keypress actions
				//_dn_editor_func.key_press_shortcuts(_obj, callback);	
			}

			handle = typeof handle !== 'undefined' ? handle : false;
			containment = typeof containment !== 'undefined' ? containment : 'parent';
			
			// Fix for dragging when stage is scaled
			// https://gungfoo.wordpress.com/2013/02/15/jquery-ui-resizabledraggable-with-transform-scale-set/
			_obj.draggable({
				scroll: true,
				handle: handle,
				cancel:'._dn_text',
				containment: containment,
				start: function(event, ui){
					/*
					 * After having trouble dragging images after resing them taking this line out seems to fix it.
					 * I thougt the code was nesseccery before but now everything seems to work fine without it.
					 * So needs monitoring before completely removing it.
					 * 
					if( typeof(_obj.data('resized')) !== 'undefined'){
						if( _dn_debug ){ console.log('item has been resized'); }
						ui.position.left = 0;
						ui.position.top = 0;
					}*/
				},
				drag: function(event, ui){
					
					// Get zoomScale
					var element = document.querySelector('._dn_editor_stage');
					//var scaleX = element.getBoundingClientRect().width / element.offsetWidth;
					//var zoomScale = scaleX;
					var zoomScale = stage_scale;
					if( _dn_debug ){ console.log(zoomScale); }

					var changeLeft = ui.position.left - ui.originalPosition.left; // find change in left
					var newLeft = ui.originalPosition.left + changeLeft / zoomScale; // adjust new left by our zoomScale
					if( _dn_debug ){ console.log(ui.position.top+' '+ui.originalPosition.top); }
					var changeTop = ui.position.top - ui.originalPosition.top; // find change in top
					var newTop = ui.originalPosition.top + changeTop / zoomScale; // adjust new top by our zoomScale

					ui.position.left = newLeft;
					ui.position.top = newTop;

					$('.edit_panel').find('.settings').find('._set_left').val(newLeft);
					$('.edit_panel').find('.settings').find('._set_top').val(newTop);
				},
				//cancel : '.Text_element',
				stop: function(event, ui) {
					if( _dn_debug ){ console.log(ui); }
					// Show dropped position.
					var stoppos = ui.position;

					/*if( $('.img_is_fullwidth').prop("checked") === true ){
						if( _dn_debug ){ console.log('FULL WIDTH USE PERCENTAGE'); }
						var percent = ImgMCE_global.pixToPerc($(this), $(this).closest('._dn_cont'));
						stoppos = {'top': ui.position.top, 'left': percent.left+'%'};
					}*/
					
					if( _dn_debug ){ console.log(stoppos); }

					if (typeof(callback) == 'function') {
				        callback.call(_obj, stoppos, settings)
				    }
				}	
			});
		},



		/**
		 * MAKE ITEMS RESIZABLE
		 *
		 *
		 */
		make_resizable: function(_obj, settings, callback) {
			
			if( _dn_debug ){ console.log('make .itm resizable'); }

			var aspectRatio = typeof _obj.data('aspect_ratio') !== 'undefined' ? _obj.data('aspect_ratio') : 0;
			var resize_handles = typeof _obj.data('rsh') !== 'undefined' ? _obj.data('rsh') : 'n, e, s, w, ne, se, sw, nw';
			
			//console.log(resize_handles);
			// Fix for resizing when stage is scaled
			// https://gungfoo.wordpress.com/2013/02/15/jquery-ui-resizabledraggable-with-transform-scale-set/
			_obj.resizable({
			    handles: resize_handles, //'n, e, s, w, ne, se, sw, nw',
			    aspectRatio: aspectRatio,
			    minWidth: -(_obj.width()) * 10,  // these need to be large and negative
				minHeight: -(_obj.height()) * 10, // so we can shrink our resizable while scaled
				create: function( event, ui ) {
					// Hide N and S handle if object is smaller than 30px
					if( _obj.width() <= 40 ){
						_obj.find('.ui-resizable-s').hide();
						_obj.find('.ui-resizable-n').hide();
					}else{
						_obj.find('.ui-resizable-s').show();
						_obj.find('.ui-resizable-n').show();
					}
					if( _obj.height() <= 40 && !_obj.hasClass('text_elmt')){
						_obj.find('.ui-resizable-e').hide();
						_obj.find('.ui-resizable-w').hide();
					}else{
						_obj.find('.ui-resizable-e').show();
						_obj.find('.ui-resizable-w').show();
					}
				},
			    start: function(event, ui){
					resizing = true;
			    },
			    // Make text (font-size) resizable.
			    resize: function (event, ui) {
				    // Get zoomScale
					var element = document.querySelector('._dn_editor_stage');
					//var scaleX = element.getBoundingClientRect().width / element.offsetWidth;
					//var zoomScale = scaleX;
					var zoomScale = stage_scale;
					if( _dn_debug ){ console.log(zoomScale); }

					var changeWidth = ui.size.width - ui.originalSize.width; // find change in width
					var newWidth = ui.originalSize.width + changeWidth / zoomScale; // adjust new width by our zoomScale

					var changeHeight = ui.size.height - ui.originalSize.height; // find change in height
					var newHeight = ui.originalSize.height + changeHeight / zoomScale; // adjust new height by our zoomScale

					ui.size.width = newWidth;
					ui.size.height = newHeight;

					$('.edit_panel').find('.settings').find('._set_width').val(newWidth);
					$('.edit_panel').find('.settings').find('._set_height').val(newHeight);

					if( ui.size.width <= 40 ){
						_obj.find('.ui-resizable-s').hide();
						_obj.find('.ui-resizable-n').hide();
					}else{
						_obj.find('.ui-resizable-s').show();
						_obj.find('.ui-resizable-n').show();
					}
					if( ui.size.height <= 40 && !_obj.hasClass('text_elmt')){
						_obj.find('.ui-resizable-e').hide();
						_obj.find('.ui-resizable-w').hide();
					}else{
						_obj.find('.ui-resizable-e').show();
						_obj.find('.ui-resizable-w').show();
					}
			    },
			    stop: function(event, ui){
					resizing = false;
					if( _dn_debug ){ console.log('Finish resizing '); }
					
					_obj.data('resized', 1);
					
					/*var itm = $(this).data('itm'),
						font_size = $('#itm_'+itm).find('#edit_itm_fontsize').val();*/

					if (typeof(callback) == 'function') {
				        callback.call(_obj, {'width': $(this).width(), 'height': $(this).height()}, settings);
				    }

					
					// TIMELINE ARR ITMS
					/*_t.wppas.create_timeline_itm({ID: itm});
			
					timeline_arr[cur_view_size][itm]['css']['layer']['height'] = $('.'+itm).height()+'px';
					timeline_arr[cur_view_size][itm]['css']['layer']['width'] = $('.'+itm).width()+'px';
					timeline_arr[cur_view_size][itm]['css']['item']['font-size'] = font_size;
					timeline_arr[cur_view_size][itm]['css']['layer']['font-size'] = font_size;
					timeline_arr[cur_view_size][itm]['font']['font-size'] = font_size;
					*/
						
					//_t.wppas.wppas_update_code_editor_from_preview();
			    }
			}); 	
		},



		/**
		 * ROTATING ITEM
		 *
		 *
		 */
		rotating_itm: function(_obj, callback) { 
			
			var dragging = false,
				target_wp,
				o_x, o_y, h_x, h_y, last_angle;
				
			_obj.find('.rotate_handle').remove();
			_obj.find('._dn_obj_container').append('<div class="rotate_handle"><svg viewBox="0 0 512 512"><path fill="currentColor" d="M500 8h-27.711c-6.739 0-12.157 5.548-11.997 12.286l2.347 98.568C418.075 51.834 341.788 7.73 255.207 8.001 118.82 8.428 7.787 120.009 8 256.396 8.214 393.181 119.165 504 256 504c63.926 0 122.202-24.187 166.178-63.908 5.113-4.618 5.354-12.561.482-17.433l-19.738-19.738c-4.498-4.498-11.753-4.785-16.501-.552C351.787 433.246 306.105 452 256 452c-108.322 0-196-87.662-196-196 0-108.322 87.662-196 196-196 79.545 0 147.941 47.282 178.675 115.302l-126.389-3.009c-6.737-.16-12.286 5.257-12.286 11.997V212c0 6.627 5.373 12 12 12h192c6.627 0 12-5.373 12-12V20c0-6.627-5.373-12-12-12z" class=""></path></svg></div>');
			
			_obj.find('.rotate_handle').off('mousedown').on('mousedown', function(e) {
				if($(e.target).hasClass('rotate_handle') || $(e.target).parent().hasClass('rotate_handle')) {
					if( _dn_debug ){ console.log('start rotating'); }
					h_x = e.pageX;
					h_y = e.pageY; // clicked point
					e.preventDefault();
					e.stopPropagation();
					dragging = true;
					target_wp = $(e.target).closest('._dn_obj_container');
					if (!target_wp.data("origin")) target_wp.data("origin", {
						left: target_wp.offset().left,
						top: target_wp.offset().top
					});
					// Stop default item dragging. now it only needs to rotate.
					if(dragging && _obj.find('._dn_cont').find('._dn_layer.ui-draggable')){
						_obj.find('._dn_cont').find('._dn_layer.ui-draggable').draggable('destroy');	
					}
					o_x = target_wp.data("origin").left;
					o_y = target_wp.data("origin").top; // origin point
					
					//last_angle = target_wp.data("last_angle") || 0;
					var mts = (360 / (2 * Math.PI));
					last_angle = (_dn_editor_func.getRotationDegrees(target_wp) / mts);
				}
			});
			
			jQuery(document).on('mousemove', function(e) {
				
				if (dragging) {
					
					var s_x = e.pageX,
						s_y = e.pageY; // start rotate point
					if (s_x !== o_x && s_y !== o_y) { //start rotate
						var s_rad = Math.atan2(s_y - o_y, s_x - o_x); // current to origin
						s_rad -= Math.atan2(h_y - o_y, h_x - o_x); // handle to origin
						s_rad += last_angle; // relative to the last one
						
						var degree = (s_rad * (360 / (2 * Math.PI)));
		
						target_wp.css('-moz-transform', 'rotate(' + degree + 'deg)');
						target_wp.css('-webkit-transform', 'rotate(' + degree + 'deg)');
						target_wp.css('-o-transform', 'rotate(' + degree + 'deg)');
						target_wp.css('-ms-transform', 'rotate(' + degree + 'deg)');
					}
				}
			}); // end mousemove
			
			jQuery(document).on('mouseup', function (e) {
				
				if(dragging){
					if( _dn_debug ){ console.log('end rotating'); }
					var s_x = e.pageX,
						s_y = e.pageY;
						
					// Saves the last angle for future iterations
					var s_rad = Math.atan2(s_y - o_y, s_x - o_x); // current to origin
					s_rad -= Math.atan2(h_y - o_y, h_x - o_x); // handle to origin
					s_rad += last_angle;
					
					var degree = (s_rad * (360 / (2 * Math.PI)));
					
					if (typeof(callback) == 'function') {
				        callback.call(_obj, {'transform': 'rotate('+degree+'deg)'}); //'transform-origin': '50% 50%'
					}
					
					dragging = false;
				}
				
			});
		},

		getRotationDegrees: function(obj) {
			var matrix = obj.css("-webkit-transform") ||
			obj.css("-moz-transform")    ||
			obj.css("-ms-transform")     ||
			obj.css("-o-transform")      ||
			obj.css("transform");
			if(matrix !== 'none') {
				var values = matrix.split('(')[1].split(')')[0].split(',');
				var a = values[0];
				var b = values[1];
				var angle = Math.round(Math.atan2(b, a) * (180/Math.PI));
			} else { var angle = 0; }
			return angle;
		},







		/**
		 * MAKE ITEMS SORTABLE
		 *
		 *
		 */
		make_sortable: function(sort, _obj, settings){
				
			sort.obj.sortable({
				handle: sort.handle,
				axis: "y",
				containment: sort.containment, //"#banner_timeline",
				update: function( event, ui ) {
					var itm = jQuery(ui.item);
					_dn_editor_func.update_sortable_list_item_positions(sort.obj, _obj, settings);
					got_saved = 0;
				},
				stop: function( event, ui ) {
					
				},
				placeholder: "ui-state-highlight"
			});
			sort.obj.disableSelection();	
		},


		/**
		 * UPDATE SORTABLE LIST POSITIONS.
		 *
		 *
		 */
		update_sortable_list_item_positions: function(_itm, _obj, settings){
			
			var positions = _itm.sortable( "toArray", {attribute: 'data-nr'} );
			if( _dn_debug ){
				console.log('position');
				console.log(positions);
				console.log(positions.length);
			}
			// Update z-indexes.
			var zindex = positions.length; // +4
			jQuery.each(positions, function( index, value ) {
				zindex--;
				
				var slide_nr = _obj.find('.slides_and_layers_box').find('.slide.selected').data('nr'); //_obj.closest('.slide').data('nr');
				var tmp_obj = $.extend(true, {}, settings.banner_obj);
				_dn_editor_func.set_undo_redo(tmp_obj, 'undo');
				console.log(slide_nr);
				settings.banner_obj.slides[slide_nr].layers[value].css.layer = $.extend(settings.banner_obj.slides[slide_nr].layers[value].css.layer, {'z-index': zindex});

				$('._dn_inner').find('.slide_'+settings.current_slide).find('._dn_layer[data-nr = '+value+']').css({'z-index': zindex});
			});
		},




		// Update timeline item positions without dragging.
		//_dn_editor_func.update_timeline_item_positions();
		update_timeline_item_positions: function(_obj, settings, go){
			var layer_nr = _obj.find('.layers_box').find('.layer.selected').data('nr');
			var slide_nr = _obj.find('.layers_box').find('.layer.selected').closest('.slide').data('nr');
			var slide_obj = _obj.find('.slides_and_layers_box').find('.slide_'+slide_nr);

			var positions = [];
			var next_after_detection = 0;

			slide_obj.find('.layers_box').find('.layer').each(function(index, item){

				var layer_num = $(item).data('nr');
				if( layer_nr === layer_num ){
					if( go === 'up'){
						positions.splice((index-1), 0, layer_num);
					}else{
						positions.push(layer_num);
    					next_after_detection = 1;
					}
				}else{
					if( go === 'up'){
						positions.push(layer_num);
					}else{
						if( next_after_detection ){
							next_after_detection = 0;
							positions.splice((index-1), 0, layer_num);
					  	}else{
						  	positions.push(layer_num);
					  	}
					}
				}
			});
			  
			var zindex = positions.length;
			$.each( positions, function( index, value ) {
				zindex--;
				console.log(value+' zindex:'+zindex);

				var tmp_obj = $.extend(true, {}, settings.banner_obj);
				_dn_editor_func.set_undo_redo(tmp_obj, 'undo');

				settings.banner_obj.slides[slide_nr].layers[value].css.layer = $.extend(settings.banner_obj.slides[slide_nr].layers[value].css.layer, {'z-index': zindex});

				$('._dn_inner').find('.slide_'+settings.current_slide).find('._dn_layer[data-nr = '+value+']').css({'z-index': zindex});
			});
		},




		/**
		 * IMAGE UPLOAD RESULTS CONTAINER
		 *
		 *
		 */
		image_upload_result_container(_obj, container, settings){
			container._dn_upload_result_grid({
				'user_id': settings.user_id,
				'callback': function(msg){
					if( _dn_debug ){
						console.log(msg);
						console.log(settings);
					}
					var slide_nr = settings.current_slide;
					$('.editor_stage_container').find('._dn_inner').append('<div class="_dn_loading_elmt img _dn_layer _dn_elmt"><div class="icon"><i class="fas fa-spinner fa-pulse"></i></div></div>');
				
					$.ajax({
						type: "POST",
						url: _dn_.ajaxurl,
						async: false,
						data: {
							"action": "add_layer_to_banner",
							"content": msg.src,
							"use": msg.use,
							"type": "image",
							"editor": JSON.stringify(settings.editor),
							"banner_obj": JSON.stringify(settings.banner_obj),
							"slide_nr": slide_nr
						}
					}).done(function( msg ){

						var obj = JSON.parse(msg);

						var tmp_obj = $.extend(true, {}, settings.banner_obj);
						_dn_editor_func.set_undo_redo(tmp_obj, 'undo');
						
						settings.banner_obj = obj.banner_obj;
						$('.editor_stage_container').find('._dn_cont').find('.slide_'+slide_nr).append(obj.html);
						$('.slides_and_layers_box').find('.slide_'+settings.current_slide).find('.layers_box').prepend(obj.timeline_item);
						$('.editor_stage_container').find('._dn_inner').find('._dn_loading_elmt').remove();

						settings = _dn_editor_func.add_layer_to_timeline(_obj, obj.timeline, obj.layer_nr, settings);
						//_dn_editor_func.timeline_is_visible_btn(_obj);
						got_saved = 0;
					});
				}
				// end callback
			});
		},




		/**
		 * DESELECT ITEMS
		 *
		 *
		 */
		deselect_items: function(_obj, settings) {
			//if( _dn_debug ){  console.log(settings); }
			if( $('.banner_element').find('.selected').length > 0){
				if( _dn_debug ){ console.log('deselect items - function:'); console.log(settings.banner_obj); console.log(selected_tool_btn); }
				
				// Remove editable text functions.
				//_dn_editor_func.remove_editable_text_functions($('.banner_element').find('._dn_layer.selected').find('._dn_obj').children(':first'), settings);
				_dn_editor_func.remove_editable_text_functions($('.banner_element').find('._dn_layer.selected').find('._dn_obj').find('._dn_text'), settings);

				// remove all code adjustments possibly added by plugins.
				if(typeof(settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].plugins) !== 'undefined'){
					$.each( settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].plugins, function( pl, plugin ){	
						if( typeof(plugin.code) !== 'undefined'){
							if( typeof(plugin.code.remove) !== 'undefined'){
								//
								// @since v1.1.5 changed _obj to jQuery("._dn_BannerEditor") to fix a compiler issue with Google compiler (https://closure-compiler.appspot.com/home)
								// If compiled with Google compiler an error: "_obj is undefined" was triggered when item had a plugin attached. 
								// This did not happen if the code was compiled using (minifier.org) but we like to compile everything with the same compiler.
								//
								// EDIT: This happens because when compiled the variable _dn_obj gets renamed. So if we call '_dn_obj' in the string it's undefined... 
								//
								//var run_code = plugin.code.remove.replace(/{LAYER}/g, '_obj');
								var run_code = plugin.code.remove.replace(/{LAYER}/g, 'jQuery("._dn_BannerEditor")');
								eval(run_code);
							}
						}
					});
				}


				// Save content html (if necessery)
				var _selected_obj = $('.banner_element').find('._dn_layer.selected').find('._dn_obj');
				var _selected_obj_elem = _selected_obj.children(':first');
				
				if ( _selected_obj.hasClass('shape') || _selected_obj_elem.hasClass("_dn_elem") || _selected_obj_elem.hasClass('shape') ){
					
					if( typeof settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer] !== 'undefined'){
						//var content = _selected_obj.parent().html();
						var content = _selected_obj.closest('._dn_obj').html();
						settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].content = encodeURIComponent(_dn_editor_func.escapeSingleQuotes(content));
						if( _selected_obj_elem.find('._dn_text').length){
							settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].text = encodeURIComponent(_dn_editor_func.escapeSingleQuotes( _selected_obj_elem.find('._dn_text').html() ));
						}
					}
				}

				

				$('.bc_editor_settings').css({'background-color': '#54606b'});
				$('.editor_stage_container').removeClass('layer_selected');
				$('.layer_editor_content_settings').css({'display': 'none'});

				if( typeof(selected_tool_btn) !== 'undefined' && selected_tool_btn !== ''){
					if( !$('.bc_editor_toolbar').find('.selected').length){
						$('.bc_editor_toolbar').find('[data-option="'+selected_tool_btn+'"]').addClass('selected');
						$('.bc_editor_settings').find('.'+selected_tool_btn+'_settings').show();
					}
				}else{
					_dn_editor_func.close_editor_settings(_obj);
				}

				if( _obj.find('.ui-draggable').length){
					$('.banner_element').find('._dn_layer.selected.ui-draggable').draggable('destroy');
					$('.banner_element').find('._dn_layer.selected').resizable("destroy");
				}
				$('.banner_element').find('._dn_layer').removeClass('selected');
				$('.edit_bar_container').removeClass('visible');
				$('.edit_bar_container').removeClass('open');
				$('.edit_panel').removeClass('visible');
				$('.banner_element').find('._dn_layer').find('.Layer_isSelected').remove();
				$('.rotate_handle').remove();
				$('.slides_and_layers_box').find('.layer').removeClass('selected');

				_obj.find('.timeline_layer_element').removeClass('selected_layer');
				_obj.find('.timeline_layer_animation_container').removeClass('selected_layer');

				// Destroy color pickers
			    $('.obj_bg_color').coloringPick({'destroy':true});
			    // Destroy edit panel select boxes
			    //$('.edit_panel').find('.selectBox').spr_selectBox({'destroy': true});
			    _dn_editor_func.detroy_selectBox();
			    
			    // Destroy font family selector
				$('.font_family_selector').next('.font-select').remove();
				
				// Remove timeline animation popup
				_obj.find('.timeline_animation_popup').hide();
			}
		},



		/**
		 * DESTROY selectBox
		*/
		detroy_selectBox(){
			$('.edit_panel').find('.selectBox').spr_selectBox({'destroy': true});
		},




		/**
		 * MAKE TEXT EDITABLE
		 *
		 *
		 */
		make_text_editable: function(layer, settings){
			
			if( layer.find('._dn_text').length ){
				if( _dn_debug ){ console.log('MAKE TEXT EDITABLE'); }

				var text_obj = layer.find('._dn_text');
				
				if( !text_obj.hasClass('editable')){
					text_obj.selectText();
			    	text_obj.prop('contenteditable',true).addClass('editable').focus();
			  	}
		  	}
		},



		/**
		 * REMOVE EDITABLE FUNCTIONS from text layers
		 *
		 *
		 */
		remove_editable_text_functions: function(text_obj, settings){
			if ( text_obj.hasClass("_dn_text") ){
			    text_obj.prop('contenteditable',false).removeClass('editable');
			    text_obj.removeAttr( "contenteditable" );
				//var text_content = text_obj.parent().html();
				//var text_content = text_obj.closest('._dn_obj').html();
				
			    /*if( typeof settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer] !== 'undefined'){
					//settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].content = text_content;
					settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].content = encodeURIComponent(_dn_editor_func.escapeSingleQuotes(text_content));
			    }*/
			    got_saved = 0;
			    if( _dn_debug ){ console.log(settings); }
			}
		},




		/**
		 * ESCAPE HTML
		 * _dn_editor_func.escapeHtml(text);
		 *
		 */
		escapeHtml(text) {
			var map = {
			  '&': '&amp;',
			  '<': '&lt;',
			  '>': '&gt;',
			  '"': '&quot;',
			  "'": '&#039;'
			};
		  
			return text.replace(/[&<>"']/g, function(m) { return map[m]; });
		},

		/**
		 * ESCAPE SINGLE QUOTES
		 * _dn_editor_func.escapeSingleQuotes(text);
		 *
		 */
		escapeSingleQuotes(text) {
			var map = {
			  "'": '&#039;'
			};
		  
			return text.replace(/[']/g, function(m) { return map[m]; });
		},



		/**
		 * SELECT LAYER
		 *
		 *
		 */
		select_layer: function(layer, settings, _obj) {

			// Ignore when in Preview mode
			if( _obj.hasClass('is_playing') ){
				if( _dn_debug ){ console.log('Preview mode, layer selection has been disabled.'); }
				return;
			}
				
			
			if( !layer.hasClass('selected')){
				_dn_editor_func.deselect_items(_obj, settings);

				var layer_nr = layer.data('nr');
				settings.current_layer = layer_nr;

				// Save current selected tool button.
				selected_tool_btn = _obj.find('.bc_editor_toolbar').find('.selected').data('option');

				if( _dn_debug ){ console.log(settings); console.log(selected_tool_btn); }
				
				layer.addClass('selected');
				if( layer.find('.Layer_isSelected').length == 0){
					layer.prepend('<div class="Layer_isSelected"></div>');
				}

				_obj.find('.syncscroll_left').find("[data-nr='" + layer_nr + "']").addClass('selected_layer');
				_obj.find('.syncscroll_right').find("[data-nr='" + layer_nr + "']").addClass('selected_layer');


				// Set layer position settings
				var o_pos_left = layer.position().left / stage_scale,
					o_pos_top = layer.position().top / stage_scale;
					//percent = ImgMCE_global.pixToPerc(layer, layer.closest('._dn_cont'));
					
				$('.edit_bar_container').find('.edit_panel').find('.settings').find('._set_left').val(o_pos_left);
				$('.edit_bar_container').find('.edit_panel').find('.settings').find('._set_top').val(o_pos_top);


				// Set layer aspectratio
				if( layer.find('._dn_obj').hasClass('image') ){
					layer.data('aspect_ratio', layer.find('img').width()+'/'+layer.find('img').height() );
				}


				// Stop layer animations (if there are any)
				if( typeof(_stop_layer) !== 'undefined'){ 
					if( _stop_layer.hasOwnProperty(layer_nr) ){
						if( _dn_debug ){ console.log('Stop layer_'+layer_nr+' "in view" layer animation'); }
						_stop_layer[layer_nr](); 

						// Reposition layer to start position
						layer.css({
							'left': settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].css.layer.left,
							'top': settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].css.layer.top
						});
						
					}
				};
				$('.editor_stage_container').find('.js_preview').html('');
				

				
				settings.current_slide = $('.slides_and_layers_box').find('.layer[data-nr = '+settings.current_layer+']').closest('.slide').data('nr');
				$('.slides_and_layers_box').find('.layer').removeClass('selected');
				$('.slides_and_layers_box').find('.layer[data-nr = '+settings.current_layer+']').addClass('selected');

				// Default Layer Settings
				settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer] = $.extend({
					'css': {},
					'actions' : {},
					'animation': {},
					'render_html': 0	
				},settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer]);


				// Keypress actions
				_dn_editor_func.key_press_shortcuts(_obj, layer, settings, function(css, settings){ _dn_editor_func.save_layer_position(css, settings)});


				// MAKE LAYER DRAGGABLE
				_dn_editor_func.make_draggable( layer, false, false, 1, settings, function(css, settings){ _dn_editor_func.save_layer_position(css, settings)});


				// SETUP EDIT BAR
				_dn_editor_func.make_draggable($('.edit_bar_container'), '.drag_position');
				$('.edit_bar_container').addClass('visible');
				$('.editor_stage_container').addClass('layer_selected');

				// Editor left panel
				if( !_obj.find('.bc_editor_settings').hasClass('opened')){
					// Delay to make sure everything is positioned correctly before closing.
					setTimeout(function() { 
						_obj.find('.toolbar_holder').css({'width':344});
						_obj.find('.bc_editor_settings').css({'opacity':1,'z-index':1}).css({'margin-left':0}).addClass('opened');
						_dn_bc.trigger_resize();
					}, 160);
				}
				_obj.find('.tool_btn').removeClass('selected');
				_obj.find('.bc_editor_settings').find('.setting').css({'display': 'none'});
				_obj.find('.layer_editor_content_settings').css({'display': 'block'});
				_obj.find('.edit_panel').find('.panel_box').removeClass('visible');
				_obj.find('.edit_panel').find('.settings_panel').addClass('visible');	
				_obj.find('.layer_editor_content_settings').closest('.bc_editor_settings').css({'background-color': '#ffffff'});
				_obj.find('.edit_tool_btn').removeClass('selected');
				_obj.find('.edit_tool_btn[data-panel = "settings"]').addClass('selected');
				

				// Show/hide text tool button
				var show_effects = 0,
					effect_type = 'text';

				if( layer.find('._dn_obj').hasClass('text')){
					_obj.find('.edit_tool_btn[data-panel = "text"]').show();
					show_effects = 1;
					effect_type = 'text';
		 		}else{
					_obj.find('.edit_tool_btn[data-panel = "text"]').hide();
				}
				
				if( layer.find('._dn_obj').hasClass('image')){
					_obj.find('.edit_tool_btn[data-panel = "filters"]').show();
					show_effects = 1;
					effect_type = 'image';
				}else{
					_obj.find('.edit_tool_btn[data-panel = "filters"]').hide();
				}

				if( show_effects ){
					_obj.find('.edit_tool_btn[data-panel = "effects"]').show();
					_obj.find('.effects_panel').find('.effect_box').each(function(index, item){
						if(!$(item).hasClass(effect_type)){
							$(item).hide();
						}else{
							$(item).show();
						}
					});
				}else{
					_obj.find('.edit_tool_btn[data-panel = "effects"]').hide();
				}

				// Show/hide border options
				if( layer.find('._dn_elem').length ){
					_obj.find('.mn_border_settings').show();
					_obj.find('.mn_css_settings').show();
				}else{
					_obj.find('.mn_border_settings').hide();
					_obj.find('.mn_css_settings').hide();
				}

				_obj.find('.settings').find('.svg_stroke_box').hide();


				// set colorpicker color
				if( !_dn_editor_func.contains_svg( layer.find('._dn_obj'))){

					_obj.find('.settings_panel').find('.obj_color_picker_container').html('<input type="" class="obj_bg_color" data-picker="solid" value="">');

					var elmt_css = settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].css;
					elmt_css = 'element' in elmt_css ? elmt_css.element : {};
					var bg_color = 'background' in elmt_css ? elmt_css.background : layer.find('._dn_elem').css('background-color'); //'transparent';
					bg_color = typeof(bg_color) == 'undefined' ? 'transparent' : bg_color;
					bg_color = bg_color.replace(/\+/g,' ');
					if( _dn_debug ){ console.log( bg_color); }

					_obj.find('.obj_bg_color').attr('data-picker_changeable', true);
					_obj.find('.obj_bg_color').data('picker_changeable', true);
					if( bg_color.length > 30 ){
						_obj.find('.obj_bg_color').attr('data-picker', 'gradient');
						_obj.find('.obj_bg_color').data('picker', 'gradient');
					}

					_obj.find('.obj_bg_color').val( bg_color );
					_obj.find('.obj_bg_color').attr('value', bg_color);

					// Font Color
					if( layer.find('._dn_obj').hasClass('text') ){
						var obj_css = settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].css,
							font_color = '',
							bg_color = '';

						if( typeof(obj_css.element) !== 'undefined' ){
							font_color = obj_css.element['color'];
							bg_color = obj_css.element['background'];
						}
						else
						{
							font_color = layer.find('._dn_elem').css('color');
							bg_color = layer.find('._dn_elem').css('background-color');
						}

						_obj.find('.obj_font_color').val( font_color );
						_obj.find('.obj_font_color').attr('value', font_color);
						//_obj.find('.obj_bg_color').val( bg_color );
						//_obj.find('.obj_bg_color').attr('value', bg_color);

						_obj.find('.obj_font_color').attr('data-picker', 'solid');
						_obj.find('.obj_font_color').data('picker', 'solid');
						_obj.find('.obj_font_color').attr('data-picker_changeable', false);
						_obj.find('.obj_font_color').data('picker_changeable', false);
					}

					// Border Color
					if( layer.find('._dn_obj').find('._dn_elem').length ){
						var obj_css = settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].css;
						if( typeof(obj_css.element) !== 'undefined' ){
							_obj.find('.obj_border_color').val( obj_css.element['border-color'] );
						}

						_obj.find('.obj_border_color').attr('data-picker', 'solid');
						_obj.find('.obj_border_color').data('picker', 'solid');
						_obj.find('.obj_border_color').attr('data-picker_changeable', false);
						_obj.find('.obj_border_color').data('picker_changeable', false);
					}
					
				}else{
					// If SVG color gets already set when opening the editor (look for function settings_func)
				}


				_dn_edit_bar.edit_layer_settings(_obj, settings);
				
				// Example code for exporting a layer to use as object template. 
				if( _dn_debug ){ 
				
					var selected_layer = settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer];

					console.log( JSON.stringify({'layer': selected_layer, 'external': ext }) ); 
					var ext = {};
					if( typeof(selected_layer.css.obj) !== 'undefined'){
						if( typeof(selected_layer.css.obj['font-family']) !== 'undefined')
						{
							var font_fam_no_space = selected_layer.css.obj['font-family'].replace(/ /g,"-");
							var font_arr = settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].plugins.google_font[font_fam_no_space];
							//var font_arr = settings.banner_obj.external.styles[font_fam_no_space];
							ext.styles = {};
							//ext.styles[font_fam_no_space] = {"font": font_arr.font, "url": encodeURIComponent(font_arr.url)};
							ext.styles[font_fam_no_space] = font_arr;
						}
					}
					//console.log( JSON.stringify({'layer': selected_layer, 'external': ext }) ); 
				}


				// IF TEXT MAKE EDITABLE
				_dn_editor_func.make_text_editable(layer, settings);
			}	
		},




		/**
		 * UPDATE LAYER CSS
		 *
		 */
		layer_css: function(options) {

			options = $.extend({
				'layer': null,
				'key': 'opacity',
				'value': 1,
				'settings': null
			}, options );

			var css_key = options.key,
				css_val = options.value,
				attributes = {},
				need_px = ['left', 'top']; 

			attributes[css_key] = css_val;

			var css_value = need_px.includes(css_key) ? css_val+'px' : css_val;
			options.layer.css(css_key, css_value);
			
			// Update banner obj
			if(options.settings !== null){
				if( _dn_debug ){ console.log('Update Banner Layer CSS changes'); }
				var tmp_obj = $.extend(true, {}, options.settings.banner_obj);
				_dn_editor_func.set_undo_redo(tmp_obj, 'undo');

				options.settings.banner_obj.slides[options.settings.current_slide].layers[options.settings.current_layer].css.layer = $.extend(options.settings.banner_obj.slides[options.settings.current_slide].layers[options.settings.current_layer].css.layer, attributes );
				got_saved = 0;
			}				
		},




		/**
		 * UPDATE LAYER OBJ CSS
		 *
		 */
		layer_obj_css: function(options) {

			options = $.extend({
				'layer': null,
				'key': 'opacity',
				'value': 1,
				'settings': null
			}, options );

			var css_key = options.key,
				css_val = options.value,
				attributes = {};

			attributes[css_key] = css_val;
			options.layer.css(css_key, css_val);
			
			// Update banner obj
			if(options.settings !== null){
				if( _dn_debug ){ console.log('Update Banner Obj CSS changes'); }
				var tmp_obj = $.extend(true, {}, options.settings.banner_obj);
				_dn_editor_func.set_undo_redo(tmp_obj, 'undo');

				options.settings.banner_obj.slides[options.settings.current_slide].layers[options.settings.current_layer].css.obj = $.extend(options.settings.banner_obj.slides[options.settings.current_slide].layers[options.settings.current_layer].css.obj, attributes );
				got_saved = 0;
			}				
		},


		/**
		 * UPDATE LAYER OBJ ELEMENT CSS
		 *
		 */
		layer_obj_elem_css: function(options) {
			options = $.extend({
				'layer': null,
				'key': 'opacity',
				'value': 1,
				'metric': 'px',
				'settings': null
			}, options );

			var css_key = options.key,
				css_val = options.value,
				attributes = {};
			
			attributes[css_key] = css_val;

			if( css_key !== 'custom'){
				if( css_key === 'box-shadow'){
					options.layer.css('box-shadow', css_val);
					options.layer.css('-webkit-box-shadow', css_val);
					options.layer.css('-moz-box-shadow', css_val);
				}else{
					options.layer.css(css_key, css_val+options.metric);
				}
			}else{
				if(typeof options.value.id !== 'undefined'){
					options.layer.attr('id', options.value.id);
				}
				if(typeof options.value.class !== 'undefined'){
					options.layer.addClass(options.value.class);
				}
				if(typeof options.value.style !== 'undefined'){

					var style_obj = options.value.style.split(';');
					$.each( style_obj, function( key, value ) {
						if( value !== '' && value.indexOf(':') >= 0){
							var stl = value.split(':');
							options.layer.css(stl[0],stl[1]);
						}
					});
					
				}
			}
			
			// Update banner obj
			if(options.settings !== null){
				if( _dn_debug ){ console.log('Update Banner Obj CSS changes'); }
				var tmp_obj = $.extend(true, {}, options.settings.banner_obj);
				_dn_editor_func.set_undo_redo(tmp_obj, 'undo');

				options.settings.banner_obj.slides[options.settings.current_slide].layers[options.settings.current_layer].css.element = $.extend(options.settings.banner_obj.slides[options.settings.current_slide].layers[options.settings.current_layer].css.element, attributes );
				got_saved = 0;
			}
		},



		/**
		 * UPDATE LAYER FILTER CSS
		 *
		 */
		layer_filter_css: function(options) {

			options = $.extend({
				'layer': null,
				'key': 'filter',
				'value': '',
				'filter': '',
				'settings': null
			}, options );

			var css_key = options.key,
				css_val = options.value,
				attributes = {};

			attributes[css_key] = css_val;
			options.layer.css(css_key, css_val);
			
			// Update banner obj
			if(options.settings !== null){
				if( _dn_debug ){ console.log('Update Banner Layer CSS changes'); }
				var tmp_obj = $.extend(true, {}, options.settings.banner_obj);
				_dn_editor_func.set_undo_redo(tmp_obj, 'undo');

				options.settings.banner_obj.slides[options.settings.current_slide].layers[options.settings.current_layer].css.layer = $.extend(options.settings.banner_obj.slides[options.settings.current_slide].layers[options.settings.current_layer].css.layer, attributes );
				options.settings.banner_obj.slides[options.settings.current_slide].layers[options.settings.current_layer].filter = options.filter;
				got_saved = 0;
			}
			
			if( _dn_debug ){ console.log( options.settings.banner_obj ); }
		},





		/**
		 * Check if element contains SVG
		*/
		contains_svg(_obj){
			if( _dn_debug ){ console.log(_obj); }
			if(_obj.find("svg").length){
				// Make sure it's not the rotate handle
				if( _obj.find("svg").length == 1 && _obj.find("svg").parent().hasClass('rotate_handle')){
					return 0;
				}
				if( _dn_debug ){ console.log('Item is SVG'); }
				return 1;
			}

			return 0;
		},






		/**
		 * Update Layer Object BG Color
		*/
		change_object_color(color, css_key, settings, cl){

			var _dn_layer = $('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer);
			var _dn_obj = _dn_layer.find('._dn_obj');
			var item_is_svg = _dn_editor_func.contains_svg(_dn_obj);
			var csskey = '',
				attributes = {},
				obj_html = '';

			// If CSS key is provided.
			if( css_key !== ''){
				if( _dn_obj.hasClass('text') || _dn_obj.hasClass('shape') || _dn_obj.hasClass('element') ){
					_dn_layer.find('._dn_elem').css(css_key, color);
				}
				/*
				if( _dn_obj.hasClass('text') ){
					_dn_layer.find('._dn_elem').css(css_key, color);
				}else if( _dn_obj.hasClass('shape')){
					_dn_layer.find('._dn_elem').css(css_key, color);
				}
				*/
				attributes[css_key] = color;
				settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].css.element = $.extend(settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].css.element, attributes );
			}else{
				if(item_is_svg){
					csskey = _dn_layer.find('.colorful.'+cl).css('fill') !== 'none' ? 'fill' : 'stroke';
					_dn_layer.find('.colorful.'+cl).css(csskey, color);
				}else{
					if( _dn_obj.hasClass('shape')){
						csskey = 'background';
						if(_dn_obj.find('.html_shape').length){
							_dn_obj.find('.html_shape').css(csskey, color);
						}else if(_dn_obj.find('.shape_ani').length){
							_dn_obj.find('._dn_pin_pulse').css(csskey, color);
							_dn_obj.find('._dn_pin_icon').css(csskey, color);
						}else if(_dn_obj.find('.poi-single-point').length){
							_dn_obj.find('.poi-img-replace').css(csskey, color);
							//_dn_obj.find('._dn_pin_icon').css(csskey, color);
						}else{
							_dn_layer.find('.shape').css(csskey, color);
						}		
					}else if( _dn_obj.hasClass('element')){
						csskey = 'background';
						if(_dn_obj.find('.poi-single-point').length){
							_dn_obj.find('.poi-img-replace').css(csskey, color);
						}else{
							_dn_layer.find('._dn_elem').css(csskey, color);
						}
					}else if( _dn_obj.hasClass('text')){
						csskey = 'color';
						_dn_layer.find('._dn_text').css(csskey, color);
					}
				}

				attributes[csskey] = color;

				// Remove rotate handle from object html.
				obj_html = '<div class="temp_cont">'+_dn_obj.html()+'</div>';
				var $c = $(obj_html); //Get the JQ object to a var
				$c.find('.rotate_handle').remove(); //Remove it from there
				$c.find('._dn_text').prop('contenteditable',false).removeClass('editable');
				$c.find('._dn_text').removeAttr( "contenteditable" );
				obj_html = $c.html(); //Get back the html

				var tmp_obj = $.extend(true, {}, settings.banner_obj);
				_dn_editor_func.set_undo_redo(tmp_obj, 'undo');

				settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].content = obj_html;
				settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].css.element = $.extend(settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].css.element, attributes );
			}
			

			
			got_saved = 0;
		},




		load_banner(arr, settings, _obj){
			if(arr.status !== 'draft' && arr.status !== 0){
				got_saved = 1;
			}
			_obj.find('.banner_element').find('.stage').html(arr.template);
			_obj.find('.scrollarea').scrollTo({top:'50%', left:'50%'}, 100);
			_obj.find('.banner_element').find('._dn_cont').removeClass('_dn_hidden').addClass('_dn_visible');
			
			// Add title
			_obj.closest('.imgmce_editor').find("._dn_banner_title").val(settings.banner_obj.title);
			
			// Create Timeline
			_obj.find('.slides_and_layers_box').html(arr.timeline); // right (old)
			_obj.find('.editor_stage_holder').find('.timeline_container').replaceWith(arr.timeline_);
			settings = _dn_editor_func.stage_timeline(_obj, settings);

			// Re-position timeline layers based on z-index
			_obj.find('.layers_box').find('.layer').sort(sort_li).appendTo('.layers_box');
			_obj.find('.timeline_layers_sortable').find('.timeline_layer_element').sort(sort_li).appendTo('.timeline_layers_sortable');
			_obj.find('.syncscroll_right').find('.timeline_layer_animation_container').sort(sort_li).appendTo('.syncscroll_right');
			function sort_li(a, b){ 
				var aa = _obj.find('._dn_inner').find('.slide_'+settings.current_slide).find('._dn_layer[data-nr = '+$(a).data('nr')+']').css('z-index');
				var bb = _obj.find('._dn_inner').find('.slide_'+settings.current_slide).find('._dn_layer[data-nr = '+$(b).data('nr')+']').css('z-index');
				
				return (parseInt(bb,10)) - (parseInt(aa,10));
			}

			// Make Timeline Sortable
			_dn_editor_func.make_sortable({ 
				'obj':_obj.find('.slides_and_layers_box').find('.layers_box'), 
				'containment': '.slide', 
				'handle': '.icon'
			}, _obj, settings);

			// Timeline Hide layers
			//_dn_editor_func.timeline_is_visible_btn(_obj);

			if( settings.banner_obj.size.fw){
				_dn_editor_func.adjust_full_width_size(_obj);
			}
		},


		// Timeline Hide layers
		// @since v1.1.9 removed. Moved to bottom timeline.
		/*timeline_is_visible_btn: function(_obj){
			_obj.find('.layers_box').find('.layer').off('click').on('click', '.layer_visible', function(){
				var layer_nr = $(this).closest('.layer').data('nr');
				$(this).toggleClass('is_visible');
				if($(this).hasClass('is_visible')){
					$(this).find('.invisible_icon').hide();
					$(this).find('.visible_icon').show();
				}else{
					$(this).find('.invisible_icon').show();
					$(this).find('.visible_icon').hide();
				}
				_obj.find('.banner_element').find('.stage').find('.layer_'+layer_nr).toggleClass('hide_layer');
			});
		},*/


		close_editor_settings: function(_obj){
			_obj.find('.bc_editor_settings').css({'margin-left':'-300px', 'opacity':0,'z-index':'-1'}).removeClass('opened');
			_obj.find('.tool_btn').removeClass('selected');
			// Delay to make sure everything is positioned correctly before closing.
			setTimeout(function() { 
				_obj.find('.toolbar_holder').css({'width':53});
				_dn_bc.trigger_resize();
			}, 160);
		},


		// _dn_editor_func.adjust_full_width_size(_obj);
		adjust_full_width_size(_obj){

			setTimeout(function(){
				_obj.find('._set_bg_width').css({'opacity':.1});
				_obj.find('._set_bg_width').prop('disabled', true);

				var w = _obj.find('.editor_stage_container').find('.scrollarea').outerWidth();
				console.log(w);
				_obj.find('.editor_stage_container').find('._dn_cont').css({'width':w});
				_obj.find('.editor_stage_container').find('._dn_cont').find('._dn_inner').css({'width':'100%'});
			},0);
			
		},


		// _dn_editor_func.layer_add_animation_max_width();
		layer_add_animation_max_width: function(_target,_elem, ui, side){
			var pos = _target.position();
		
			if( side === 'left'){
				if (ui.position.left + ui.size.width > (pos.left-10)) {
					_elem.resizable({ maxWidth: ui.size.width }); // $(this)
				}else{
					_elem.resizable({ maxWidth: 'auto' });
				}
			}else{
				console.log( ui.position.left );
				console.log( 'pos: '+(pos.left+_target.width()+10) );
				if (ui.position.left < (pos.left+_target.width()+10)) {
					_elem.resizable({ maxWidth: ui.size.width }); // $(this)
				}else{
					_elem.resizable({ maxWidth: 'auto' });
				}
			}
		},



		/**
		 * ADD LAYER TO TIMELINE
		 */
		// _dn_editor_func.add_layer_to_timeline(_obj, obj.timeline, obj.layer_nr, settings);
		add_layer_to_timeline: function(_obj, timeline, layer_nr, settings){
			var _timeline = _obj.find('.timeline_container');

			_obj.find('.timeline_layers_sortable').prepend(timeline.layer); // add layer
			_obj.find('.syncscroll_right').prepend(timeline.animation); // add animation bar

			// Set Animation bar width
			_obj.find('.timeline_layer_animation_container[data-nr = '+layer_nr+']').find('.layer_animation_container').css({'width': _obj.find('.timeline_seconds_element_duration').width()});

			settings = _dn_editor_func.stage_timeline(_obj, settings);

			// Set default layer view duration
			var length = _timeline.find( ".layer_animation_container" ).width();
			var view_duration = ((length/10) /8);
			console.log( settings.banner_obj.slides[settings.current_slide].layers[layer_nr] );
			if( typeof settings.banner_obj.slides[settings.current_slide].layers[layer_nr].animation === 'undefined'){ settings.banner_obj.slides[settings.current_slide].layers[layer_nr].animation = {'in': {},'view': {}, 'out': {}}; }
			settings.banner_obj.slides[settings.current_slide].layers[layer_nr].animation['view'] = $.extend(settings.banner_obj.slides[settings.current_slide].layers[layer_nr].animation['view'], {'duration': view_duration} );

			return settings;
		},


		/**
		 * STAGE TIMELINE 
		 */
		// _dn_editor_func.stage_timeline();
		stage_timeline: function( _obj, settings ){
			var _timeline = _obj.find('.timeline_container');

			// Set slide duration
			var length = _timeline.find( ".timeline_seconds_element_duration" ).width();
			var slide_duration = ((length/10) /8);
			// Add slide duration if it does not exist yet.
			settings.banner_obj.slides[settings.current_slide] = $.extend({'duration': slide_duration}, settings.banner_obj.slides[settings.current_slide]);


			// Set timeline container size
			var timeline_height = _timeline.find('.timeline_layer_animation_container').height()*_timeline.find('.timeline_layer_animation_container').length + 48;
			if( timeline_height < 151 ){
				_timeline.css({'height': _timeline.find('.timeline_layer_animation_container').height()*_timeline.find('.timeline_layer_animation_container').length + 48});
				_obj.find('.editor_stage_container').css({'height': 'calc((100% - '+timeline_height+'px))'});
			}
			
			var sz = _timeline.height() - 45;
			_timeline.find('.syncscroll').css({'min-height': sz});


			// SYNC SCROLLING
			_timeline.find('.syncscroll').on('scroll', function () {
				_timeline.find('.syncscroll').scrollTop($(this).scrollTop());
			});
		
			_timeline.find('.syncscroll_right').on('scroll', function () {
				_timeline.find('.timeline_seconds_inner').scrollLeft($(this).scrollLeft());
			});

			
			// TIMELINE HEIGHT
			_timeline.resizable({
				//minHeight: 166,
				grid: [ 0, 37 ],
				minWidth:_timeline.width(),
				maxWidth:_timeline.width(),
				maxHeight: _timeline.find('.timeline_layer_animation_container').height()*_timeline.find('.timeline_layer_animation_container').length + 55,
				handles:'n',
				resize: function( event, ui ) {
					console.log(ui.size.height);
					var sz = ui.size.height - 45;
					console.log( 'new timeline size: '+ sz  );
					_timeline.find('.syncscroll').css({'min-height': sz});
					_obj.find('.editor_stage_container').css({'height': 'calc((100% - '+_timeline.height()+'px))'});
				}
			});
			
		
		
			// SELECT LAYER
			_timeline.find('.timeline_layer_element').find('.timeline_layer_cont').off('click').on('click', function(){
				var layer_nr = $(this).parent().data('nr');
				var _layer = $(this).parent();

				if( !_layer.hasClass('selected_layer')){
					
					_dn_editor_func.deselect_items(_obj, settings);
					_dn_editor_func.select_layer(_obj.find('.banner_element').find('._dn_layer[data-nr = '+layer_nr+']'), settings, _obj);

					_timeline.find('.timeline_layer_element').removeClass('selected_layer');
					_timeline.find('.timeline_layer_animation_container').removeClass('selected_layer');
					_layer.addClass('selected_layer');
					_timeline.find('.syncscroll_right').find("[data-nr='" + layer_nr + "']").addClass('selected_layer');
				}
			});
		
		
			
			// LAYER VISIBILITY
			_timeline.find('.layer_is_visible_btn').off('click').on('click', function(){
		
				$(this).parent().toggleClass('layer_is_visible');
				if( $(this).parent().hasClass('layer_is_visible') ){
					$(this).find('.visible').show();
					$(this).find('.not_visible').hide();
				}else{
					$(this).find('.visible').hide();
					$(this).find('.not_visible').show();
				}
				_obj.find('.banner_element').find('.stage').find('.layer_'+$(this).parent().data('nr')).toggleClass('hide_layer');
			});
		
		
		
			// LAYERS Z-INDEX 
			_timeline.find('.timeline_layers_sortable').sortable({
				handle: '.drag_handle',
				axis: "y",
				containment: '.timeline_layers_sortable',
				placeholder: "ui-state-highlight",
				update: function( event, ui ) {
					var nextPosition;
					var index = ui.item.data('nr');
					var currPosition = _timeline.find(".syncscroll_right").find("[data-nr='" + index + "']"); 
					if (typeof(ui.item.next().data('nr')) === 'undefined') {
						nextPosition = _timeline.find('.syncscroll_right span:last');
						currPosition.insertAfter(nextPosition);
					} else {
						index = ui.item.next().data('nr');
						nextPosition = _timeline.find('.syncscroll_right').find("[data-nr='" + index + "']");
						currPosition.insertBefore(nextPosition);
					}
					
					_dn_editor_func.update_sortable_list_item_positions(_obj.find('.timeline_layers_sortable'), _obj, settings);
					
					got_saved = 0;
				},
				stop: function( event, ui ) {
					
				}
			});
			_timeline.find('.timeline_layers_sortable').disableSelection();
		
		
		
		
		
			// SLIDE DURATION
			var sec = 5;
			_timeline.find( ".timeline_seconds_element_duration" ).resizable({
				minHeight: 36,
				maxHeight:36,
				grid: 8, // 1 sec = 8
				// 5 sec = ( 5 x 8 ) = 40 x 10 = 400px
				// 400/10 / 8 = 5
				// 800/10 / 8 = 10
				handles: 'e',
				//handles: {e : $('.element_duration_handle')},
				resize: function( event, ui ) {
					console.log(ui);

					var length = $(this).width();
					var view_duration = ((length/10) /8);

					settings.banner_obj.slides[settings.current_slide] = $.extend(settings.banner_obj.slides[settings.current_slide], {'duration': view_duration});
		
					_timeline.find('.layer_animation_container').each(function(index, item){
						if( !$(item).hasClass('custom_size') && !$(item).hasClass('has_delay') ){
							var layer_nr = $(this).parent().data('nr');
							$(item).width(ui.size.width);
							if( typeof settings.banner_obj.slides[settings.current_slide].layers[layer_nr].animation === 'undefined'){ settings.banner_obj.slides[settings.current_slide].layers[layer_nr].animation = {'in': {},'view': {}, 'out': {}}; }
							settings.banner_obj.slides[settings.current_slide].layers[layer_nr].animation['view'] = $.extend(settings.banner_obj.slides[settings.current_slide].layers[layer_nr].animation['view'], {'duration': view_duration} );

						}
					});
					
					sec = (ui.size.width/10) / 8;
					console.log(sec);
				}
			});
			
		
		
		
			/**
			 * DELAY
			*/
			_timeline.find( ".layer_animation_container" ).draggable({ 
				axis: 'x',
				grid: [8],
				containment: '.timeline_layer_animation_container',
				cancel: ".animation_drag_handle, .animation_drag_margin",
				stop: function( event, ui ) {
					var sec = $(this).position().left;
					var delay = ((sec/10) /8);
					var layer_nr = $(this).parent().data("nr");
					var length = $(this).width();
					var view_duration = ((length/10) /8);
					console.log('Layer nr: '+layer_nr+' Delay: '+delay+' sec.');

					if( sec !== 0){
						$(this).addClass('has_delay');
						var w = $(this).width()+$(this).position().left;
						if( w > _obj.find('.timeline_seconds_element_duration').width()){
							_obj.find('.timeline_seconds_element_duration').width(w);
						}
					}else{
						$(this).removeClass('has_delay');
					}

					// Change animation slider value.
					_obj.find('.edit_panel').find( ".animation_delay_slider" ).slider({value:delay});
					_obj.find('.edit_panel').find('.animation').find('.animation_delay_box').find('.slider_input_val').val(delay);

					if( typeof settings.banner_obj.slides[settings.current_slide].layers[layer_nr].animation === 'undefined'){ settings.banner_obj.slides[settings.current_slide].layers[layer_nr].animation = {'in': {},'view': {}, 'out': {}}; }
					settings.banner_obj.slides[settings.current_slide].layers[layer_nr].animation['in'] = $.extend(settings.banner_obj.slides[settings.current_slide].layers[layer_nr].animation['in'], {'delay': delay} );
					settings.banner_obj.slides[settings.current_slide].layers[layer_nr].animation['view'] = $.extend(settings.banner_obj.slides[settings.current_slide].layers[layer_nr].animation['view'], {'duration': view_duration} );
				}
			}).resizable({
				minHeight: 35,
				maxHeight:35,
				grid: 8,
				containment: '.timeline_layer_animation_container',
				handles: 'e,w',
				resize: function( event, ui ) {
					var layer_nr = $(this).parent().data("nr");

					if( (ui.size.width) !== _timeline.find('.timeline_seconds_element_duration').width()){
						$(this).addClass('custom_size');
						var w = $(this).width()+$(this).position().left;
						if( w > _obj.find('.timeline_seconds_element_duration').width()){
							_obj.find('.timeline_seconds_element_duration').width(w);
						}
					}else{
						$(this).removeClass('custom_size');
					}
					
					var sec = $(this).position().left;
					var delay = ((sec/10) /8);
					console.log('Delay: '+delay+' sec.');
					
					var length = $(this).width();
					var view_duration = ((length/10) /8);
					console.log('Length: '+view_duration+' sec.');

					if( typeof settings.banner_obj.slides[settings.current_slide].layers[layer_nr].animation === 'undefined'){ settings.banner_obj.slides[settings.current_slide].layers[layer_nr].animation = {'in': {},'view': {}, 'out': {}}; }
					settings.banner_obj.slides[settings.current_slide].layers[layer_nr].animation['view'] = $.extend(settings.banner_obj.slides[settings.current_slide].layers[layer_nr].animation['view'], {'duration': view_duration} );
				}
			});
		
		
		
		
			/**
			 * DURATION
			*/
			_timeline.find( ".layer_add_animation_left").resizable({
				minHeight: 35,
				maxHeight:35,
				minWidth:8,
				grid: 8,
				containment: 'parent',
				handles: 'e',
				start: function( event, ui ){
					// Set MaxWidth
					var _target = $(this).closest('.layer_animation_duration_container').find('.layer_add_animation_right');
					_dn_editor_func.layer_add_animation_max_width(_target, $(this), ui, 'left');
					
				},
				resize: function( event, ui ) {
					// Set MaxWidth
					var _target = $(this).closest('.layer_animation_duration_container').find('.layer_add_animation_right');
					var layer_nr = $(this).closest('.timeline_layer_animation_container').data('nr');
					_dn_editor_func.layer_add_animation_max_width(_target, $(this), ui, 'left');

					var sec = ui.size.width/80;
					console.log(sec);
					settings.banner_obj.slides[settings.current_slide].layers[layer_nr].animation['in'] = $.extend(settings.banner_obj.slides[settings.current_slide].layers[layer_nr].animation['in'], {'duration': sec} );
					//_obj.find('.banner_element').find('.stage').find('.layer_'+layer_nr).css({'animation-duration':sec+'s', '-webkit-animation-duration':sec+'s'});
				},
				stop: function( event, ui ) {
					$(this).css({'left': 'auto'});
				}
			});
			_timeline.find( ".layer_add_animation_right").resizable({
				minHeight: 35,
				maxHeight:35,
				minWidth:8,
				grid: 8,
				containment: 'parent',
				handles: 'w',
				start: function( event, ui ){
					// Set MaxWidth
					var _target = $(this).closest('.layer_animation_duration_container').find('.layer_add_animation_left');
					_dn_editor_func.layer_add_animation_max_width(_target, $(this), ui, 'right');
				},
				resize: function( event, ui ) {
					// Set MaxWidth
					var _target = $(this).closest('.layer_animation_duration_container').find('.layer_add_animation_left');
					var layer_nr = $(this).closest('.timeline_layer_animation_container').data('nr');
					_dn_editor_func.layer_add_animation_max_width(_target, $(this), ui, 'right');

					var sec = ui.size.width/80;
					console.log(sec);
					settings.banner_obj.slides[settings.current_slide].layers[layer_nr].animation['out'] = $.extend(settings.banner_obj.slides[settings.current_slide].layers[layer_nr].animation['out'], {'duration': sec} );
				},
				stop: function( event, ui ) {
					$(this).css({'left': 'auto'});
				}
			});



			// OPEN ADD ANIMATION POPUP
			_timeline.find('.timeline_layer_animation_container').find('.layer_add_animation').off('click').on('click', function(){
				var _ani_btn = $(this);
				var ani_type = $(this).data('ani');
				var animation = $(this).data('animation'); // animation class name
				var layer_nr = $(this).closest('.timeline_layer_animation_container').data('nr');
				if( _dn_debug ){ console.log('Layer: '+layer_nr+', '+ani_type+' animation'); }

				

				// Loop true all animation options
				_obj.find('.timeline_animation_popup').find('.animation_box').each(function(index, item){
					$(item).show();
					// Hide animations for other builds (in/out)
					if(!$(item).hasClass(ani_type+'_animation')){
						$(item).hide();
					}
					// select current animation
					if($(item).data('class') === animation){
						$(item).addClass('selected');
					}
				});

				// Move selected to front
				//_obj.find('.timeline_animation_popup').find('.tml_animation_content').scrollTop(0);
				_obj.find('.timeline_animation_popup').find('.animation_box.selected').prependTo(".tml_animation_content");
				
				_obj.find('.timeline_animation_popup').find('.tml_ani_header_txt').html('Animation '+ani_type);

				var pos = $(this).offset();
				var pos_top = pos.top - $(window).scrollTop();
				var pop_height = _obj.find('.timeline_animation_popup').height();
				_obj.find('.timeline_animation_popup').css({'top': (pos_top-pop_height), 'left': (pos.left-98)});
				_obj.find('.timeline_animation_popup').show();

				// ACTIONS
				// HOVER ANIMATION BOX 
				_obj.find('.timeline_animation_popup').find('.tml_animation_content').off('mouseenter').on('mouseenter', '.animation_box', function(){
					console.log($(this).data('class'));
					_dn_get_scripts( {'css':{0:"{INC_DIR}files/imgmce_animations.css"}} );
					
					$(this).find('.example_shape').addClass($(this).data('class'));
				});
				_obj.find('.timeline_animation_popup').find('.tml_animation_content').off('mouseleave').on('mouseleave', '.animation_box', function(){
					$(this).find('.example_shape').removeClass($(this).data('class'));
				});

				// ADD ANIMATION
				_obj.find('.timeline_animation_popup').find('.animation_box').off('click').on('click', function(){
					var ani_class = $(this).data('class');
					//var code = $(this).find('.animation_code').val();
					//console.log(ani_class); console.log(code); console.log(layer_nr);

					_obj.find('.timeline_animation_popup').find('.animation_box').removeClass('selected');
					$(this).addClass('selected');
					_ani_btn.data('animation', ani_class);

					if( ani_class !== 'none'){
						_ani_btn.find('.layer_add_animation_icon').addClass('has_animation');
						_ani_btn.find('.layer_add_animation_text').html(ani_class);
					}else{
						_ani_btn.find('.layer_add_animation_icon').removeClass('has_animation');
						_ani_btn.find('.layer_add_animation_text').html('');
					}

					settings.banner_obj.slides[settings.current_slide].layers[layer_nr].animation[ani_type] = $.extend(settings.banner_obj.slides[settings.current_slide].layers[layer_nr].animation[ani_type], {'animation': ani_class} ); // 'code':code
					_obj.find('.timeline_animation_popup').hide();
				});	
			});

			// Close animation popup
			_obj.find('.timeline_animation_popup').find('.tml_ani_close_btn').off('click').on('click', function(){
				_obj.find('.timeline_animation_popup').hide();
			});

			return settings;
		},


		// _dn_editor_func.animation_object_fix(settings);
		animation_object_fix: function(settings){
			$.each( settings.banner_obj.slides[0].layers, function( key, value ) {
				if( typeof value.animation !== 'undefined'){
					if( $.isArray(value.animation) ){ 
						settings.banner_obj.slides[0].layers[key].animation = {...value.animation};
					}
					$.each( settings.banner_obj.slides[0].layers[key].animation, function( k, v ) {
						if( $.isArray(v) ){ 
							settings.banner_obj.slides[0].layers[key].animation[k] = {...v};
						}
					});
				}
			});

			return settings;
		}
	};







	var _dn_edit_bar = {

		// SETTINGS _dn_edit_bar.edit_layer_settings(_obj, settings);
		edit_layer_settings: function(_obj, settings) {
			if( _dn_debug ){ console.log('Layer settings panel'); }
			var _dn_obj = _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).find('._dn_obj');

			// Select COLOR by default
			var mn_type = 'color';
			_obj.find('.edit_panel').find('.settings_options').find('.mn_opt').removeClass('selected');
			_obj.find('.edit_panel').find('.settings_options').find('.mn_opt[data-cat = "color"]').addClass('selected');

			settings_func( mn_type );

			_obj.find('.edit_panel').find('.settings_options').off('click').on('click', '.mn_opt', function(e) {
				_obj.find('.edit_panel').find('.settings_options').find('.mn_opt').removeClass('selected');
				$(this).addClass('selected');

				mn_type = $(this).data('cat');
				if( _dn_debug ){ console.log(mn_type); }
				settings_func( mn_type );
			});


			function settings_func(mn_type)
			{
				if( _dn_debug ){ console.log(mn_type); }

				_obj.find('.edit_panel').find('.settings').find('.mn_box').hide();
				_obj.find('.edit_panel').find('.settings').find('.settings_'+mn_type+'_box').show();

				// Layer obj element BG Color
				if( _dn_obj.hasClass('shape') || _dn_obj.hasClass('element') || _dn_obj.hasClass('text')){
					var item_is_svg = _dn_editor_func.contains_svg(_dn_obj);
					
					if( !item_is_svg){
						var css_key = _dn_obj.hasClass('text') ? 'background' : '';

						// Activate colorpicker
						_obj.find('.settings_color_box').find('.color_box').show();
						_obj.find('.obj_bg_color').coloringPick({
							'picker':$('.obj_bg_color').data('picker'),
							'picker_changeable': $('.obj_bg_color').data('picker_changeable'),
							'theme': 'light',
							'picker_text': 'Color',
							'change': function(val){},
							'on_select': function(color){
								//console.log(color);
								_dn_editor_func.change_object_color(color, css_key, settings);
							},
						});
					}
					else
					{
						// Activate colorpickers
						_obj.find('.settings_panel').find('.color_box').show();
						_obj.find('.settings_panel').find('.obj_color_picker_container').html('');
						var colors = {};
						$.each(_dn_obj.find('svg').find('.colorful'), function(key, val) {
							for(var i = 0; i < 20; i++) { 
								var c = (i+1);
								if($(this).hasClass('c'+c) && typeof colors[i] == 'undefined'){

									var clr = $(this).css('fill') !== 'none' ? $(this).css('fill') : '';
									
									if( clr === ''){
										clr = $(this).attr('fill') ? $(this).attr('fill') : $(this).css('fill');
										if(clr == 'none'){
											clr = $(this).css('stroke') ? $(this).css('stroke') : $(this).attr('stroke');
										}
									}
									
									colors[i] = clr;
									//colors[i] = $(this).attr('fill') ? $(this).attr('fill') : $(this).css('fill');

									_obj.find('.settings_panel').find('.obj_color_picker_container').append('<input type="" class="obj_bg_color_'+c+'" data-picker="solid" value="'+colors[i]+'">');
									_obj.find('.obj_bg_color_'+c).attr('data-picker', 'solid');
									_obj.find('.obj_bg_color_'+c).data('picker', 'solid');
									_obj.find('.obj_bg_color_'+c).attr('data-picker_changeable', false);
									_obj.find('.obj_bg_color_'+c).data('picker_changeable', false);
									
									_obj.find('.obj_bg_color_'+c).coloringPick({
										'picker': _obj.find('.obj_bg_color_'+c).data('picker'),
										'picker_changeable': _obj.find('.obj_bg_color_'+c).data('picker_changeable'),
										'theme': 'light',
										'picker_text': 'Color',
										'change': function(val){},
										'on_select': function(color){
											_dn_editor_func.change_object_color(color, '', settings, 'c'+c);
										},
									});

									
									break;
								}
							}
						});
					}
				}else{
					_obj.find('.settings_panel').find('.color_box').hide();
				}

				
				
				
				// Layer Obj Opacity
				var opacity_value = _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).find('._dn_obj').css('opacity')*100;
				_obj.find('.edit_panel').find('.opacity_box').find('.slider_input_val').val(opacity_value);
				_obj.find('.edit_panel').find('.opacity_box').find('.slider_input_val').on('change', function(){
					opacity_value = $(this).val();
					_obj.find('.edit_panel').find( ".alpha_slider" ).slider({value:opacity_value});
				});

				_obj.find('.edit_panel').find( ".alpha_slider" ).slider({
					value: opacity_value,
					slide: function( event, ui ) {
						_obj.find('.edit_panel').find('.opacity_box').find('.slider_input_val').val(ui.value);
						_dn_editor_func.layer_obj_css({
							'layer': _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).find('._dn_obj'),
							'key': 'opacity',
							'value': (ui.value/100)
						});
					},
					change: function( event, ui ) {
						
						_dn_editor_func.layer_obj_css({
							'layer': _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).find('._dn_obj'),
							'key': 'opacity',
							'value': (ui.value/100),
							'settings': settings
						});
					}
				});

				// Layer Obj Blur
				if( _dn_debug ){
					console.log(settings.current_slide);
					console.log(settings.current_layer);
					console.log( _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).find('._dn_obj').css('filter') );
				}
				var blur_am = _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).find('._dn_obj').css('filter').match(/\((.*)\)/);
				blur_am = parseInt(blur_am[1], 10);
				_obj.find('.edit_panel').find('.blur_box').find('.slider_input_val').val(blur_am);
				_obj.find('.edit_panel').find('.blur_box').find('.slider_input_val').on('change', function(){
					blur_am = $(this).val();
					_obj.find('.edit_panel').find( ".blur_slider" ).slider({value:blur_am});
				});
				
				_obj.find('.edit_panel').find( ".blur_slider" ).slider({
					value: blur_am,
					slide: function( event, ui ) {
						_obj.find('.edit_panel').find('.blur_box').find('.slider_input_val').val(ui.value);
						_dn_editor_func.layer_obj_css({
							'layer': _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).find('._dn_obj'),
							'key': 'filter',
							'value': 'blur('+ui.value+'px)'
						});
					},
					change: function( event, ui ) {
						_dn_editor_func.layer_obj_css({
							'layer': _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).find('._dn_obj'),
							'key': 'filter',
							'value': 'blur('+ui.value+'px)',
							'settings': settings
						});
					}
				});



				// DROP SHADOW Settings
				if( _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).find('._dn_elem').length ){
					_obj.find('.layer_shadow_box').show();
				}else{
					_obj.find('.layer_shadow_box').hide();
				}
				
				if( typeof settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].shadow === 'undefined'){
					settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].shadow = $.extend(
						settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].shadow, 
						{
							'add': false, 
							'horizontal': 0,
							'vertical': 0,
							'blur': 5,
							'spread': 5,
							'color': 'rgba(0,0,0,0.5)',
							'opacity':.5,
							'style': ''
						} 
					);
				}
				var shadow = settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].shadow;

				// Add shadow
				_obj.find('.edit_panel').find('.add_drop_shadow_box').find('.drop_shadow').prop("checked", shadow.add);
				_obj.find('.edit_panel').find('.add_drop_shadow_box').off('click').on('click', '.drop_shadow', function(e) {
					var is_checked = $(this).prop("checked");
					if( _dn_debug ){ console.log(is_checked); }
					var shadow_value = is_checked ? shadow.style+' '+shadow.horizontal+'px '+shadow.vertical+'px '+shadow.blur+'px '+shadow.spread+'px '+shadow.color : 'none';
					settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].shadow = $.extend(settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].shadow, {'add': is_checked,'value':shadow_value} );
					
					_dn_editor_func.layer_obj_elem_css({
						'layer': _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).find('._dn_elem'),
						'key': 'box-shadow',
						'value': shadow_value
					});
				});
				

				// Shadow horizontal
				var horizontal_length = shadow.horizontal;
				_obj.find('.edit_panel').find('.horizontal_length').find('.slider_input_val').val(horizontal_length);
				_obj.find('.edit_panel').find('.horizontal_length').find('.slider_input_val').on('change', function(){
					horizontal_length = $(this).val();
					_obj.find('.edit_panel').find( ".horizontal_length_slider" ).slider({value:horizontal_length});
				});
				
				_obj.find('.edit_panel').find( ".horizontal_length_slider" ).slider({
					value: horizontal_length,
					min: -200,
					max: 200,
					slide: function( event, ui ) {
						_obj.find('.edit_panel').find('.horizontal_length').find('.slider_input_val').val(ui.value);
						var shadow = settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].shadow;
						var shadow_value = shadow.add ? shadow.style+' '+ui.value+'px '+shadow.vertical+'px '+shadow.blur+'px '+shadow.spread+'px '+shadow.color : 'none';
						settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].shadow = $.extend(settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].shadow, {'horizontal': ui.value, 'value': shadow_value} );
						_dn_editor_func.layer_obj_elem_css({
							'layer': _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).find('._dn_elem'),
							'key': 'box-shadow',
							'value': shadow_value
						});
					},
					change: function( event, ui ) {
						var shadow = settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].shadow;
						var shadow_value = shadow.add ? shadow.style+' '+ui.value+'px '+shadow.vertical+'px '+shadow.blur+'px '+shadow.spread+'px '+shadow.color : 'none';
						settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].shadow = $.extend(settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].shadow, {'horizontal': ui.value, 'value': shadow_value} );
						_dn_editor_func.layer_obj_elem_css({
							'layer': _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).find('._dn_elem'),
							'key': 'box-shadow',
							'value': shadow_value
						});
					}
				});

				// Shadow vertical
				var vertical_length = shadow.vertical;
				_obj.find('.edit_panel').find('.vertical_length').find('.slider_input_val').val(vertical_length);
				_obj.find('.edit_panel').find('.vertical_length').find('.slider_input_val').on('change', function(){
					vertical_length = $(this).val();
					_obj.find('.edit_panel').find( ".vertical_length_slider" ).slider({value:vertical_length});
				});
				
				_obj.find('.edit_panel').find( ".vertical_length_slider" ).slider({
					value: vertical_length,
					min: -200,
					max: 200,
					slide: function( event, ui ) {
						_obj.find('.edit_panel').find('.vertical_length').find('.slider_input_val').val(ui.value);
						var shadow = settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].shadow;
						var shadow_value = shadow.add ? shadow.style+' '+shadow.horizontal+'px '+ui.value+'px '+shadow.blur+'px '+shadow.spread+'px '+shadow.color : 'none';
						settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].shadow = $.extend(settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].shadow, {'vertical': ui.value, 'value': shadow_value} );
						_dn_editor_func.layer_obj_elem_css({
							'layer': _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).find('._dn_elem'),
							'key': 'box-shadow',
							'value': shadow_value
						});
					},
					change: function( event, ui ) {
						var shadow = settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].shadow;
						var shadow_value = shadow.add ? shadow.style+' '+shadow.horizontal+'px '+ui.value+'px '+shadow.blur+'px '+shadow.spread+'px '+shadow.color : 'none';
						settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].shadow = $.extend(settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].shadow, {'vertical': ui.value, 'value': shadow_value} );
						_dn_editor_func.layer_obj_elem_css({
							'layer': _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).find('._dn_elem'),
							'key': 'box-shadow',
							'value': shadow_value
						});
					}
				});

				// Shadow blur
				var blur_radius = shadow.blur;
				_obj.find('.edit_panel').find('.blur_radius').find('.slider_input_val').val(blur_radius);
				_obj.find('.edit_panel').find('.blur_radius').find('.slider_input_val').on('change', function(){
					blur_radius = $(this).val();
					_obj.find('.edit_panel').find( ".blur_radius_slider" ).slider({value:blur_radius});
				});
				
				_obj.find('.edit_panel').find( ".blur_radius_slider" ).slider({
					value: blur_radius,
					max: 200,
					slide: function( event, ui ) {
						_obj.find('.edit_panel').find('.blur_radius').find('.slider_input_val').val(ui.value);
						var shadow = settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].shadow;
						var shadow_value = shadow.add ? shadow.style+' '+shadow.horizontal+'px '+shadow.vertical+'px '+ui.value+'px '+shadow.spread+'px '+shadow.color : 'none';
						settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].shadow = $.extend(settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].shadow, {'blur': ui.value, 'value':shadow_value} );
						_dn_editor_func.layer_obj_elem_css({
							'layer': _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).find('._dn_elem'),
							'key': 'box-shadow',
							'value': shadow_value
						});
					},
					change: function( event, ui ) {
						var shadow = settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].shadow;
						var shadow_value = shadow.add ? shadow.style+' '+shadow.horizontal+'px '+shadow.vertical+'px '+ui.value+'px '+shadow.spread+'px '+shadow.color : 'none';
						settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].shadow = $.extend(settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].shadow, {'blur': ui.value, 'value':shadow_value} );
						
						_dn_editor_func.layer_obj_elem_css({
							'layer': _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).find('._dn_elem'),
							'key': 'box-shadow',
							'value': shadow_value
						});
					}
				});

				// Shadow spread
				var spread_radius = shadow.spread;
				_obj.find('.edit_panel').find('.spread_radius').find('.slider_input_val').val(spread_radius);
				_obj.find('.edit_panel').find('.spread_radius').find('.slider_input_val').on('change', function(){
					spread_radius = $(this).val();
					_obj.find('.edit_panel').find( ".spread_radius_slider" ).slider({value:spread_radius});
				});
				
				_obj.find('.edit_panel').find( ".spread_radius_slider" ).slider({
					value: spread_radius,
					max: 200,
					slide: function( event, ui ) {
						_obj.find('.edit_panel').find('.spread_radius').find('.slider_input_val').val(ui.value);
						var shadow = settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].shadow;
						var shadow_value = shadow.add ? shadow.style+' '+shadow.horizontal+'px '+shadow.vertical+'px '+shadow.blur+'px '+ui.value+'px '+shadow.color : 'none';
						settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].shadow = $.extend(settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].shadow, {'spread': ui.value, 'value':shadow_value});
						_dn_editor_func.layer_obj_elem_css({
							'layer': _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).find('._dn_elem'),
							'key': 'box-shadow',
							'value': shadow_value
						});
					},
					change: function( event, ui ) {
						var shadow = settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].shadow;
						var shadow_value = shadow.add ? shadow.style+' '+shadow.horizontal+'px '+shadow.vertical+'px '+shadow.blur+'px '+ui.value+'px '+shadow.color : 'none';
						settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].shadow = $.extend(settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].shadow, {'spread': ui.value, 'value':shadow_value} );
						
						_dn_editor_func.layer_obj_elem_css({
							'layer': _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).find('._dn_elem'),
							'key': 'box-shadow',
							'value': shadow_value
						});
					}
				});

				// Shadow Color picker
				_obj.find('.shadow_color').val(shadow.color);
				_obj.find('.shadow_color').coloringPick({
					'picker':'solid',
					'picker_changeable': false,
					'theme': 'light',
					'picker_text': 'Color',
					'change': function(val){},
					'on_select': function(color){
						//console.log(color);
						var shadow_value = shadow.add ? shadow.style+' '+shadow.horizontal+'px '+shadow.vertical+'px '+shadow.blur+'px '+shadow.spread+'px '+color : 'none';
						settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].shadow = $.extend(settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].shadow, {'color': color, 'value':shadow_value} );
						
						_dn_editor_func.layer_obj_elem_css({
							'layer': _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).find('._dn_elem'),
							'key': 'box-shadow',
							'value': shadow_value
						});
					},
				});

				// Shadow Type
				_dn_editor_func.detroy_selectBox();
				var shadow_style = ''; //_obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).find('._dn_elem').css('border-style');
					
				_obj.find('.edit_panel').find('.shadow_style_options').spr_selectBox({
					'value': shadow_style,
					'options': [
						{'value': '', 'option': 'Outline'},
						{'value': 'inset', 'option': 'Inset'}
					],
					'callback': function(val){
						if( _dn_debug ){ console.log(val); }
						var shadow_value = shadow.add ? val+' '+shadow.horizontal+'px '+shadow.vertical+'px '+shadow.blur+'px '+shadow.spread+'px '+shadow.color : 'none';
						settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].shadow = $.extend(settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].shadow, {'style': val, 'value':shadow_value} );
						
						_dn_editor_func.layer_obj_elem_css({
							'layer': _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).find('._dn_elem'),
							'key': 'box-shadow',
							'value': shadow_value
						});
					}
				});

				



				// SVG STROKE THICKNES (If svg and has strokes)
				var layer = _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer);
				var is_svg = _dn_editor_func.contains_svg( layer.find('._dn_obj'));

				if( is_svg && layer.find("[stroke]").length ){
					_obj.find('.edit_panel').find('.settings').find('.svg_stroke_box').show();
					_obj.find('.settings').find('.svg_stroke_sliders_box').html('');
				
					layer.find("[stroke-width]").each(function(i, item){
						var h = '',
							stroke_width = $(item).attr('stroke-width');
						
						h+= '<div class="set_box svg_stroke_width_box">';
							h+= '<span class="title">Stroke '+(i+1)+' Width</span>';
							h+= '<div class="svg_stroke_width_slider_'+(i+1)+' _dn_ui_slider"></div>';
							h+= '<input class="svg_stroke_width_input_val_'+(i+1)+' slider_input_val" value="'+stroke_width+'" />';
							//h+= '<div class="svg_stroke_width_input_val_'+(i+1)+' slider_input_val">'+stroke_width+'</div>';
						h+= '</div>';

						_obj.find('.svg_stroke_sliders_box').append(h);

						_obj.find('.edit_panel').find('.svg_stroke_width_input_val_'+(i+1)).on('change', function(){
							stroke_width = $(this).val();
							_obj.find('.edit_panel').find( ".svg_stroke_width_slider_"+(i+1) ).slider({value:stroke_width});
						});
						
						_obj.find('.edit_panel').find( ".svg_stroke_width_slider_"+(i+1) ).slider({
							value: stroke_width,
							max:100,
							slide: function( event, ui ) {
								_obj.find('.edit_panel').find('.svg_stroke_width_input_val_'+(i+1)).val(ui.value);
								$(item).attr('stroke-width', ui.value);
								$(item).prop('stroke-width', ui.value);
								//console.log( ui.value );
							},
							change: function( event, ui ) {
								$(item).attr('stroke-width', ui.value);
								$(item).prop('stroke-width', ui.value);
								//console.log( ui.value );
							}
						});
					});
				}
				// end is svg




				// BORDER SETTINGS ( only if object has class ._dn_elem )
				// Radius
				if( _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).find('._dn_elem').length){
					
					var border_radius_value = _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).find('._dn_elem').css('border-radius');
					border_radius_value = parseInt(border_radius_value, 10);
					_obj.find('.edit_panel').find('.border_radius_box').find('.slider_input_val').val(border_radius_value);
					_obj.find('.edit_panel').find('.border_radius_box').find('.slider_input_val').on('change', function(){
						border_radius_value = $(this).val();
						_obj.find('.edit_panel').find( ".border_radius_slider" ).slider({value:border_radius_value});
					});

					_obj.find('.edit_panel').find( ".border_radius_slider" ).slider({
						value: border_radius_value,
						max: 50,
						slide: function( event, ui ) {
							_obj.find('.edit_panel').find('.border_radius_box').find('.slider_input_val').val(ui.value);
							_dn_editor_func.layer_obj_elem_css({
								'layer': _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).find('._dn_elem'),
								'key': 'border-radius',
								'metric': '%',
								'value': ui.value
							});
						},
						change: function( event, ui ) {
							_dn_editor_func.layer_obj_elem_css({
								'layer': _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).find('._dn_elem'),
								'key': 'border-radius',
								'metric': '%',
								'value': ui.value,
								'settings': settings
							});
						}
					});


					// Border color
					_obj.find('.settings_border_box').find('.border_color_box').show();
					_obj.find('.obj_border_color').coloringPick({
						'picker':$('.obj_border_color').data('picker'),
						'picker_changeable': $('.obj_border_color').data('picker_changeable'),
						'theme': 'light',
						'picker_text': 'Color',
						'change': function(val){console.log('border-color')},
						'on_select': function(color){
							_dn_editor_func.change_object_color(color, 'border-color', settings);
						},
					});


					// Border size
					var border_width_value = _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).find('._dn_elem').css('border-width');
					border_width_value = parseInt(border_width_value, 10);
					_obj.find('.edit_panel').find('.border_width_box').find('.slider_input_val').val(border_width_value);
					_obj.find('.edit_panel').find('.border_width_box').find('.slider_input_val').on('change', function(){
						border_width_value = $(this).val();
						_obj.find('.edit_panel').find( ".border_width_slider" ).slider({value:border_width_value});
					});

					_obj.find('.edit_panel').find( ".border_width_slider" ).slider({
						value: border_width_value,
						max: 30,
						slide: function( event, ui ) {
							_obj.find('.edit_panel').find('.border_width_box').find('.slider_input_val').val(ui.value);
							_dn_editor_func.layer_obj_elem_css({
								'layer': _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).find('._dn_elem'),
								'key': 'border-width',
								'value': ui.value
							});
						},
						change: function( event, ui ) {
							_dn_editor_func.layer_obj_elem_css({
								'layer': _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).find('._dn_elem'),
								'key': 'border-width',
								'value': ui.value,
								'settings': settings
							});
						}
					});


					// border style
					//_dn_editor_func.detroy_selectBox(); // @since v1.1.9 moved this up to shadow type selectbox
					var border_style = _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).find('._dn_elem').css('border-style');
					//console.log(border_style);
					_dn_editor_func.layer_obj_elem_css({
						'layer': _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).find('._dn_elem'),
						'key': 'border-style',
						'metric': '',
						'value': border_style,
						'settings': settings
					});
					
					_obj.find('.edit_panel').find('.border_style_options').spr_selectBox({
						'value': border_style,
						'options': [
							{'value': '', 'option': 'None'},
							{'value': 'solid', 'option': 'Solid'},
							{'value': 'dotted', 'option': 'Dotted' },
							{'value': 'dashed', 'option': 'Dashed' },
							{'value': 'double', 'option': 'Double' },
							{'value': 'groove', 'option': 'Groove' },
							{'value': 'ridge', 'option': 'Ridge' },
							{'value': 'inset', 'option': 'Inset' },
							{'value': 'outset', 'option': 'Outset' }
						],
						'callback': function(val){
							if( _dn_debug ){ console.log(val); }

							_dn_editor_func.layer_obj_elem_css({
								'layer': _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).find('._dn_elem'),
								'key': 'border-style',
								'metric': '',
								'value': val,
								'settings': settings
							});
						}
					});

				}
				// end if obj has class ._dn_elem

				


				// SIZE SETTINGS
				_obj.find('.edit_panel').find('.settings_size_box').find('._set_width').val(parseInt(_dn_obj.css('width'), 10));

				if( !_dn_obj.hasClass('text') ){ // && !_dn_obj.hasClass('image')
					_obj.find('.edit_panel').find('.settings_size_box').find('._set_height').prop('readonly', false).css({'opacity': 1});
					_obj.find('.edit_panel').find('.settings_size_box').find('._set_height').val(parseInt(_dn_obj.css('height'), 10));

					/*if(_dn_obj.hasClass('image')){
						var img_h = _dn_obj.find('img').height();
						_obj.find('.edit_panel').find('.settings_size_box').find('._set_height').val( img_h );
						_obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).height( img_h );
					}*/
				}else{
					_obj.find('.edit_panel').find('.settings_size_box').find('._set_height').val('auto');
					_obj.find('.edit_panel').find('.settings_size_box').find('._set_height').prop('readonly', true).css({'opacity': .4});
				}
				// Position data gets set imediatly when layer gets selected. If we dont do it there jQuery .position() returns 0

				_obj.find('.edit_panel').find('.settings_size_box').find('._set_inpt').on('change', function(){
					var prop = $(this).data('prop'),
						val = $(this).val(),
						css = {};

					_dn_editor_func.layer_css({
						'layer': _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer),
						'key': prop,
						'value': val,
						'settings': settings
					});
				});



				// CSS SETTINGS
				if( mn_type === 'css' && _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).find('._dn_elem').length){
					
					var element_params = new _dn_Element_Params(_obj, settings, {'cat': 'settings_css_box', 'debug':_dn_debug});
					element_params.elm_params_setup();


					var element_arr = settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].css.element;
					if( typeof element_arr === 'undefined'){ element_arr = {}; }
					if( typeof element_arr.custom === 'undefined'){ element_arr.custom = {'class': '','id': ''}; }
					
					_obj.find('.edit_panel').find('.settings_css_box').find('._set_class').val( element_arr.custom.class );
					_obj.find('.edit_panel').find('.settings_css_box').find('._set_id').val( element_arr.custom.id );
					_obj.find('.edit_panel').find('.settings_css_box').find('._set_style').val( element_arr.custom.style );

					_obj.find('.edit_panel').find('.settings_css_box').find('._set_inpt').on('change', function(){
						var prop = $(this).data('prop'),
							val = $(this).val(),
							arr = {};
						
						arr[prop] = val;

						_dn_editor_func.layer_obj_elem_css({
							'layer': _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).find('._dn_elem'),
							'key': 'custom',
							'value': arr,
							'settings': settings
						});
					});
				}

			}
			// end settings_func
		}

	};







	/**
	 * SELECT ALL TEXT in Element
	*/
	$.fn.selectText = function(){
	    var doc = document;
	    var element = this[0];
	    if( _dn_debug ){ console.log(this, element); }
	    if (doc.body.createTextRange) {
	        var range = document.body.createTextRange();
	        range.moveToElementText(element);
	        range.select();
	    } else if (window.getSelection) {
	        var selection = window.getSelection();        
	        var range = document.createRange();
	        range.selectNodeContents(element);
	        selection.removeAllRanges();
	        selection.addRange(range);
	    }
	};











	/** ##################################################################################
	 * BANNER EDITOR
	*/
	$.fn._dn_banner_editor = function(options){
		
		if( _dn_debug ){ console.log(options); }
	  	// Defaults
		var settings = $.extend({
			'id': 0,
			'user_id': 0,
			'banner_obj': {},
			'current_slide': 0,
			'current_layer': 0,
			'page': {},
			'upload_dir': '',
			'upload': {},
			'tinymce' : 0,
			'destroy': false,
			'callback': null
		}, options );

		settings.page = $.extend({
			'title': '2. Create Banner',
		}, settings.page );

	  
	 	return this.each(function(i,el){
	 		var _obj = $(el),
				html = '';
			
			if( typeof settings.banner_obj.id !== 'undefined' ){
				settings.id = settings.banner_obj.id;
			}
			if( typeof settings.banner_obj.responsive === 'undefined' ){
				settings.banner_obj.responsive = 1;
			}
			if( typeof settings.banner_obj.align === 'undefined' ){
				settings.banner_obj.align = 'center';
			}
			
			// Add user id to banner_obj
			if( typeof settings.banner_obj.user_id === 'undefined' ){
				settings.banner_obj.user_id = settings.user_id;
			}	
			
			if( _dn_debug ){ console.log(settings); }
			
			
			 
			if( settings.destroy ){
				$(document).off('click.deselect_layers');
				$(document).off('keydown');
				_obj.find('._dnMyImages').off('click');
				_obj.find(".my_images").off('click', '.edit');
				_obj.off().removeData();
				return;
			}

	 		// Load external styles (if nessecery)
	 		if( typeof settings.banner_obj.external !== 'undefined' ){
		 		if( typeof settings.banner_obj.external.styles !== 'undefined' ){
		 			$.each( settings.banner_obj.external.styles, function( key, val ) {
		 				if ($("link[href*='" + val.font + "']").length === 0){
						     $('link:last').after('<link href="' + val.url + '" rel="stylesheet" type="text/css">');
					    }
		 			});
		 		}
			}


			// Activate editor menu buttons
			$('._dn_menu').find('.menu_tab.editor').show();
			_dn_bc._imc_menu_actions(_obj);
			

	 		// Wait for page to be loaded
			_dn_editor_func.onReady(function (){
				if( _dn_debug ){ console.log('PAGE IS LOADED') };
				$('#_dn_EditorLoader').hide();
				//$('#_dn_EditorContainer').css('visibility', 'visible');
			});
			

			// UNDO button actions
			_obj.find('._dn_undo').off('click').on('click', function(){
				if (typeof _dn_undo !== 'undefined' && _dn_undo.length > 0) {
					if( _dn_debug ){ console.log('reset undo template'); }
					var last_key = _dn_undo.length-1;
					
					$.ajax({
						type: "POST",
						url: _dn_.ajaxurl,
						data: {
							"action": "load_banner",
							"id": settings.id,
							"banner_obj": JSON.stringify(_dn_undo[last_key]),
							"debug":_dn_debug
						}
					}).done(function( msg ) {
						var arr = JSON.parse(msg);

						//delete _dn_undo[last_key];
						var last_undo_value = _dn_undo.pop();
						var tmp_obj = $.extend(true, {}, settings.banner_obj);
						_dn_editor_func.set_undo_redo(tmp_obj, 'redo');

						if (typeof _dn_undo == 'undefined' || _dn_undo.length <= 0) {
							_obj.find('._dn_undo').removeClass('active');
						}

						settings.banner_obj = arr.banner_obj;
						settings.template = arr.template;
						settings.timeline = arr.timeline;
		
						_dn_editor_func.load_banner(arr, settings, _obj);
					});
				}
			});

			// REDO button actions
			_obj.find('._dn_redo').off('click').on('click', function(){
				if (typeof _dn_redo !== 'undefined' && _dn_redo.length > 0) {
					if( _dn_debug ){ console.log('reset redo template'); }
					var last_key = _dn_redo.length-1;
					if( _dn_debug ){ console.log(_dn_redo[last_key]); }

					$.ajax({
						type: "POST",
						url: _dn_.ajaxurl,
						data: {
							"action": "load_banner",
							"id": settings.id,
							"banner_obj": JSON.stringify(_dn_redo[last_key]),
							"debug":_dn_debug
						}
					}).done(function( msg ) {
						var arr = JSON.parse(msg);

						//delete _dn_undo[last_key];
						var last_redo_value = _dn_redo.pop();
						var tmp_obj = $.extend(true, {}, settings.banner_obj);
						_dn_editor_func.set_undo_redo(tmp_obj, 'undo');

						if (typeof _dn_redo == 'undefined' || _dn_redo.length <= 0) {
							_obj.find('._dn_redo').removeClass('active');
						}

						settings.banner_obj = arr.banner_obj;
						settings.template = arr.template;
						settings.timeline = arr.timeline;
		
						_dn_editor_func.load_banner(arr, settings, _obj);
					});
				}
			});



			
			// Image Uploads
			_obj.find('._dn_add_image_from_url').on('change', function(){
				var url = $(this).val(),
					h = '';

				if( ImgMCE_global.is_url( url ) ){
					h+= '<div class="grid-item" data-src="'+url+'" data-use="src"><img src="'+url+'" /><div class="info_btn" data-info="'+ImgMCE_global.basename(url)+'"><svg viewBox="0 0 448 512" style="height:18px;border-radius:2px;"><path fill="currentColor" d="M400 32H48C21.49 32 0 53.49 0 80v352c0 26.51 21.49 48 48 48h352c26.51 0 48-21.49 48-48V80c0-26.51-21.49-48-48-48zm-176 86c23.196 0 42 18.804 42 42s-18.804 42-42 42-42-18.804-42-42 18.804-42 42-42zm56 254c0 6.627-5.373 12-12 12h-88c-6.627 0-12-5.373-12-12v-24c0-6.627 5.373-12 12-12h12v-64h-12c-6.627 0-12-5.373-12-12v-24c0-6.627 5.373-12 12-12h64c6.627 0 12 5.373 12 12v100h12c6.627 0 12 5.373 12 12v24z"></path></svg></div></div>';
					_obj.find('#upload_result').prepend(h);
					_dn_editor_func.image_upload_result_container(_obj, $('#upload_result'), settings);
				}
			});

			if( typeof(settings.editor.upload.dir) !== 'undefined'){
				var folder_structure = settings.editor.upload.structure.replace('{DIR}/', '');
				var upload_folder = ImgMCE_global.create_url_from_structure(folder_structure, {
					'id': settings.id,
					'uid': settings.user_id,
					'dir': settings.editor.upload.dir,
					'folder': settings.editor.upload.folder
				});
				
				if( _dn_debug ){ console.log(upload_folder); console.log(settings.editor.upload.folder); }

				_obj.find('.box')._dn_file_uploader({
					'banner_id':settings.id, 
					'user_id': settings.user_id, 
					'result_grid': $('#upload_result'),
					'max_upload_size': settings.editor.image.upload_size,
					'upload': {
						'folder': upload_folder+'images/',
						'dir': settings.editor.upload.dir,
						'src' : settings.editor.upload.src
					},
					'allowed_file_types': settings.editor.image.upload_file_types,
					'text': {
						'upload_info': 'Max. size '+settings.editor.image.upload_size+' MB. '+_dn_bc.allowed_upload_file_types(settings.editor.image.upload_file_types)+' only.',
					},
					'callback': function(src){
						_dn_editor_func.image_upload_result_container(_obj, $('#upload_result'), settings);
					}
				});
			}
			
			_obj.find("#_dn_zoom").slider({
            	value: 100,
            	max: 200,
            	min: 20,
            	step:10,
            	slide: function(event, ui) {
					stage_scale = ui.value/100;
					$(this).data('val', ui.value);
					$(this).attr('data-val', ui.value);
					$( ".stage" ).css({"transform": "translate(0px, 0px) scale("+stage_scale+")"});
                	window.dispatchEvent(new Event("resize"));
				},
				change: function(event, ui){
					stage_scale = ui.value/100;
					$(this).data('val', ui.value);
					$(this).attr('data-val', ui.value);
					$( ".stage" ).css({"transform": "translate(0px, 0px) scale("+stage_scale+")"});
                	window.dispatchEvent(new Event("resize"));
				}
        	});

			// Backgound color pickers
			//settings.banner_obj.css = $.extend(settings.banner_obj.css, {'background': ''} );
			$('.banner_bg_color').val(settings.banner_obj.css.background);
			$('.bg_color_palets').find('.current').css('background', settings.banner_obj.css.background);
			$('.bg_color_palets').find('.current').attr('data-color', settings.banner_obj.css.background);

			$('.banner_bg_color').each(function(i,p){
				$(p).coloringPick({
					'picker':$(p).data('picker'),
					'theme': 'light',
					'picker_text': '<svg viewBox="0 0 448 512" style="height:20px;width:20px;color:#ffffff;"><path fill="#FFF" d="M436 238H242V44c0-6.6-5.4-12-12-12h-12c-6.6 0-12 5.4-12 12v194H12c-6.6 0-12 5.4-12 12v12c0 6.6 5.4 12 12 12h194v194c0 6.6 5.4 12 12 12h12c6.6 0 12-5.4 12-12V274h194c6.6 0 12-5.4 12-12v-12c0-6.6-5.4-12-12-12z"></path></svg>',
					'change': function(val){
						$('.bg_color_palets').find('.current').css('background', val);
					},
					'on_select': function(color){
						settings.banner_obj.css = $.extend(settings.banner_obj.css, {'background': color} );
						$('.editor_stage_container').find('._dn_cont').css({'background': color});

						$('.bg_color_palets').find('.current').css('background', color);
						$('.bg_color_palets').find('.current').attr('data-color', color);
						$('.bg_color_palets').find('.current').data('color', color);
						got_saved = 0;
					},
				});
			});

			// Background color presets
			_obj.find('.bg_palet').off('click').on('click', function(){
				var color = $(this).data('color');
				if( _dn_debug ){ console.log(color); }
				var key = color == 'transparent' ? 'background-color' : 'background';
				if( color == 'transparent' ){
					_obj.find('.editor_stage_container').find('._dn_cont').addClass('transparent');
				}else{
					_obj.find('.editor_stage_container').find('._dn_cont').removeClass('transparent');
				}
				settings.banner_obj.css = $.extend(settings.banner_obj.css, {'background': color} );
				_obj.find('.editor_stage_container').find('._dn_cont').css(key, color);
				got_saved = 0;
			});

			// Background sizing
			_obj.find('.main_settings_option_box').find('._set_bg_width').val(settings.banner_obj.size.w);
			_obj.find('.main_settings_option_box').find('._set_bg_height').val(settings.banner_obj.size.h);
			_obj.find('.main_settings_option_box').on('change', '._set_inpt', function(){
				var w = _obj.find('.main_settings_option_box').find('._set_bg_width').val(),
					h = _obj.find('.main_settings_option_box').find('._set_bg_height').val();
				
				settings.banner_obj.size = {'full':w+'x'+h, 'w':w, 'h':h};
				_obj.find('.banner_element').find('._dn_cont').css({width:w,height:h});
				_obj.find('.banner_element').find('._dn_cont').attr("size", w+'x'+h);
				_obj.find('.banner_element').find('._dn_cont').data('size', w+'x'+h);
				_obj.find('.banner_element').find('._dn_cont').find('._dn_inner').css({width:w,height:h});
				console.log('NEW SIZE:');
				console.log(settings.banner_obj.size);
			});

			// Image align
			console.log(settings.banner_obj.align);
			//_obj.find('.main_settings_option_box').find('._dn_image_align option:eq('+settings.banner_obj.align+')').prop("selected", true);
			_obj.find('.main_settings_option_box').find('._dn_image_align option[value="'+settings.banner_obj.align+'"]').attr('selected', 'selected');
			_obj.find('.main_settings_option_box').on('change', '._dn_image_align', function(){
				var align = $(this).val();
				settings.banner_obj.align = align;
			});


			// Loop Element
			_obj.find('.main_settings_option_box').find('.loop_element').prop("checked", settings.banner_obj.loop_element);
			_obj.find('.loop_element').off('click').on('click', function(e){
				settings.banner_obj.loop_element = $(this).prop('checked');
			});
	
			// Is Full width (fw)
			_obj.find('.main_settings_option_box').find('.img_is_fullwidth').prop("checked", settings.banner_obj.size.fw);
			_obj.find('.img_is_fullwidth').off('click').on('click', function(e){
				settings.banner_obj.size.fw = $(this).prop('checked');
				
				if( settings.banner_obj.size.fw ){
					_dn_editor_func.adjust_full_width_size(_obj);
				}else{
					_obj.find('._set_bg_width').css({'opacity':1});
					_obj.find('._set_bg_width').prop('disabled', false);
					_obj.find('.editor_stage_container').find('._dn_cont').css({'width': settings.banner_obj.size.w});
					_obj.find('.editor_stage_container').find('._dn_cont').find('._dn_inner').css({'width':settings.banner_obj.size.w});
				}
			});

			// Is responsive
			_obj.find('.main_settings_option_box').find('.img_is_responsive').prop("checked", settings.banner_obj.responsive);
			_obj.off('click').on('click', '.img_is_responsive', function(e){
				settings.banner_obj.responsive = $(this).prop('checked');
				if( settings.banner_obj.responsive ){
					$('.editor_stage_container').find('._dn_cont').addClass('responsive');
				}else{
					$('.editor_stage_container').find('._dn_cont').removeClass('responsive');
				}
			});
			


	 		// Reset main page style
	 		$('._dn_menu').removeClass('select_size');
			_obj.show();
			_obj._dn_update_page_color({'color':_obj.data('bg')});

	 		// Menu
	 		$('._dn_menu').addClass('editor');
	 		$('._dn_menu').find('.menu_tab').removeClass('selected');
	 		$('._dn_menu').find('.bc_editor').show().addClass('selected');


	 		// Banner is Saved check.
	 		_dn_editor_func.check_banner_saved({
	 			'unload': function(){
	 				// Remove banner if draft.
					$.ajax({
						type: "POST",
						url: _dn_.ajaxurl,
						async: false,
						data: {
							"action": "check_banner_draft",
							"id": settings.id
						}
					}).done(function( msg ){});
	 			}
	 		});

			 if( _dn_debug ){ console.log(settings.banner_obj); }

	 		// LOAD banner template
			$.ajax({
				type: "POST",
				url: _dn_.ajaxurl,
				data: {
					"action": "load_banner",
					"id": settings.id,
					"slide": 0, // testing
					"banner_obj": JSON.stringify(settings.banner_obj), //settings.banner_obj
					"debug":_dn_debug
				}
			}).done(function( msg ) {
				var arr = JSON.parse(msg);
				if( _dn_debug ){ console.log(arr); }

				_dn_editor_func.load_banner(arr, settings, _obj);
			});


			// Deselect layers
			$(document).on('click.deselect_layers', function(e){  
				if ( !$(e.target).hasClass("_dn_layer") && 
					!$(e.target).parents('._dn_layer').length &&
					!$(e.target).hasClass("layer") && 
					!$(e.target).parents('.layer').length &&
					!$(e.target).hasClass("timeline_animation_popup") && 
					!$(e.target).parents('.timeline_animation_popup').length &&
					!$(e.target).hasClass("timeline_layers_sortable") && 
					!$(e.target).parents(".timeline_layers_sortable").length && 
					!$(e.target).hasClass("timeline_layer_animation_container") && 
					!$(e.target).parents(".timeline_layer_animation_container").length && 
					!$(e.target).hasClass("edit_tool_btn") &&
					!$(e.target).parents('.edit_tool_btn').length &&
					!$(e.target).hasClass("edit_panel") &&
					!$(e.target).parents(".edit_panel").length &&
					!$(e.target).hasClass("_close_colpicker") &&
					!$(e.target).parents("._close_colpicker").length &&
					!$('body').hasClass('coloringPickOpen')
				){
					if( _dn_debug ){ console.log('deselect layers - $(document)'); console.log(settings); };
					_dn_editor_func.deselect_items(_obj, settings);
				}
			});


			// Select layer
			_obj.find('.banner_element').off('click').on('click', '._dn_layer', function(e) {
				_dn_editor_func.select_layer($(this), settings, _obj);
			});





			// ##
	 		// Toolbar Actions
	 		_obj.find('.tool_btn').off('click').on('click', function(){
	 			_obj.find('.tool_btn').removeClass('selected');
				$(this).addClass('selected');

	 			if( !_obj.find('.bc_editor_settings').hasClass('opened')){
	 				_obj.find('.toolbar_holder').css({'width':344});
	 				_obj.find('.bc_editor_settings').css({'opacity':1,'z-index':1}).css({'margin-left':0}).addClass('opened');
	 				_dn_bc.trigger_resize();
				 }
				 

	 			var option = $(this).data('option');
	 			_obj.find('.bc_editor_settings').find('.setting').hide();
				_obj.find('.bc_editor_settings').find('.'+option+'_settings').show();

				if( _dn_debug ){ console.log(settings.editor); };

				// LOAD TEMPLATES
				if( option == 'templates'){
					$.ajax({
						type: "POST",
						url: _dn_.ajaxurl,
						data: {
							"action": "editor_load_templates",
							"editor": JSON.stringify(settings.editor),
							"banner_obj": JSON.stringify(settings.banner_obj)
						}
					}).done(function( msg ) {
						var arr = JSON.parse(msg);
						if( _dn_debug ){ console.log(arr); }
						_obj.find('._dn_templates_holder').html(arr.html);
					});

					// Template actions
					_obj.off('click').on('click', '._dn_tpl_item', function(e) {
						var data = $(this).data('tpl_id');
						if( _dn_debug ){ console.log( data ); }
						if( data == '_dn_tpl_save'){
							if( _dn_debug ){ console.log('save as template'); }
							console.log( JSON.stringify(settings.banner_obj) );

							var tpl_set = $.extend(true,{}, settings),
								banner_title = _obj.closest('.imgmce_editor').find("._dn_banner_title").val(),
								new_id = _dn_bc._imc_id_generator( settings.editor.user_id );

							tpl_set.editor.upload = $.extend(tpl_set.editor.upload, {
								"structure": "{DIR}/{FOLDER}/{ID}",
								"folder": "resources/templates/",
							});

							$.ajax({
								type: "POST",
								url: _dn_.ajaxurl,
								data: {
									"action": "_dn_save_banner",
									"new_id": new_id,
									"title": banner_title,
									"editor": JSON.stringify(tpl_set.editor),
									"banner_obj": JSON.stringify(tpl_set.banner_obj)
								}
							}).done(function( msg ) {
								var arr = JSON.parse(msg);

								var ratio = arr.banner_obj['size']['w'] / arr.banner_obj['size']['h'];
								var new_height = ratio >= 1 ? 120/ratio : 120;
								var new_width = ratio >= 1 ? 120 : (120/ratio)/10;

								// Fix for low rectangles (leaderboards).
								new_width = new_height < 50 ? 250 : new_width;
								new_height = new_height < 50 ? 250/ratio : new_height;
								
								var h = '';
								h+= '<div class="_dn_tpl_item" style="width:'+new_width+'px;height:'+new_height+'px;" data-tpl_id="'+arr.banner_obj.id+'">';
									h+= arr.banner_template;
								h+= '</div>';
								_obj.find('._dn_templates_holder').append(h);
			
								if( _dn_debug ){
									console.log('Banner Saved as Template');
									console.log(arr);
								}
							});
			
						}else{
							var new_id = _dn_bc._imc_id_generator( settings.editor.user_id );
							$.ajax({
								type: "POST",
								url: _dn_.ajaxurl,
								data: {
									"action": "load_template",
									"id": $(this).data('tpl_id'),
									"new_id": new_id,
									"editor": JSON.stringify(settings.editor)
								}
							}).done(function( msg ){
								var arr = JSON.parse(msg);

								if( _dn_debug ){ console.log(arr); }

								if( typeof(arr.error) === 'undefined'){
									settings.banner_obj = arr.banner_obj;
									settings.id = settings.banner_obj.id;
									settings.template = arr.template;
									settings.timeline = arr.timeline;

									if( _dn_debug ){ console.log(settings); }

									_dn_editor_func.load_banner(arr, settings, _obj);
								}
							});
						}
					});
					
				}
				// end if template
			 });
			 
	 		_obj.find('.bc_editor_settings').find('.close_settings').off('click').on('click', function(){
				_dn_editor_func.close_editor_settings(_obj);	
			});
			 

			





	 		// ##
	 		// Timeline Actions
	 		_obj.find('.timeline_holder').find('.close_timeline').off('click').on('click', function(){
	 			_obj.find('.timeline_holder').toggleClass('closed');
	 			if(_obj.find('.timeline_holder').hasClass('closed')){
	 				_obj.find('.timeline_holder').find('.close_ico').html('<svg aria-hidden="true" data-fa-processed="" data-prefix="fal" data-icon="angle-left" role="img" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 192 512" class="svg-inline--fa fa-angle-left fa-w-6" style="height:20px;font-size: 48px;"><path fill="currentColor" d="M25.1 247.5l117.8-116c4.7-4.7 12.3-4.7 17 0l7.1 7.1c4.7 4.7 4.7 12.3 0 17L64.7 256l102.2 100.4c4.7 4.7 4.7 12.3 0 17l-7.1 7.1c-4.7 4.7-12.3 4.7-17 0L25 264.5c-4.6-4.7-4.6-12.3.1-17z" class=""></path></svg>');
	 			}else{
	 				_obj.find('.timeline_holder').find('.close_ico').html('<svg aria-hidden="true" data-fa-processed="" data-prefix="fal" data-icon="angle-right" role="img" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 192 512" class="svg-inline--fa fa-angle-right fa-w-6" style="font-size:48px;height:20px;"><path fill="currentColor" d="M166.9 264.5l-117.8 116c-4.7 4.7-12.3 4.7-17 0l-7.1-7.1c-4.7-4.7-4.7-12.3 0-17L127.3 256 25.1 155.6c-4.7-4.7-4.7-12.3 0-17l7.1-7.1c4.7-4.7 12.3-4.7 17 0l117.8 116c4.6 4.7 4.6 12.3-.1 17z" class=""></path></svg>');
	 			}
	 		});
			
			// Select layer from timeline
	 		_obj.find('.slides_and_layers_box').off('click').on('click', '.layer', function(e){
				var _layer = $(this);
				// If layer is not yet selected
				if( !_layer.hasClass('selected')){
					_dn_editor_func.deselect_items(_obj, settings);
					_dn_editor_func.select_layer(_obj.find('.banner_element').find('._dn_layer[data-nr = '+_layer.data('nr')+']'), settings, _obj);
				}
	 		});

	 		_obj.find('.slides_and_layers_box').on('click', '.icon', function(){
				if( _dn_debug ){ console.log('drag'); }
	 		});





	 		// ##
			// Edit Bar Actions 
			_obj.find('.editor_stage_menu').find('.edit_tool_btn').off('click').on('click', function(){

	 			if( !$(this).hasClass('drag_position') && !$(this).hasClass('duplicate')){
					_obj.find('.edit_bar_container').addClass('open');
					_obj.find('.edit_panel').find('.panel_box').removeClass('visible');
					_obj.find('.edit_panel').addClass('visible');
					_obj.find('.edit_panel').find('.header').html( $('.'+$(this).data('panel')+'_panel').data('header') );
				}	

				_obj.find('.edit_tool_btn').removeClass('selected');
				$(this).addClass('selected');

				// Show the selected panel
				var selected_panel = $(this).data('panel');
				_obj.find('.edit_panel').find('.'+selected_panel+'_panel').addClass('visible');	 		

	 			// Settings
	 			if($(this).hasClass('settings')){
					
					_dn_edit_bar.edit_layer_settings(_obj, settings);
	 			}


	 			// Filters
	 			else if($(this).hasClass('filters')){
					if( _dn_debug ){ console.log('Filters panel'); }
					 
					var _dn_obj = _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).find('._dn_obj'),
						_dn_layer = _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer),
						_dn_filter = _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).find('.layer_filter');

					if( _dn_debug ){ console.log( _dn_layer ); }
					
					// Add content to filter previews
					_obj.find('.filters_panel').find('.filter_content').html( _dn_obj.html() );

					_obj.find('.edit_panel').find( ".filter" ).off('click').on('click', function(){
						var filter = $(this).data('filter'),
							layer_filter = $(this).data('layer-filter');

						//_dn_layer.attr("style", 'filter:'+layer_filter);
						_dn_layer.css({"filter": layer_filter});

						_dn_filter.removeClass (function (index, className) {
							return (className.match (/(^|\s)_dnfilter_\S+/g) || []).join(' ');
						});

						if( filter !== '' ){
							_dn_filter.addClass('_dnfilter'+filter);
						}	

						_dn_editor_func.layer_filter_css({
							'layer': _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer),
							'key': 'filter',
							'value': layer_filter,
							'filter': filter,
							'settings': settings
						});

					});
	 				
	 			}


				

				// Effects
				else if($(this).hasClass('effects')){
					if( _dn_debug ){ console.log('Effects panel'); }

					var effect_plugins = new _dn_Plugins(_obj, settings, {'cat': 'effects_panel', 'debug':_dn_debug});
					effect_plugins.plugin_setup();
				}



	 			// TEXT
	 			else if($(this).hasClass('text')){
					if( _dn_debug ){ console.log('text panel'); }

					_dn_editor_func.detroy_selectBox();

					var _dn_obj = _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).find('._dn_text');
					if( typeof settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].text == 'undefined' ){
						settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].text = encodeURIComponent(_dn_obj.html());
					}
					var layer_text = _dn_bc.urldecode(settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].text);

					// Textarea
					_obj.find('.edit_panel').find('.text_panel').find('.text_content').val(layer_text);
					_obj.find('.edit_panel').find('.text_panel').find('.text_content').off('change').on('change', function(){
						var value = $(this).val();
						console.log(_dn_obj);
						_dn_obj.html(value);
						settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].text = encodeURIComponent(value);
					});
					 
					// Font color
					_obj.find('.text_panel').find('.color_box').show();
					_obj.find('.obj_font_color').coloringPick({
						'picker':$('.obj_font_color').data('picker'),
						'picker_changeable': $('.obj_font_color').data('picker_changeable'),
						'theme': 'light',
						'picker_text': 'Color',
						'change': function(val){console.log(val);},
						'on_select': function(color){
							console.log(color);
							_dn_editor_func.change_object_color(color, 'color', settings);
						},
					});

	 				// Text align
	 				// First get current element text-align value.
	 				_obj.find('.edit_panel').find('.text_panel').find('.text_align').removeClass('selected');
	 				var align = _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).find('._dn_text').css('text-align');
	 				_obj.find('.edit_panel').find('.text_panel').find('.text_align[data-align = "'+align+'"]').addClass('selected');

	 				_obj.find('.edit_panel').find('.text_panel').off('click').on('click', '.text_align', function(){
						if( _dn_debug ){ console.log( $(this).data('align')); }
						_obj.find('.edit_panel').find('.text_panel').find('.text_align').removeClass('selected');
	 					$(this).addClass('selected');

	 					_dn_editor_func.layer_obj_css({
							'layer': _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).find('._dn_text'),
							'key': 'text-align',
							'value': $(this).data('align'),
							'settings': settings
						});
	 				});

	 				// Text font-size
	 				var font_size = _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).find('._dn_text').css('font-size').split('px')[0];
					_obj.find('.edit_panel').find('.font_size_box').find('.slider_input_val').val(font_size);
					_obj.find('.edit_panel').find('.font_size_box').find('.slider_input_val').on('change', function(){
						font_size = $(this).val();
						_obj.find('.edit_panel').find( ".font_size_slider" ).slider({value:font_size});
					});

					_obj.find('.edit_panel').find( ".font_size_slider" ).slider({
						value: font_size,
						max: 300,
    					slide: function( event, ui ) {
    						_obj.find('.edit_panel').find('.font_size_box').find('.slider_input_val').val(ui.value);
    						_dn_editor_func.layer_obj_css({
    							'layer': _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).find('._dn_text'),
    							'key': 'font-size',
    							'value': ui.value
    						});
    					},
    					change: function( event, ui ) {
    						
    						_dn_editor_func.layer_obj_css({
    							'layer': _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).find('._dn_text'),
    							'key': 'font-size',
    							'value': ui.value,
    							'settings': settings
    						});
    					}
    				});

    				// Font weight
    				var font_weight = _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).find('._dn_text').css('font-weight');

    				_obj.find('.edit_panel').find('.font_weight_selector').spr_selectBox({
    					'value': font_weight,
						'options': [
							{'value': '100', 'option': 'Light'},
							{'value': '400', 'option': 'Normal'},
							{'value': '800', 'option': 'Bold' }
						],
						'callback': function(val){
							if( _dn_debug ){ console.log(val); }
							_dn_editor_func.layer_obj_css({
    							'layer': _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).find('._dn_text'),
    							'key': 'font-weight',
    							'value': val,
    							'settings': settings
    						});
						}
					});


					// FONT FAMILY - Google Fonts
					_obj.find('.edit_panel').find('.font_family_selector')._dn_fontselect({
					//_obj.find('.edit_panel').find('.font_family_selector')._dn_google_fonts({
						'fonts': _dn_.assets_url+'fonts/google-fonts/fonts.json',
						'value': _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).find('._dn_text').css('font-family'),
						'callback': function(font, url){
					
							_dn_editor_func.layer_obj_css({
    							'layer': _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).find('._dn_text'),
    							'key': 'font-family',
    							'value': font['font-family'],
    							'settings': settings
    						});

							if( typeof settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].plugins == 'undefined' ){
								settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].plugins = {'google_font':{}};
							}

							var font_fam_no_space = font['font-family'].replace(/ /g,"-");

							settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].plugins['google_font'] = {
								'external': {'css': [url] },
								'font': font['font-family']
							};
							
							if( _dn_debug ){ console.log( settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].plugins ); }
						}
					});


					// RENDER HTML
					var is_checked = settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].render_html;
					_obj.find('.render_html_switch').prop('checked', is_checked);

					_obj.off('click').on('click', '.render_html_switch', function(e) {
					//$('.render_html_switch').on('change', function(){
						if($(this).prop('checked') == true) {
					        if( _dn_debug ){ console.log("Checked Box Selected"); }
					        $(this).val(1);
					        $(this).attr('value', 1);
					        settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].render_html = 1;
					        var content = _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).find('._dn_text').html();
					        // Decode content
					        var new_content = $('<div />').html(content).text();
					        _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).find('._dn_text').html(new_content);
					        new_content = _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).find('._dn_obj').html();
					        settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].content = new_content;
					        if( _dn_debug ){ console.log(settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].content); }
					    } else {
					        if( _dn_debug ){ console.log("Checked Box deselect"); }
					        $(this).val(0);
					        $(this).attr('value', 0);
					        settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].render_html = 0;
					        var content = _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).find('._dn_text').html();
					        // Encode content
					        var new_content = $('<div />').text(content).html();
					        _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).find('._dn_text').html(new_content);
					        new_content = _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).find('._dn_obj').html();
					        settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].content = new_content;
					        if( _dn_debug ){ console.log(settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].content); }
					    }
					    got_saved = 0;
					});
	 			}


	 			// ACTIONS
	 			else if($(this).hasClass('actions')){

	 				var actions = settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].actions;
	 				var click_action = typeof actions !== 'undefined' ? actions.click_action : '';
	 				if( _dn_debug ){ console.log(click_action); }

	 				_dn_editor_func.detroy_selectBox();

	 				if( typeof click_action !== 'undefined' && click_action !== ''){

						_obj.find('.click_action_result').find('.click_action_option').hide();
						_obj.find('.click_action_result').find('.'+click_action).show();

						if( click_action == 'gotourl' ){
							_obj.find('.edit_panel').find('.gotourl_input').val( actions.url );
						}else if( click_action == 'callback' ){
							_obj.find('.edit_panel').find('.callback_input').val( actions.callback );
						}else if( click_action == 'poi_popup' ){
							var popup_content = decodeURIComponent(actions.content);
							popup_content = popup_content.replace(/<br \/>?/g, '\n');
							_obj.find('.edit_panel').find('.poi_popup_input').val( popup_content );
							_obj.find('.edit_panel').find('.poi_popup_position option[value="'+actions.popup_position+'"]').prop('selected', true);
						}
	 				}

					
					// Check if selected item is poi (point of intrest)
					var layer_is_poi = 0;
					if( _obj.find('.banner_element').find('.layer_'+settings.current_layer).find('.poi-single-point').length ){
						layer_is_poi = 1;
					}

					var action_options = [
						{'value': '', 'option': 'None'},
						{'value': 'gotourl', 'option': 'Go to URL'},
						{'value': 'callback', 'option': 'Callback' }
					];

					if( layer_is_poi ){
						action_options.push({'value': 'poi_popup', 'option': 'Popup'});
					}

	 				_obj.find('.edit_panel').find('.click_action_options').spr_selectBox({
	 					'value': click_action,
						'options': action_options,
						'callback': function(val){
							if( _dn_debug ){ console.log(val); }

							settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].actions = $.extend(settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].actions, {'click_action': val} );

							_obj.find('.click_action_result').find('.click_action_option').hide();
							if( val !== '' ){
								_obj.find('.click_action_result').find('.'+val).show();
							}
						}
					});

					_obj.find('.edit_panel').find('.click_action_input').off('change').on('change', function(){
						var click_action = _obj.find('.click_action_options').parent().find('._select_dropdown').find('.selected').data('value');
						var attributes = {};
			
						if( click_action == 'gotourl' ){
							attributes = {'url': $(this).val()}
						}else if(click_action == 'callback'){
							attributes = {'callback': $(this).val()}
						}else if(click_action == 'poi_popup'){
							var popup_position = _obj.find('.edit_panel').find('.poi_popup_position').val();
							var popup_content = _obj.find('.edit_panel').find('.poi_popup_input').val(); //popup_content.replace(/\n\r?/g, '<br />');
							popup_content = popup_content.replace(/\n\r?/g, '<br />');

							if( _dn_debug ){ console.log(popup_position); console.log(_obj.find('.edit_panel').find('.poi_popup_input').val()); }
							attributes = {'content': encodeURIComponent(popup_content), 'popup_position': popup_position}
						}
						var attributes = $.extend(settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].actions, attributes );
						
						// @since v1.1.8 Fix to convert array to object if necessary
						// https://stackoverflow.com/a/46382705/3481803
						if( $.isArray(attributes) ){ attributes = {...attributes}; }
						
						settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].actions = attributes;
						//settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].actions = $.extend(settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].actions, attributes );
					});
	 			}






	 			// ANIMATION
	 			else if($(this).hasClass('animation')){
					if( _dn_debug ){ console.log('animation panel'); }
					_dn_editor_func.detroy_selectBox();
					
					var layer = _obj.find('._dn_editor_stage').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer);
					var is_svg = _dn_editor_func.contains_svg( layer.find('._dn_obj'));
					
					// If svg and has strokes.
					if( is_svg && layer.find("path[stroke]").length ){
						_obj.find('.edit_panel').find('.animation_panel').find('.svg_stroke_animation_panel').show();

						// Run Stroke Animation
						var run_svg_ani = true;
						if( !layer.find('svg').hasClass('_dn_ani')){
							run_svg_ani = false;
						}
						
						_obj.find('.edit_panel').find('.animation_panel').find('.svg_animation_runner').prop('checked', run_svg_ani);
						_obj.find('.svg_animation_runner').off('click').on('click', function(e) {
							var is_checked = $(this).prop("checked");
							if( _dn_debug ){console.log(is_checked);}
							run_svg_ani = is_checked;
							if( run_svg_ani ){
								layer.find('svg').addClass('_dn_ani');
							}else{
								layer.find('svg').removeClass('_dn_ani');
							}
						});

						// Set default sync variable
						var load_sync = true;
						if( typeof(layer.find('svg').data('sync')) !== 'undefined'){
							load_sync = layer.find('svg').data('sync');
						}

						_obj.find('.edit_panel').find('.animation_panel').find('.svg_animation_sync').prop('checked', load_sync);
						
						// Sync animation
						_obj.find('.svg_animation_sync').off('click').on('click', function(e) {
							var option = $(this).data("box");
							var is_checked = $(this).prop("checked");
							if( _dn_debug ){ 
								console.log(option);
								console.log(is_checked);
							}
							load_sync = is_checked;
							layer.find('svg').data('sync', is_checked);
							layer.find('svg').attr('data-sync', is_checked);
							layer.find('svg').prop('data-sync', is_checked);

							load_svg_animation_speed_sliders();
						});

						load_svg_animation_speed_sliders();
					

						function load_svg_animation_speed_sliders(){
							_obj.find('.svg_animation_speed_sliders_box').html('');

							layer.find("[stroke]").each(function(i, item){
								var h = '',
									speed = 100;
								
								if( load_sync && i) return;
								
								if( typeof($(item).data('speed')) !== 'undefined'){
									speed = $(item).data('speed');
								}

								h+= '<div class="set_box svg_animation_speed_box">';
									h+= '<span class="title">Stroke '+(i+1)+' Speed</span>';
									h+= '<div class="svg_animation_speed_slider_'+(i+1)+' _dn_ui_slider"></div>';
									h+= '<input class="svg_animation_speed_slider_input_val_'+(i+1)+' slider_input_val" value="'+speed+'" />';
									//h+= '<div class="svg_animation_speed_slider_input_val_'+(i+1)+' slider_input_val">'+speed+'</div>';
								h+= '</div>';

								_obj.find('.svg_animation_speed_sliders_box').append(h);

								_obj.find('.edit_panel').find('.svg_animation_speed_slider_input_val_'+(i+1)).on('change', function(){
									speed = $(this).val();
									_obj.find('.edit_panel').find( ".svg_animation_speed_slider_"+(i+1) ).slider({value:speed});
								});
								
								_obj.find('.edit_panel').find( ".svg_animation_speed_slider_"+(i+1) ).slider({
									value: speed,
									max:300,
									slide: function( event, ui ) {
										_obj.find('.edit_panel').find('.svg_animation_speed_slider_input_val_'+(i+1)).val(ui.value);
										//console.log( ui.value );
									},
									change: function( event, ui ) {
										$(item).data('speed', ui.value);
										$(item).attr('data-speed', ui.value);
										$(item).prop('data-speed', ui.value);
										//console.log( ui.value );
									}
								});
							});
						}
					}
					// end is svg
					


	 				// Select IN by default
	 				var ani_type = 'in';
	 				_obj.find('.edit_panel').find('.animation_options').find('.ani_opt').removeClass('selected');
	 				_obj.find('.edit_panel').find('.animation_options').find('.ani_opt[data-cat = "in"]').addClass('selected');

	 				animation_func( ani_type );

	 				_obj.find('.edit_panel').find('.animation_options').off('click').on('click', '.ani_opt', function(e) {
						_obj.find('.edit_panel').find('.animation_options').find('.ani_opt').removeClass('selected');
	 					$(this).addClass('selected');

	 					if( _dn_debug ){ console.log( $(this).data('cat')); }
	 					ani_type = $(this).data('cat');
	 					if( _dn_debug ){ console.log(ani_type); }
	 					animation_func( ani_type );
	 				});

	 				
	 				function animation_func( ani_type ){

						_dn_editor_func.detroy_selectBox();

						// Animation plugins
						_obj.find('.animation').find('.animation_effect_plugins').find('.plugin_box').removeClass('in view out');
						_obj.find('.animation').find('.animation_effect_plugins').find('.plugin_box').addClass(ani_type);
						_obj.find('.animation').find('.animation_effect_plugins').find('.plugin_box').attr('data-group', ani_type);
						_obj.find('.animation').find('.animation_effect_plugins').find('.plugin_box').data('group', ani_type);
						 
						var animation_plugins = new _dn_Plugins(_obj, settings, {'cat': 'animation', 'group':ani_type, 'debug':_dn_debug});
						animation_plugins.plugin_setup();
						// end Animation plugins

						
						// @since v1.1.9 repeatbox removed
	 					/*if(ani_type !== 'view'){
							_obj.find('.edit_panel').find('.animation').find('.animation_repeat_box').hide();
	 					}else{
							_obj.find('.edit_panel').find('.animation').find('.animation_repeat_box').show();
						}*/
						if(ani_type === 'view'){
							_obj.find('.animation').find('.direction_easing').hide();
						}else{
							_obj.find('.animation').find('.direction_easing').show();
						}

						if(ani_type !== 'in'){
							_obj.find('.animation').find('.delay_duration').find('.spr_column').removeClass('spr_col-6');
						}else{
							_obj.find('.animation').find('.delay_duration').find('.spr_column').addClass('spr_col-6');
						}

	 					settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].animation = $.extend({
	 						'in': {},
	 						'view': {'duration': (_obj.find('.timeline_seconds_element_duration').width()/80)},
	 						'out': {}
	 					}, settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].animation );
						 if( _dn_debug ){ console.log(settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].animation); }

	    				// Fix to make sure object is no array.
	    				if( $.isArray(settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].animation[ani_type]) ){
	 						settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].animation[ani_type] = {};
	 					}

	 					var animation = settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].animation[ani_type];
	 					if( _dn_debug ){ console.log( settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].animation ); }



	 					// Repeat animation checkbox
	 					var animation_repeat = typeof animation !== 'undefined' ? animation.repeat : false;
		 				animation_repeat = typeof animation_repeat !== 'undefined'? animation_repeat : false;
	 					_obj.find('.edit_panel').find('.animation').find('.animation_repeat_box').find('.animation_repeat').prop('checked', animation_repeat);

	 					_obj.find('.edit_panel').find('.animation_repeat_box').off('click').on('click', '.option_checkbox', function(e) {
			   				var option = $(this).data("box");
							var is_checked = $(this).prop("checked");
							if( _dn_debug ){ 
								console.log(option);
								console.log(is_checked);
							}
							settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].animation[ani_type] = $.extend(settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].animation[ani_type], {'repeat': is_checked} );
						});


						// Delay (only show for IN animations)
						if(ani_type == 'in'){
							_obj.find('.edit_panel').find( ".animation_delay_box" ).show();

							var animation_delay = typeof animation !== 'undefined' ? animation.delay : 0;
							animation_delay = typeof animation_delay !== 'undefined'? animation_delay : 0;
							
							_obj.find('.edit_panel').find('.animation').find('.animation_delay_box').find('.slider_input_val').val(animation_delay);
							_obj.find('.edit_panel').find('.animation_delay_box').find('.slider_input_val').on('change', function(){
								animation_delay = $(this).val();
								_obj.find('.edit_panel').find( ".animation_delay_slider" ).slider({value:animation_delay});

								// Move timeline object.
								var _timeline_obj = _obj.find('.syncscroll_right').find("[data-nr='" + settings.current_layer + "']");
								_timeline_obj.find('.layer_animation_container').css({'left': (animation_delay*10)*8+'px'});
							});

							_obj.find('.edit_panel').find('.animation').find('.animation_delay_slider').slider({
								value: animation_delay,
								max: 30,
								step: .1,
								slide: function( event, ui ){ $('.edit_panel').find('.animation').find('.animation_delay_box').find('.slider_input_val').val(ui.value); },
								change: function( event, ui ){
									// Fix! we need to reset anytype here for some unknown reason...
									ani_type = _obj.find('.edit_panel').find('.animation_options').find('.selected').data('cat');
									if( _dn_debug ){ console.log(ani_type); }

									// Move timeline object.
									var _timeline_obj = _obj.find('.syncscroll_right').find("[data-nr='" + settings.current_layer + "']");
									_timeline_obj.find('.layer_animation_container').css({'left': (ui.value*10)*8+'px'});

									settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].animation[ani_type] = $.extend(settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].animation[ani_type], {'delay': ui.value} );
									if( _dn_debug ){ console.log(settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].animation[ani_type].delay); }
								}
							});
						}else{
							_obj.find('.edit_panel').find( ".animation_delay_box" ).hide();
						}

		 				// Duration
		 				var animation_duration = typeof animation !== 'undefined' ? animation.duration : 0;
		 				animation_duration = typeof animation_duration !== 'undefined'? animation_duration : 0;
		 				_obj.find('.edit_panel').find('.animation').find('.animation_duration_box').find('.slider_input_val').val(animation_duration);
						_obj.find('.edit_panel').find('.animation_duration_box').find('.slider_input_val').on('change', function(){
							animation_duration = $(this).val();
							_obj.find('.edit_panel').find( ".animation_duration_slider" ).slider({value:animation_duration});
						});

						_obj.find('.edit_panel').find('.animation').find('.animation_duration_slider').slider({
	    					value: animation_duration,
	    					max: 10,
	    					step: .1,
	    					slide: function( event, ui ){ _obj.find('.edit_panel').find('.animation').find('.animation_duration_box').find('.slider_input_val').val(ui.value); },
	    					change: function( event, ui ) {
	    						// Fix! we need to reset anytype here for some unknown reason...
	    						ani_type = _obj.find('.edit_panel').find('.animation_options').find('.selected').data('cat');

	    						settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].animation[ani_type] = $.extend(settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].animation[ani_type], {'duration': ui.value} );
	    						if( _dn_debug ){ console.log(settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].animation[ani_type].duration); }
	    					}
						});
						

						// Easing
						var animation_easing = typeof animation !== 'undefined' ? animation.easing : 'linear';
		 				animation_easing = typeof animation_easing !== 'undefined'? animation_easing : 'linear';

		 				var easing_options = [
							{'value': 'linear', 'option': 'linear'},
							{'value': 'swing', 'option': 'swing'},
							{'value': 'easeInQuad', 'option': 'easeInQuad' },
							{'value': 'easeOutQuad', 'option': 'easeOutQuad' },
							{'value': 'easeInOutQuad', 'option': 'easeInOutQuad' },
							{'value': 'easeInCubic', 'option': 'easeInCubic' },
							{'value': 'easeOutCubic', 'option': 'easeOutCubic' },
							{'value': 'easeInOutCubic', 'option': 'easeInOutCubic' },
							{'value': 'easeInQuart', 'option': 'easeInQuart' },
							{'value': 'easeOutQuart', 'option': 'easeOutQuart' },
							{'value': 'easeInOutQuart', 'option': 'easeInOutQuart' },
							{'value': 'easeInQuint', 'option': 'easeInQuint' },
							{'value': 'easeOutQuint', 'option': 'easeOutQuint' },
							{'value': 'easeInOutQuint', 'option': 'easeInOutQuint' },
							{'value': 'easeInExpo', 'option': 'easeInExpo' },
							{'value': 'easeOutExpo', 'option': 'easeOutExpo' },
							{'value': 'easeInOutExpo', 'option': 'easeInOutExpo' },
							{'value': 'easeInSine', 'option': 'easeInSine' },
							{'value': 'easeOutSine', 'option': 'easeOutSine' },
							{'value': 'easeInOutSine', 'option': 'easeInOutSine' },
							{'value': 'easeInCirc', 'option': 'easeInCirc' },
							{'value': 'easeOutCirc', 'option': 'easeOutCirc' },
							{'value': 'easeInOutCirc', 'option': 'easeInOutCirc' },
							{'value': 'easeInElastic', 'option': 'easeInElastic' },
							{'value': 'easeOutElastic', 'option': 'easeOutElastic' },
							{'value': 'easeInOutElastic', 'option': 'easeInOutElastic' },
							{'value': 'easeInBack', 'option': 'easeInBack' },
							{'value': 'easeOutBack', 'option': 'easeOutBack' },
							{'value': 'easeInOutBack', 'option': 'easeInOutBack' },
							{'value': 'easeInBounce', 'option': 'easeInBounce' },
							{'value': 'easeOutBounce', 'option': 'easeOutBounce' },
							{'value': 'easeInOutBounce', 'option': 'easeInOutBounce' }
						];

						_obj.find('.edit_panel').find('.animation').find('.animation_easing').spr_selectBox({
	    					'value': animation_easing,
							'options': easing_options,
							'callback': function(val){
								
								// Fix! we need to reset anytype here for some unknown reason...
	    						ani_type = _obj.find('.edit_panel').find('.animation_options').find('.selected').data('cat');

								settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].animation[ani_type] = $.extend(settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].animation[ani_type], {'easing': val} );
	    						if( _dn_debug ){ console.log(settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].animation[ani_type].easing); }
							}
						});


						// Effect
						//_obj.find('.edit_panel').find('.animation').find('.animation_effect_box').hide();
						

	    				// Direction
		 				var animation_direction = typeof animation !== 'undefined' ? animation.direction : '';

		 				_obj.find('.edit_panel').find('.animation').find('.animation_direction').spr_selectBox({
	    					'value': animation_direction,
							'options': [
								{'value': '', 'option': 'None'},
								{'value': 'top', 'option': 'Top to bottom'},
								{'value': 'bottom', 'option': 'Bottom to top'},
								{'value': 'left', 'option': 'Left to right' },
								{'value': 'right', 'option': 'Right to left' }
							],
							'callback': function(val){
								// Fix! we need to reset anytype here for some unknown reason...
	    						ani_type = _obj.find('.edit_panel').find('.animation_options').find('.selected').data('cat');

								settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].animation[ani_type] = $.extend(settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].animation[ani_type], {'direction': val} );
	    						if( _dn_debug ){ console.log(settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].animation[ani_type].direction); }
							}
						});


						// CLASSES
						var animation_classes = typeof animation !== 'undefined' ? animation.classes : '';
						_obj.find('.edit_panel').find('.animation').find('.animation_classes').val(animation_classes);
						_obj.find('.edit_panel').find('.animation').find('.animation_classes').on('change', function(){
							animation_classes = $(this).val();
							settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].animation[ani_type] = $.extend(settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer].animation[ani_type], {'classes': animation_classes} );
						});
	 				}
	 			}

				 
				 

				// Duplicate Layer
				if($(this).hasClass('duplicate')){
					if( _dn_debug ){ console.log('Duplicate Layer'); }
					var tmp_copy_obj = $.extend(true, {}, settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer]);
					var layer_to_copy = tmp_copy_obj;
					//var layer_to_copy = settings.banner_obj.slides[settings.current_slide].layers[settings.current_layer];
					if( _dn_debug ){ console.log(layer_to_copy); console.log(layer_to_copy.css.layer); }

					// Adjust top and left (just move it a little bit to make it clear the layer got copied.)
					//layer_to_copy.css.layer
					var l_left = layer_to_copy.css.layer.left,
						l_top = layer_to_copy.css.layer.top;
					
					layer_to_copy.css.layer.left = l_left+20;
					layer_to_copy.css.layer.top = l_top+20;

					$.ajax({
						type: "POST",
						url: _dn_.ajaxurl,
						async: false,
						data: {
							"action": "duplicate_layer",
							"id": settings.id,
							"slide_nr": settings.current_slide,
							"layer_obj": JSON.stringify(layer_to_copy),
							"banner_obj": JSON.stringify(settings.banner_obj)
						}
					}).done(function( msg ){
						var obj = JSON.parse(msg);
						if( _dn_debug ){ console.log(obj); }

						settings.banner_obj = obj.banner_obj;
						settings = _dn_editor_func.add_layer_to_timeline(_obj, obj.timeline, obj.layer_nr, settings);
						
						_obj.find('.editor_stage_container').find('._dn_cont').find('.slide_'+settings.current_slide).append(obj.html);
						_obj.find('.slides_and_layers_box').find('.slide_'+settings.current_slide).find('.layers_box').prepend(obj.timeline_item);
						_obj.find('.editor_stage_container').find('._dn_inner').find('._dn_loading_elmt').remove();
						got_saved = 0;
					});
				}



	 			// Remove
	 			if($(this).hasClass('remove')){
					if( _dn_debug ){ console.log('Remove Layer'); }

					_dn_editor_func.deselect_items(_obj, settings);

					var remove_id = settings.id,
						remove_slide_nr = settings.current_slide,
						remove_layer_nr = settings.current_layer,
						remove_banner_obj = JSON.stringify(settings.banner_obj);

	 				$.ajax({
						type: "POST",
						url: _dn_.ajaxurl,
						async: false,
						data: {
							"action": "remove_layer",
							"id": remove_id,
							"slide_nr": remove_slide_nr,
							"layer_nr": remove_layer_nr,
							"banner_obj": remove_banner_obj
						}
					}).done(function( msg ){
						var obj = JSON.parse(msg);
						settings.banner_obj = obj.banner_obj;
						if( _dn_debug ){ console.log(settings.banner_obj); }
						
						$('body').removeClass('coloringPickOpen');
						_obj.find('.editor_stage_container').find('._dn_cont').find('.slide_'+settings.current_slide).find('.layer_'+settings.current_layer).remove();
						_obj.find('.slides_and_layers_box').find('.slide_'+settings.current_slide).find('.layer[data-nr = '+settings.current_layer+']').remove();
						_obj.find('.syncscroll_left').find('.timeline_layer_element[data-nr = '+settings.current_layer+']').remove();
						_obj.find('.syncscroll_right').find('.timeline_layer_animation_container[data-nr = '+settings.current_layer+']').remove();
						got_saved = 1;
					});
	 			}
	 		});
	 		




	 		// ##
	 		// Background Color Option tabs Actions
	 		_obj.find('.bg_opt').off('click').on('click', function(){
				_obj.find('.bg_opt').removeClass('selected');
				$(this).addClass('selected');
				var opt = $(this).data('cat');

				_obj.find('.background_settings').find('.tab_boxes').find('.tab_option_box').removeClass('visible');
				_obj.find('.background_settings').find('.tab_boxes').find('.'+opt).addClass('visible');

			});



			// ##
			// Text Option Actions
			_obj.find('.text_palets').off('click').on('click', '.text_palet', function(e) {
				if( _dn_debug ){ console.log( $(this).html().trim() ); }
				// add loader
				_obj.find('.icons').find('.shape_palets').prepend( '<div class="shape_palet _loader_"><div class="icon"><i class="fas fa-spinner fa-pulse"></i></div></div>');

				var _layer_objcd = '';
				if( $(this).find('._layer_objcd').length){
					_layer_objcd = JSON.parse(ImgMCE_global.urldecode( $(this).find('._layer_objcd').val() ));

					if( typeof(_layer_objcd.external.styles) !== 'undefined' ){
						$.each( _layer_objcd.external.styles, function( key, value ) {
							if (!$("link[href='"+value.url+"']").length){
								$('<link href="'+value.url+'" rel="stylesheet" type="text/css">').appendTo("head");
							}
							 //document.write("<link rel='stylesheet' href='"+site_url+assets_path+"/css/embed/display.css' type='text/css' media='all' />");
						});
					}
				}

				$.ajax({
					type: "POST",
					url: _dn_.ajaxurl,
					async: false,
					data: {
						"action": "add_layer_to_banner",
						"layer_json": JSON.stringify(_layer_objcd),
						"content": $(this).html().trim(),
						"aspect_ratio": $(this).data('aspect_ratio'),
						"resize_handles": $(this).data('rsh'),
						"size": $(this).data('size'),
						"type": "text",
						"id": settings.id,
						"banner_obj": JSON.stringify(settings.banner_obj),
						"slide_nr": settings.current_slide
					}
				}).done(function( msg ){

					var tmp_obj = $.extend(true, {}, settings.banner_obj);
					_dn_editor_func.set_undo_redo(tmp_obj, 'undo');

					var obj = JSON.parse(msg);
					
					settings.banner_obj = obj.banner_obj;
					_obj.find('.editor_stage_container').find('._dn_cont').find('.slide_'+settings.current_slide).append( obj.html ); //_dn_bc.urldecode()
					//_obj.find('.editor_stage_container').find('._dn_cont').find('.slide_'+settings.current_slide).append( obj.html );
					_obj.find('.slides_and_layers_box').find('.slide_'+settings.current_slide).find('.layers_box').prepend(obj.timeline_item);
					_obj.find('.editor_stage_container').find('._dn_inner').find('._dn_loading_elmt').remove();

					settings = _dn_editor_func.add_layer_to_timeline(_obj, obj.timeline, obj.layer_nr, settings);
					//_dn_editor_func.timeline_is_visible_btn(_obj);
					got_saved = 0;
				});
				// end ajax
			});






	 		// ##
			// Load Stock images
			_dn_editor_func.image_upload_result_container(_obj, $('#stock_result'), settings);
			

			// Image Option tabs Actions
			_obj.find('.image_opt').off('click').on('click', function(){
				_obj.find('.image_opt').removeClass('selected');
				$(this).addClass('selected');
				var opt = $(this).data('cat');

				_obj.find('.images_settings').find('.tab_boxes').find('.tab_option_box').removeClass('visible');
				_obj.find('.images_settings').find('.tab_boxes').find('.'+opt).addClass('visible');

				if( opt === 'my'){
					// Image Uploads results
					_dn_editor_func.image_upload_result_container(_obj, _obj.find('#upload_result'), settings);
				}
				if( opt === 'giphy'){
					_dn_editor_func.image_upload_result_container(_obj, $('#giphy_result'), settings);
					//_obj.find('#giphy_result').masonry('reloadItems');
				}
			});






	 		// ##
	 		// Shape tabs Actions
	 		_obj.find('.shape_opt').off('click').on('click', function(){
				_obj.find('.shape_opt').removeClass('selected');
				$(this).addClass('selected');
				var opt = $(this).data('cat');

				_obj.find('.shapes_settings').find('.tab_boxes').find('.tab_option_box').removeClass('visible');
				_obj.find('.shapes_settings').find('.tab_boxes').find('.'+opt).addClass('visible');

				if(opt === 'icons'){
					if( _dn_debug ){ console.log(_dn_.assets_url); }

					// Load FontAwesome Icons (if they are not yet loaded)
					if(_obj.find('.icons').find('.shape_palets').find('.fontawesome').length === 0){
						// add loader
						_obj.find('.icons').find('.shape_palets').prepend( '<div class="shape_palet _loader_"><div class="icon">'+ImgMCE_global.loading_ico()+'</div></div>');
						
						// Load JSON file
						$.getJSON( _dn_.assets_url+"/fonts/font-awesome/5.0.3/icons.json" )
						.done(function( json ) {
					    	// Remove loader
					    	_obj.find('.icons').find('.shape_palets').find('._loader_').remove();

						    $.each(json, function( index, value ) {
						    	var svg_arr = value.svg;
						    	var icon_name = index;
						    	$.each(svg_arr, function( key, item ) {
						    		//var svg = item.raw;
						    		var svg = create_svg(item, icon_name);
						    		_obj.find('.icons').find('.shape_palets').append( '<div class="shape_palet fontawesome _dn_filter_box" data-search="'+icon_name+'" data-aspect_ratio="1" data-size="100x100">'+svg+'</div>');
						    	});
						    });
					  	})
					  	.fail(function( jqxhr, textStatus, error ) {
					    	var err = textStatus + ", " + error;
					    	if( _dn_debug ){ console.log( "Request Failed: " + err ); }
						});
				  	}

					function create_svg(options, icon_name)
					{
						var html = '';

						html+= '<svg xmlns="http://www.w3.org/2000/svg" viewBox="'+options.viewBox+'">';
							html+= '<path d="'+options.path+'" class="colorful c1"></path>';
						html+= '</svg>';

						return html;
					}
				}
				// end if opt == icons



				if(opt === 'emojis'){

					// Load twemoji Icons (if they are not yet loaded)
					if(_obj.find('.emojis').find('.shape_palets').find('.twemoji').length === 0){
						// add loader
						_obj.find('.emojis').find('.shape_palets').prepend( '<div class="shape_palet _loader_"><div class="icon">'+ImgMCE_global.loading_ico()+'</div></div>');
						
						// Load JSON file
						$.getJSON( _dn_.assets_url+"/emojis/twemoji.json" )
						.done(function( json ) {
					    	// Remove loader
					    	_obj.find('.emojis').find('.shape_palets').find('._loader_').remove();

						    $.each(json, function( index, value ) {
								//console.log(value);
								_obj.find('.emojis').find('.shape_palets').append( '<div class="shape_palet twemoji _dn_filter_emoji_box" data-search="'+value.name+'" data-aspect_ratio="1" data-size="100x100">'+_dn_bc.urldecode(value.code)+'</div>');
								
						    });
					  	})
					  	.fail(function( jqxhr, textStatus, error ) {
					    	var err = textStatus + ", " + error;
					    	if( _dn_debug ){ console.log( "Request Failed: " + err ); }
						});
				  	}
				}
				// end if opt == emojis
			});
			

			// Shape palet mouseover play animation (if available)
			_obj.find('.shape_palets').off('mouseover').on('mouseover', '.badge', function(e) {
				if( _dn_debug ){ console.log('BADGE'); };
				$(this).closest('.shape_palet').find("._dn_ani")._dn_animate_stroke();
			});

			// Add Shape to banner
			_obj.find('.shape_palets').off('click').on('click', '.shape_palet', function(e) {

				var shape_id = $(this).data('key'),
					group_id = $(this).data('group'),
					shape_type = $(this).closest('.shape_option_box').data('shape-type'),
					content = _dn_bc.remove_class_from_string($(this).html(), 'badge'),
					_layer_objcd = '';
				
				if( $(this).find('._layer_objcd').length){
					_layer_objcd = JSON.parse(ImgMCE_global.urldecode( $(this).find('._layer_objcd').val() ));

					if( typeof(_layer_objcd.external.styles) !== 'undefined' ){
						$.each( _layer_objcd.external.styles, function( key, value ) {
							if (!$("link[href='"+value.url+"']").length){
								$('<link href="'+value.url+'" rel="stylesheet" type="text/css">').appendTo("head");
							}
								//document.write("<link rel='stylesheet' href='"+site_url+assets_path+"/css/embed/display.css' type='text/css' media='all' />");
						});
					}
				}

				if( _dn_debug ){
					console.log(shape_type);
					console.log(content);
					console.log(JSON.stringify(settings.banner_obj));
					console.log(settings.current_slide);
				}
				_obj.find('.editor_stage_container').find('._dn_inner').append('<div class="_dn_loading_elmt img _dn_layer _dn_elmt"><div class="icon"><i class="fas fa-spinner fa-pulse"></i></div></div>');
				//
				$.ajax({
					type: "POST",
					url: _dn_.ajaxurl,
					async: false,
					data: {
						"action": "add_layer_to_banner",
						"layer_json": JSON.stringify(_layer_objcd),
						"obj_id": shape_id,
						"group_id": group_id,
						"shape_type": shape_type,
						"content": content,
						"aspect_ratio": $(this).data('aspect_ratio'),
						"size": $(this).data('size'),
						"type": "shape",
						"id": settings.id,
						"banner_obj": JSON.stringify(settings.banner_obj),
						"slide_nr": settings.current_slide
					}
				}).done(function( msg ){
					
					var obj = JSON.parse(msg);

					var tmp_obj = $.extend(true, {}, settings.banner_obj);
					_dn_editor_func.set_undo_redo(tmp_obj, 'undo');

					if( _dn_debug ){
						console.log(obj);
						console.log(settings);
					}
				
					settings.banner_obj = obj.banner_obj;
					_obj.find('.editor_stage_container').find('._dn_cont').find('.slide_'+settings.current_slide).append(obj.html); //_dn_bc.urldecode()
					_obj.find('.slides_and_layers_box').find('.slide_'+settings.current_slide).find('.layers_box').prepend(obj.timeline_item);
					_obj.find('.editor_stage_container').find('._dn_inner').find('._dn_loading_elmt').remove();

					settings = _dn_editor_func.add_layer_to_timeline(_obj, obj.timeline, obj.layer_nr, settings);
					//_dn_editor_func.timeline_is_visible_btn(_obj);
					got_saved = 0;
					if( _dn_debug ){
						console.log(settings);
					}
				});
				// end ajax
				
			});








			// ##
	 		// Element tabs Actions
	 		_obj.find('.element_opt').off('click').on('click', function(){
				_obj.find('.element_opt').removeClass('selected');
				$(this).addClass('selected');
				var opt = $(this).data('cat');

				_obj.find('.elements_settings').find('.tab_boxes').find('.tab_option_box').removeClass('visible');
				_obj.find('.elements_settings').find('.tab_boxes').find('.'+opt).addClass('visible');

			});

			// Add Element to banner
			_obj.find('.element_palets').off('click').on('click', '.element_palet', function(e) {

				var element_id = $(this).data('key'),
					group_id = $(this).data('group'),
					element_type = $(this).closest('.element_option_box').data('element-type'),
					content = _dn_bc.remove_class_from_string($(this).html(), 'badge'),
					_layer_objcd = '';
				
				if( $(this).find('._layer_objcd').length){
					_layer_objcd = JSON.parse(ImgMCE_global.urldecode( $(this).find('._layer_objcd').val() ));

					if( typeof(_layer_objcd.external.styles) !== 'undefined' ){
						$.each( _layer_objcd.external.styles, function( key, value ) {
							if (!$("link[href='"+value.url+"']").length){
								$('<link href="'+value.url+'" rel="stylesheet" type="text/css">').appendTo("head");
							}
								//document.write("<link rel='stylesheet' href='"+site_url+assets_path+"/css/embed/display.css' type='text/css' media='all' />");
						});
					}
				}

				if( _dn_debug ){
					console.log(element_type);
					console.log(content);
					console.log(JSON.stringify(settings.banner_obj));
					console.log(settings.current_slide);
				}
				_obj.find('.editor_stage_container').find('._dn_inner').append('<div class="_dn_loading_elmt img _dn_layer _dn_elmt"><div class="icon"><i class="fas fa-spinner fa-pulse"></i></div></div>');
				//
				$.ajax({
					type: "POST",
					url: _dn_.ajaxurl,
					async: false,
					data: {
						"action": "add_layer_to_banner",
						"layer_json": JSON.stringify(_layer_objcd),
						"obj_id": element_id,
						"group_id": group_id,
						"element_type": element_type,
						"content": content,
						"aspect_ratio": $(this).data('aspect_ratio'),
						"size": $(this).data('size'),
						"type": "element",
						"id": settings.id,
						"banner_obj": JSON.stringify(settings.banner_obj),
						"slide_nr": settings.current_slide
					}
				}).done(function( msg ){
					
					var obj = JSON.parse(msg);

					var tmp_obj = $.extend(true, {}, settings.banner_obj);
					_dn_editor_func.set_undo_redo(tmp_obj, 'undo');
					
					settings.banner_obj = obj.banner_obj;
					_obj.find('.editor_stage_container').find('._dn_cont').find('.slide_'+settings.current_slide).append(obj.html); //_dn_bc.urldecode()
					_obj.find('.slides_and_layers_box').find('.slide_'+settings.current_slide).find('.layers_box').prepend(obj.timeline_item);
					_obj.find('.editor_stage_container').find('._dn_inner').find('._dn_loading_elmt').remove();

					settings = _dn_editor_func.add_layer_to_timeline(_obj, obj.timeline, obj.layer_nr, settings);
					//_dn_editor_func.timeline_is_visible_btn(_obj);
					got_saved = 0;
				});
				// end ajax
				
			});











			// ##
			// Button tabs Actions
			
			// EXPORT AS IMAGE BUTTON
			_obj.closest('.imgmce_editor').find('.export_as_image_btn').off('click').on('click', function(){
				
				var id = settings.id;
				var nodeJQ = $('.editor_stage_container').find('._dn_'+id);
				var node = document.getElementById('_dn_cnt_'+id).firstChild;
				var size = $(nodeJQ).data('size');
				size = size.split("x"); 
				var file_type = 'png';
				
				// https://github.com/tsayen/dom-to-image
				domtoimage.toPng(node, { width:size[0], height: size[1] })
					.then(function (dataUrl) {
						var img = new Image();
						img.src = dataUrl;
						var link = document.createElement('a');
						link.download = 'image-'+id+'.'+file_type;
						link.href = dataUrl;
						link.click();
					})
					.catch(function (error) {
						console.error('oops, something went wrong!', error);
				});
			});

			// PLAY BUTTON / PREVIEW BTN Action
			_obj.closest('.imgmce_editor').find('.play_btn').off('click').on('click', function(){

				var is_playing = _obj.hasClass('is_playing') ? 1 : 0;
				if( _dn_debug ){ console.log('play '+is_playing); }
				

				if( !is_playing ){
					_dn_editor_func.deselect_items(_obj, settings);
					_dn_editor_func.close_editor_settings(_obj);
					_obj.find('.stage_zoom').hide();
					//dn_content = _obj.find('._dn_editor_stage').find('._dn_cont').clone();
					
					_obj.addClass('is_playing');
					$(this).find('.btn_text').html('STOP PREVIEW');
					_obj.closest('.imgmce_editor').find('._dn_menu').find('.save_btn').hide();
					_obj.closest('.imgmce_editor').find('._dn_menu').find('.export_as_image_btn').hide();
					if( _dn_debug ){ 
						console.log(settings.banner_obj); 
						console.log(JSON.stringify(settings.banner_obj)); 
					}
					var rand_id = Math.floor(Math.random() * 6) + 1;

					// Fix array issue. Make sure array's get transformed into objects.
					//console.log('DEBUG');
					//console.log(settings);
					_dn_editor_func.animation_object_fix(settings);

					$.ajax({
						type: "POST",
						url: _dn_.ajaxurl,
						data: {
							"action": "load_banner",
							"args":JSON.stringify({
								"load_banner_script": 1,
								"adjust_id": "__"+rand_id+"__",
								"debug":_dn_debug
							}),
							"banner_obj": JSON.stringify(settings.banner_obj),
							"debug":_dn_debug
						}
					}).done(function( msg ){

						var obj = JSON.parse(msg);

						if( _dn_debug ){ console.log(obj); }
						
						_obj.find('._dn_editor_stage').html(obj.template);

						if( !_obj.find('._dn_editor_stage').find("._dn_ani").parents(".inactive").length && !_obj.find('._dn_editor_stage').find("._dn_ani").parents(".in_ani_complete").length ){
							_obj.find('._dn_editor_stage').find("._dn_ani")._dn_animate_stroke({'callback': function(set){ console.log(set.total_frames); }});
						}
					});
					// end ajax
				}else{
					if( _dn_debug ){ console.log('Replacing dn_content after playing.'); }
					
					//_obj.find('._dn_editor_stage').html(dn_content);
					$.ajax({
						type: "POST",
						url: _dn_.ajaxurl,
						data: {
							"action": "load_banner",
							"args":JSON.stringify({
								"load_banner_script": 0
							}),
							"banner_obj": JSON.stringify(settings.banner_obj),
							"debug":_dn_debug
						}
					}).done(function( msg ){
						var obj = JSON.parse(msg);

						_dn_editor_func.load_banner(obj, settings, _obj);
					});
					dn_content = '';
					
					_obj.removeClass('is_playing');
					$(this).find('.btn_text').html('PREVIEW');
					_obj.closest('.imgmce_editor').find('._dn_menu').find('.save_btn').show();
					_obj.closest('.imgmce_editor').find('._dn_menu').find('.export_as_image_btn').show();
					_obj.find('.stage_zoom').show();
				}
			});



			// SAVE BUTTON Action
			_obj.closest('.imgmce_editor').find('.save_btn').off('click').on('click', function(){
				if( _dn_debug ){ console.log('SAVING'); console.log( settings.banner_obj ); }
				var _btn = $(this),
					banner_title = _obj.closest('.imgmce_editor').find("._dn_banner_title").val(),
					return_all_code = 1;
				
				if( _obj.closest('.imgmce_editor').find("._return_all_code").length ){
					return_all_code = _obj.closest('.imgmce_editor').find("._return_all_code").prop("checked");
				}
					
				_btn.addClass('saving');
				_btn.find('.save_text').html('SAVING');
				_dn_editor_func.deselect_items(_obj, settings);

				settings.banner_obj.title = banner_title;
				settings.editor.return_all_code = return_all_code;
				_dn_editor_func.animation_object_fix(settings);
				if( _dn_debug ){ console.log(settings); }

				$.ajax({
					type: "POST",
					url: _dn_.ajaxurl,
					data: {
						"action": "_dn_save_banner",
						"id": settings.banner_obj.id,
						"title": banner_title,
						"editor": JSON.stringify(settings.editor),
						"banner_obj": JSON.stringify(settings.banner_obj)
					}
				}).done(function( msg ) {
					var arr = JSON.parse(msg);

					_btn.removeClass('saving');
					_btn.find('.save_text').html('SAVE');
					got_saved = 1;
					if( _dn_debug ){
						console.log('Banner Saved');
						console.log(arr);
					}

					
					// Fire editor callback if provided
					var editor_save_callback = window[settings.editor.callback]; 
					if(typeof editor_save_callback === 'function') {
						if( _dn_debug ){ console.log('calling editor callback...'); }
						editor_save_callback(_obj, arr, settings);
					}
					

					
					// Fire callback if provided
					// deprecated @since v1.1.0, use settings.editor.callback
					if (typeof(settings.callback) == 'function') {
						if( _dn_debug ){ console.log('This callback has been deprecated @since v1.1.0, use settings.editor.callback'); }
						settings.callback.call(_obj, arr);
					}

					// Close popup and destroy editor element
					if( settings.editor.in_popup ){
						$('body').find('#TMCimgModal').remove(); 
						$("html").removeClass("Open_imgMCEModal");
						_obj._dn_banner_editor({"destroy":true});
					}

				});
			});


			// REMOVE BUTTON Action
			_obj.find('#_dn_remove_btn').off('click').on('click', function(){
				var _btn = $(this);

				_btn.addClass('removing');

				$.ajax({
					type: "POST",
					url: _dn_.ajaxurl,
					data: {
						"action": "_dn_remove_banner",
						"id": settings.id
					}
				}).done(function( msg ) {
					//var arr = JSON.parse(msg);

					_btn.removeClass('removing');
				});
			});



			// SEARCH / FILTER
			//_obj.find("._dn_search_filter").on('keyup', function(){
			_obj.find("._dn_search_filter").on('change', function(){
				$(this).closest('.tab_option_box').find('.scrollarea').css('opacity',.3);

				var _sr = $(this),
					filter = $(this).val(), 
					filter_values = $(this).data('value-class'),
					count = 0,
					search_loop = 0;
					if( _dn_debug ){ console.log('filtering... '+filter_values); }
				
				//console.log($('.'+filter_values).length);
				$('.'+filter_values).each(function(){
					//$(this).text().search(new RegExp(filter, "i")) < 0 || 
					var search_string = 'imc_'+$(this).data('search'),
						search_group = '',
						search_tags = '';

					if($(this).hasClass('sticker_palet')){
						search_string = $(this).data('key');
						search_group = $(this).data('group');
						search_tags = $(this).find('._obj_tags').length ? $(this).find('._obj_tags').html() : '';
					}
					
					if( typeof(search_string) !== 'undefined' && typeof(search_group) !== 'undefined' && typeof(search_tags) !== 'undefined'){
						if(search_string.search(new RegExp(filter, "i")) < 0 && search_group.search(new RegExp(filter, "i")) < 0 && search_tags.search(new RegExp(filter, "i")) < 0){
							$(this).fadeOut();
							$(this).removeClass("highlite");
							$(this).removeClass("active");
						} else {
							$(this).show();
							$(this).addClass("highlite");
							$(this).addClass("active");
							count++;
						}
						search_loop++;
					}
				});
				if( search_loop == $('.'+filter_values).length){
					//console.log('Search Complete');
					_obj.find('.scrollarea').css({'opacity':1});
				}
				
			});


			// SEARCH STOCK Images
			_obj.find('.img_option_box').find('._dn_search_images').on('change', function(){
				var result_box = $(this).data('result-box-id'),
					query = $(this).val();
				
				if( _dn_debug ){ console.log(query); }
				if( _dn_debug ){ console.log(result_box); }
				$.ajax({
					type: "POST",
					url: _dn_.ajaxurl,
					data: {
						"action": "search_stock_images",
						"result_box": result_box,
						"query": query
					}
				}).done(function( msg ) {
					var arr = JSON.parse(msg);
					if( _dn_debug ){ console.log(arr); }
					
					_obj.find('#'+result_box).html(arr.template);
					if( arr.template !== ''){
						_dn_editor_func.image_upload_result_container(_obj, $('#'+result_box), settings);
						_obj.find('#'+result_box).masonry('reloadItems');
					}
				});

			});

	 	});
	};





	// start screen functions
	var _dn_ss = {

		_dn_exit_editor(){
			if(!got_saved){
				if (!confirm('Are you sure you want to leave without saving? Banner changes will be lost.')) {
					return false;
				}
			}
			return true;
		},

		_dn_NewImage(_obj, settings){
			
			_obj.find("._dn_menu").removeClass("editor my_images").addClass("select_size");
			_obj.find("._dn_ChooseSize").html("");
			_obj.find("._dn_ChooseSize").show();
			_obj.find("._dn_ChooseSize")._dn_size_boxes(settings);
		},
                    
	};




	/**
	 * SETUP
	*/
	$.fn.imgmce_setup = function(options) {
		
		// Defaults
		var settings = $.extend(true,{
			'user_id': 0,
			'sizes': {},
			'editor': {},
			'banner_obj': {},
			'destroy': false
		}, options );

		// Look if image uploads should be enabled
		//settings.editor.image.image_uploads = typeof(settings.editor.upload.dir) === 'undefined' ? 0 : 1;
	
		return this.each(function(i,el){
			var _obj = $(el);
			
			// Make sure this only runs once. ... :) I know this needs improvements but it works for now...
			if(i) return;

			settings.editor = JSON.parse(settings.editor);
			
			settings.page = $.extend({
				'title': '1. Select Image Size',
			}, settings.page );

			// SET GLOBAL VARIABLES
			_dn_debug = parseInt(settings.editor.debug);
			active_editor = settings.editor.active_editor;


			if( settings.destroy){
				_obj.find(".ttip").tooltipster('destroy');
				_obj.find("._dnNewImage").off('click');
				_obj.find("._dnMyImages").off('click');
				_obj.find(".my_images").off('click','.edit');
				_obj.off().removeData();
				settings = {};
				settings.banner_obj = {};
				settings.banner_obj.upload = {};
			
				return;
			}

			var in_popup = _obj.parents('.TMCimgEditor').length ? 1 : 0;
			settings.editor.in_popup = in_popup;
			if( in_popup){
				_obj.find('.CloseImgMCEModal').show();
			}else{
				_obj.find('.CloseImgMCEModal').hide();
			}
			if( _dn_debug ){ console.log('Loaded inside popup? '+in_popup); console.log(settings.editor.upload); }

			//Activate Tooltips
			ImgMCE_global.activate_tooltips(_obj);


			// If opened from tinymce editor
			var has_upload = 0;
			if( $.isArray(settings.editor.upload) ){
				has_upload = settings.editor.upload.length > 0 ? 1 : 0;
			}else{
				has_upload = Object.keys(settings.editor.upload).length > 0 ? 1 : 0;
			}
			if( _dn_debug ){ console.log(settings.editor.tinymce); console.log(has_upload); }

			// SHOW/HIDE Full code | All code button
			// @since v1.1.6 not longer only for tinymce
			// settings.editor.tinymce &&
			if( has_upload && Number(settings.editor.save_to_folder)){
				_obj.find('._add_all_code').show();
			}else{
				//_obj.find('._add_all_code').hide();
				_obj.find('._add_all_code').remove();
			}


			// LOAD START SCREEN or EDITOR
			//if (JSON.stringify(settings.banner_obj) !== '{}'){
			//if( Object.keys(settings.banner_obj).length > 0 ){
			if(settings.banner_obj.size.full !== ''){
				_obj.find("._dn_ChooseSize").hide();
				//settings.banner_obj.upload = settings.editor.upload;
				if( _dn_debug ){ console.log('banner_obj exist'); console.log(settings.banner_obj.upload); } //.banner_obj.upload

				// Check if id is already available
				if( typeof settings.banner_obj.id === 'undefined'){
					settings.banner_obj.id = _dn_bc._imc_id_generator( settings.editor.user_id );
				}
				
				_obj.find("._dn_BannerEditor")._dn_banner_editor(settings);
			}else{
				if( _dn_debug ){ console.log('banner_obj empty Load Choose Size window'); }
				_dn_ss._dn_NewImage(_obj, settings);
				//_obj.imgmce_setup({"destroy":true});
			}
			

			// New image button
			_obj.find("._dnNewImage").off('click').on("click", function(){
				
				if( _obj.find("._dn_menu").hasClass("editor") ){
					if( !_dn_ss._dn_exit_editor()) return false;
				}

				// Destroy BannerEditor
				_obj.find("._dn_BannerEditor")._dn_banner_editor({"destroy":true});
				
				_obj.find("._dn_BannerEditor").hide();
				_obj.find(".menu_tab").removeClass("selected");
				_obj.find(".menu_tab.bc_editor").hide();
				$(this).closest(".menu_tab").addClass("selected");

				settings.banner_obj = {};

				var h = '';
				h+= '<div class="_imc_loader">';
					h+= '<div class="loading_logo">';
						h+= '<svg width="20px" height="20px" viewBox="0 0 310 426"><g><g id="bottom_xA0_Image_3_"><g><g><path fill="#FFFF00" d="M237,225c-0.33,0-0.67,0-1,0c-53.73,59.93-108.85,118.49-163,178c-0.85,0.18-0.94-0.39-1-1c26.08-58.92,51.7-118.3,77-178C178,224.67,209.67,222.67,237,225z"></path></g><g></g></g></g><g id="top_xA0_Image_3_"><g id="XMLID_3_"><g><path fill="#FFFF00" d="M289,165c0,1.33,0,2.67,0,4c-17.86,18.48-34.64,38.03-52,57c-56,0-112,0-168,0c0-1,0-2,0-3c21.5-64.83,42.62-130.05,63-196c46.33,0,92.67,0,139,0c-27.25,45.75-54.78,91.22-81,138C223,165,256,165,289,165z"></path></g><g></g></g></g></g><g id="BACK_1_"><g id="bottom_xA0_Image_1_"><g id="XMLID_5_"><g><path fill="#D7CB05" d="M149,225c0,1.33,0,2.67,0,4c-26.73,57.27-50.59,117.41-77,175c-16.02-1.31-37.3,2.63-50-2c25.93-59.4,52.98-117.69,79-177C117,225,133,225,149,225z"></path></g><g></g></g></g><g id="top_xA0_Image_1_"><g id="XMLID_4_"><g><path fill="#D7CB05" d="M133,27c0,1,0,2,0,3c-21.17,64.5-41.92,129.41-62,195c-16.33,0-32.67,0-49,0c0-1,0-2,0-3C43.17,157.5,63.92,92.59,84,27C100.33,27,116.67,27,133,27z"></path></g><g></g></g></g></g></svg>';
					h+= '</div>';
					//h+= '<div class="loading_text">Loading Editor...</div>';
				h+= '</div>';
				
				_obj.html(h);
				console.log(settings);
				ImgMCE_global.load_editor({
					'editor':settings.editor
				});
			});


			// MY IMAGES BUTTON
			_obj.find("._dnMyImages").off('click').on("click", function(){
				
				if( _obj.find("._dn_menu").hasClass("editor") ){
					if( !_dn_ss._dn_exit_editor()) return false;
				}
				
				// Destroy BannerEditor
				_obj.find("._dn_BannerEditor")._dn_banner_editor({"destroy":true});
				
				_obj.find("._dn_menu").removeClass("editor select_size").addClass("my_images");
				_obj.find(".menu_tab").removeClass("selected");
				_obj.find(".menu_tab.bc_editor").hide();
				$(this).closest(".menu_tab").addClass("selected");
				_obj.find("._dn_MyImages")._dn_update_page_color({'color':_obj.find("._dn_MyImages").data('bg')});

				_obj.find('._dn_menu_center').find('._dn_banner_title').hide();
				
				_obj.find('.bc_page').hide();

				//settings = {};
				//settings.in_popup = in_popup;

				var h = '';
				h+= '<div class="_imc_loader">';
					h+= '<div class="loading_logo">';
						h+= '<svg width="20px" height="20px" viewBox="0 0 310 426"><g><g id="bottom_xA0_Image_3_"><g><g><path fill="#FFFF00" d="M237,225c-0.33,0-0.67,0-1,0c-53.73,59.93-108.85,118.49-163,178c-0.85,0.18-0.94-0.39-1-1c26.08-58.92,51.7-118.3,77-178C178,224.67,209.67,222.67,237,225z"></path></g><g></g></g></g><g id="top_xA0_Image_3_"><g id="XMLID_3_"><g><path fill="#FFFF00" d="M289,165c0,1.33,0,2.67,0,4c-17.86,18.48-34.64,38.03-52,57c-56,0-112,0-168,0c0-1,0-2,0-3c21.5-64.83,42.62-130.05,63-196c46.33,0,92.67,0,139,0c-27.25,45.75-54.78,91.22-81,138C223,165,256,165,289,165z"></path></g><g></g></g></g></g><g id="BACK_1_"><g id="bottom_xA0_Image_1_"><g id="XMLID_5_"><g><path fill="#D7CB05" d="M149,225c0,1.33,0,2.67,0,4c-26.73,57.27-50.59,117.41-77,175c-16.02-1.31-37.3,2.63-50-2c25.93-59.4,52.98-117.69,79-177C117,225,133,225,149,225z"></path></g><g></g></g></g><g id="top_xA0_Image_1_"><g id="XMLID_4_"><g><path fill="#D7CB05" d="M133,27c0,1,0,2,0,3c-21.17,64.5-41.92,129.41-62,195c-16.33,0-32.67,0-49,0c0-1,0-2,0-3C43.17,157.5,63.92,92.59,84,27C100.33,27,116.67,27,133,27z"></path></g><g></g></g></g></g></svg>';
					h+= '</div>';
				h+= '</div>';
				_obj.find("._dn_MyImages").html(h).show();
				
				$.ajax({
					type: "POST",
					url: _dn_.ajaxurl,
					data: {
						"action": "load_my_images_template",
						"settings": JSON.stringify(settings)
					}
				}).done(function( msg ){
					_obj.find("._dn_MyImages").html(msg);
					ImgMCE_global.activate_tooltips(_obj);
					
					window.dispatchEvent(new Event('resize'));
				});

			});

			// Edit image button
			_obj.find(".my_images").off('click').on('click', '.edit', function(){
				if( _dn_debug ){ console.log('edit'); }
				
				var json =  JSON.parse($(this).closest('.action_buttons').find('._lib_tpl_json_code').val() ),
					tinymce = active_editor !== '' ? 1 : 0,
					edit_as_new = $(this).hasClass('edit_as_new') ? 1 : 0,
					parent_id = edit_as_new ? json.id : 0;
				
				// give new ID if we use the image as template
				if(edit_as_new){
					json.id = _dn_bc._imc_id_generator( settings.editor.user_id );
				}


				// Add banner_obj to settings
				settings.banner_obj = json;
				var h = '';
				h+= '<div class="_imc_loader">';
					h+= '<div class="loading_logo">';
						h+= '<svg width="20px" height="20px" viewBox="0 0 310 426"><g><g id="bottom_xA0_Image_3_"><g><g><path fill="#FFFF00" d="M237,225c-0.33,0-0.67,0-1,0c-53.73,59.93-108.85,118.49-163,178c-0.85,0.18-0.94-0.39-1-1c26.08-58.92,51.7-118.3,77-178C178,224.67,209.67,222.67,237,225z"></path></g><g></g></g></g><g id="top_xA0_Image_3_"><g id="XMLID_3_"><g><path fill="#FFFF00" d="M289,165c0,1.33,0,2.67,0,4c-17.86,18.48-34.64,38.03-52,57c-56,0-112,0-168,0c0-1,0-2,0-3c21.5-64.83,42.62-130.05,63-196c46.33,0,92.67,0,139,0c-27.25,45.75-54.78,91.22-81,138C223,165,256,165,289,165z"></path></g><g></g></g></g></g><g id="BACK_1_"><g id="bottom_xA0_Image_1_"><g id="XMLID_5_"><g><path fill="#D7CB05" d="M149,225c0,1.33,0,2.67,0,4c-26.73,57.27-50.59,117.41-77,175c-16.02-1.31-37.3,2.63-50-2c25.93-59.4,52.98-117.69,79-177C117,225,133,225,149,225z"></path></g><g></g></g></g><g id="top_xA0_Image_1_"><g id="XMLID_4_"><g><path fill="#D7CB05" d="M133,27c0,1,0,2,0,3c-21.17,64.5-41.92,129.41-62,195c-16.33,0-32.67,0-49,0c0-1,0-2,0-3C43.17,157.5,63.92,92.59,84,27C100.33,27,116.67,27,133,27z"></path></g><g></g></g></g></g></svg>';
					h+= '</div>';
				h+= '</div>';
				_obj.html(h);
				
				ImgMCE_global.load_editor({
					'editor':settings.editor,
					'banner_obj': settings.banner_obj,
					'parent_id': parent_id,
				});
			});


			// Remove image button (on my images page)
			// .off('click') doesn't work here for some reaseon (it makes the button unclickable). need to figure out why...
			_obj.find(".my_images").on('click', '.remove_btn', function(){
				if( _dn_debug ){ console.log('remove image ?'); console.log(settings); }

				var obj_id = $(this).data('id');

				if (!confirm('Are you sure you want to remove this image?')) {
					return false;
				}
				
				if( _dn_debug ){ console.log('YES, remove it!'); }
				$.ajax({
					type: "POST",
					url: _dn_.ajaxurl,
					data: {
						"action": "remove_folder",
						"upload": JSON.stringify({
							"upload_folder": 'user_uploads/'+settings.user_id+'/'+obj_id+'/', // we know the folder has to be uder_uploads here.
							"upload_dir": settings.editor.upload.dir,
							"upload_src": settings.editor.upload.src
						}),
						"id": obj_id
					}
				}).done(function( msg ){
					var obj = JSON.parse(msg);
					if( _dn_debug ){ console.log(obj); }

					if( obj.removed ){
						_obj.find('.my_images').find('.image_'+obj_id).remove();
					}else{
						alert(obj.msg);
					}
				});
			});

			// Select image button
			_obj.find(".my_images").on('click', '.select_image', function(){
				var json = JSON.parse($(this).closest('.banner_title').find('.image_code').val());
				var rand_id = Math.floor(Math.random() * 6) + 1;
				
				$.ajax({
					type: "POST",
					url: _dn_.ajaxurl,
					data: {
						"action": "load_banner",
						"args": JSON.stringify({
							'load_banner_script': 1,
							"adjust_id": "_ub"+rand_id+"ub_",
						}),
						"banner_obj": JSON.stringify(json),
						"debug":_dn_debug,
						"id": json.id
					}
				}).done(function( msg ){
					var obj = JSON.parse(msg),
						banner_obj = obj.banner_obj,
						banner_template = obj.template;

					_obj.find('.selected_image_cont').html(banner_template);

					// Set data
					_obj.find('.selected_image_info').find('.export_btn').attr('data-id', banner_obj.id);
					_obj.find('.selected_image_info').find('.export_btn').attr('data-user_id', banner_obj.user_id);
					_obj.find('.selected_image_info').show();

					// Set shortcode
					var shortcode = '[imgmce_element id="'+banner_obj.id+'" user_id="'+banner_obj.user_id+'"]';
					_obj.find('.selected_image_info').find('.shortcode_input').val(shortcode);
					


				
						


					// Export image as HTML5
					_obj.find('.selected_image_info').find('.export_as_html5').off('click').on('click',function(){
						var id = $(this).data('id'),
							user_id = $(this).data('user_id');
						
						if( _dn_debug ){console.log('export as HTML5');}

						$.ajax({
							type: "POST",
							url: _dn_.ajaxurl,
							data: {
								"action": "export_as_html5",
								"banner_obj": JSON.stringify(banner_obj),
								"banner_tpl": banner_template,
								"upload": JSON.stringify({
									"folder": 'user_uploads/'+user_id+'/',
									"dir": settings.editor.upload.dir,
									"src": settings.editor.upload.src
								}),
								"id": id
							}
						}).done(function( msg ){
							var arr = JSON.parse(msg);
							if( _dn_debug ){console.log(arr);}
							if( arr.zipped ){
								window.location = arr.zipped.src;
							}
						});
					});


					// Export image as template
					_obj.find('.selected_image_info').find('.export_as_template').off('click').on('click',function(){
						var id = $(this).data('id'),
							user_id = $(this).data('user_id');

						$.ajax({
							type: "POST",
							url: _dn_.ajaxurl,
							data: {
								"action": "export_folder",
								"upload": JSON.stringify({
									"folder": 'user_uploads/'+user_id+'/',
									"dir": settings.editor.upload.dir,
									"src": settings.editor.upload.src
								}),
								"id": id
							}
						}).done(function( msg ){
							var obj = JSON.parse(msg);
							
							if( obj.zipped ){
								window.location = obj.src;
							}else{
								if( _dn_debug ){console.log(obj);}
							}
						});
					});
				});
			});
			

			// Close Modal
			_obj.find(".CloseImgMCEModal").off('click').on("click", function(){
				
				if( $("._dn_menu").hasClass("editor") ){
					if( !_dn_ss._dn_exit_editor()) return false;
				}

				_obj.find("._dn_BannerEditor")._dn_banner_editor({"destroy":true});
				$("body").find("#TMCimgModal").remove();
				$("html").removeClass("Open_imgMCEModal");
			});

	   	});
	}




	

















	/**
	 * GOOGLE FONTS select
	 * https://github.com/tommoor/fontselect-jquery-plugin/blob/master/jquery.fontselect.js
	*/
	/**
	 * GOOGLE FONTS select
     * Customized version from: https://github.com/tommoor/fontselect-jquery-plugin/blob/master/jquery.fontselect.js
	*/
	$.fn._dn_fontselect = function(options) {  

        var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };

        var settings = $.extend({
			fonts: [],
			value: '',
            style: 'font-select _select_label',
            placeholder: 'Select a font',
            lookahead: 2,
            api: 'https://fonts.googleapis.com/css?family=',
            callback: null
        }, options );


        var Fontselect = (function(){

            function Fontselect(original, o){
                this.$original = $(original);
                this.options = o;
				this.fonts = o.fonts;
                this.active = false;
                this.setupHtml();
                this.getVisibleFonts();
                this.bindEvents();
                this.searchFont();

				//var font = this.$original.val();
				var font = this.noQuotes(this.options.value);
                if (font) {
					this.$original.val(font);
                    this.updateSelected();
                    this.addFontLink(font);
                }
            }

            Fontselect.prototype.bindEvents = function(){
                var self = this;
                // Close dropdown automatically on clicks outside dropdown
                $(document).on('click', function(event){
                    //if(self.active && !$(event.target).parents('#fontSelect-'+ self.$original.context.id).length){
                    if(self.active && !$(event.target).parents('#fontSelect').length){
                        self.toggleDrop();
                    }
                });
                
                $('li', this.$results)
					.click(__bind(this.selectFont, this))
					.mouseenter(__bind(this.activateFont, this))
					.mouseleave(__bind(this.deactivateFont, this));
                
                $('span', this.$select).click(__bind(this.toggleDrop, this));
				this.$arrow.click(__bind(this.toggleDrop, this));
            };

            Fontselect.prototype.toggleDrop = function(ev){
				
                if(this.active){
                    this.$element.removeClass('font-select-active');
					this.$drop.hide();
					this.$search.hide();
                    clearInterval(this.visibleInterval);
                } else {
                    this.$element.addClass('font-select-active');
					this.$drop.show();
					this.$search.show();
					this.moveToSelected();
                    this.visibleInterval = setInterval(__bind(this.getVisibleFonts, this), 500);
                }
                
                this.active = !this.active;
            };

            /**
             * SELECT FONT
             */
            Fontselect.prototype.selectFont = function(){
                
                var font = $('li.active', this.$results).data('value');
				this.$original.val(font).change();
				this.selected_font = this.noQuotes(font);
                $('li', this.$results).removeClass('selected');
                $('li.active', this.$results).addClass('selected');

                // Fire option callback
                if(typeof(settings.callback) === 'function' ){
                    settings.callback.call($('li.active', this.$results).get(0), this.toStyle(font), this.options.api+font);
                }
                    
                this.updateSelected();
                this.toggleDrop();
            };


            // SEARCH / FILTER
            Fontselect.prototype.searchFont = function(){
                var self = this;
                self.$element.find("._dn_font_search_filter").on('change', function(){
                        
                    var _sr = $(this),
                        filter = _sr.val(), 
                        filter_values = _sr.data('value-class'),
                        count = 0,
                        search_loop = 0;
                        console.log('filtering... '+filter_values);
                    
                    self.$element.find('.'+filter_values).each(function(){
                        var search_string = 'imc_'+$(this).data('value');
                        
                        if( typeof(search_string) !== 'undefined'){
                            if(search_string.search(new RegExp(filter, "i")) < 0){
                                $(this).fadeOut();
                                $(this).removeClass("active");
                                $(this).addClass("hidden");
                            } else {
                                $(this).show();
                                $(this).addClass("active");
                                $(this).removeClass("hidden");
                                
                                var font = $(this).data('value');
                                self.addFontLink(font);
                                count++;
                            }
                            search_loop++;
                        }
                    });
                });
            };

            Fontselect.prototype.moveToSelected = function(){
                
				//var $li, font = this.$original.val();
				var $li, font = this.noQuotes(this.options.value);
            
                if (font && font !== 'sans-serif'){
					$li = $("li[data-value='"+ font +"']", this.$results);
                } else {
                    $li = $("li", this.$results).first();
                }

                this.$results.scrollTop($li.addClass('active').position().top);
            };

            Fontselect.prototype.activateFont = function(ev){
                console.log('activate');
                var self = this;
                //self.toggleDrop();
                
                $('li.active', this.$results).removeClass('active');
                $(ev.currentTarget).addClass('active');
            };

            Fontselect.prototype.deactivateFont = function(ev){
                var self = this;
                //self.toggleDrop();
                $(ev.currentTarget).removeClass('active');
            };

            Fontselect.prototype.updateSelected = function(){
                
                var font = this.$original.val();
				$('span', this.$element).text(this.toReadable(font)).css(this.toStyle(font));
            };

            Fontselect.prototype.setupHtml = function(){
                
                this.$original.empty().hide();
                //this.$element = $('<div>', {'id': 'fontSelect-'+this.$original.context.id, 'class': this.options.style});
                this.$element = $('<div>', {'id': 'fontSelect', 'class': '_dn_fontselect '+this.options.style});
                this.$arrow = $('<div class="label_text"></div><div class="dropdown_arrow"><svg viewBox="0 0 320 512" style="height:15px;vertical-align:top;"><path fill="currentColor" d="M41 288h238c21.4 0 32.1 25.9 17 41L177 448c-9.4 9.4-24.6 9.4-33.9 0L24 329c-15.1-15.1-4.4-41 17-41z" class=""></path></svg></div>');
                this.$select = $('<a><span class="selected_font">'+ this.options.value +'</span></a>');
                this.$search = $('<div><input class="_dn_font_search_filter search_filter" data-value-class="dn_font" placeholder="Search Fonts" /></div>');
                this.$drop = $('<div>', {'class': 'fs-drop _select_dropdown'});
                this.$results = $('<ul>', {'class': 'fs-results'});

				this.$original.after(this.$element.append(this.$select.append(this.$arrow)).append(this.$search).append(this.$drop));
				this.$search.hide();
				this.$drop.append(this.$results.append(this.fontsAsHtml())).hide();
                /*this.$original.after(this.$element.append(this.$search).append(this.$drop));
				this.$drop.append(this.$results.append(this.fontsAsHtml()));*/
				
				//this.moveToSelected();
            };

            Fontselect.prototype.fontsAsHtml = function(){
                
                var fonts = this.fonts;
                var l = fonts.length;
                var r, s, h = '';
				var add_variant = '';
				var selected = '';
                
                for(var i=0; i<l; i++){
                    add_variant = fonts[i].variants[0] !== 'regular' ? ':'+fonts[i].variants[0] : '';
					font = fonts[i].family+add_variant;

                    r = this.toReadable(font);
					s = this.toStyle(font);

					selected = s['font-family'] === this.noQuotes(this.options.value) ? ' selected' : '';

                    h += '<li class="option dn_font'+selected+'" data-value="'+ font +'" style="font-family:'+s['font-family'] +'; font-weight: '+s['font-weight'] +'">'+ r +'</li>';
                }
                
                return h;
            };

			Fontselect.prototype.noQuotes = function(font){
				return font.replace(/"/g,"");
			};

            Fontselect.prototype.toReadable = function(font){
                return font.replace(/[\+|:]/g, ' ');
            };
            
            Fontselect.prototype.toStyle = function(font){
                var t = font.split(':');
                return {'font-family': this.toReadable(t[0]), 'font-weight': (t[1] || 400)};
            };

            Fontselect.prototype.getVisibleFonts = function(){
            
                if(this.$results.is(':hidden')) return;
                
                var fs = this;
                var top = this.$results.scrollTop();
                var bottom = top + this.$results.height();
                
                if(this.options.lookahead){
                    var li = $('li', this.$results).first().height();
                    bottom += li*this.options.lookahead;
                }
            
                $('li', this.$results).each(function(){

                    if( !$(this).hasClass('hidden')){
                        var ft = $(this).position().top+top;
                        var fb = ft + $(this).height();

                        if ((fb >= top) && (ft <= bottom)){
                            var font = $(this).data('value');
                            fs.addFontLink(font);
                        }
                    }
                
                });
            };

            Fontselect.prototype.addFontLink = function(font){
            
                var link = this.options.api + font;
            
				if (!$("link[href='"+link+"']").length){
					$('<link />').attr('rel','stylesheet').attr('href',link).appendTo("head");
				}
			};

            return Fontselect;
        })();


        return this.each(function(){  
            if( !$(this).parent().find('#fontSelect').length ){
                var self = this;
                $.getJSON( settings.fonts ).done(function( fonts ){
                    settings.fonts = fonts.items;
                    return new Fontselect(self, settings);
                });
            }
        });
    };
	
}(jQuery, window));